<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_PTBCheckbox extends Tbp_Dynamic_Item {

	function is_available() {
		return function_exists( 'run_ptb' );
	}

	function get_category() {
		return 'ptb';
	}

	function get_type() {
		return array( 'text', 'textarea', 'wp_editor' );
	}

	function get_label() {
		return __( 'PTB (Checkbox)', 'tbp' );
	}

	function get_value( $args = array() ) {
		$value = '';

		if ( ! empty( $args['field'] ) && function_exists( 'ptb_get_field' ) ) {
			$field_name = explode( ':', $args['field'] );
			return ptb_get_field( $field_name[1], [
				'seperator' => isset( $args['sep'] ) ? $args['sep'] : ''
			] );
		}

		return $value;

	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Field', 'tbp' ),
				'id' => 'field',
				'type' => 'select',
				'options' => Tbp_Utils::get_ptb_fields_by_type( 'checkbox' ),
			),
			array(
				'label' => __( 'Separator', 'tbp' ),
				'id' => 'sep',
				'type' => 'text',
				'help' => __( 'Character to separate items when multiple options are selected.', 'tbp' ),
			),
		);
	}
}