<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_PTBTextarea extends Tbp_Dynamic_Item {

	function is_available() {
		return function_exists( 'run_ptb' );
	}

	function get_category() {
		return 'ptb';
	}

	function get_type() {
		return array( 'textarea', 'wp_editor' );
	}

	function get_label() {
		return __( 'PTB (Textarea)', 'tbp' );
	}

	function get_value( $args = array() ) {
		$value='';
		if(!empty($args['field'])){
		    $the_query = Tbp_Utils::get_actual_query();
		    if($the_query===null || $the_query->have_posts()){
				if($the_query!==null){
					$the_query->the_post();
				}
				$field_name = explode( ':', $args['field'] );
				$formatting = empty( $args['formatting'] ) ? 'y' : $args['formatting'];
				$value = get_post_meta(get_the_ID(), "ptb_{$field_name[1]}", true );
				if ( $formatting === 'y' ) {
					$value = PTB_CMB_Base::format_text( $value );
				}
		    }
		    if($the_query!==null){
				wp_reset_postdata();
		    }
		}
		return $value;
	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Field', 'tbp' ),
				'id' => 'field',
				'type' => 'select',
				'options' => Tbp_Utils::get_ptb_fields_by_type( 'textarea' ),
			),
			array(
				'label' => __( 'Content Formatting', 'tbp' ),
				'id' => 'formatting',
				'type' => 'select',
				'options' => [
					'y' => __( 'Enabled', 'tbp' ),
					'n' => __( 'Disabled', 'tbp' ),
				],
			),
		);
	}
}