<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_PostAuthorAvatar extends Tbp_Dynamic_Item {

	function get_category() {
		return 'post';
	}

	function get_type() {
		return array( 'image' );
	}

	function get_label() {
		return __( 'Post Author Avatar', 'tbp' );
	}

	function get_value( $args = array() ) {
		$size = isset( $args['size'] ) ? (int) $args['size'] : 96;
		$user_id = get_post_field( 'post_author', parent::get_current_post_id() );
		$value = get_avatar_url( $user_id, array( 'size' => $size ) );
		return $value;
	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Size', 'tbp' ),
				'id' => 'size',
				'type' => 'number',
				'class'=>'large',
				'help' => __( 'Height and width of the avatar in pixels. Default is 96.', 'tbp' )
			),
		);
	}
}
