<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_PostAuthorMeta extends Tbp_Dynamic_Item {

	function get_category() {
		return 'post';
	}

	function get_type() {
		return array( 'text', 'textarea', 'wp_editor' );
	}

	function get_label() {
		return __( 'Post Author Meta', 'tbp' );
	}

	function get_value( $args = array() ) {
		$value = '';
		if ( ! empty( $args['key'] ) ) {
			$user_id = get_post_field( 'post_author', parent::get_current_post_id() );
			if ( ! empty( $user_id ) ) {
				$value = get_user_meta( $user_id, $args['key'], true );
			}
		}
		return $value;
	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Meta Key', 'tbp' ),
				'id' => 'key',
				'type' => 'text',
				'help' => __( 'Any user meta field can be displayed. To display user Biographical Info, set this option to <code>description</code>.', 'tbp' )
			),
		);
	}
}
