<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_PostAuthorURL extends Tbp_Dynamic_Item {

	function get_category() {
		return 'post';
	}

	function get_type() {
		return array( 'text', 'textarea', 'wp_editor', 'url' );
	}

	function get_label() {
		return __( 'Post Author URL', 'tbp' );
	}

	function get_value( $args = array() ) {
		$display = isset( $args['display'] ) ? $args['display'] : 'url';
		$user_id = get_post_field( 'post_author', parent::get_current_post_id() );
		if ( $args['display'] === 'url' ) {
			$value = get_the_author_meta( 'url', $user_id );
		} else {
			$value = get_author_posts_url( $user_id );
		}
		return $value;
	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Display', 'tbp' ),
				'id' => 'display',
				'type' => 'select',
				'options' => array(
					'url' => __( 'Website', 'tbp' ),
					'archive' => __( 'Author Archive Page', 'tbp' ),
				),
			)
		);
	}
}
