<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_PostTitle extends Tbp_Dynamic_Item {

	function get_category() {
		return 'post';
	}

	function get_type() {
		return array( 'text', 'textarea', 'wp_editor' );
	}

	function get_label() {
		return __( 'Post Title', 'tbp' );
	}

	function get_value( $args = array() ) {
		if ( empty( $args['post_id'] ) ) {
		    $args['post_id'] = parent::get_current_post_id();
		}
		$value = get_the_title( $args['post_id'] );
		return $value;
	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Post ID', 'tbp' ),
				'id' => 'post_id',
				'type' => 'number',
				'help' => __( 'Leave empty to get the data from current post in the loop.', 'tbp' ),
			),
		);
	}
}
