<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_ProductGallery extends Tbp_Dynamic_Item {

	function is_available() {
		return themify_is_woocommerce_active();
	}

	function get_category() {
		return 'wc';
	}

	function get_type() {
		return array( 'gallery', 'wp_editor' );
	}

	function get_label() {
		return __( 'Product Gallery', 'tbp' );
	}

	function get_value( $args = array() ) {
		$value='';
		if ( empty( $args['post_id'] ) ) {
		    $the_query = Tbp_Utils::get_wc_actual_query();
		    if ( $the_query===null || $the_query->have_posts() ) {
				if($the_query!==null){
					$the_query->the_post();
				}
				global $product;
		    }
		    if ( $the_query !== null ) {
				wp_reset_postdata();
		    }
		} else {
		    $product = wc_get_product( $args['post_id'] );
		}
		if ( ! empty( $product ) ) {
			$value = $product->get_gallery_image_ids();
			if ( isset( $args['include_variation'] ) && $args['include_variation'] === 'y' && $product->is_type( 'variable' ) ) {
				$variation_images = wp_list_pluck( $product->get_available_variations(), 'image_id' );
				if ( is_array( $variation_images ) ) {
					$value = array_merge( $value, $variation_images );
				}
			}
		}

		return ! empty( $value ) ? '[gallery ids="' . implode( ',', $value ) . '"]' : '';
	}

	function get_options() {
		return array(
			array(
				'label' => __( 'Product ID', 'tbp' ),
				'id' => 'post_id',
				'type' => 'number',
				'help' => __( 'Leave empty to get the data from current product in the loop.', 'tbp' ),
			),
			array(
				'id' => 'include_variation',
				'label' => __( 'Include Variation Images', 'tbp' ),
				'type' => 'select',
				'options' => array(
					'' => __( 'No', 'tbp' ),
					'y' => __( 'Yes', 'tbp' )
				)
			),
		);
	}
}
