/* DUPLICATOR-PRO (PHP MULTI-THREADED BUILD MODE) MYSQL SCRIPT CREATED ON : 2023-11-06 17:34:35 */

/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;

CREATE TABLE IF NOT EXISTS `come_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) NOT NULL DEFAULT '',
  `user_pass` varchar(255) NOT NULL DEFAULT '',
  `user_nicename` varchar(50) NOT NULL DEFAULT '',
  `user_email` varchar(100) NOT NULL DEFAULT '',
  `user_url` varchar(100) NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(255) NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT 0,
  `display_name` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`),
  KEY `user_email` (`user_email`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext DEFAULT NULL,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=59 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `cerber_acl` (
  `ip` varchar(81) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL,
  `ip_long_begin` bigint(20) unsigned NOT NULL DEFAULT 0,
  `ip_long_end` bigint(20) unsigned NOT NULL DEFAULT 0,
  `tag` char(1) NOT NULL,
  `comments` varchar(250) NOT NULL,
  `acl_slice` smallint(5) unsigned NOT NULL DEFAULT 0,
  `ver6` smallint(5) unsigned NOT NULL DEFAULT 0,
  `v6range` varchar(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `req_uri` varchar(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  KEY `main_for_selects` (`acl_slice`,`ver6`,`ip_long_begin`,`ip_long_end`,`tag`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE IF NOT EXISTS `cerber_blocks` (
  `ip` varchar(39) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL,
  `block_until` bigint(20) unsigned NOT NULL,
  `reason` varchar(250) NOT NULL,
  `reason_id` int(11) unsigned NOT NULL DEFAULT 0,
  UNIQUE KEY `ip` (`ip`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE IF NOT EXISTS `cerber_countries` (
  `country` char(3) NOT NULL DEFAULT '' COMMENT 'Country code',
  `locale` char(10) NOT NULL DEFAULT '' COMMENT 'Locale i18n',
  `country_name` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`country`,`locale`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE IF NOT EXISTS `cerber_lab` (
  `ip` varchar(39) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL,
  `reason_id` int(11) unsigned NOT NULL DEFAULT 0,
  `stamp` bigint(20) unsigned NOT NULL,
  `details` text NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE IF NOT EXISTS `cerber_lab_ip` (
  `ip` varchar(39) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL,
  `reputation` int(11) unsigned NOT NULL,
  `expires` int(11) unsigned NOT NULL,
  PRIMARY KEY (`ip`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE IF NOT EXISTS `cerber_lab_net` (
  `ip` varchar(39) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `ip_long_begin` bigint(20) unsigned NOT NULL DEFAULT 0,
  `ip_long_end` bigint(20) unsigned NOT NULL DEFAULT 0,
  `country` char(3) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `expires` int(11) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`ip`),
  UNIQUE KEY `begin_end` (`ip_long_begin`,`ip_long_end`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE IF NOT EXISTS `cerber_log` (
  `ip` varchar(39) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL,
  `ip_long` bigint(20) unsigned NOT NULL DEFAULT 0,
  `user_login` varchar(60) NOT NULL,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `stamp` decimal(14,4) NOT NULL,
  `activity` int(10) unsigned NOT NULL DEFAULT 0,
  `session_id` char(32) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `country` char(3) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `details` varchar(250) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `ac_bot` int(10) unsigned NOT NULL DEFAULT 0,
  `ac_status` int(10) unsigned NOT NULL DEFAULT 0,
  `ac_by_user` bigint(20) unsigned NOT NULL DEFAULT 0,
  KEY `ip` (`ip`),
  KEY `ip_long` (`ip_long`),
  KEY `session_index` (`session_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE IF NOT EXISTS `cerber_qmem` (
  `ip` varchar(39) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL,
  `http_code` int(10) unsigned NOT NULL,
  `stamp` int(10) unsigned NOT NULL,
  KEY `ip_stamp` (`ip`,`stamp`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE IF NOT EXISTS `cerber_traffic` (
  `ip` varchar(39) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL,
  `ip_long` bigint(20) unsigned NOT NULL DEFAULT 0,
  `hostname` varchar(250) NOT NULL DEFAULT '',
  `uri` text NOT NULL,
  `request_fields` mediumtext CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `request_details` mediumtext NOT NULL,
  `session_id` char(32) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `stamp` decimal(14,4) NOT NULL,
  `processing` int(10) NOT NULL DEFAULT 0,
  `country` char(3) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `request_method` char(8) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL,
  `http_code` int(10) unsigned NOT NULL,
  `wp_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `wp_type` int(10) unsigned NOT NULL DEFAULT 0,
  `is_bot` int(10) unsigned NOT NULL DEFAULT 0,
  `blog_id` int(10) unsigned NOT NULL DEFAULT 0,
  `php_errors` text NOT NULL,
  `req_status` int(10) unsigned NOT NULL DEFAULT 0,
  KEY `stamp` (`stamp`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE IF NOT EXISTS `come_cbnetpo_ping_optimizer` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date_time` datetime NOT NULL,
  `post_title` text DEFAULT NULL,
  `log_data` text DEFAULT NULL,
  `type` tinyint(4) DEFAULT 1,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=30 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci;

CREATE TABLE IF NOT EXISTS `come_cerber_files` (
  `scan_id` int(10) unsigned NOT NULL,
  `scan_type` int(10) unsigned NOT NULL DEFAULT 1,
  `scan_mode` int(10) unsigned NOT NULL DEFAULT 0,
  `scan_step` int(10) unsigned NOT NULL DEFAULT 0,
  `scan_status` int(10) unsigned NOT NULL DEFAULT 0,
  `file_status` int(10) unsigned NOT NULL DEFAULT 0,
  `file_name_hash` varchar(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `file_name` text NOT NULL,
  `file_type` int(10) unsigned NOT NULL DEFAULT 0,
  `file_hash` varchar(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `file_md5` varchar(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `file_hash_repo` varchar(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `hash_match` int(10) unsigned NOT NULL DEFAULT 0,
  `file_size` bigint(20) unsigned NOT NULL DEFAULT 0,
  `file_perms` int(11) NOT NULL DEFAULT 0,
  `file_writable` int(10) unsigned NOT NULL DEFAULT 0,
  `file_mtime` int(10) unsigned NOT NULL DEFAULT 0,
  `file_ext` varchar(255) NOT NULL DEFAULT '',
  `extra` text NOT NULL,
  PRIMARY KEY (`scan_id`,`file_name_hash`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE IF NOT EXISTS `come_cerber_sets` (
  `the_key` varchar(255) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL,
  `the_id` bigint(20) NOT NULL DEFAULT 0,
  `the_value` longtext NOT NULL,
  `expires` bigint(20) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`the_key`,`the_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE IF NOT EXISTS `come_cerber_uss` (
  `user_id` bigint(20) unsigned NOT NULL,
  `ip` varchar(39) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL,
  `country` char(3) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `started` int(10) unsigned NOT NULL,
  `expires` int(10) unsigned NOT NULL,
  `session_id` char(32) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '',
  `wp_session_token` varchar(250) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL,
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE IF NOT EXISTS `come_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext DEFAULT NULL,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT 0,
  `comment_author` tinytext NOT NULL,
  `comment_author_email` varchar(100) NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT 0,
  `comment_approved` varchar(20) NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) NOT NULL DEFAULT '',
  `comment_type` varchar(20) NOT NULL DEFAULT 'comment',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT 0,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10))
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_duplicator_pro_entities` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `type` varchar(100) NOT NULL,
  `data` longtext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `type_idx` (`type`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_duplicator_pro_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) NOT NULL,
  `hash` varchar(50) NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) NOT NULL,
  `package` longtext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) NOT NULL DEFAULT '',
  `link_name` varchar(255) NOT NULL DEFAULT '',
  `link_image` varchar(255) NOT NULL DEFAULT '',
  `link_target` varchar(25) NOT NULL DEFAULT '',
  `link_description` varchar(255) NOT NULL DEFAULT '',
  `link_visible` varchar(20) NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT 1,
  `link_rating` int(11) NOT NULL DEFAULT 0,
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) NOT NULL DEFAULT '',
  `link_notes` mediumtext NOT NULL,
  `link_rss` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(191) NOT NULL DEFAULT '',
  `option_value` longtext NOT NULL,
  `autoload` varchar(20) NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`),
  KEY `autoload` (`autoload`)
) ENGINE=InnoDB AUTO_INCREMENT=2878 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext DEFAULT NULL,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=506 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT 0,
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext NOT NULL,
  `post_title` text NOT NULL,
  `post_excerpt` text NOT NULL,
  `post_status` varchar(20) NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) NOT NULL DEFAULT 'open',
  `post_password` varchar(255) NOT NULL DEFAULT '',
  `post_name` varchar(200) NOT NULL DEFAULT '',
  `to_ping` text NOT NULL,
  `pinged` text NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT 0,
  `guid` varchar(255) NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT 0,
  `post_type` varchar(20) NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT 0,
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`(191)),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB AUTO_INCREMENT=208 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_shortpixel_folders` (
  `id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `path` varchar(512) DEFAULT NULL,
  `name` varchar(64) DEFAULT NULL,
  `path_md5` char(32) DEFAULT NULL,
  `file_count` int(11) DEFAULT NULL,
  `status` smallint(6) NOT NULL DEFAULT 0,
  `ts_updated` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `ts_created` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  UNIQUE KEY `spf_path_md5` (`path_md5`),
  KEY `path` (`path`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE IF NOT EXISTS `come_shortpixel_meta` (
  `id` mediumint(10) NOT NULL AUTO_INCREMENT,
  `folder_id` mediumint(9) NOT NULL,
  `ext_meta_id` int(10) DEFAULT NULL,
  `path` varchar(512) DEFAULT NULL,
  `name` varchar(64) DEFAULT NULL,
  `path_md5` char(32) DEFAULT NULL,
  `compressed_size` int(10) NOT NULL DEFAULT 0,
  `compression_type` tinyint(4) DEFAULT NULL,
  `keep_exif` tinyint(4) DEFAULT 0,
  `cmyk2rgb` tinyint(4) DEFAULT 0,
  `resize` tinyint(4) DEFAULT NULL,
  `resize_width` smallint(6) DEFAULT NULL,
  `resize_height` smallint(6) DEFAULT NULL,
  `backup` tinyint(4) DEFAULT 0,
  `status` smallint(6) NOT NULL DEFAULT 0,
  `retries` tinyint(4) NOT NULL DEFAULT 0,
  `message` varchar(255) DEFAULT NULL,
  `ts_added` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `ts_optimized` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  UNIQUE KEY `sp_path_md5` (`path_md5`),
  KEY `path` (`path`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE IF NOT EXISTS `come_shortpixel_postmeta` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `attach_id` bigint(20) unsigned NOT NULL,
  `parent` bigint(20) unsigned NOT NULL,
  `image_type` tinyint(4) DEFAULT 0,
  `size` varchar(50) DEFAULT NULL,
  `status` tinyint(4) DEFAULT 0,
  `compression_type` tinyint(4) DEFAULT NULL,
  `compressed_size` int(11) DEFAULT NULL,
  `original_size` int(11) DEFAULT NULL,
  `tsAdded` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `tsOptimized` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  `extra_info` longtext DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `attach_id` (`attach_id`),
  KEY `parent` (`parent`),
  KEY `size` (`size`),
  KEY `status` (`status`),
  KEY `compression_type` (`compression_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE IF NOT EXISTS `come_shortpixel_queue` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `queue_name` varchar(30) NOT NULL,
  `plugin_slug` varchar(30) NOT NULL,
  `status` int(11) NOT NULL DEFAULT 0,
  `list_order` int(11) NOT NULL,
  `item_id` int(11) NOT NULL,
  `item_count` int(11) DEFAULT 1,
  `value` longtext NOT NULL,
  `tries` int(11) NOT NULL DEFAULT 0,
  `created` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `updated` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  UNIQUE KEY `uq_come_` (`plugin_slug`,`queue_name`,`item_id`),
  KEY `queue_name` (`queue_name`),
  KEY `plugin_slug` (`plugin_slug`),
  KEY `status` (`status`),
  KEY `item_id` (`item_id`),
  KEY `list_order` (`list_order`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE IF NOT EXISTS `come_statistics_exclusions` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `date` date NOT NULL,
  `reason` varchar(180) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `count` bigint(20) NOT NULL,
  PRIMARY KEY (`ID`),
  KEY `date` (`date`),
  KEY `reason` (`reason`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci ROW_FORMAT=COMPACT;

CREATE TABLE IF NOT EXISTS `come_statistics_historical` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `category` varchar(25) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `page_id` bigint(20) NOT NULL,
  `uri` varchar(190) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `value` bigint(20) NOT NULL,
  PRIMARY KEY (`ID`),
  UNIQUE KEY `page_id` (`page_id`),
  UNIQUE KEY `uri` (`uri`),
  KEY `category` (`category`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci ROW_FORMAT=COMPACT;

CREATE TABLE IF NOT EXISTS `come_statistics_pages` (
  `page_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `uri` varchar(190) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `type` varchar(180) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `date` date NOT NULL,
  `count` int(11) NOT NULL,
  `id` int(11) NOT NULL,
  PRIMARY KEY (`page_id`),
  UNIQUE KEY `date_2` (`date`,`uri`),
  KEY `url` (`uri`),
  KEY `date` (`date`),
  KEY `id` (`id`),
  KEY `uri` (`uri`,`count`,`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci ROW_FORMAT=COMPACT;

CREATE TABLE IF NOT EXISTS `come_statistics_search` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `last_counter` date NOT NULL,
  `engine` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `host` varchar(190) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `words` varchar(190) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `visitor` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`ID`),
  KEY `last_counter` (`last_counter`),
  KEY `engine` (`engine`),
  KEY `host` (`host`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci ROW_FORMAT=COMPACT;

CREATE TABLE IF NOT EXISTS `come_statistics_useronline` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `ip` varchar(60) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `created` int(11) DEFAULT NULL,
  `timestamp` int(10) NOT NULL,
  `date` datetime NOT NULL,
  `referred` text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `agent` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `platform` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `version` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `location` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `user_id` bigint(48) NOT NULL,
  `page_id` bigint(48) NOT NULL,
  `type` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci ROW_FORMAT=COMPACT;

CREATE TABLE IF NOT EXISTS `come_statistics_visit` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `last_visit` datetime NOT NULL,
  `last_counter` date NOT NULL,
  `visit` int(10) NOT NULL,
  PRIMARY KEY (`ID`),
  UNIQUE KEY `unique_date` (`last_counter`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci ROW_FORMAT=COMPACT;

CREATE TABLE IF NOT EXISTS `come_statistics_visitor` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `last_counter` date NOT NULL,
  `referred` text CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `agent` varchar(180) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `platform` varchar(180) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `version` varchar(180) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `UAString` varchar(190) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `ip` varchar(60) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL,
  `location` varchar(10) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `user_id` bigint(40) NOT NULL,
  `hits` int(11) DEFAULT NULL,
  `honeypot` int(11) DEFAULT NULL,
  PRIMARY KEY (`ID`),
  UNIQUE KEY `date_ip_agent` (`last_counter`,`ip`,`agent`(50),`platform`(50),`version`(50)),
  KEY `agent` (`agent`),
  KEY `platform` (`platform`),
  KEY `version` (`version`),
  KEY `location` (`location`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci ROW_FORMAT=COMPACT;

CREATE TABLE IF NOT EXISTS `come_statistics_visitor_relationships` (
  `ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `visitor_id` bigint(20) NOT NULL,
  `page_id` bigint(20) NOT NULL,
  `date` datetime NOT NULL,
  PRIMARY KEY (`ID`),
  KEY `visitor_id` (`visitor_id`),
  KEY `page_id` (`page_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_general_ci ROW_FORMAT=COMPACT;

CREATE TABLE IF NOT EXISTS `come_termmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext DEFAULT NULL,
  PRIMARY KEY (`meta_id`),
  KEY `term_id` (`term_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) NOT NULL DEFAULT '',
  `slug` varchar(200) NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT 0,
  PRIMARY KEY (`term_id`),
  KEY `slug` (`slug`(191)),
  KEY `name` (`name`(191))
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `term_order` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT 0,
  `taxonomy` varchar(32) NOT NULL DEFAULT '',
  `description` longtext NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT 0,
  `count` bigint(20) NOT NULL DEFAULT 0,
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_tf_storage` (
  `key` char(16) CHARACTER SET latin1 COLLATE latin1_general_ci NOT NULL,
  `value` mediumtext NOT NULL,
  `expire` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`key`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE IF NOT EXISTS `come_tm_taskmeta` (
  `meta_id` bigint(20) NOT NULL AUTO_INCREMENT,
  `task_id` bigint(20) NOT NULL DEFAULT 0,
  `meta_key` varchar(255) DEFAULT NULL,
  `meta_value` longtext DEFAULT NULL,
  PRIMARY KEY (`meta_id`),
  KEY `meta_key` (`meta_key`(191)),
  KEY `task_id` (`task_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_tm_tasks` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) NOT NULL,
  `type` varchar(300) NOT NULL,
  `class_identifier` varchar(300) DEFAULT '0',
  `attempts` int(11) DEFAULT 0,
  `description` varchar(300) DEFAULT NULL,
  `time_created` timestamp NOT NULL DEFAULT current_timestamp(),
  `last_locked_at` bigint(20) DEFAULT 0,
  `status` varchar(300) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_yoast_indexable` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `permalink` longtext DEFAULT NULL,
  `permalink_hash` varchar(40) DEFAULT NULL,
  `object_id` bigint(20) DEFAULT NULL,
  `object_type` varchar(32) NOT NULL,
  `object_sub_type` varchar(32) DEFAULT NULL,
  `author_id` bigint(20) DEFAULT NULL,
  `post_parent` bigint(20) DEFAULT NULL,
  `title` text DEFAULT NULL,
  `description` mediumtext DEFAULT NULL,
  `breadcrumb_title` text DEFAULT NULL,
  `post_status` varchar(20) DEFAULT NULL,
  `is_public` tinyint(1) DEFAULT NULL,
  `is_protected` tinyint(1) DEFAULT 0,
  `has_public_posts` tinyint(1) DEFAULT NULL,
  `number_of_pages` int(11) unsigned DEFAULT NULL,
  `canonical` longtext DEFAULT NULL,
  `primary_focus_keyword` varchar(191) DEFAULT NULL,
  `primary_focus_keyword_score` int(3) DEFAULT NULL,
  `readability_score` int(3) DEFAULT NULL,
  `is_cornerstone` tinyint(1) DEFAULT 0,
  `is_robots_noindex` tinyint(1) DEFAULT 0,
  `is_robots_nofollow` tinyint(1) DEFAULT 0,
  `is_robots_noarchive` tinyint(1) DEFAULT 0,
  `is_robots_noimageindex` tinyint(1) DEFAULT 0,
  `is_robots_nosnippet` tinyint(1) DEFAULT 0,
  `twitter_title` text DEFAULT NULL,
  `twitter_image` longtext DEFAULT NULL,
  `twitter_description` longtext DEFAULT NULL,
  `twitter_image_id` varchar(191) DEFAULT NULL,
  `twitter_image_source` text DEFAULT NULL,
  `open_graph_title` text DEFAULT NULL,
  `open_graph_description` longtext DEFAULT NULL,
  `open_graph_image` longtext DEFAULT NULL,
  `open_graph_image_id` varchar(191) DEFAULT NULL,
  `open_graph_image_source` text DEFAULT NULL,
  `open_graph_image_meta` mediumtext DEFAULT NULL,
  `link_count` int(11) DEFAULT NULL,
  `incoming_link_count` int(11) DEFAULT NULL,
  `prominent_words_version` int(11) unsigned DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `blog_id` bigint(20) NOT NULL DEFAULT 1,
  `language` varchar(32) DEFAULT NULL,
  `region` varchar(32) DEFAULT NULL,
  `schema_page_type` varchar(64) DEFAULT NULL,
  `schema_article_type` varchar(64) DEFAULT NULL,
  `has_ancestors` tinyint(1) DEFAULT 0,
  `estimated_reading_time_minutes` int(11) DEFAULT NULL,
  `version` int(11) DEFAULT 1,
  `object_last_modified` datetime DEFAULT NULL,
  `object_published_at` datetime DEFAULT NULL,
  `inclusive_language_score` int(3) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `object_type_and_sub_type` (`object_type`,`object_sub_type`),
  KEY `object_id_and_type` (`object_id`,`object_type`),
  KEY `permalink_hash_and_object_type` (`permalink_hash`,`object_type`),
  KEY `subpages` (`post_parent`,`object_type`,`post_status`,`object_id`),
  KEY `prominent_words` (`prominent_words_version`,`object_type`,`object_sub_type`,`post_status`),
  KEY `published_sitemap_index` (`object_published_at`,`is_robots_noindex`,`object_type`,`object_sub_type`)
) ENGINE=InnoDB AUTO_INCREMENT=81 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_yoast_indexable_hierarchy` (
  `indexable_id` int(11) unsigned NOT NULL,
  `ancestor_id` int(11) unsigned NOT NULL,
  `depth` int(11) unsigned DEFAULT NULL,
  `blog_id` bigint(20) NOT NULL DEFAULT 1,
  PRIMARY KEY (`indexable_id`,`ancestor_id`),
  KEY `indexable_id` (`indexable_id`),
  KEY `ancestor_id` (`ancestor_id`),
  KEY `depth` (`depth`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_yoast_migrations` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `version` varchar(191) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `come_yoast_migrations_version` (`version`)
) ENGINE=InnoDB AUTO_INCREMENT=25 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_yoast_primary_term` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) DEFAULT NULL,
  `term_id` bigint(20) DEFAULT NULL,
  `taxonomy` varchar(32) NOT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `blog_id` bigint(20) NOT NULL DEFAULT 1,
  PRIMARY KEY (`id`),
  KEY `post_taxonomy` (`post_id`,`taxonomy`),
  KEY `post_term` (`post_id`,`term_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE IF NOT EXISTS `come_yoast_seo_links` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(255) DEFAULT NULL,
  `post_id` bigint(20) unsigned DEFAULT NULL,
  `target_post_id` bigint(20) unsigned DEFAULT NULL,
  `type` varchar(8) DEFAULT NULL,
  `indexable_id` int(11) unsigned DEFAULT NULL,
  `target_indexable_id` int(11) unsigned DEFAULT NULL,
  `height` int(11) unsigned DEFAULT NULL,
  `width` int(11) unsigned DEFAULT NULL,
  `size` int(11) unsigned DEFAULT NULL,
  `language` varchar(32) DEFAULT NULL,
  `region` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `link_direction` (`post_id`,`type`),
  KEY `indexable_link_direction` (`indexable_id`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

/***** TABLE CREATION END *****/
INSERT IGNORE INTO `come_users` VALUES 
("1","land-log-1357","$P$BTbqwSz97TAULjX4.swwTwzBW9agaN/","Spark Garten","write@sparkway-media.de","http://sparkway-client.de/sparkgarten","2022-01-08 22:03:30","","0","Spark Garten");

INSERT IGNORE INTO `come_usermeta` VALUES 
("1","1","nickname","Garten-Admin"),
("2","1","first_name",""),
("3","1","last_name",""),
("4","1","description",""),
("5","1","rich_editing","true"),
("6","1","syntax_highlighting","true"),
("7","1","comment_shortcuts","false"),
("8","1","admin_color","fresh"),
("9","1","use_ssl","0"),
("10","1","show_admin_bar_front","true"),
("11","1","locale",""),
("12","1","come_capabilities","a:1:{s:13:\"administrator\";b:1;}"),
("13","1","come_user_level","10"),
("14","1","dismissed_wp_pointers",""),
("15","1","show_welcome_panel","0"),
("17","1","come_dashboard_quick_press_last_post_id","191"),
("18","1","community-events-location","a:1:{s:2:\"ip\";s:21:\"2a02:8109:abbf:d160::\";}"),
("19","1","closedpostboxes_dashboard","a:0:{}"),
("20","1","metaboxhidden_dashboard","a:8:{i:0;s:19:\"dashboard_right_now\";i:1;s:18:\"dashboard_activity\";i:2;s:9:\"ab_widget\";i:3;s:12:\"themify_news\";i:4;s:24:\"wpseo-dashboard-overview\";i:5;s:32:\"wpseo-wincher-dashboard-overview\";i:6;s:21:\"dashboard_quick_press\";i:7;s:17:\"dashboard_primary\";}"),
("22","1","tgmpa_dismissed_notice_tgmpa","1"),
("23","1","duplicator_pro_created_format","1"),
("24","1","wp_statistics","a:1:{s:13:\"dashboard_set\";s:6:\"13.1.6\";}"),
("25","1","meta-box-order_dashboard","a:4:{s:6:\"normal\";s:108:\"dashboard_site_health,dashboard_right_now,dashboard_activity,ab_widget,themify_news,wpseo-dashboard-overview\";s:4:\"side\";s:68:\"dashboard_quick_press,dashboard_primary,cerber_quick,themify_updates\";s:7:\"column3\";s:0:\"\";s:7:\"column4\";s:0:\"\";}"),
("27","1","wp_ping_opt_99_admin_notice_dismissed5","true"),
("28","1","managenav-menuscolumnshidden","a:5:{i:0;s:11:\"link-target\";i:1;s:11:\"css-classes\";i:2;s:3:\"xfn\";i:3;s:11:\"description\";i:4;s:15:\"title-attribute\";}"),
("29","1","metaboxhidden_nav-menus","a:2:{i:0;s:25:\"themify-menu-widgets-meta\";i:1;s:12:\"add-post_tag\";}"),
("31","1","wp_media_library_mode","list"),
("33","1","come_user-settings","libraryContent=browse&ampamphidetb=1"),
("34","1","come_user-settings-time","1661730978"),
("35","1","nav_menu_recently_edited","2"),
("36","1","come_themify_module_favorite","{\"text\":\"1\",\"buttons\":\"1\",\"image\":\"1\",\"icon\":\"1\"}"),
("37","1","_yoast_wpseo_profile_updated","1661730922"),
("38","1","wpseo_title",""),
("39","1","wpseo_metadesc",""),
("40","1","wpseo_noindex_author",""),
("41","1","wpseo_content_analysis_disable",""),
("42","1","wpseo_keyword_analysis_disable",""),
("43","1","wpseo_inclusive_language_analysis_disable",""),
("44","1","user_meta_org_name",""),
("45","1","user_meta_org_logo",""),
("46","1","facebook",""),
("47","1","instagram",""),
("48","1","linkedin",""),
("49","1","myspace",""),
("50","1","pinterest",""),
("51","1","soundcloud",""),
("52","1","tumblr",""),
("53","1","twitter",""),
("54","1","youtube",""),
("55","1","wikipedia",""),
("57","1","come_yoast_notifications","a:1:{i:0;a:2:{s:7:\"message\";O:61:\"Yoast\\WP\\SEO\\Presenters\\Admin\\Indexing_Notification_Presenter\":3:{s:18:\"\0*\0total_unindexed\";i:5;s:9:\"\0*\0reason\";s:23:\"home_url_option_changed\";s:20:\"\0*\0short_link_helper\";O:38:\"Yoast\\WP\\SEO\\Helpers\\Short_Link_Helper\":2:{s:17:\"\0*\0options_helper\";O:35:\"Yoast\\WP\\SEO\\Helpers\\Options_Helper\":0:{}s:17:\"\0*\0product_helper\";O:35:\"Yoast\\WP\\SEO\\Helpers\\Product_Helper\":0:{}}}s:7:\"options\";a:10:{s:4:\"type\";s:7:\"warning\";s:2:\"id\";s:13:\"wpseo-reindex\";s:4:\"user\";O:7:\"WP_User\":8:{s:4:\"data\";O:8:\"stdClass\":10:{s:2:\"ID\";s:1:\"1\";s:10:\"user_login\";s:13:\"land-log-1357\";s:9:\"user_pass\";s:34:\"$P$BTbqwSz97TAULjX4.swwTwzBW9agaN/\";s:13:\"user_nicename\";s:12:\"Spark Garten\";s:10:\"user_email\";s:23:\"write@sparkway-media.de\";s:8:\"user_url\";s:37:\"http://sparkway-client.de/sparkgarten\";s:15:\"user_registered\";s:19:\"2022-01-08 22:03:30\";s:19:\"user_activation_key\";s:0:\"\";s:11:\"user_status\";s:1:\"0\";s:12:\"display_name\";s:12:\"Spark Garten\";}s:2:\"ID\";i:1;s:4:\"caps\";a:1:{s:13:\"administrator\";b:1;}s:7:\"cap_key\";s:17:\"come_capabilities\";s:5:\"roles\";a:1:{i:0;s:13:\"administrator\";}s:7:\"allcaps\";a:89:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:20:\"wpseo_manage_options\";b:1;s:10:\"copy_posts\";b:1;s:15:\"manage_security\";b:1;s:17:\"read_tbp_template\";b:1;s:25:\"read_private_tbp_template\";b:1;s:17:\"edit_tbp_template\";b:1;s:18:\"edit_tbp_templates\";b:1;s:28:\"edit_published_tbp_templates\";b:1;s:21:\"publish_tbp_templates\";b:1;s:19:\"delete_tbp_template\";b:1;s:20:\"delete_tbp_templates\";b:1;s:28:\"delete_private_tbp_templates\";b:1;s:30:\"delete_published_tbp_templates\";b:1;s:25:\"edit_others_tbp_templates\";b:1;s:27:\"delete_others_tbp_templates\";b:1;s:14:\"read_tbp_theme\";b:1;s:22:\"read_private_tbp_theme\";b:1;s:14:\"edit_tbp_theme\";b:1;s:15:\"edit_tbp_themes\";b:1;s:25:\"edit_published_tbp_themes\";b:1;s:18:\"publish_tbp_themes\";b:1;s:16:\"delete_tbp_theme\";b:1;s:17:\"delete_tbp_themes\";b:1;s:25:\"delete_private_tbp_themes\";b:1;s:27:\"delete_published_tbp_themes\";b:1;s:22:\"edit_others_tbp_themes\";b:1;s:24:\"delete_others_tbp_themes\";b:1;s:13:\"administrator\";b:1;}s:6:\"filter\";N;s:16:\"\0WP_User\0site_id\";i:1;}s:5:\"nonce\";N;s:8:\"priority\";d:0.8000000000000000444089209850062616169452667236328125;s:9:\"data_json\";a:0:{}s:13:\"dismissal_key\";N;s:12:\"capabilities\";s:20:\"wpseo_manage_options\";s:16:\"capability_check\";s:3:\"all\";s:14:\"yoast_branding\";b:0;}}}"),
("58","1","session_tokens","a:1:{s:64:\"5e5dff3abf502d493edce0ab8b594dd9a239124f5880b9b647d0cf13fe31ae9e\";a:4:{s:10:\"expiration\";i:1699464627;s:2:\"ip\";s:39:\"2a02:8109:abbf:d160:f03d:9ac0:289d:fd3d\";s:2:\"ua\";s:117:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/17.1 Safari/605.1.15\";s:5:\"login\";i:1699291827;}}");

INSERT IGNORE INTO `cerber_acl` VALUES 
("91.64.101.148","1530946964","1530946964","W","My IP address","0","0","",""),
("2a02:8109:abbf:d160:7069:bf31:7436:be44","189195236130159894","189195236130159894","W","My IP address","0","1","31641467280963262#68#31641467280963262#68","");

INSERT IGNORE INTO `cerber_blocks` VALUES 
("2a02:8109:abbf:d160:61e6:e74e:6b:7176","1698180030","Attempt to log in with non-existing username: prosen-log-3820","703");

INSERT IGNORE INTO `cerber_log` VALUES 
("2a02:8109:abbf:d160:61e6:e74e:6b:7176","1","prosen-log-3820","0","1698176430.8277","51","eGWRAXyPDLQNEifhCwYZBazd","","0|0|0|0|sparkway-client.de/sparkgarten/come-in/","0","0","0"),
("2a02:8109:abbf:d160:61e6:e74e:6b:7176","1","","0","1698176430.8287","10","eGWRAXyPDLQNEifhCwYZBazd","","703|0|0|0|sparkway-client.de/sparkgarten/come-in/","0","703","0");

INSERT IGNORE INTO `cerber_traffic` VALUES 
("2a02:8109:abbf:d160:61e6:e74e:6b:7176","0","","https://sparkway-client.de/sparkgarten/come-in/","","{\"1\":\"Mozilla\\/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit\\/605.1.15 (KHTML, like Gecko) Version\\/17.0 Safari\\/605.1.15\",\"2\":\"https:\\/\\/sparkway-client.de\\/sparkgarten\\/come-in\"}","eGWRAXyPDLQNEifhCwYZBazd","0","1698176430.7976","35","","POST","403","0","600","0","1","","0");

INSERT IGNORE INTO `come_cbnetpo_ping_optimizer` VALUES 
("1","2022-01-25 04:57:34","Automatisch gespeicherter Entwurf","NOT Pinging (no ping sites in services lists)~^","7"),
("2","2022-03-03 21:47:08","Automatisch gespeicherter Entwurf","NOT Pinging (no ping sites in services lists)~^","7"),
("3","2022-04-01 16:53:38","Automatisch gespeicherter Entwurf","NOT Pinging (no ping sites in services lists)~^","7"),
("4","2022-05-24 18:57:35","Automatisch gespeicherter Entwurf","NOT Pinging (no ping sites in services lists)~^","7"),
("5","2022-05-24 19:20:59","","NOT Pinging (no ping sites in services lists)~^","7"),
("6","2022-05-24 19:21:25","","NOT Pinging (no ping sites in services lists)~^","7"),
("7","2022-05-24 19:21:25","","NOT Pinging (no ping sites in services lists)~^","7"),
("8","2022-05-24 19:21:25","","NOT Pinging (no ping sites in services lists)~^","7"),
("9","2022-05-24 19:21:32","","NOT Pinging (no ping sites in services lists)~^","7"),
("10","2022-05-24 19:40:50","Home","NOT Pinging (no ping sites in services lists)~^","7"),
("11","2022-05-24 19:40:51","Home","NOT Pinging (no ping sites in services lists)~^It would have pinged if ping sites were available.<br><br>Reason: new post %title%","7"),
("12","2022-07-10 01:29:38","Automatisch gespeicherter Entwurf","NOT Pinging (no ping sites in services lists)~^","7"),
("13","2022-07-10 01:30:43","Home","NOT Pinging (no ping sites in services lists)~^","7"),
("14","2022-07-10 01:30:43","Home","NOT Pinging (no ping sites in services lists)~^It would have pinged if ping sites were available.<br><br>Reason: new post %title%","7"),
("15","2022-07-10 01:30:52","Home","NOT Pinging (no ping sites in services lists)~^","7"),
("16","2022-07-10 01:31:06","Home","NOT Pinging (no ping sites in services lists)~^","7"),
("17","2022-07-10 01:31:07","Home","NOT Pinging (no ping sites in services lists)~^It would have pinged if ping sites were available.<br><br>Reason: new post %title%","7"),
("18","2022-07-10 01:31:12","Home","NOT Pinging (no ping sites in services lists)~^","7"),
("19","2022-07-10 01:31:13","Home","NOT Pinging (no ping sites in services lists)~^It would have pinged if ping sites were available.<br><br>Reason: new post %title%","7"),
("20","2022-07-10 01:31:16","Home","NOT Pinging (no ping sites in services lists)~^","7"),
("21","2022-07-10 01:31:17","Home","NOT Pinging (no ping sites in services lists)~^It would have pinged if ping sites were available.<br><br>Reason: new post %title%","7"),
("22","2022-07-10 01:36:47","Home","NOT Pinging (no ping sites in services lists)~^","7"),
("23","2022-07-10 01:38:36","","NOT Pinging (no ping sites in services lists)~^","7"),
("24","2022-07-10 01:39:35","","NOT Pinging (no ping sites in services lists)~^","7"),
("25","2022-07-10 01:40:36","","NOT Pinging (no ping sites in services lists)~^","7"),
("26","2022-07-10 01:41:36","","NOT Pinging (no ping sites in services lists)~^","7"),
("27","2022-07-10 01:42:18","","NOT Pinging (no ping sites in services lists)~^","7"),
("28","2022-07-10 01:42:18","","NOT Pinging (no ping sites in services lists)~^","7"),
("29","2022-07-10 01:42:50","Automatisch gespeicherter Entwurf","NOT Pinging (no ping sites in services lists)~^","7");

INSERT IGNORE INTO `come_cerber_sets` VALUES 
("admin_message","0","a:0:{}","0"),
("admin_notice","0","a:0:{}","0"),
("boot_cerber_addons","0","a:0:{}","0"),
("cerber_admin_wide","0","","0"),
("cerber_user","1","a:2:{s:10:\"last_login\";a:2:{s:2:\"ip\";s:37:\"2a02:8109:abbf:d160:aded:cb58:fa0:d21\";s:2:\"ua\";s:40:\"e45ee5e37e01feb6d8c7784143cf9ecb55a4a953\";}s:11:\"2fa_history\";a:2:{i:0;i:9;i:1;i:1641829589;}}","0"),
("garbage_collector","0","1698176497","0"),
("hash_pl_2c76650bfc9322c8b9a0469c9ae9921dab6d99a7","0","a:4:{s:4:\"name\";s:15:\"Builder Contact\";s:3:\"ver\";s:5:\"2.2.0\";s:4:\"hash\";a:25:{s:8:\"init.php\";s:64:\"048b12286152183c5f9474157ac27d7933426db654d6d44f8bdb9215d879bc23\";s:16:\"assets/admin.css\";s:64:\"59850e5f74c1d595921da87aa06c73bd8faeb820381959e8d216e418976beecc\";s:19:\"assets/admin.css.gz\";s:64:\"282226ca52ed58aa8b58cf2f0ec4adb357f19efc134e08fcd3a31bfa439540a7\";s:15:\"assets/admin.js\";s:64:\"ab8b93158279c345060b0ce84da0197dde4b710ee4f64b422ecd6f4856204182\";s:18:\"assets/admin.js.gz\";s:64:\"a8e824f45deef465fac1fab1a12da28bcf4b9cc9e6fa7aa6d317dfd5111bb29d\";s:20:\"assets/admin.min.css\";s:64:\"192f9044ca0595640aece577117a58bfc6155cb5fba013f3b193131ea9c871bb\";s:23:\"assets/admin.min.css.gz\";s:64:\"58300d30d7c25c687f2127800b365733e638e9dd5f272d02e723505cddd5736d\";s:19:\"assets/admin.min.js\";s:64:\"00a9e599b43aa742eb7396e97821cf96e527913fffb412b1dbf6f0d1f087ba81\";s:22:\"assets/admin.min.js.gz\";s:64:\"e5be41123e7aee64ca7301cf66238010789227ebbc4ba8db134cc546a7c878e4\";s:17:\"assets/scripts.js\";s:64:\"958e5c9e5fbc001e0d3dc25c13d834edaa1228a55302e5836a965217bd07576f\";s:20:\"assets/scripts.js.gz\";s:64:\"3693da6c73de1a518c416232042ec7dcad0d68a8ef33d8dd07f4ed354e814f8a\";s:21:\"assets/scripts.min.js\";s:64:\"f03a217552467650c700a5fd41771fdd77e36339095cb8234342af06e512dc8d\";s:24:\"assets/scripts.min.js.gz\";s:64:\"bd328bb9e81a6c9e2d80d15705040c11375456b9d7b66fa9d2b171a27d6d311e\";s:16:\"assets/style.css\";s:64:\"8116aff0da0c1b86c66036fe18853133501d87a7290a028818e949c581d96ed2\";s:19:\"assets/style.css.gz\";s:64:\"1e05e4fa7fc5ce26566045a745fab32235d6b388941edbd62d077aa0b40157f3\";s:20:\"assets/style.min.css\";s:64:\"c6b55fe72c21cc8de632dfd7378a43c87d457a42b35c7d98499e85ce74424a49\";s:23:\"assets/style.min.css.gz\";s:64:\"9fdfcab75a3595210b8c1599769c31813d1c3b20e548e505f651edef2ee57faf\";s:17:\"assets/style1.svg\";s:64:\"d5fb0d2d242e6f663e74f0e3163f93deda5011305e571ddb3aef80dcc44160ae\";s:17:\"assets/style2.svg\";s:64:\"13c61274d2891dbc99796a6bf4bb3a710108559af101f7044b9e8dce1110cc53\";s:17:\"assets/style3.svg\";s:64:\"64f9b4a2fbe6aabba1d3d6931c71f71ae900baa300660c27a5e32a8036ea5c41\";s:17:\"assets/style4.svg\";s:64:\"7e1cb9e556bf8d9a69fa65ddb4ff55ce7aa9fd31df9ef771af6743ed35aa3388\";s:20:\"languages/readme.txt\";s:64:\"5458ce0b3aaa938f093ececab947bda9e1f3a4bb6831f72d449bd796827bf4b0\";s:26:\"modules/module-contact.php\";s:64:\"79723768ec37d9e2fd5685ecc7daa8d59d4a7b3799ecd101de6848f8c07f9069\";s:40:\"sample/contact_sample-builder-layout.zip\";s:64:\"1b385f990f191466bb5d6259e7a9c0d77b11df2417621299d7c0a938e04eab97\";s:30:\"templates/template-contact.php\";s:64:\"a05c5f2800e3184e7028802d875c46eb9a9312cf8c0236c0a1f6ccc36c17a4ff\";}s:4:\"time\";i:1653414118;}","0"),
("hash_pl_f2dcaf4b34e498bcc5ce0b678c2aac4e65c89a1a","0","a:4:{s:4:\"name\";s:15:\"Themify Updater\";s:3:\"ver\";s:5:\"1.3.9\";s:4:\"hash\";a:24:{s:10:\"readme.txt\";s:64:\"2b11df8c1c5f7c8e9f068a4aa08f7fd553893c9da04204aeb48423bb949d3365\";s:19:\"themify-updater.php\";s:64:\"f54f879bca9db3f4044a1d77d6088470e017f625e455d56e2dc28de8ee07c641\";s:24:\"css/themify-upgrader.css\";s:64:\"5c47698c5d4ac66aab2f12dcd8a9500cd2c410adc091d8665fede9c266e6b5b1\";s:27:\"css/themify-upgrader.css.gz\";s:64:\"34aaa09333b733c3b903734a4473ee46f7f62ee6d828198a2a6be365ea2dd969\";s:28:\"css/themify-upgrader.min.css\";s:64:\"bb9d4da821e4b1f8943a29be0f761bc05bdda77700b1f59543cc3d14d4b6ce1e\";s:31:\"css/themify-upgrader.min.css.gz\";s:64:\"9ff18343bc69a8c7b9cbf051948082ede93ca8321fbfe336430c3bdabbce6521\";s:17:\"img/ajax-done.png\";s:64:\"526ea5ef1b0b766ff024a6286dcf40e90ee4807291edaed44c885efa5ce3d36d\";s:18:\"img/ajax-error.png\";s:64:\"38037a24a90a967012150bedafafa96e23dbfeb20ba517ab720c8677f9f0c73d\";s:19:\"img/ajax-loader.gif\";s:64:\"e70f9f79a14836eae00118bccd65946b79bc1ca60ba86a0280f3915d30311874\";s:30:\"includes/class.auto.update.php\";s:64:\"72adeccaba285350981844b3d64f6c072874196dffde004ce91836a9162a7ace\";s:24:\"includes/class.cache.php\";s:64:\"b81c0fbc73e474b5dc21f8965fca93b50832415ec7637b04d279d13e35bcb704\";s:26:\"includes/class.license.php\";s:64:\"22d02d9245438ceca525f46f6072d4121f9fef958f826b48266163099c05b439\";s:32:\"includes/class.notifications.php\";s:64:\"0dd02129ed5f8b866f4dfa302b622ebebda5b16ac05e667e021b3e14ca2a52a8\";s:28:\"includes/class.promotion.php\";s:64:\"0a29af0347ddcd7feb68a46b7cbaad4f25ac417f5013aa6fc37022b3b107a4f0\";s:26:\"includes/class.request.php\";s:64:\"5de30143532ee976b232524ad8c7b9893cc1f0d952ef6e20dcb952fe150e5524\";s:24:\"includes/class.utils.php\";s:64:\"69cd8c67e6798624f16a808bf312f05ee57bbc5c2f7a658aab8f50f6f6e5b857\";s:26:\"includes/class.version.php\";s:64:\"ba3df7a1c01f6b5cf84cb8c5f3afa06737b51e23b1bb461bddb2ea7bad0629e2\";s:28:\"includes/themify.updater.php\";s:64:\"547f1a6e122653a1dd6ef1dd3b27530f7ee7e6cc17d2145cb77799113d2db7f7\";s:22:\"js/themify-upgrader.js\";s:64:\"1516d3995119fb58e5130b7fc926c47e7a4d82c87ddf6a6d8f791c7d10f83af0\";s:25:\"js/themify-upgrader.js.gz\";s:64:\"662c53491011cf53e615e848b047cba49aa162341a3e9624dc9898b31db8295a\";s:26:\"js/themify-upgrader.min.js\";s:64:\"5f8a932010c30d3936d19cc45d5289ba1ee5df30e48b9c728b3ee8b5ce837b81\";s:29:\"js/themify-upgrader.min.js.gz\";s:64:\"6b853a7ba1bd6c3e885920f3ff09d7a93d5c139c0022862e182ae6ff2c2d6df9\";s:24:\"templates/admin_menu.php\";s:64:\"27faeb9dba7c5869941591cc41698a688f20b01dacfde403b3fe5133becf2bcd\";s:23:\"templates/promotion.php\";s:64:\"b89a0edb77af4073ae2d91fea3696a5c60deb92008481396fe9e3346f93b4af8\";}s:4:\"time\";i:1653413569;}","0"),
("refresh_add_on_list","0","0","0"),
("_activated","0","a:3:{s:7:\"Version\";s:5:\"8.9.5\";s:4:\"time\";i:1641682970;s:4:\"user\";i:1;}","0"),
("_background_tasks","0","a:0:{}","0"),
("_cerberkey_","0","a:3:{i:0;s:32:\"7bd0b1c61f61be4b3551ed3d912d827b\";i:1;i:1676764115;i:4;s:40:\"SK//OJLXWRIUSFHGDKZQP95NM64AYE08V1B3T72C\";}","0"),
("_cerberlab_","0","a:3:{s:5:\"nodes\";a:9:{i:1;a:1:{s:4:\"last\";a:6:{i:0;d:0.0581281185150146484375;i:1;s:6:\"Active\";i:2;b:0;i:3;i:1676764117;i:4;s:4:\"http\";i:5;s:14:\"108.61.190.127\";}}i:2;a:1:{s:4:\"last\";a:6:{i:0;d:0.1877181529998779296875;i:1;s:6:\"Active\";i:2;b:0;i:3;i:1676764117;i:4;s:4:\"http\";i:5;s:12:\"204.48.16.53\";}}i:3;a:1:{s:4:\"last\";a:6:{i:0;d:0.3029401302337646484375;i:1;s:6:\"Active\";i:2;b:0;i:3;i:1676764118;i:4;s:4:\"http\";i:5;s:11:\"45.76.68.27\";}}i:4;a:1:{s:4:\"last\";a:6:{i:0;d:0.0685060024261474609375;i:1;s:6:\"Active\";i:2;b:0;i:3;i:1676764118;i:4;s:4:\"http\";i:5;s:13:\"178.62.68.142\";}}i:5;a:1:{s:4:\"last\";a:6:{i:0;d:0.3594739437103271484375;i:1;s:6:\"Active\";i:2;b:0;i:3;i:1676764118;i:4;s:4:\"http\";i:5;s:12:\"45.76.162.74\";}}i:6;a:1:{s:4:\"last\";a:6:{i:0;d:0.5508630275726318359375;i:1;s:6:\"Active\";i:2;b:0;i:3;i:1676764119;i:4;s:4:\"http\";i:5;s:13:\"45.77.233.161\";}}i:7;a:1:{s:4:\"last\";a:6:{i:0;d:0.1809360980987548828125;i:1;s:6:\"Active\";i:2;b:0;i:3;i:1676764119;i:4;s:4:\"http\";i:5;s:13:\"159.203.18.45\";}}i:8;a:1:{s:4:\"last\";a:6:{i:0;d:0.0005199909210205078125;i:1;i:0;i:2;s:58:\"Network error occurred while connecting to the node #8 (0)\";i:3;i:1676764119;i:4;s:4:\"http\";i:5;s:19:\"node8.cerberlab.net\";}}i:9;a:1:{s:4:\"last\";a:6:{i:0;d:0.0004751682281494140625;i:1;i:0;i:2;s:58:\"Network error occurred while connecting to the node #9 (0)\";i:3;i:1676764119;i:4;s:4:\"http\";i:5;s:19:\"node9.cerberlab.net\";}}}s:4:\"best\";i:1;s:10:\"last_check\";i:1676764119;}","0"),
("_cerber_mnemosyne","0","a:3:{i:0;s:20:\"LV0BST46UO8WH2X5RNCZ\";i:4;i:9;i:9;s:18:\"COTBIVS0AUE69H7KMZ\";}","0"),
("_check_env","0","1676764119","0");

INSERT IGNORE INTO `come_cerber_uss` VALUES 
("1","2a02:8109:abbf:d160:7069:bf31:7436:be44","","1676764060","1676936860","","f9b72889ede65515cd05067d5c0ddf56d2e9cce4160e4ffa76c001c4962593cd");

INSERT IGNORE INTO `come_duplicator_pro_entities` VALUES 
("1","DUP_PRO_Global_Entity","{\n    \"uninstall_settings\": false,\n    \"uninstall_packages\": false,\n    \"crypt\": true,\n    \"wpfront_integrate\": false,\n    \"package_ui_created\": 1,\n    \"package_mysqldump\": false,\n    \"package_mysqldump_path\": \"\",\n    \"package_phpdump_mode\": 0,\n    \"package_mysqldump_qrylimit\": 131072,\n    \"archive_build_mode\": 2,\n    \"archive_compression\": true,\n    \"ziparchive_validation\": false,\n    \"ziparchive_mode\": 0,\n    \"ziparchive_chunk_size_in_mb\": 32,\n    \"homepath_as_abspath\": false,\n    \"archive_build_mode_schedule\": -1,\n    \"archive_compression_schedule\": true,\n    \"server_load_reduction\": 0,\n    \"max_package_runtime_in_min\": 90,\n    \"php_max_worker_time_in_sec\": 20,\n    \"cleanup_mode\": 0,\n    \"cleanup_email\": \"\",\n    \"auto_cleanup_hours\": 24,\n    \"lock_mode\": 1,\n    \"json_mode\": 0,\n    \"ajax_protocol\": \"admin\",\n    \"custom_ajax_url\": \"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-admin\\/admin-ajax.php\",\n    \"clientside_kickoff\": false,\n    \"basic_auth_enabled\": false,\n    \"basic_auth_user\": \"\",\n    \"basic_auth_password\": \"\",\n    \"installer_name_mode\": \"simple\",\n    \"installer_base_name\": \"installer.php\",\n    \"chunk_size\": 2048,\n    \"skip_archive_scan\": false,\n    \"send_email_on_build_mode\": 1,\n    \"notification_email_address\": \"\",\n    \"storage_htaccess_off\": false,\n    \"max_storage_retries\": 10,\n    \"max_default_store_files\": 20,\n    \"purge_default_package_record\": false,\n    \"dropbox_upload_chunksize_in_kb\": 2000,\n    \"dropbox_transfer_mode\": 1,\n    \"gdrive_upload_chunksize_in_kb\": 1024,\n    \"gdrive_transfer_mode\": 0,\n    \"s3_upload_part_size_in_kb\": 6000,\n    \"onedrive_upload_chunksize_in_kb\": 3200,\n    \"local_upload_chunksize_in_MB\": 16,\n    \"manual_mode_storage_ids\": [\n        \"-2\"\n    ],\n    \"license_status\": 0,\n    \"license_expiration_time\": 1641688146,\n    \"license_no_activations_left\": false,\n    \"license_key_visible\": 1,\n    \"lkp\": \"\",\n    \"license_limit\": -1,\n    \"last_edd_api_response\": null,\n    \"last_edd_api_timestamp\": 0,\n    \"last_system_check_timestamp\": 1699291882,\n    \"initial_activation_timestamp\": 1641688156,\n    \"ssl_useservercerts\": true,\n    \"ssl_disableverify\": true,\n    \"import_chunk_size\": 1024,\n    \"import_custom_path\": \"\",\n    \"ipv4_only\": false,\n    \"debug_on\": false,\n    \"unhook_third_party_js\": false,\n    \"unhook_third_party_css\": false,\n    \"profile_idea\": false,\n    \"profile_beta\": false,\n    \"dupHidePackagesGiftFeatures\": true,\n    \"id\": 1\n}"),
("2","DUP_PRO_Secure_Global_Entity","{\n    \"basic_auth_password\": null,\n    \"lkp\": \"\",\n    \"id\": 2\n}"),
("3","DUP_PRO_System_Global_Entity","{\n    \"type\": \"DUP_PRO_System_Global_Entity\",\n    \"recommended_fixes\": [],\n    \"schedule_failed\": false,\n    \"package_check_ts\": 1699292068\n}"),
("4","DUP_PRO_Package_Template_Entity","{\n    \"name\": \"Default\",\n    \"notes\": \"The default template.\",\n    \"filter_sites\": [],\n    \"archive_export_onlydb\": 0,\n    \"archive_filter_on\": 0,\n    \"archive_filter_dirs\": \"\",\n    \"archive_filter_exts\": \"\",\n    \"archive_filter_files\": \"\",\n    \"archive_filter_names\": false,\n    \"database_filter_on\": 0,\n    \"databasePrefixFilter\": false,\n    \"databasePrefixSubFilter\": false,\n    \"database_filter_tables\": \"\",\n    \"database_compatibility_modes\": [],\n    \"installer_opts_secure_on\": 0,\n    \"installer_opts_secure_pass\": \"\",\n    \"installerPassowrd\": \"r7kKNxDvGomRh33tOJt0o7vGVoMNdFxe6rHNvAwhHjOBqHzr0RGFODpLOPguOhOll+eGUag9QRfbCqyzMBY0ng==\",\n    \"installer_opts_skip_scan\": 0,\n    \"installer_opts_db_host\": \"\",\n    \"installer_opts_db_name\": \"\",\n    \"installer_opts_db_user\": \"\",\n    \"installer_opts_cpnl_enable\": false,\n    \"installer_opts_cpnl_host\": \"\",\n    \"installer_opts_cpnl_user\": \"\",\n    \"installer_opts_cpnl_pass\": \"\",\n    \"installer_opts_cpnl_db_action\": \"create\",\n    \"installer_opts_cpnl_db_host\": \"\",\n    \"installer_opts_cpnl_db_name\": \"\",\n    \"installer_opts_cpnl_db_user\": \"\",\n    \"installer_opts_brand\": -2,\n    \"is_default\": true,\n    \"is_manual\": false,\n    \"id\": 4\n}"),
("5","DUP_PRO_Package_Template_Entity","{\n    \"name\": \"[Manual Mode]\",\n    \"notes\": \"\",\n    \"filter_sites\": \"\",\n    \"archive_export_onlydb\": 0,\n    \"archive_filter_on\": 0,\n    \"archive_filter_dirs\": \"\",\n    \"archive_filter_exts\": \"\",\n    \"archive_filter_files\": \"\",\n    \"archive_filter_names\": false,\n    \"database_filter_on\": 0,\n    \"databasePrefixFilter\": false,\n    \"databasePrefixSubFilter\": false,\n    \"database_filter_tables\": \"\",\n    \"database_compatibility_modes\": \"\",\n    \"installer_opts_secure_on\": 0,\n    \"installer_opts_secure_pass\": \"\",\n    \"installerPassowrd\": \"rf7UfEkMoqJkEsgiLCexS+rLATpv9w0bkHsCIdgLHJub30qBGAGml+0rDUlVCG6g7C1Pe9e\\/LPIe\\/Jt0nmAFEA==\",\n    \"installer_opts_skip_scan\": 0,\n    \"installer_opts_db_host\": \"\",\n    \"installer_opts_db_name\": \"\",\n    \"installer_opts_db_user\": \"\",\n    \"installer_opts_cpnl_enable\": 0,\n    \"installer_opts_cpnl_host\": \"\",\n    \"installer_opts_cpnl_user\": \"\",\n    \"installer_opts_cpnl_pass\": \"\",\n    \"installer_opts_cpnl_db_action\": \"create\",\n    \"installer_opts_cpnl_db_host\": \"\",\n    \"installer_opts_cpnl_db_name\": \"\",\n    \"installer_opts_cpnl_db_user\": \"\",\n    \"installer_opts_brand\": -2,\n    \"is_default\": false,\n    \"is_manual\": true,\n    \"id\": 5\n}");

INSERT IGNORE INTO `come_duplicator_pro_packages` VALUES 
("7","20231106_gartenheckerasen_spark","7dee4bdf8967fca84395_20231106173403","20","2023-11-06 18:34:17","land-log-1357","{\n    \"ID\": 7,\n    \"Created\": \"2023-11-06 17:34:03\",\n    \"Version\": \"4.5.8.3\",\n    \"VersionWP\": \"6.3.2\",\n    \"VersionDB\": \"10.5.21\",\n    \"VersionPHP\": \"8.1.25\",\n    \"VersionOS\": \"Linux\",\n    \"Name\": \"20231106_gartenheckerasen_spark\",\n    \"Hash\": \"7dee4bdf8967fca84395_20231106173403\",\n    \"NameHash\": \"20231106_gartenheckerasen_spark_7dee4bdf8967fca84395_20231106173403\",\n    \"Type\": 0,\n    \"notes\": \"\",\n    \"StorePath\": \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/backups-dup-pro\\/tmp\",\n    \"StoreURL\": \"https:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/backups-dup-pro\\/\",\n    \"ScanFile\": \"20231106_gartenheckerasen_spark_7dee4bdf8967fca84395_20231106173403_scan.json\",\n    \"timer_start\": 1699292069.3749530315399169921875,\n    \"Runtime\": 0,\n    \"ExeSize\": \"0\",\n    \"ZipSize\": \"0\",\n    \"Brand\": \"Default\",\n    \"Brand_ID\": -1,\n    \"ziparchive_mode\": 0,\n    \"Archive\": {\n        \"ExportOnlyDB\": 0,\n        \"FilterDirs\": \"\",\n        \"FilterExts\": \"\",\n        \"FilterFiles\": \"\",\n        \"FilterDirsAll\": [\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/.opcache\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/.tmb\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/ai1wm-backups\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/backups-dup-lite\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/backups-dup-pro\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/backups-dup-pro\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/backupwordpress\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/bps-backup\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/cache\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/content\\/cache\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/contents\\/cache\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/infinitewp\\/backups\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/managewp\\/backups\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/old-cache\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/plugins\\/all-in-one-wp-migration\\/storage\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/plugins\\/really-simple-captcha\\/tmp\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/plugins\\/wordfence\\/tmp\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/updraft\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/aiowps_backups\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/backup-guard\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/backupbuddy_backups\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/backupbuddy_temp\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/ithemes-security\\/backups\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/mainwp\\/backup\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/pb_backupbuddy\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/snapshots\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/sucuri\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/wp-clone\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/wp_all_backup\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/wpbackitup_backups\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/wfcache\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/wishlist-backup\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/wpvividbackups\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-snapshots\"\n        ],\n        \"FilterExtsAll\": [],\n        \"FilterFilesAll\": [\n            \".DS_Store\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/.htaccess\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/.user.ini\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/php.ini\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/web.config\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-config.php\",\n            \"dbcache\",\n            \"debug_log\",\n            \"error_log\",\n            \"objectcache\",\n            \"pgcache\",\n            \"ws_ftp.log\"\n        ],\n        \"FilterOn\": 0,\n        \"FilterNames\": false,\n        \"File\": \"20231106_gartenheckerasen_spark_7dee4bdf8967fca84395_20231106173403_archive.zip\",\n        \"Format\": \"ZIP\",\n        \"PackDir\": \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\",\n        \"Size\": 197305986,\n        \"Dirs\": null,\n        \"DirCount\": 1659,\n        \"RecursiveLinks\": [],\n        \"Files\": null,\n        \"FileCount\": 12493,\n        \"file_count\": -1,\n        \"FilterInfo\": {\n            \"Dirs\": {\n                \"Warning\": [],\n                \"AddonSites\": [],\n                \"Size\": [],\n                \"Core\": [],\n                \"Global\": [],\n                \"Instance\": [],\n                \"Unreadable\": []\n            },\n            \"Files\": {\n                \"Warning\": [],\n                \"Size\": [],\n                \"Core\": [],\n                \"Global\": [],\n                \"Instance\": [],\n                \"Unreadable\": []\n            },\n            \"Exts\": {\n                \"Core\": [],\n                \"Global\": [],\n                \"Instance\": [],\n                \"Unreadable\": []\n            },\n            \"TreeSize\": null,\n            \"TreeWarning\": null\n        },\n        \"ListDelimiter\": \"\\n\",\n        \"throttleDelayInUs\": 0\n    },\n    \"Multisite\": {\n        \"FilterSites\": \"\"\n    },\n    \"Installer\": {\n        \"File\": \"20231106_gartenheckerasen_spark_7dee4bdf8967fca84395_20231106173403_installer.php\",\n        \"Size\": 0,\n        \"OptsSecureOn\": 0,\n        \"passowrd\": \"N5iJG7KPg+5vcc1izjHdZ1mKxb7n9vNcLJVeIZrGlqlAlV1M1aPGJ2sC+pRmYqfGWWkXmw3LI2AxxmE22u36dA==\",\n        \"OptsSecurePass\": \"\",\n        \"OptsSkipScan\": 0,\n        \"OptsDBHost\": \"\",\n        \"OptsDBName\": \"\",\n        \"OptsDBUser\": \"\",\n        \"OptsCPNLHost\": \"\",\n        \"OptsCPNLUser\": \"\",\n        \"OptsCPNLPass\": \"\",\n        \"OptsCPNLEnable\": 0,\n        \"OptsCPNLConnect\": false,\n        \"OptsCPNLDBAction\": \"create\",\n        \"OptsCPNLDBHost\": \"\",\n        \"OptsCPNLDBName\": \"\",\n        \"OptsCPNLDBUser\": \"\",\n        \"numFilesAdded\": 0,\n        \"numDirsAdded\": 0\n    },\n    \"Database\": {\n        \"info\": {\n            \"buildMode\": \"PHPCHUNKING\",\n            \"charSetList\": [\n                \"utf8\",\n                \"utf8mb4\"\n            ],\n            \"collationList\": [\n                \"ascii_general_ci\",\n                \"latin1_general_ci\",\n                \"utf8_general_ci\",\n                \"utf8mb4_general_ci\",\n                \"utf8mb4_unicode_520_ci\",\n                \"utf8mb4_unicode_ci\"\n            ],\n            \"engineList\": [\n                \"InnoDB\"\n            ],\n            \"isTablesUpperCase\": 0,\n            \"isNameUpperCase\": 0,\n            \"name\": \"sparkway_client_degarten\",\n            \"tablesBaseCount\": 47,\n            \"tablesFinalCount\": 47,\n            \"muFilteredTableCount\": 0,\n            \"tablesRowCount\": 1715,\n            \"tablesSizeOnDisk\": 5390336,\n            \"tablesList\": {\n                \"cerber_acl\": {\n                    \"inaccurateRows\": 2,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"cerber_blocks\": {\n                    \"inaccurateRows\": 1,\n                    \"insertedRows\": false,\n                    \"size\": 16384\n                },\n                \"cerber_countries\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 16384\n                },\n                \"cerber_lab\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 16384\n                },\n                \"cerber_lab_ip\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 16384\n                },\n                \"cerber_lab_net\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"cerber_log\": {\n                    \"inaccurateRows\": 2,\n                    \"insertedRows\": false,\n                    \"size\": 65536\n                },\n                \"cerber_qmem\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"cerber_traffic\": {\n                    \"inaccurateRows\": 1,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_cbnetpo_ping_optimizer\": {\n                    \"inaccurateRows\": 29,\n                    \"insertedRows\": false,\n                    \"size\": 16384\n                },\n                \"come_cerber_files\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 16384\n                },\n                \"come_cerber_sets\": {\n                    \"inaccurateRows\": 15,\n                    \"insertedRows\": false,\n                    \"size\": 16384\n                },\n                \"come_cerber_uss\": {\n                    \"inaccurateRows\": 1,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_commentmeta\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_comments\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 98304\n                },\n                \"come_duplicator_pro_entities\": {\n                    \"inaccurateRows\": 5,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_duplicator_pro_packages\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_links\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_options\": {\n                    \"inaccurateRows\": 1218,\n                    \"insertedRows\": false,\n                    \"size\": 458752\n                },\n                \"come_postmeta\": {\n                    \"inaccurateRows\": 241,\n                    \"insertedRows\": false,\n                    \"size\": 2211840\n                },\n                \"come_posts\": {\n                    \"inaccurateRows\": 69,\n                    \"insertedRows\": false,\n                    \"size\": 589824\n                },\n                \"come_shortpixel_folders\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_shortpixel_meta\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_shortpixel_postmeta\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 98304\n                },\n                \"come_shortpixel_queue\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 114688\n                },\n                \"come_statistics_exclusions\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_statistics_historical\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 65536\n                },\n                \"come_statistics_pages\": {\n                    \"inaccurateRows\": 1,\n                    \"insertedRows\": false,\n                    \"size\": 98304\n                },\n                \"come_statistics_search\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 65536\n                },\n                \"come_statistics_useronline\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 16384\n                },\n                \"come_statistics_visit\": {\n                    \"inaccurateRows\": 6,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_statistics_visitor\": {\n                    \"inaccurateRows\": 1,\n                    \"insertedRows\": false,\n                    \"size\": 98304\n                },\n                \"come_statistics_visitor_relationships\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_termmeta\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_terms\": {\n                    \"inaccurateRows\": 3,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_term_relationships\": {\n                    \"inaccurateRows\": 8,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_term_taxonomy\": {\n                    \"inaccurateRows\": 3,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_tf_storage\": {\n                    \"inaccurateRows\": 13,\n                    \"insertedRows\": false,\n                    \"size\": 65536\n                },\n                \"come_tm_taskmeta\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_tm_tasks\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_usermeta\": {\n                    \"inaccurateRows\": 52,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_users\": {\n                    \"inaccurateRows\": 1,\n                    \"insertedRows\": false,\n                    \"size\": 65536\n                },\n                \"come_yoast_indexable\": {\n                    \"inaccurateRows\": 12,\n                    \"insertedRows\": false,\n                    \"size\": 114688\n                },\n                \"come_yoast_indexable_hierarchy\": {\n                    \"inaccurateRows\": 7,\n                    \"insertedRows\": false,\n                    \"size\": 65536\n                },\n                \"come_yoast_migrations\": {\n                    \"inaccurateRows\": 24,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_yoast_primary_term\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_yoast_seo_links\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                }\n            },\n            \"varLowerCaseTables\": \"0\",\n            \"dbEngine\": \"MariaDB\",\n            \"version\": \"10.5.21\",\n            \"versionComment\": \"mariadb.org binary distribution\",\n            \"viewCount\": 0,\n            \"procCount\": 0,\n            \"funcCount\": 0,\n            \"triggerList\": []\n        },\n        \"Type\": \"MySQL\",\n        \"Size\": 0,\n        \"File\": \"20231106_gartenheckerasen_spark_7dee4bdf8967fca84395_20231106173403_database.sql\",\n        \"FilterTables\": \"\",\n        \"FilterOn\": 0,\n        \"prefixFilter\": false,\n        \"prefixSubFilter\": false,\n        \"DBMode\": \"PHPCHUNKING\",\n        \"Compatible\": \"\",\n        \"Comments\": \"mariadb.org binary distribution\",\n        \"dbStorePathPublic\": \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/backups-dup-pro\\/tmp\\/20231106_gartenheckerasen_spark_7dee4bdf8967fca84395_20231106173403_database.sql\"\n    },\n    \"Status\": \"20.0\",\n    \"schedule_id\": -1,\n    \"build_progress\": {\n        \"thread_start_time\": 1699292075,\n        \"initialized\": true,\n        \"installer_built\": false,\n        \"archive_started\": false,\n        \"archive_start_time\": 0,\n        \"archive_has_database\": false,\n        \"archive_built\": false,\n        \"database_script_built\": false,\n        \"failed\": false,\n        \"next_archive_file_index\": 0,\n        \"next_archive_dir_index\": 0,\n        \"retries\": 0,\n        \"current_build_mode\": 2,\n        \"current_build_compression\": true,\n        \"dupCreate\": null,\n        \"dupExpand\": null,\n        \"warnings\": []\n    },\n    \"db_build_progress\": {\n        \"tablesToProcess\": [\n            \"come_users\",\n            \"come_usermeta\",\n            \"cerber_acl\",\n            \"cerber_blocks\",\n            \"cerber_countries\",\n            \"cerber_lab\",\n            \"cerber_lab_ip\",\n            \"cerber_lab_net\",\n            \"cerber_log\",\n            \"cerber_qmem\",\n            \"cerber_traffic\",\n            \"come_cbnetpo_ping_optimizer\",\n            \"come_cerber_files\",\n            \"come_cerber_sets\",\n            \"come_cerber_uss\",\n            \"come_commentmeta\",\n            \"come_comments\",\n            \"come_duplicator_pro_entities\",\n            \"come_duplicator_pro_packages\",\n            \"come_links\",\n            \"come_options\",\n            \"come_postmeta\",\n            \"come_posts\",\n            \"come_shortpixel_folders\",\n            \"come_shortpixel_meta\",\n            \"come_shortpixel_postmeta\",\n            \"come_shortpixel_queue\",\n            \"come_statistics_exclusions\",\n            \"come_statistics_historical\",\n            \"come_statistics_pages\",\n            \"come_statistics_search\",\n            \"come_statistics_useronline\",\n            \"come_statistics_visit\",\n            \"come_statistics_visitor\",\n            \"come_statistics_visitor_relationships\",\n            \"come_termmeta\",\n            \"come_terms\",\n            \"come_term_relationships\",\n            \"come_term_taxonomy\",\n            \"come_tf_storage\",\n            \"come_tm_taskmeta\",\n            \"come_tm_tasks\",\n            \"come_yoast_indexable\",\n            \"come_yoast_indexable_hierarchy\",\n            \"come_yoast_migrations\",\n            \"come_yoast_primary_term\",\n            \"come_yoast_seo_links\"\n        ],\n        \"validationStage1\": false,\n        \"doneInit\": true,\n        \"doneFiltering\": true,\n        \"doneCreates\": true,\n        \"completed\": false,\n        \"startTime\": 1699292069.3901669979095458984375,\n        \"wasInterrupted\": true,\n        \"errorOut\": false,\n        \"failureCount\": 0,\n        \"countCheckData\": {\n            \"countTotal\": 0,\n            \"impreciseTotalRows\": 1716,\n            \"tables\": {\n                \"come_users\": {\n                    \"start\": \"1\",\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_usermeta\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"cerber_acl\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"cerber_blocks\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"cerber_countries\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"cerber_lab\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"cerber_lab_ip\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"cerber_lab_net\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"cerber_log\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"cerber_qmem\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"cerber_traffic\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_cbnetpo_ping_optimizer\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_cerber_files\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_cerber_sets\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_cerber_uss\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_commentmeta\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_comments\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_duplicator_pro_entities\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_duplicator_pro_packages\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_links\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_options\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_postmeta\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_posts\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_shortpixel_folders\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_shortpixel_meta\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_shortpixel_postmeta\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_shortpixel_queue\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_statistics_exclusions\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_statistics_historical\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_statistics_pages\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_statistics_search\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_statistics_useronline\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_statistics_visit\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_statistics_visitor\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_statistics_visitor_relationships\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_termmeta\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_terms\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_term_relationships\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_term_taxonomy\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_tf_storage\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_tm_taskmeta\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_tm_tasks\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_yoast_indexable\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_yoast_indexable_hierarchy\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_yoast_migrations\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_yoast_primary_term\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                },\n                \"come_yoast_seo_links\": {\n                    \"start\": 0,\n                    \"end\": 0,\n                    \"count\": 0,\n                    \"create\": true\n                }\n            }\n        }\n    },\n    \"upload_infos\": [\n        {\n            \"storage_id\": \"-2\",\n            \"archive_offset\": 0,\n            \"copied_installer\": false,\n            \"copied_archive\": false,\n            \"progress\": 0,\n            \"num_failures\": 0,\n            \"failed\": false,\n            \"cancelled\": false,\n            \"upload_id\": null,\n            \"failure_count\": 0,\n            \"data\": \"\",\n            \"data2\": \"\",\n            \"has_started\": false,\n            \"status_message_details\": \"\",\n            \"started_timestamp\": null,\n            \"stopped_timestamp\": null,\n            \"chunkPosition\": []\n        }\n    ],\n    \"active_storage_id\": -1,\n    \"template_id\": 5\n}");

INSERT IGNORE INTO `come_options` VALUES 
("1","siteurl","http://sparkway-client.de/sparkgarten","yes"),
("2","home","http://sparkway-client.de/sparkgarten","yes"),
("3","blogname","Garten Hecke Rasen","yes"),
("4","blogdescription","EXCLUSIVE GARTEN- &amp; LANDSCHAFTSPFLEGE","yes"),
("5","users_can_register","0","yes"),
("6","admin_email","write@sparkway-media.de","yes"),
("7","start_of_week","1","yes"),
("8","use_balanceTags","0","yes"),
("9","use_smilies","1","yes"),
("10","require_name_email","1","yes"),
("11","comments_notify","1","yes"),
("12","posts_per_rss","10","yes"),
("13","rss_use_excerpt","0","yes"),
("14","mailserver_url","mail.example.com","yes"),
("15","mailserver_login","login@example.com","yes"),
("16","mailserver_pass","password","yes"),
("17","mailserver_port","110","yes"),
("18","default_category","1","yes"),
("19","default_comment_status","","yes"),
("20","default_ping_status","open","yes"),
("21","default_pingback_flag","","yes"),
("22","posts_per_page","10","yes"),
("23","date_format","j. F Y","yes"),
("24","time_format","G:i","yes"),
("25","links_updated_date_format","j. F Y G:i","yes"),
("26","comment_moderation","1","yes"),
("27","moderation_notify","1","yes"),
("28","permalink_structure","/%postname%/","yes"),
("30","hack_file","0","yes"),
("31","blog_charset","UTF-8","yes"),
("32","moderation_keys","","no"),
("33","active_plugins","a:14:{i:0;s:29:\"antispam-bee/antispam_bee.php\";i:1;s:27:\"autoptimize/autoptimize.php\";i:2;s:32:\"blackhole-bad-bots/blackhole.php\";i:3;s:24:\"builder-contact/init.php\";i:4;s:39:\"disable-gutenberg/disable-gutenberg.php\";i:5;s:33:\"duplicate-post/duplicate-post.php\";i:6;s:33:\"duplicator-pro/duplicator-pro.php\";i:7;s:57:\"manage-notification-emails/manage-notification-emails.php\";i:9;s:43:\"themify-builder-pro/themify-builder-pro.php\";i:10;s:35:\"themify-updater/themify-updater.php\";i:11;s:37:\"tinymce-advanced/tinymce-advanced.php\";i:13;s:27:\"updraftplus/updraftplus.php\";i:14;s:24:\"wordpress-seo/wp-seo.php\";i:15;s:35:\"wp-fastest-cache/wpFastestCache.php\";}","yes"),
("34","category_base","","yes"),
("35","ping_sites","http://rpc.pingomatic.com/\nhttp://xping.pubsub.com/ping/\nhttp://www.blogpeople.net/servlet/web...\nhttp://www.bloglines.com/ping\nhttp://services.newsgator.com/ngws/xm...\nhttp://rpc.weblogs.com/RPC2\nhttp://twingly.com/rpc-ping\nhttp://rpc.pingomatic.com\nhttp://rpc.icerocket.com:10080/\nhttp://rpc.bloggerei.de/ping/\nhttp://rpc.blogbuzzmachine.com/RPC2\nhttp://ping.wordblog.de/\nhttp://ping.myblog.jp/\nhttp://ping.feedburner.com/\nhttp://ping.blo.gs/\nhttp://blogsearch.google.de/ping/RPC2\nhttp://rpc.weblogs.com/RPC2\nhttp://ping.bloggers.jp/rpc/\nhttp://blogsearch.google.com/ping/RPC2","yes"),
("36","comment_max_links","2","yes"),
("37","gmt_offset","","yes"),
("38","default_email_category","1","yes"),
("39","recently_edited","","no"),
("40","template","themify-ultra","yes"),
("41","stylesheet","themify-ultra","yes"),
("42","comment_registration","1","yes"),
("43","html_type","text/html","yes"),
("44","use_trackback","0","yes"),
("45","default_role","subscriber","yes"),
("46","db_version","55853","yes"),
("47","uploads_use_yearmonth_folders","1","yes"),
("48","upload_path","","yes"),
("49","blog_public","0","yes"),
("50","default_link_category","2","yes"),
("51","show_on_front","page","yes"),
("52","tag_base","","yes"),
("53","show_avatars","","yes"),
("54","avatar_rating","G","yes"),
("55","upload_url_path","","yes"),
("56","thumbnail_size_w","150","yes"),
("57","thumbnail_size_h","150","yes"),
("58","thumbnail_crop","1","yes"),
("59","medium_size_w","300","yes"),
("60","medium_size_h","300","yes"),
("61","avatar_default","mystery","yes"),
("62","large_size_w","1024","yes"),
("63","large_size_h","1024","yes"),
("64","image_default_link_type","none","yes"),
("65","image_default_size","","yes"),
("66","image_default_align","","yes"),
("67","close_comments_for_old_posts","","yes"),
("68","close_comments_days_old","14","yes"),
("69","thread_comments","1","yes"),
("70","thread_comments_depth","5","yes"),
("71","page_comments","","yes"),
("72","comments_per_page","50","yes"),
("73","default_comments_page","newest","yes"),
("74","comment_order","asc","yes"),
("75","sticky_posts","a:0:{}","yes"),
("76","widget_categories","a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}","yes"),
("77","widget_text","a:4:{i:1;a:0:{}i:2;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:90:\"<a href=\"http://sparkway-client.de/sparkgarten/impressum/\">Impressum</a>  |  Datenschutz\";s:6:\"filter\";b:1;s:6:\"visual\";b:1;s:14:\"tf_search_ajax\";s:0:\"\";}i:3;a:5:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:43:\"Ihr Garten- und Landschaftsprofi seit 2003.\";s:6:\"filter\";b:1;s:6:\"visual\";b:1;s:14:\"tf_search_ajax\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}","yes"),
("78","widget_rss","a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}","yes"),
("79","uninstall_plugins","a:10:{s:29:\"antispam-bee/antispam_bee.php\";a:2:{i:0;s:12:\"Antispam_Bee\";i:1;s:9:\"uninstall\";}s:23:\"wp-cerber/wp-cerber.php\";s:13:\"cerber_finito\";s:24:\"wordpress-seo/wp-seo.php\";s:14:\"__return_false\";s:27:\"wp-optimize/wp-optimize.php\";s:21:\"wpo_uninstall_actions\";s:27:\"autoptimize/autoptimize.php\";s:29:\"autoptimizeMain::on_uninstall\";s:44:\"shortpixel-image-optimiser/wp-shortpixel.php\";a:2:{i:0;s:32:\"\\ShortPixel\\Helper\\InstallHelper\";i:1;s:15:\"uninstallPlugin\";}s:57:\"manage-notification-emails/manage-notification-emails.php\";s:16:\"fa_mne_uninstall\";s:33:\"duplicator-pro/duplicator-pro.php\";a:2:{i:0;s:24:\"Duplicator\\Core\\Unistall\";i:1;s:8:\"unistall\";}s:46:\"under-construction-page/under-construction.php\";a:2:{i:0;s:3:\"UCP\";i:1;s:9:\"uninstall\";}s:27:\"wp-cerber-off/wp-cerber.php\";s:13:\"cerber_finito\";}","no"),
("80","timezone_string","Europe/Berlin","yes"),
("81","page_for_posts","0","yes"),
("82","page_on_front","8","yes"),
("83","default_post_format","0","yes"),
("84","link_manager_enabled","0","yes"),
("85","finished_splitting_shared_terms","1","yes"),
("86","site_icon","0","yes"),
("87","medium_large_size_w","768","yes"),
("88","medium_large_size_h","0","yes"),
("89","wp_page_for_privacy_policy","12","yes"),
("90","show_comments_cookies_opt_in","1","yes"),
("91","admin_email_lifespan","1713728610","yes"),
("92","disallowed_keys","","no"),
("93","comment_previously_approved","1","yes"),
("94","auto_plugin_theme_update_emails","a:0:{}","no"),
("95","auto_update_core_dev","enabled","yes"),
("96","auto_update_core_minor","enabled","yes"),
("97","auto_update_core_major","enabled","yes"),
("98","wp_force_deactivated_plugins","a:0:{}","yes"),
("99","initial_db_version","49752","yes"),
("100","come_user_roles","a:7:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:88:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:20:\"wpseo_manage_options\";b:1;s:10:\"copy_posts\";b:1;s:15:\"manage_security\";b:1;s:17:\"read_tbp_template\";b:1;s:25:\"read_private_tbp_template\";b:1;s:17:\"edit_tbp_template\";b:1;s:18:\"edit_tbp_templates\";b:1;s:28:\"edit_published_tbp_templates\";b:1;s:21:\"publish_tbp_templates\";b:1;s:19:\"delete_tbp_template\";b:1;s:20:\"delete_tbp_templates\";b:1;s:28:\"delete_private_tbp_templates\";b:1;s:30:\"delete_published_tbp_templates\";b:1;s:25:\"edit_others_tbp_templates\";b:1;s:27:\"delete_others_tbp_templates\";b:1;s:14:\"read_tbp_theme\";b:1;s:22:\"read_private_tbp_theme\";b:1;s:14:\"edit_tbp_theme\";b:1;s:15:\"edit_tbp_themes\";b:1;s:25:\"edit_published_tbp_themes\";b:1;s:18:\"publish_tbp_themes\";b:1;s:16:\"delete_tbp_theme\";b:1;s:17:\"delete_tbp_themes\";b:1;s:25:\"delete_private_tbp_themes\";b:1;s:27:\"delete_published_tbp_themes\";b:1;s:22:\"edit_others_tbp_themes\";b:1;s:24:\"delete_others_tbp_themes\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:37:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:15:\"wpseo_bulk_edit\";b:1;s:28:\"wpseo_edit_advanced_metadata\";b:1;s:10:\"copy_posts\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}s:13:\"wpseo_manager\";a:2:{s:4:\"name\";s:11:\"SEO Manager\";s:12:\"capabilities\";a:39:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:15:\"wpseo_bulk_edit\";b:1;s:28:\"wpseo_edit_advanced_metadata\";b:1;s:20:\"wpseo_manage_options\";b:1;s:23:\"view_site_health_checks\";b:1;s:10:\"copy_posts\";b:1;}}s:12:\"wpseo_editor\";a:2:{s:4:\"name\";s:10:\"SEO Editor\";s:12:\"capabilities\";a:37:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:15:\"wpseo_bulk_edit\";b:1;s:28:\"wpseo_edit_advanced_metadata\";b:1;s:10:\"copy_posts\";b:1;}}}","yes"),
("101","fresh_site","0","yes"),
("102","WPLANG","de_DE","yes"),
("103","widget_block","a:6:{i:2;a:1:{s:7:\"content\";s:19:\"<!-- wp:search /-->\";}i:3;a:1:{s:7:\"content\";s:159:\"<!-- wp:group --><div class=\"wp-block-group\"><!-- wp:heading --><h2>Neueste Beiträge</h2><!-- /wp:heading --><!-- wp:latest-posts /--></div><!-- /wp:group -->\";}i:4;a:1:{s:7:\"content\";s:230:\"<!-- wp:group --><div class=\"wp-block-group\"><!-- wp:heading --><h2>Neueste Kommentare</h2><!-- /wp:heading --><!-- wp:latest-comments {\"displayAvatar\":false,\"displayDate\":false,\"displayExcerpt\":false} /--></div><!-- /wp:group -->\";}i:5;a:1:{s:7:\"content\";s:145:\"<!-- wp:group --><div class=\"wp-block-group\"><!-- wp:heading --><h2>Archive</h2><!-- /wp:heading --><!-- wp:archives /--></div><!-- /wp:group -->\";}i:6;a:1:{s:7:\"content\";s:150:\"<!-- wp:group --><div class=\"wp-block-group\"><!-- wp:heading --><h2>Kategorien</h2><!-- /wp:heading --><!-- wp:categories /--></div><!-- /wp:group -->\";}s:12:\"_multiwidget\";i:1;}","yes"),
("104","sidebars_widgets","a:12:{s:19:\"wp_inactive_widgets\";a:0:{}s:15:\"footer-widget-1\";a:1:{i:0;s:13:\"media_image-2\";}s:15:\"footer-widget-2\";a:1:{i:0;s:6:\"text-3\";}s:15:\"footer-widget-3\";a:1:{i:0;s:6:\"text-2\";}s:15:\"header-widget-1\";a:0:{}s:15:\"header-widget-2\";a:0:{}s:15:\"header-widget-3\";a:0:{}s:12:\"sidebar-main\";a:3:{i:0;s:7:\"block-2\";i:1;s:7:\"block-3\";i:2;s:7:\"block-4\";}s:13:\"social-widget\";a:0:{}s:11:\"sidebar-alt\";a:2:{i:0;s:7:\"block-5\";i:1;s:7:\"block-6\";}s:20:\"footer-social-widget\";a:0:{}s:13:\"array_version\";i:3;}","yes"),
("105","cron","a:22:{i:1699293600;a:1:{s:15:\"cerber_hourly_1\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1699293811;a:1:{s:34:\"wp_privacy_delete_old_export_files\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1699294200;a:1:{s:15:\"cerber_hourly_2\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1699294739;a:1:{s:36:\"updater_hourly_schedule_notification\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1699300138;a:1:{s:28:\"rsssl_every_three_hours_hook\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:23:\"rsssl_every_three_hours\";s:4:\"args\";a:0:{}s:8:\"interval\";i:10800;}}}i:1699308211;a:5:{s:18:\"wp_https_detection\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:32:\"recovery_mode_clean_expired_keys\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1699308226;a:2:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:25:\"delete_expired_transients\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1699308228;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1699312109;a:1:{s:21:\"wp_update_user_counts\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1699312607;a:2:{s:13:\"wpseo-reindex\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:31:\"wpseo_permalink_structure_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1699314727;a:2:{s:26:\"wpo_minify_purge_old_cache\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:29:\"wpo_smush_clear_backup_images\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1699323600;a:1:{s:12:\"cerber_daily\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1699327411;a:1:{s:33:\"updraftplus_clean_temporary_files\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1699331267;a:2:{s:14:\"updraft_backup\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}s:23:\"updraft_backup_database\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}}i:1699333272;a:1:{s:15:\"ao_cachechecker\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1699372100;a:1:{s:28:\"wp_statistics_add_visit_hook\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1699386220;a:1:{s:30:\"wp_delete_temp_updater_backups\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}}i:1699741081;a:1:{s:22:\"themify_cron_clear_css\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:9:\"four_week\";s:4:\"args\";a:0:{}s:8:\"interval\";i:2419200;}}}i:1699744607;a:1:{s:16:\"wpseo_ryte_fetch\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}}i:1699750327;a:1:{s:21:\"wpo_weekly_cron_tasks\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}}i:1699826611;a:1:{s:30:\"wp_site_health_scheduled_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}}s:7:\"version\";i:2;}","yes"),
("106","widget_pages","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("107","widget_calendar","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("108","widget_archives","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("109","widget_media_audio","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("110","widget_media_image","a:2:{i:2;a:16:{s:4:\"size\";s:6:\"medium\";s:5:\"width\";i:720;s:6:\"height\";i:101;s:7:\"caption\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:9:\"link_type\";s:6:\"custom\";s:8:\"link_url\";s:0:\"\";s:13:\"image_classes\";s:0:\"\";s:12:\"link_classes\";s:0:\"\";s:8:\"link_rel\";s:0:\"\";s:17:\"link_target_blank\";b:0;s:11:\"image_title\";s:0:\"\";s:13:\"attachment_id\";i:158;s:3:\"url\";s:87:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png\";s:5:\"title\";s:0:\"\";s:14:\"tf_search_ajax\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}","yes"),
("111","widget_media_gallery","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("112","widget_media_video","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("113","widget_meta","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("114","widget_search","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("115","widget_tag_cloud","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("116","widget_nav_menu","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("117","widget_custom_html","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("119","theme_mods_twentytwentyone","a:2:{s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1641680280;s:4:\"data\";a:3:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:3:{i:0;s:7:\"block-2\";i:1;s:7:\"block-3\";i:2;s:7:\"block-4\";}s:9:\"sidebar-2\";a:2:{i:0;s:7:\"block-5\";i:1;s:7:\"block-6\";}}}}","yes"),
("142","recovery_keys","a:0:{}","yes"),
("143","https_detection_errors","a:1:{s:19:\"bad_response_source\";a:1:{i:0;s:68:\"Es sieht so aus, als ob die Antwort nicht von dieser Website stammt.\";}}","yes"),
("150","finished_updating_comment_type","1","yes"),
("153","recently_activated","a:2:{s:46:\"under-construction-page/under-construction.php\";i:1699291921;s:47:\"really-simple-ssl/rlrsssl-really-simple-ssl.php\";i:1699291898;}","yes"),
("162","auto_update_themes","a:1:{i:1;s:15:\"twentytwentytwo\";}","no"),
("166","current_theme","Themify Ultra","yes"),
("167","theme_mods_themify-ultra","a:26:{i:0;b:0;s:18:\"nav_menu_locations\";a:2:{s:10:\"footer-nav\";i:3;s:8:\"main-nav\";i:2;}s:18:\"custom_css_post_id\";i:-1;s:13:\"heading1_font\";s:180:\"{\"family\":{\"fonttype\":\"google\",\"name\":\"Montserrat\"},\"weight\":\"400\",\"sizenum\":\"40\",\"linenum\":\"50\",\"mobile\":{\"sizeunit\":\"px\",\"lineunit\":\"px\",\"letterspacingunit\":\"px\",\"weight\":\"400\"}}\";s:13:\"heading2_font\";s:180:\"{\"family\":{\"fonttype\":\"google\",\"name\":\"Montserrat\"},\"weight\":\"300\",\"sizenum\":\"40\",\"linenum\":\"50\",\"mobile\":{\"sizeunit\":\"px\",\"lineunit\":\"px\",\"letterspacingunit\":\"px\",\"weight\":\"300\"}}\";s:13:\"heading3_font\";s:180:\"{\"family\":{\"fonttype\":\"google\",\"name\":\"Montserrat\"},\"weight\":\"200\",\"sizenum\":\"30\",\"linenum\":\"40\",\"mobile\":{\"sizeunit\":\"px\",\"lineunit\":\"px\",\"letterspacingunit\":\"px\",\"weight\":\"200\"}}\";s:21:\"headerwrap_background\";s:129:\"{\"transparent\":\"\",\"noimage\":\"\",\"color\":\"89c43d\",\"opacity\":\"0.55\",\"mobile\":{\"color\":\"\",\"opacity\":\"1.00\",\"position\":\"\",\"style\":\"\"}}\";s:28:\"sticky_headerwrap_background\";s:105:\"{\"color\":\"254001\",\"opacity\":\"0.36\",\"mobile\":{\"color\":\"ffffff\",\"opacity\":\"0.43\",\"position\":\"\",\"style\":\"\"}}\";s:25:\"sticky_header_imageselect\";s:159:\"{\"id\":158,\"src\":\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\",\"imgwidth\":\"300\",\"imgheight\":\"\",\"mobile\":{\"imgwidth\":\"250\"}}\";s:15:\"site-logo_image\";s:184:\"{\"mode\":\"none\",\"id\":\"\",\"src\":\"\",\"imgwidth\":\"350\",\"mobile\":{\"sizeunit\":\"px\",\"lineunit\":\"px\",\"letterspacingunit\":\"px\",\"weight\":\"\",\"color\":\"\",\"opacity\":1,\"mode\":\"image\",\"imgwidth\":\"250\"}}\";s:24:\"main_nav_link_background\";s:63:\"{\"color\":\"\",\"opacity\":1,\"mobile\":{\"color\":\"\",\"opacity\":\"1.00\"}}\";s:19:\"main_nav_link_color\";s:80:\"{\"color\":\"ffffff\",\"opacity\":\"1.00\",\"mobile\":{\"color\":\"ffffff\",\"opacity\":\"1.00\"}}\";s:18:\"main_nav_link_font\";s:262:\"{\"family\":{\"fonttype\":\"google\",\"name\":\"Montserrat\"},\"weight\":\"500\",\"sizenum\":\"18\",\"texttransform\":\"uppercase\",\"mobile\":{\"sizeunit\":\"px\",\"lineunit\":\"px\",\"letterspacingunit\":\"px\",\"weight\":\"500\"},\"italic\":\"\",\"normal\":\"\",\"underline\":\"\",\"linethrough\":\"\",\"nostyle\":\"\"}\";s:25:\"main_nav_link_hover_color\";s:74:\"{\"color\":\"\",\"opacity\":\"1.00\",\"mobile\":{\"color\":\"6a992e\",\"opacity\":\"1.00\"}}\";s:19:\"main_nav_background\";s:88:\"{\"color\":\"\",\"opacity\":1,\"mobile\":{\"color\":\"\",\"opacity\":\"1.00\",\"position\":\"\",\"style\":\"\"}}\";s:24:\"sticky_header_link_color\";s:69:\"{\"mobile\":{\"color\":\"f06eaa\",\"opacity\":\"1.00\"},\"color\":\"\",\"opacity\":1}\";s:24:\"sticky_header_font_color\";s:63:\"{\"color\":\"\",\"opacity\":1,\"mobile\":{\"color\":\"\",\"opacity\":\"1.00\"}}\";s:18:\"sticky_header_font\";s:234:\"{\"sizenum\":\"20\",\"family\":{\"fonttype\":\"google\",\"name\":\"Montserrat\"},\"weight\":\"500\",\"italic\":\"\",\"normal\":\"\",\"underline\":\"\",\"linethrough\":\"\",\"nostyle\":\"\",\"mobile\":{\"sizeunit\":\"px\",\"lineunit\":\"px\",\"letterspacingunit\":\"px\",\"weight\":\"500\"}}\";s:23:\"sticky_header_link_font\";s:87:\"{\"italic\":\"\",\"normal\":\"\",\"bold\":\"\",\"underline\":\"\",\"linethrough\":\"\",\"nostyle\":\"nostyle\"}\";s:17:\"header_link_color\";s:63:\"{\"color\":\"\",\"opacity\":1,\"mobile\":{\"color\":\"\",\"opacity\":\"1.00\"}}\";s:9:\"body_font\";s:150:\"{\"family\":{\"fonttype\":\"google\",\"name\":\"Montserrat\"},\"weight\":\"400\",\"mobile\":{\"sizeunit\":\"px\",\"lineunit\":\"px\",\"letterspacingunit\":\"px\",\"weight\":\"400\"}}\";s:21:\"footerwrap_background\";s:105:\"{\"color\":\"446913\",\"opacity\":\"1.00\",\"mobile\":{\"color\":\"446913\",\"opacity\":\"1.00\",\"position\":\"\",\"style\":\"\"}}\";s:26:\"main_nav_link_active_color\";s:80:\"{\"color\":\"ffffff\",\"opacity\":\"1.00\",\"mobile\":{\"color\":\"152106\",\"opacity\":\"1.00\"}}\";s:22:\"mobile_menu_icon_color\";s:35:\"{\"color\":\"34520d\",\"opacity\":\"1.00\"}\";s:27:\"mobile_menu_icon_background\";s:35:\"{\"color\":\"ffffff\",\"opacity\":\"0.47\"}\";s:30:\"main_nav_link_hover_background\";s:35:\"{\"color\":\"3d5e13\",\"opacity\":\"1.00\"}\";}","yes"),
("168","theme_switched","","yes"),
("169","widget_themify-layout-parts","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("170","widget_themify-feature-posts","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("171","widget_themify-list-pages","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("172","widget_themify-list-categories","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("173","widget_themify-recent-comments","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("174","widget_themify-social-links","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("175","widget_themify-twitter","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("176","widget_themify-most-commented","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("177","widget_themify-google-maps","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("178","themify_clear_legacy","1","yes"),
("179","themify_migrate_settings_name","1","no"),
("180","themify_data","a:141:{s:16:\"setting-page_404\";s:1:\"0\";s:10:\"setting-gf\";s:2:\"on\";s:21:\"setting-webfonts_list\";s:4:\"full\";s:22:\"setting-default_layout\";s:12:\"sidebar-none\";s:27:\"setting-default_post_layout\";s:5:\"grid3\";s:27:\"setting-post_content_layout\";s:5:\"boxed\";s:19:\"setting-post_filter\";s:2:\"no\";s:23:\"setting-disable_masonry\";s:3:\"yes\";s:19:\"setting-post_gutter\";s:6:\"gutter\";s:30:\"setting-default_layout_display\";s:7:\"excerpt\";s:30:\"setting-default_excerpt_length\";s:2:\"25\";s:25:\"setting-default_more_text\";s:13:\"Mehr lesen...\";s:20:\"setting-excerpt_more\";s:1:\"1\";s:21:\"setting-index_orderby\";s:4:\"rand\";s:19:\"setting-index_order\";s:4:\"DESC\";s:26:\"setting-default_post_title\";s:3:\"yes\";s:33:\"setting-default_unlink_post_title\";s:2:\"no\";s:25:\"setting-default_post_meta\";s:3:\"yes\";s:25:\"setting-default_post_date\";s:3:\"yes\";s:27:\"setting-auto_featured_image\";s:1:\"1\";s:30:\"setting-default_media_position\";s:5:\"above\";s:26:\"setting-default_post_image\";s:2:\"no\";s:33:\"setting-default_unlink_post_image\";s:2:\"no\";s:31:\"setting-image_post_feature_size\";s:5:\"blank\";s:32:\"setting-default_page_post_layout\";s:8:\"sidebar1\";s:37:\"setting-default_page_post_layout_type\";s:7:\"classic\";s:31:\"setting-default_page_post_title\";s:2:\"no\";s:38:\"setting-default_page_unlink_post_title\";s:2:\"no\";s:30:\"setting-default_page_post_meta\";s:3:\"yes\";s:30:\"setting-default_page_post_date\";s:3:\"yes\";s:42:\"setting-default_page_single_media_position\";s:5:\"above\";s:31:\"setting-default_page_post_image\";s:2:\"no\";s:38:\"setting-default_page_unlink_post_image\";s:2:\"no\";s:38:\"setting-image_post_single_feature_size\";s:5:\"blank\";s:22:\"setting-comments_posts\";s:2:\"on\";s:23:\"setting-post_author_box\";s:2:\"on\";s:36:\"setting-search-result_layout_display\";s:7:\"excerpt\";s:32:\"setting-search-result_post_title\";s:2:\"no\";s:39:\"setting-search-result_unlink_post_title\";s:2:\"no\";s:31:\"setting-search-result_post_date\";s:2:\"no\";s:36:\"setting-search-result_media_position\";s:5:\"above\";s:32:\"setting-search-result_post_image\";s:2:\"no\";s:39:\"setting-search-result_unlink_post_image\";s:2:\"no\";s:27:\"setting-default_page_layout\";s:12:\"sidebar-none\";s:23:\"setting-hide_page_title\";s:3:\"yes\";s:23:\"setting-hide_page_image\";s:3:\"yes\";s:22:\"setting-comments_pages\";s:2:\"on\";s:17:\"setting-lazy-blur\";s:2:\"25\";s:18:\"setting-cache-live\";s:5:\"10080\";s:18:\"setting-cache_gzip\";s:2:\"on\";s:12:\"setting-webp\";s:2:\"on\";s:20:\"setting-webp-quality\";s:1:\"5\";s:22:\"setting-jquery-migrate\";s:2:\"on\";s:53:\"setting-customizer_responsive_design_tablet_landscape\";s:4:\"1024\";s:43:\"setting-customizer_responsive_design_tablet\";s:3:\"768\";s:43:\"setting-customizer_responsive_design_mobile\";s:3:\"600\";s:33:\"setting-mobile_menu_trigger_point\";s:3:\"900\";s:20:\"setting-color_design\";s:16:\"theme-color-lime\";s:21:\"setting-header_design\";s:12:\"header-block\";s:28:\"setting-exclude_site_tagline\";s:2:\"on\";s:27:\"setting-exclude_search_form\";s:2:\"on\";s:19:\"setting_search_form\";s:11:\"live_search\";s:30:\"setting-exclude_header_widgets\";s:2:\"on\";s:29:\"setting-exclude_social_widget\";s:2:\"on\";s:26:\"setting-mobile_menu_expand\";s:2:\"on\";s:22:\"setting-header_widgets\";s:17:\"headerwidget-3col\";s:21:\"setting-footer_design\";s:12:\"footer-block\";s:32:\"setting-exclude_footer_site_logo\";s:2:\"on\";s:38:\"setting-exclude_footer_menu_navigation\";s:2:\"on\";s:28:\"setting-exclude_footer_texts\";s:2:\"on\";s:27:\"setting-exclude_footer_back\";s:2:\"on\";s:22:\"setting-use_float_back\";s:3:\"off\";s:22:\"setting-footer_widgets\";s:17:\"footerwidget-3col\";s:23:\"setting-mega_menu_posts\";s:1:\"5\";s:29:\"setting-mega_menu_image_width\";s:3:\"180\";s:30:\"setting-mega_menu_image_height\";s:3:\"120\";s:28:\"setting-mega_menu_post_count\";s:3:\"off\";s:29:\"setting-color_animation_speed\";s:1:\"5\";s:29:\"setting-relationship_taxonomy\";s:8:\"category\";s:37:\"setting-relationship_taxonomy_entries\";s:1:\"3\";s:45:\"setting-relationship_taxonomy_display_content\";s:4:\"none\";s:30:\"setting-single_slider_autoplay\";s:3:\"off\";s:27:\"setting-single_slider_speed\";s:6:\"normal\";s:28:\"setting-single_slider_effect\";s:5:\"slide\";s:28:\"setting-single_slider_height\";s:4:\"auto\";s:18:\"setting-more_posts\";s:8:\"infinite\";s:19:\"setting-entries_nav\";s:8:\"numbered\";s:29:\"setting-footer_text_left_hide\";s:4:\"hide\";s:30:\"setting-footer_text_right_hide\";s:4:\"hide\";s:24:\"setting-gallery_lightbox\";s:8:\"lightbox\";s:30:\"setting-lightbox_disable_share\";s:2:\"on\";s:38:\"setting-default_portfolio_index_layout\";s:12:\"sidebar-none\";s:43:\"setting-default_portfolio_index_post_layout\";s:5:\"grid3\";s:29:\"setting-portfolio_post_filter\";s:3:\"yes\";s:33:\"setting-portfolio_disable_masonry\";s:3:\"yes\";s:24:\"setting-portfolio_gutter\";s:6:\"gutter\";s:39:\"setting-default_portfolio_index_display\";s:4:\"none\";s:39:\"setting-default_portfolio_single_layout\";s:12:\"sidebar-none\";s:54:\"setting-default_portfolio_single_portfolio_layout_type\";s:9:\"fullwidth\";s:22:\"themify_portfolio_slug\";s:7:\"project\";s:31:\"themify_portfolio_category_slug\";s:18:\"portfolio-category\";s:30:\"setting-page_builder_is_active\";s:6:\"enable\";s:37:\"setting-page_builder_gallery_lightbox\";s:6:\"enable\";s:14:\"setting-gutter\";s:3:\"3.2\";s:14:\"setting-narrow\";s:3:\"1.6\";s:12:\"setting-none\";s:1:\"0\";s:41:\"setting-page_builder_animation_appearance\";s:4:\"none\";s:42:\"setting-page_builder_animation_parallax_bg\";s:4:\"none\";s:44:\"setting-page_builder_animation_scroll_effect\";s:4:\"none\";s:44:\"setting-page_builder_animation_sticky_scroll\";s:4:\"none\";s:22:\"setting-link_icon_type\";s:9:\"font-icon\";s:32:\"setting-link_type_themify-link-0\";s:10:\"image-icon\";s:33:\"setting-link_title_themify-link-0\";s:7:\"Twitter\";s:31:\"setting-link_img_themify-link-0\";s:102:\"https://heshmedia-client.de/heshvorlage/wp-content/themes/themify-ultra/themify/img/social/twitter.png\";s:32:\"setting-link_type_themify-link-1\";s:10:\"image-icon\";s:33:\"setting-link_title_themify-link-1\";s:8:\"Facebook\";s:31:\"setting-link_img_themify-link-1\";s:103:\"https://heshmedia-client.de/heshvorlage/wp-content/themes/themify-ultra/themify/img/social/facebook.png\";s:32:\"setting-link_type_themify-link-2\";s:10:\"image-icon\";s:33:\"setting-link_title_themify-link-2\";s:7:\"YouTube\";s:31:\"setting-link_img_themify-link-2\";s:102:\"https://heshmedia-client.de/heshvorlage/wp-content/themes/themify-ultra/themify/img/social/youtube.png\";s:32:\"setting-link_type_themify-link-3\";s:10:\"image-icon\";s:33:\"setting-link_title_themify-link-3\";s:9:\"Pinterest\";s:31:\"setting-link_img_themify-link-3\";s:104:\"https://heshmedia-client.de/heshvorlage/wp-content/themes/themify-ultra/themify/img/social/pinterest.png\";s:32:\"setting-link_type_themify-link-4\";s:9:\"font-icon\";s:33:\"setting-link_title_themify-link-4\";s:7:\"Twitter\";s:33:\"setting-link_ficon_themify-link-4\";s:10:\"fa-twitter\";s:32:\"setting-link_type_themify-link-5\";s:9:\"font-icon\";s:33:\"setting-link_title_themify-link-5\";s:8:\"Facebook\";s:33:\"setting-link_ficon_themify-link-5\";s:11:\"fa-facebook\";s:32:\"setting-link_type_themify-link-6\";s:9:\"font-icon\";s:33:\"setting-link_title_themify-link-6\";s:7:\"YouTube\";s:33:\"setting-link_ficon_themify-link-6\";s:10:\"fa-youtube\";s:32:\"setting-link_type_themify-link-7\";s:9:\"font-icon\";s:33:\"setting-link_title_themify-link-7\";s:9:\"Pinterest\";s:33:\"setting-link_ficon_themify-link-7\";s:12:\"fa-pinterest\";s:22:\"setting-link_field_ids\";s:273:\"{\"themify-link-0\":\"themify-link-0\",\"themify-link-1\":\"themify-link-1\",\"themify-link-2\":\"themify-link-2\",\"themify-link-3\":\"themify-link-3\",\"themify-link-4\":\"themify-link-4\",\"themify-link-5\":\"themify-link-5\",\"themify-link-6\":\"themify-link-6\",\"themify-link-7\":\"themify-link-7\"}\";s:23:\"setting-link_field_hash\";s:1:\"8\";s:25:\"setting-img_php_base_size\";s:5:\"large\";s:27:\"setting-global_feature_size\";s:5:\"blank\";s:25:\"setting-recaptcha_version\";s:2:\"v2\";s:7:\"version\";s:5:\"7.3.6\";}","no"),
("181","themify_flush_rewrite_rules_after_manual_update","1","no"),
("182","themify-ultra_themify_import_notice","0","no"),
("198","user_has_tb_frontend","1","yes"),
("205","tadv_settings","a:10:{s:9:\"toolbar_1\";s:128:\"formatselect,bold,italic,blockquote,bullist,numlist,alignleft,aligncenter,alignright,hr,image,media,link,unlink,undo,redo,wp_adv\";s:9:\"toolbar_2\";s:138:\"styleselect,fontselect,fontsizeselect,outdent,indent,pastetext,removeformat,charmap,wp_more,forecolor,backcolor,visualblocks,table,wp_help\";s:9:\"toolbar_3\";s:0:\"\";s:9:\"toolbar_4\";s:0:\"\";s:21:\"toolbar_classic_block\";s:123:\"formatselect,bold,italic,blockquote,bullist,numlist,alignleft,aligncenter,alignright,link,forecolor,backcolor,table,wp_help\";s:13:\"toolbar_block\";s:67:\"core/code,core/image,core/strikethrough,tadv/mark,tadv/removeformat\";s:18:\"toolbar_block_side\";s:46:\"core/superscript,core/subscript,core/underline\";s:12:\"panels_block\";s:44:\"tadv/color-panel,tadv/background-color-panel\";s:7:\"options\";s:44:\"menubar_block,menubar,merge_toolbars,advlist\";s:7:\"plugins\";s:26:\"visualblocks,table,advlist\";}","yes"),
("206","tadv_admin_settings","a:2:{s:7:\"options\";s:86:\"classic_paragraph_block,table_resize_bars,table_grid,table_tab_navigation,table_advtab\";s:16:\"disabled_editors\";s:0:\"\";}","yes"),
("207","tadv_version","5900","yes"),
("212","antispam_bee","a:25:{s:12:\"regexp_check\";i:1;s:7:\"spam_ip\";i:1;s:17:\"already_commented\";i:1;s:14:\"gravatar_check\";i:0;s:10:\"time_check\";i:0;s:12:\"ignore_pings\";i:0;s:15:\"dashboard_chart\";i:1;s:15:\"dashboard_count\";i:0;s:12:\"country_code\";i:1;s:14:\"country_denied\";s:2:\"DE\";s:15:\"country_allowed\";s:0:\"\";s:13:\"translate_api\";i:1;s:14:\"translate_lang\";a:1:{i:0;s:2:\"de\";}s:12:\"bbcode_check\";i:1;s:9:\"flag_spam\";i:1;s:12:\"email_notify\";i:0;s:9:\"no_notice\";i:0;s:14:\"cronjob_enable\";i:0;s:16:\"cronjob_interval\";i:0;s:13:\"ignore_filter\";i:0;s:11:\"ignore_type\";i:1;s:14:\"reasons_enable\";i:0;s:14:\"ignore_reasons\";a:0:{}s:24:\"delete_data_on_uninstall\";i:1;s:17:\"use_output_buffer\";i:0;}","no"),
("213","antispambee_db_version","1.02","yes"),
("221","disable_gutenberg_options","a:28:{s:11:\"disable-all\";i:1;s:23:\"user-role_administrator\";i:1;s:16:\"user-role_editor\";i:1;s:16:\"user-role_author\";i:1;s:21:\"user-role_contributor\";i:1;s:20:\"user-role_subscriber\";i:1;s:14:\"post-type_post\";i:1;s:14:\"post-type_page\";i:1;s:21:\"post-type_wp_template\";i:1;s:15:\"post-type_tb_cf\";i:1;s:25:\"post-type_tbuilder_layout\";i:1;s:30:\"post-type_tbuilder_layout_part\";i:1;s:23:\"post-type_tglobal_style\";i:1;s:19:\"post-type_tbp_theme\";i:1;s:22:\"post-type_tbp_template\";i:1;s:9:\"templates\";s:0:\"\";s:8:\"post-ids\";s:0:\"\";s:12:\"whitelist-id\";s:0:\"\";s:14:\"whitelist-slug\";s:0:\"\";s:15:\"whitelist-title\";s:0:\"\";s:15:\"classic-widgets\";i:1;s:11:\"disable-nag\";i:1;s:13:\"styles-enable\";i:0;s:9:\"whitelist\";i:0;s:9:\"hide-menu\";i:0;s:8:\"hide-gut\";i:0;s:12:\"links-enable\";i:0;s:10:\"acf-enable\";i:0;}","yes"),
("234","cbnetpo_options","a:3:{s:10:\"limit_ping\";s:1:\"1\";s:12:\"limit_number\";s:1:\"1\";s:10:\"limit_time\";s:2:\"15\";}","yes"),
("235","cbnetpo_ping_optimizer","1","no"),
("240","rsssl_activated_plugin","1","yes"),
("241","rlrsssl_options","a:16:{s:12:\"site_has_ssl\";b:1;s:4:\"hsts\";b:0;s:22:\"htaccess_warning_shown\";b:0;s:19:\"review_notice_shown\";b:0;s:25:\"ssl_success_message_shown\";b:0;s:26:\"autoreplace_insecure_links\";b:1;s:17:\"plugin_db_version\";s:5:\"5.3.5\";s:20:\"do_not_edit_htaccess\";b:1;s:17:\"htaccess_redirect\";b:0;s:11:\"ssl_enabled\";b:1;s:19:\"javascript_redirect\";b:0;s:11:\"wp_redirect\";b:1;s:31:\"switch_mixed_content_fixer_hook\";b:0;s:19:\"dismiss_all_notices\";b:1;s:13:\"high_contrast\";b:0;s:21:\"dismiss_review_notice\";b:0;}","yes"),
("242","rsssl_remaining_tasks","1","yes"),
("257","rsssl_current_version","7.1.3","no"),
("260","https_migration_required","","yes"),
("261","rsssl_activation_timestamp","1641682782","yes"),
("272","rsssl_port_check_2082","fail","yes"),
("273","rsssl_port_check_8443","fail","yes"),
("274","rsssl_port_check_2222","fail","yes"),
("304","cerber-main","a:39:{s:9:\"boot-mode\";s:1:\"0\";s:8:\"attempts\";s:1:\"5\";s:6:\"period\";s:2:\"30\";s:7:\"lockout\";s:2:\"60\";s:8:\"agperiod\";s:2:\"24\";s:7:\"aglocks\";s:1:\"2\";s:6:\"aglast\";s:1:\"4\";s:10:\"limitwhite\";s:0:\"\";s:11:\"nologinhint\";s:0:\"\";s:15:\"nologinhint_msg\";s:0:\"\";s:10:\"nopasshint\";s:0:\"\";s:14:\"nopasshint_msg\";s:0:\"\";s:11:\"nologinlang\";s:0:\"\";s:5:\"proxy\";s:0:\"\";s:10:\"cookiepref\";s:0:\"\";s:6:\"subnet\";s:0:\"\";s:8:\"nonusers\";s:1:\"1\";s:7:\"wplogin\";s:1:\"1\";s:10:\"noredirect\";s:1:\"1\";s:7:\"page404\";s:1:\"1\";s:9:\"loginpath\";s:7:\"come-in\";s:9:\"loginnowp\";s:1:\"1\";s:13:\"logindeferred\";s:0:\"\";s:10:\"citadel_on\";s:1:\"1\";s:7:\"cilimit\";s:3:\"200\";s:8:\"ciperiod\";s:2:\"15\";s:10:\"ciduration\";s:2:\"60\";s:8:\"cinotify\";s:1:\"1\";s:7:\"keeplog\";s:2:\"30\";s:12:\"keeplog_auth\";s:2:\"30\";s:8:\"ip_extra\";s:0:\"\";s:9:\"cerberlab\";s:0:\"\";s:11:\"cerberproto\";s:1:\"0\";s:7:\"usefile\";s:0:\"\";s:10:\"dateformat\";s:0:\"\";s:10:\"plain_date\";s:0:\"\";s:10:\"admin_lang\";s:0:\"\";s:14:\"top_admin_menu\";s:0:\"\";s:14:\"no_white_my_ip\";s:0:\"\";}","no"),
("305","cerber-hardening","a:14:{s:8:\"stopenum\";s:1:\"1\";s:15:\"stopenum_oembed\";s:1:\"1\";s:16:\"stopenum_sitemap\";s:1:\"1\";s:8:\"adminphp\";s:0:\"\";s:8:\"phpnoupl\";s:1:\"1\";s:8:\"nophperr\";s:1:\"1\";s:6:\"xmlrpc\";s:0:\"\";s:7:\"nofeeds\";s:0:\"\";s:10:\"norestuser\";s:1:\"1\";s:6:\"norest\";s:1:\"1\";s:8:\"restauth\";s:0:\"\";s:9:\"restroles\";a:1:{i:0;s:13:\"administrator\";}s:9:\"restwhite\";a:2:{i:0;s:6:\"oembed\";i:1;s:14:\"wp-site-health\";}s:9:\"cleanhead\";s:0:\"\";}","no"),
("306","cerber-users","a:19:{s:8:\"authonly\";i:0;s:11:\"authonlyacl\";i:0;s:11:\"authonlymsg\";s:74:\"Nur registrierte und eingeloggte Nutzer dürfen sich diese Website ansehen\";s:13:\"authonlyredir\";s:0:\"\";s:8:\"regwhite\";i:0;s:12:\"regwhite_msg\";s:0:\"\";s:12:\"reglimit_num\";i:3;s:12:\"reglimit_min\";i:60;s:6:\"emrule\";i:0;s:6:\"emlist\";a:0:{}s:10:\"prohibited\";a:0:{}s:7:\"app_pwd\";i:1;s:11:\"auth_expire\";s:0:\"\";s:8:\"usersort\";s:0:\"\";s:11:\"pdata_erase\";i:0;s:14:\"pdata_sessions\";i:0;s:12:\"pdata_export\";i:0;s:9:\"pdata_act\";i:0;s:9:\"pdata_trf\";a:0:{}}","no"),
("307","cerber-antispam","a:11:{s:8:\"botscomm\";s:1:\"1\";s:7:\"botsreg\";s:1:\"0\";s:7:\"botsany\";s:1:\"0\";s:8:\"botssafe\";s:1:\"0\";s:10:\"botsnoauth\";s:1:\"1\";s:11:\"botsipwhite\";s:1:\"1\";s:10:\"customcomm\";s:1:\"0\";s:9:\"botswhite\";a:0:{}s:8:\"spamcomm\";s:1:\"0\";s:10:\"trashafter\";s:1:\"7\";s:18:\"trashafter-enabled\";s:1:\"0\";}","no"),
("308","cerber-recaptcha","a:15:{s:7:\"sitekey\";s:0:\"\";s:9:\"secretkey\";s:0:\"\";s:9:\"invirecap\";s:1:\"0\";s:10:\"recaplogin\";s:1:\"0\";s:9:\"recaplost\";s:1:\"0\";s:8:\"recapreg\";s:1:\"0\";s:13:\"recapwoologin\";s:1:\"0\";s:12:\"recapwoolost\";s:1:\"0\";s:11:\"recapwooreg\";s:1:\"0\";s:8:\"recapcom\";s:1:\"0\";s:12:\"recapcomauth\";s:1:\"0\";s:12:\"recapipwhite\";s:1:\"0\";s:16:\"recaptcha-period\";s:2:\"60\";s:16:\"recaptcha-number\";s:1:\"3\";s:16:\"recaptcha-within\";s:2:\"30\";}","no"),
("309","cerber-notifications","a:26:{s:6:\"notify\";s:0:\"\";s:5:\"above\";s:1:\"3\";s:5:\"email\";a:0:{}s:9:\"emailrate\";s:2:\"12\";s:14:\"notify-new-ver\";s:0:\"\";s:10:\"email_mask\";s:0:\"\";s:12:\"email_format\";s:0:\"\";s:8:\"use_smtp\";s:0:\"\";s:9:\"smtp_host\";s:0:\"\";s:9:\"smtp_port\";s:3:\"587\";s:9:\"smtp_encr\";s:3:\"tls\";s:8:\"smtp_pwd\";s:0:\"\";s:9:\"smtp_user\";s:0:\"\";s:9:\"smtp_from\";s:0:\"\";s:14:\"smtp_from_name\";s:9:\"WP Cerber\";s:7:\"pbtoken\";s:0:\"\";s:8:\"pbdevice\";s:1:\"N\";s:6:\"pbrate\";s:0:\"\";s:8:\"pbnotify\";s:0:\"\";s:16:\"pbnotify-enabled\";s:0:\"\";s:7:\"pb_mask\";s:0:\"\";s:9:\"pb_format\";s:0:\"\";s:12:\"wreports-day\";s:1:\"1\";s:13:\"wreports-time\";s:1:\"9\";s:12:\"email-report\";a:0:{}s:13:\"enable-report\";s:0:\"\";}","no"),
("310","cerber-traffic","a:22:{s:9:\"tienabled\";s:1:\"1\";s:9:\"tiipwhite\";i:0;s:7:\"tiwhite\";s:0:\"\";s:8:\"tierrmon\";s:1:\"1\";s:11:\"tierrnoauth\";i:1;s:6:\"timode\";s:1:\"3\";s:12:\"tilogrestapi\";i:0;s:11:\"tilogxmlrpc\";i:0;s:9:\"tinocrabs\";s:1:\"1\";s:8:\"tinolocs\";a:0:{}s:6:\"tinoua\";a:0:{}s:8:\"tifields\";i:0;s:6:\"timask\";s:0:\"\";s:6:\"tihdrs\";i:0;s:11:\"tihdrs_sent\";i:0;s:6:\"tisenv\";i:0;s:7:\"ticandy\";i:0;s:12:\"ticandy_sent\";i:0;s:8:\"tiphperr\";i:0;s:11:\"tithreshold\";s:0:\"\";s:9:\"tikeeprec\";i:30;s:14:\"tikeeprec_auth\";i:30;}","no"),
("311","cerber-user_shield","a:9:{s:7:\"ds_4acc\";i:0;s:13:\"ds_regs_roles\";a:0:{}s:10:\"ds_add_acc\";a:1:{i:0;s:13:\"administrator\";}s:11:\"ds_edit_acc\";a:1:{i:0;s:13:\"administrator\";}s:11:\"ds_4acc_acl\";i:0;s:9:\"ds_4roles\";i:0;s:11:\"ds_add_role\";a:1:{i:0;s:13:\"administrator\";}s:12:\"ds_edit_role\";a:1:{i:0;s:13:\"administrator\";}s:13:\"ds_4roles_acl\";i:0;}","no"),
("312","cerber-opt_shield","a:4:{s:8:\"ds_4opts\";i:0;s:14:\"ds_4opts_roles\";a:1:{i:0;s:13:\"administrator\";}s:13:\"ds_4opts_list\";a:7:{s:11:\"admin_email\";i:1;s:12:\"default_role\";i:1;s:4:\"home\";i:1;s:7:\"siteurl\";i:1;s:18:\"users_can_register\";i:1;s:14:\"active_plugins\";i:1;s:8:\"template\";i:1;}s:12:\"ds_4opts_acl\";i:0;}","no"),
("313","cerber-scanner","a:10:{s:8:\"scan_cpt\";a:0:{}s:9:\"scan_uext\";a:3:{i:0;s:3:\"tmp\";i:1;s:4:\"temp\";i:2;s:3:\"bak\";}s:12:\"scan_exclude\";a:0:{}s:9:\"scan_inew\";s:1:\"1\";s:9:\"scan_imod\";s:1:\"1\";s:10:\"scan_chmod\";i:0;s:8:\"scan_tmp\";i:0;s:9:\"scan_sess\";i:0;s:10:\"scan_debug\";i:0;s:13:\"scan_qcleanup\";s:2:\"30\";}","no"),
("314","cerber-schedule","a:8:{s:11:\"scan_aquick\";s:1:\"0\";s:10:\"scan_afull\";s:5:\"02:00\";s:18:\"scan_afull-enabled\";s:1:\"0\";s:10:\"scan_reinc\";a:5:{i:3;s:1:\"1\";i:4;s:1:\"1\";i:15;s:1:\"1\";i:50;s:1:\"1\";i:51;s:1:\"1\";}s:12:\"scan_relimit\";s:1:\"3\";s:10:\"scan_isize\";s:1:\"0\";s:12:\"scan_ierrors\";s:1:\"0\";s:10:\"email-scan\";a:0:{}}","no"),
("315","cerber-policies","a:12:{s:13:\"scan_delunatt\";i:0;s:11:\"scan_delupl\";a:0:{}s:14:\"scan_delunwant\";i:0;s:15:\"scan_recover_wp\";i:0;s:15:\"scan_recover_pl\";i:0;s:10:\"scan_media\";i:0;s:15:\"scan_skip_media\";a:14:{i:0;s:3:\"css\";i:1;s:3:\"jpg\";i:2;s:4:\"jpeg\";i:3;s:3:\"jpe\";i:4;s:3:\"gif\";i:5;s:3:\"png\";i:6;s:3:\"bmp\";i:7;s:3:\"tif\";i:8;s:4:\"tiff\";i:9;s:3:\"ico\";i:10;s:4:\"woff\";i:11;s:5:\"woff2\";i:12;s:3:\"eot\";i:13;s:3:\"ttf\";}s:14:\"scan_del_media\";a:5:{i:0;s:3:\"php\";i:1;s:2:\"js\";i:2;s:3:\"htm\";i:3;s:4:\"html\";i:4;s:5:\"shtml\";}s:14:\"scan_nodeltemp\";i:0;s:14:\"scan_nodelsess\";i:0;s:13:\"scan_delexdir\";a:0:{}s:13:\"scan_delexext\";a:0:{}}","no"),
("316","cerber-nexus_master","a:7:{s:13:\"master_tolist\";i:1;s:13:\"master_swshow\";i:1;s:14:\"master_at_site\";i:1;s:13:\"master_locale\";i:0;s:9:\"master_dt\";i:0;s:9:\"master_tz\";i:0;s:11:\"master_diag\";i:0;}","no"),
("317","cerber-nexus-slave","a:3:{s:9:\"slave_ips\";s:0:\"\";s:12:\"slave_access\";i:2;s:10:\"slave_diag\";i:0;}","no"),
("318","_cerber_db_errors","a:7:{i:0;a:3:{i:0;s:69:\"Table \'heshmedia_client_deheshvorlage.come_cerber_sets\' doesn\'t exist\";i:1;s:75:\"SELECT * FROM come_cerber_sets WHERE the_key = \"_nexus_mode\" AND the_id = 0\";i:2;d:1641682969.3778629302978515625;}i:1;a:3:{i:0;s:69:\"Table \'heshmedia_client_deheshvorlage.come_cerber_sets\' doesn\'t exist\";i:1;s:76:\"SELECT * FROM come_cerber_sets WHERE the_key = \"admin_notice\" AND the_id = 0\";i:2;d:1641682969.456715106964111328125;}i:2;a:3:{i:0;s:69:\"Table \'heshmedia_client_deheshvorlage.come_cerber_sets\' doesn\'t exist\";i:1;s:103:\"INSERT INTO come_cerber_sets (the_key, the_id, the_value, expires) VALUES (\"admin_notice\",0,\"a:0:{}\",0)\";i:2;d:1641682969.4568450450897216796875;}i:3;a:3:{i:0;s:69:\"Table \'heshmedia_client_deheshvorlage.come_cerber_sets\' doesn\'t exist\";i:1;s:77:\"SELECT * FROM come_cerber_sets WHERE the_key = \"admin_message\" AND the_id = 0\";i:2;d:1641682969.4569609165191650390625;}i:4;a:3:{i:0;s:69:\"Table \'heshmedia_client_deheshvorlage.come_cerber_sets\' doesn\'t exist\";i:1;s:104:\"INSERT INTO come_cerber_sets (the_key, the_id, the_value, expires) VALUES (\"admin_message\",0,\"a:0:{}\",0)\";i:2;d:1641682969.4570710659027099609375;}i:5;a:3:{i:0;s:69:\"Table \'heshmedia_client_deheshvorlage.come_cerber_sets\' doesn\'t exist\";i:1;s:81:\"SELECT * FROM come_cerber_sets WHERE the_key = \"cerber_admin_wide\" AND the_id = 0\";i:2;d:1641682969.4571850299835205078125;}i:6;a:3:{i:0;s:69:\"Table \'heshmedia_client_deheshvorlage.come_cerber_sets\' doesn\'t exist\";i:1;s:102:\"INSERT INTO come_cerber_sets (the_key, the_id, the_value, expires) VALUES (\"cerber_admin_wide\",0,\"\",0)\";i:2;d:1641682969.457295894622802734375;}}","no"),
("319","cerber-antibot","a:2:{i:0;a:2:{i:0;a:2:{i:0;s:13:\"X-ihpqcPHlmDw\";i:1;s:11:\"FQG]oUWuAK3\";}i:1;a:2:{i:0;s:15:\"WiAenQGx_JLSjVl\";i:1;s:11:\"k8OH[@oLqVb\";}}i:1;a:3:{i:0;a:2:{i:0;s:13:\"CUJx-rKnzGDFl\";i:1;s:12:\"8]XSaMceNO[J\";}i:1;a:2:{i:0;s:11:\"duswfipCBlJ\";i:1;s:13:\"Z9kMWqf8V_n0G\";}i:2;a:2:{i:0;s:12:\"fDZMHkWtSvqw\";i:1;s:8:\"PHqEpmb8\";}}}","no"),
("320","_cerber_up","a:2:{s:1:\"v\";s:3:\"9.0\";s:1:\"t\";i:1676764115;}","no"),
("322","cerber-groove","AJK8zWRtcSBTpI34","no"),
("323","cerber-groove-x","a:2:{i:0;s:32:\"siJQaGZVtyFlBnOpzhkuo6YNUSrxK4E0\";i:1;s:26:\"LZYMT3UWNKz01Aaxkc6E9jl7V5\";}","no"),
("337","auto_update_plugins","a:20:{i:0;s:37:\"tinymce-advanced/tinymce-advanced.php\";i:1;s:29:\"antispam-bee/antispam_bee.php\";i:2;s:32:\"blackhole-bad-bots/blackhole.php\";i:3;s:39:\"disable-gutenberg/disable-gutenberg.php\";i:4;s:47:\"really-simple-ssl/rlrsssl-really-simple-ssl.php\";i:5;s:44:\"shortpixel-image-optimiser/wp-shortpixel.php\";i:6;s:43:\"themify-builder-pro/themify-builder-pro.php\";i:7;s:35:\"themify-updater/themify-updater.php\";i:8;s:49:\"wordpress-ping-optimizer/cbnet-ping-optimizer.php\";i:9;s:33:\"duplicate-post/duplicate-post.php\";i:10;s:24:\"wordpress-seo/wp-seo.php\";i:11;s:27:\"updraftplus/updraftplus.php\";i:12;s:27:\"autoptimize/autoptimize.php\";i:13;s:35:\"wp-fastest-cache/wpFastestCache.php\";i:14;s:24:\"builder-contact/init.php\";i:15;s:57:\"manage-notification-emails/manage-notification-emails.php\";i:16;s:46:\"under-construction-page/under-construction.php\";i:17;s:27:\"wp-cerber-off/wp-cerber.php\";i:25;s:43:\"host-webfonts-local/host-webfonts-local.php\";i:26;s:47:\"host-google-fonts-pro/host-google-fonts-pro.php\";}","no"),
("338","updraftplus_version","1.23.11","yes"),
("339","updraft_updraftvault","a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-9906df79f4a984626024035b57d0b67f\";a:3:{s:5:\"token\";s:0:\"\";s:5:\"email\";s:0:\"\";s:5:\"quota\";i:-1;}}}","yes"),
("340","updraft_dropbox","a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-da1c6c5d9d7a05335262d3febbf2ccd3\";a:4:{s:6:\"appkey\";s:0:\"\";s:6:\"secret\";s:0:\"\";s:6:\"folder\";s:0:\"\";s:15:\"tk_access_token\";s:0:\"\";}}}","yes"),
("341","updraft_s3","a:2:{s:7:\"version\";s:1:\"1\";s:8:\"settings\";a:1:{s:34:\"s-1fa7877c396ff553d864cf266eb1e1cb\";a:3:{s:9:\"accesskey\";s:0:\"\";s:9:\"secretkey\";s:0:\"\";s:4:\"path\";s:0:\"\";}}}","yes"),
("342","updraft_cloudfiles","a:2:{s:7:\"version\";s:1:\"1\";s:8:\"settings\";a:1:{s:34:\"s-e3796d4a4b991af3f4e39220f3f3d96f\";a:5:{s:7:\"authurl\";s:35:\"https://auth.api.rackspacecloud.com\";s:6:\"region\";s:3:\"DFW\";s:4:\"user\";s:0:\"\";s:6:\"apikey\";s:0:\"\";s:4:\"path\";s:0:\"\";}}}","yes"),
("343","updraft_googledrive","a:2:{s:7:\"version\";i:1;s:8:\"settings\";a:1:{s:34:\"s-0fd8d34d253331ed387b212555568929\";a:9:{s:8:\"clientid\";s:0:\"\";s:6:\"secret\";s:0:\"\";s:5:\"token\";s:0:\"\";s:6:\"folder\";s:11:\"UpdraftPlus\";s:7:\"user_id\";s:64:\"668b22f2a426b3cbc84358516ab4bc2c9eb32d24047c9197b14bd7ded82d477f\";s:16:\"tmp_access_token\";a:4:{s:12:\"access_token\";s:221:\"ya29.a0AfB_byAVZnHSb3kPqzfZDuZRpcZyiMKEL6eRRPGFycGpAlEYmplzfnJzVK7Uu3QlqkmWVqMX2xu_jxu07Da6uikGJP-p-z2TEGGvFGNqAxFi6ZN1FX_zzlLdaCVNcpT17CrhlB-acWA_B0cW1cI8ZXxEYUVxBxxBbmhiOOoaCgYKARgSARISFQGOcNnCrffBWMa291daIGXW3agutA0174\";s:7:\"created\";i:1699291768;s:10:\"expires_in\";i:3599;s:13:\"refresh_token\";s:0:\"\";}s:10:\"expires_in\";i:1699295337;s:9:\"ownername\";s:12:\"Dirk Haensch\";s:16:\"instance_enabled\";i:1;}}}","yes"),
("344","updraft_onedrive","a:1:{s:7:\"version\";s:1:\"1\";}","yes"),
("345","updraft_ftp","a:2:{s:7:\"version\";s:1:\"1\";s:8:\"settings\";a:1:{s:34:\"s-ddccfac66011b46a6514176c58f5dedc\";a:5:{s:4:\"host\";s:0:\"\";s:4:\"user\";s:0:\"\";s:4:\"pass\";s:0:\"\";s:4:\"path\";s:0:\"\";s:7:\"passive\";s:1:\"1\";}}}","yes"),
("346","updraft_azure","a:1:{s:7:\"version\";s:1:\"1\";}","yes"),
("347","updraft_sftp","a:1:{s:7:\"version\";s:1:\"1\";}","yes"),
("348","updraft_googlecloud","a:1:{s:7:\"version\";s:1:\"1\";}","yes"),
("349","updraft_backblaze","a:1:{s:7:\"version\";s:1:\"1\";}","yes"),
("350","updraft_webdav","a:1:{s:7:\"version\";s:1:\"1\";}","yes"),
("351","updraft_s3generic","a:2:{s:7:\"version\";s:1:\"1\";s:8:\"settings\";a:1:{s:34:\"s-cd058c060e10953c6a38663a2a4a1934\";a:5:{s:9:\"accesskey\";s:0:\"\";s:9:\"secretkey\";s:0:\"\";s:4:\"path\";s:0:\"\";s:8:\"endpoint\";s:0:\"\";s:19:\"bucket_access_style\";s:10:\"path_style\";}}}","yes"),
("352","updraft_openstack","a:2:{s:7:\"version\";s:1:\"1\";s:8:\"settings\";a:1:{s:34:\"s-d17d21f2f1708f9dab8fb6851f0e52ae\";a:6:{s:7:\"authurl\";s:0:\"\";s:6:\"tenant\";s:0:\"\";s:6:\"region\";s:0:\"\";s:4:\"user\";s:0:\"\";s:8:\"password\";s:0:\"\";s:4:\"path\";s:0:\"\";}}}","yes"),
("353","updraft_dreamobjects","a:2:{s:7:\"version\";s:1:\"1\";s:8:\"settings\";a:1:{s:34:\"s-b6bea378edd2ae584942fdbea96f4186\";a:4:{s:9:\"accesskey\";s:0:\"\";s:9:\"secretkey\";s:0:\"\";s:4:\"path\";s:0:\"\";s:8:\"endpoint\";s:26:\"objects-us-east-1.dream.io\";}}}","yes"),
("354","updraftplus-addons_siteid","7bcd49e29c8d61814c52ff159414db05","no"),
("355","updraftplus_tour_cancelled_on","backup_now","yes"),
("356","updraft_retain_extrarules","a:0:{}","yes"),
("357","updraft_email","","yes"),
("358","updraft_report_warningsonly","a:0:{}","yes"),
("359","updraft_report_wholebackup","a:0:{}","yes"),
("360","updraft_extradbs","a:0:{}","yes"),
("361","updraft_include_more_path","a:0:{}","yes"),
("362","updraft_interval","weekly","yes"),
("363","updraft_retain","2","yes"),
("366","updraft_interval_database","weekly","yes"),
("367","updraft_retain_db","2","yes"),
("368","updraft_service","googledrive","yes"),
("369","updraft_include_plugins","1","yes"),
("370","updraft_include_themes","1","yes"),
("371","updraft_include_uploads","1","yes"),
("372","updraft_include_uploads_exclude","backup*,*backups,backwpup*,wp-clone,snapshots","yes"),
("373","updraft_include_others","1","yes"),
("374","updraft_include_others_exclude","upgrade,cache,updraft,backup*,*backups,mysql.sql,debug.log","yes"),
("375","updraft_split_every","400","yes"),
("376","updraft_delete_local","1","yes"),
("377","updraft_dir","updraft","yes"),
("378","updraft_debug_mode","0","yes"),
("379","updraft_ssl_useservercerts","0","yes"),
("380","updraft_ssl_disableverify","0","yes"),
("381","updraft_ssl_nossl","0","yes"),
("388","yoast_migrations_free","a:1:{s:7:\"version\";s:4:\"21.5\";}","yes"),
("389","wpseo","a:109:{s:8:\"tracking\";b:0;s:16:\"toggled_tracking\";b:0;s:22:\"license_server_version\";b:0;s:15:\"ms_defaults_set\";b:0;s:40:\"ignore_search_engines_discouraged_notice\";b:1;s:19:\"indexing_first_time\";b:0;s:16:\"indexing_started\";b:0;s:15:\"indexing_reason\";s:23:\"home_url_option_changed\";s:29:\"indexables_indexing_completed\";b:1;s:13:\"index_now_key\";s:0:\"\";s:7:\"version\";s:4:\"21.5\";s:16:\"previous_version\";s:4:\"21.4\";s:20:\"disableadvanced_meta\";b:1;s:30:\"enable_headless_rest_endpoints\";b:1;s:17:\"ryte_indexability\";b:0;s:11:\"baiduverify\";s:0:\"\";s:12:\"googleverify\";s:0:\"\";s:8:\"msverify\";s:0:\"\";s:12:\"yandexverify\";s:0:\"\";s:9:\"site_type\";s:0:\"\";s:20:\"has_multiple_authors\";s:0:\"\";s:16:\"environment_type\";s:0:\"\";s:23:\"content_analysis_active\";b:1;s:23:\"keyword_analysis_active\";b:1;s:34:\"inclusive_language_analysis_active\";b:0;s:21:\"enable_admin_bar_menu\";b:1;s:26:\"enable_cornerstone_content\";b:1;s:18:\"enable_xml_sitemap\";b:1;s:24:\"enable_text_link_counter\";b:1;s:16:\"enable_index_now\";b:1;s:19:\"enable_ai_generator\";b:0;s:22:\"show_onboarding_notice\";b:1;s:18:\"first_activated_on\";i:1640769809;s:13:\"myyoast-oauth\";b:0;s:26:\"semrush_integration_active\";b:1;s:14:\"semrush_tokens\";a:0:{}s:20:\"semrush_country_code\";s:2:\"us\";s:19:\"permalink_structure\";s:12:\"/%postname%/\";s:8:\"home_url\";s:38:\"https://sparkway-client.de/sparkgarten\";s:18:\"dynamic_permalinks\";b:0;s:17:\"category_base_url\";s:0:\"\";s:12:\"tag_base_url\";s:0:\"\";s:21:\"custom_taxonomy_slugs\";a:0:{}s:29:\"enable_enhanced_slack_sharing\";b:1;s:25:\"zapier_integration_active\";b:0;s:19:\"zapier_subscription\";a:0:{}s:14:\"zapier_api_key\";s:0:\"\";s:23:\"enable_metabox_insights\";b:0;s:23:\"enable_link_suggestions\";b:1;s:26:\"algolia_integration_active\";b:0;s:14:\"import_cursors\";a:0:{}s:13:\"workouts_data\";a:1:{s:13:\"configuration\";a:1:{s:13:\"finishedSteps\";a:0:{}}}s:28:\"configuration_finished_steps\";a:0:{}s:36:\"dismiss_configuration_workout_notice\";b:0;s:34:\"dismiss_premium_deactivated_notice\";b:0;s:19:\"importing_completed\";a:0:{}s:26:\"wincher_integration_active\";b:1;s:14:\"wincher_tokens\";a:0:{}s:36:\"wincher_automatically_add_keyphrases\";b:0;s:18:\"wincher_website_id\";s:0:\"\";s:28:\"wordproof_integration_active\";b:0;s:29:\"wordproof_integration_changed\";b:0;s:18:\"first_time_install\";b:0;s:34:\"should_redirect_after_install_free\";b:0;s:34:\"activation_redirect_timestamp_free\";i:1652258756;s:18:\"remove_feed_global\";b:0;s:27:\"remove_feed_global_comments\";b:0;s:25:\"remove_feed_post_comments\";b:0;s:19:\"remove_feed_authors\";b:0;s:22:\"remove_feed_categories\";b:0;s:16:\"remove_feed_tags\";b:0;s:29:\"remove_feed_custom_taxonomies\";b:0;s:22:\"remove_feed_post_types\";b:0;s:18:\"remove_feed_search\";b:0;s:21:\"remove_atom_rdf_feeds\";b:0;s:17:\"remove_shortlinks\";b:0;s:21:\"remove_rest_api_links\";b:0;s:20:\"remove_rsd_wlw_links\";b:0;s:19:\"remove_oembed_links\";b:0;s:16:\"remove_generator\";b:0;s:20:\"remove_emoji_scripts\";b:0;s:24:\"remove_powered_by_header\";b:0;s:22:\"remove_pingback_header\";b:0;s:28:\"clean_campaign_tracking_urls\";b:0;s:16:\"clean_permalinks\";b:0;s:32:\"clean_permalinks_extra_variables\";s:0:\"\";s:14:\"search_cleanup\";b:0;s:20:\"search_cleanup_emoji\";b:0;s:23:\"search_cleanup_patterns\";b:0;s:22:\"search_character_limit\";i:50;s:20:\"deny_search_crawling\";b:0;s:21:\"deny_wp_json_crawling\";b:0;s:20:\"deny_adsbot_crawling\";b:0;s:19:\"deny_ccbot_crawling\";b:0;s:29:\"deny_google_extended_crawling\";b:0;s:20:\"deny_gptbot_crawling\";b:0;s:27:\"redirect_search_pretty_urls\";b:0;s:29:\"least_readability_ignore_list\";a:0:{}s:27:\"least_seo_score_ignore_list\";a:0:{}s:23:\"most_linked_ignore_list\";a:0:{}s:24:\"least_linked_ignore_list\";a:0:{}s:28:\"indexables_page_reading_list\";a:5:{i:0;b:0;i:1;b:0;i:2;b:0;i:3;b:0;i:4;b:0;}s:25:\"indexables_overview_state\";s:21:\"dashboard-not-visited\";s:28:\"last_known_public_post_types\";a:5:{i:0;s:4:\"post\";i:1;s:4:\"page\";i:2;s:15:\"tbuilder_layout\";i:3;s:20:\"tbuilder_layout_part\";i:4;s:13:\"tglobal_style\";}s:28:\"last_known_public_taxonomies\";a:3:{i:0;s:8:\"category\";i:1;s:8:\"post_tag\";i:2;s:11:\"post_format\";}s:23:\"last_known_no_unindexed\";a:5:{s:27:\"wpseo_total_unindexed_terms\";i:1698176940;s:40:\"wpseo_total_unindexed_post_type_archives\";i:1699291732;s:35:\"wpseo_total_unindexed_general_items\";i:1699291732;s:31:\"wpseo_unindexed_post_link_count\";i:1699291732;s:31:\"wpseo_unindexed_term_link_count\";i:1699291732;}s:14:\"new_post_types\";a:0:{}s:14:\"new_taxonomies\";a:0:{}s:34:\"show_new_content_type_notification\";b:0;}","yes"),
("390","wpseo_titles","a:139:{s:17:\"forcerewritetitle\";b:0;s:9:\"separator\";s:7:\"sc-dash\";s:16:\"title-home-wpseo\";s:42:\"%%sitename%% %%page%% %%sep%% %%sitedesc%%\";s:18:\"title-author-wpseo\";s:41:\"%%name%%, Autor bei %%sitename%% %%page%%\";s:19:\"title-archive-wpseo\";s:38:\"%%date%% %%page%% %%sep%% %%sitename%%\";s:18:\"title-search-wpseo\";s:67:\"Du hast nach %%searchphrase%% gesucht %%page%% %%sep%% %%sitename%%\";s:15:\"title-404-wpseo\";s:48:\"Seite wurde nicht gefunden. %%sep%% %%sitename%%\";s:25:\"social-title-author-wpseo\";s:8:\"%%name%%\";s:26:\"social-title-archive-wpseo\";s:8:\"%%date%%\";s:31:\"social-description-author-wpseo\";s:0:\"\";s:32:\"social-description-archive-wpseo\";s:0:\"\";s:29:\"social-image-url-author-wpseo\";s:0:\"\";s:30:\"social-image-url-archive-wpseo\";s:0:\"\";s:28:\"social-image-id-author-wpseo\";i:0;s:29:\"social-image-id-archive-wpseo\";i:0;s:19:\"metadesc-home-wpseo\";s:0:\"\";s:21:\"metadesc-author-wpseo\";s:0:\"\";s:22:\"metadesc-archive-wpseo\";s:0:\"\";s:9:\"rssbefore\";s:0:\"\";s:8:\"rssafter\";s:58:\"Der Beitrag %%POSTLINK%% erschien zuerst auf %%BLOGLINK%%.\";s:20:\"noindex-author-wpseo\";b:0;s:28:\"noindex-author-noposts-wpseo\";b:1;s:21:\"noindex-archive-wpseo\";b:1;s:14:\"disable-author\";b:0;s:12:\"disable-date\";b:0;s:19:\"disable-post_format\";b:0;s:18:\"disable-attachment\";b:1;s:20:\"breadcrumbs-404crumb\";s:38:\"Fehler 404: Seite wurde nicht gefunden\";s:29:\"breadcrumbs-display-blog-page\";b:1;s:20:\"breadcrumbs-boldlast\";b:0;s:25:\"breadcrumbs-archiveprefix\";s:12:\"Archive für\";s:18:\"breadcrumbs-enable\";b:1;s:16:\"breadcrumbs-home\";s:10:\"Startseite\";s:18:\"breadcrumbs-prefix\";s:0:\"\";s:24:\"breadcrumbs-searchprefix\";s:16:\"Du suchtest nach\";s:15:\"breadcrumbs-sep\";s:7:\"&raquo;\";s:12:\"website_name\";s:0:\"\";s:11:\"person_name\";s:0:\"\";s:11:\"person_logo\";s:0:\"\";s:22:\"alternate_website_name\";s:0:\"\";s:12:\"company_logo\";s:0:\"\";s:12:\"company_name\";s:0:\"\";s:17:\"company_or_person\";s:7:\"company\";s:25:\"company_or_person_user_id\";b:0;s:17:\"stripcategorybase\";b:0;s:26:\"open_graph_frontpage_title\";s:12:\"%%sitename%%\";s:25:\"open_graph_frontpage_desc\";s:0:\"\";s:26:\"open_graph_frontpage_image\";s:0:\"\";s:10:\"title-post\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:13:\"metadesc-post\";s:0:\"\";s:12:\"noindex-post\";b:0;s:23:\"display-metabox-pt-post\";b:1;s:23:\"post_types-post-maintax\";i:0;s:21:\"schema-page-type-post\";s:7:\"WebPage\";s:24:\"schema-article-type-post\";s:7:\"Article\";s:17:\"social-title-post\";s:9:\"%%title%%\";s:23:\"social-description-post\";s:0:\"\";s:21:\"social-image-url-post\";s:0:\"\";s:20:\"social-image-id-post\";i:0;s:10:\"title-page\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:13:\"metadesc-page\";s:0:\"\";s:12:\"noindex-page\";b:0;s:23:\"display-metabox-pt-page\";b:1;s:23:\"post_types-page-maintax\";i:0;s:21:\"schema-page-type-page\";s:7:\"WebPage\";s:24:\"schema-article-type-page\";s:4:\"None\";s:17:\"social-title-page\";s:9:\"%%title%%\";s:23:\"social-description-page\";s:0:\"\";s:21:\"social-image-url-page\";s:0:\"\";s:20:\"social-image-id-page\";i:0;s:16:\"title-attachment\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:19:\"metadesc-attachment\";s:0:\"\";s:18:\"noindex-attachment\";b:0;s:29:\"display-metabox-pt-attachment\";b:1;s:29:\"post_types-attachment-maintax\";i:0;s:27:\"schema-page-type-attachment\";s:7:\"WebPage\";s:30:\"schema-article-type-attachment\";s:4:\"None\";s:21:\"title-tbuilder_layout\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:24:\"metadesc-tbuilder_layout\";s:0:\"\";s:23:\"noindex-tbuilder_layout\";b:0;s:34:\"display-metabox-pt-tbuilder_layout\";b:1;s:34:\"post_types-tbuilder_layout-maintax\";i:0;s:32:\"schema-page-type-tbuilder_layout\";s:7:\"WebPage\";s:35:\"schema-article-type-tbuilder_layout\";s:4:\"None\";s:28:\"social-title-tbuilder_layout\";s:9:\"%%title%%\";s:34:\"social-description-tbuilder_layout\";s:0:\"\";s:32:\"social-image-url-tbuilder_layout\";s:0:\"\";s:31:\"social-image-id-tbuilder_layout\";i:0;s:26:\"title-tbuilder_layout_part\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:29:\"metadesc-tbuilder_layout_part\";s:0:\"\";s:28:\"noindex-tbuilder_layout_part\";b:0;s:39:\"display-metabox-pt-tbuilder_layout_part\";b:1;s:39:\"post_types-tbuilder_layout_part-maintax\";i:0;s:37:\"schema-page-type-tbuilder_layout_part\";s:7:\"WebPage\";s:40:\"schema-article-type-tbuilder_layout_part\";s:4:\"None\";s:33:\"social-title-tbuilder_layout_part\";s:9:\"%%title%%\";s:39:\"social-description-tbuilder_layout_part\";s:0:\"\";s:37:\"social-image-url-tbuilder_layout_part\";s:0:\"\";s:36:\"social-image-id-tbuilder_layout_part\";i:0;s:19:\"title-tglobal_style\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:22:\"metadesc-tglobal_style\";s:0:\"\";s:21:\"noindex-tglobal_style\";b:0;s:32:\"display-metabox-pt-tglobal_style\";b:1;s:32:\"post_types-tglobal_style-maintax\";i:0;s:30:\"schema-page-type-tglobal_style\";s:7:\"WebPage\";s:33:\"schema-article-type-tglobal_style\";s:4:\"None\";s:26:\"social-title-tglobal_style\";s:9:\"%%title%%\";s:32:\"social-description-tglobal_style\";s:0:\"\";s:30:\"social-image-url-tglobal_style\";s:0:\"\";s:29:\"social-image-id-tglobal_style\";i:0;s:18:\"title-tax-category\";s:52:\"%%term_title%% Archive %%page%% %%sep%% %%sitename%%\";s:21:\"metadesc-tax-category\";s:0:\"\";s:28:\"display-metabox-tax-category\";b:1;s:20:\"noindex-tax-category\";b:0;s:25:\"social-title-tax-category\";s:22:\"%%term_title%% Archive\";s:31:\"social-description-tax-category\";s:0:\"\";s:29:\"social-image-url-tax-category\";s:0:\"\";s:28:\"social-image-id-tax-category\";i:0;s:18:\"title-tax-post_tag\";s:52:\"%%term_title%% Archive %%page%% %%sep%% %%sitename%%\";s:21:\"metadesc-tax-post_tag\";s:0:\"\";s:28:\"display-metabox-tax-post_tag\";b:1;s:20:\"noindex-tax-post_tag\";b:0;s:25:\"social-title-tax-post_tag\";s:22:\"%%term_title%% Archive\";s:31:\"social-description-tax-post_tag\";s:0:\"\";s:29:\"social-image-url-tax-post_tag\";s:0:\"\";s:28:\"social-image-id-tax-post_tag\";i:0;s:21:\"title-tax-post_format\";s:52:\"%%term_title%% Archive %%page%% %%sep%% %%sitename%%\";s:24:\"metadesc-tax-post_format\";s:0:\"\";s:31:\"display-metabox-tax-post_format\";b:1;s:23:\"noindex-tax-post_format\";b:1;s:28:\"social-title-tax-post_format\";s:22:\"%%term_title%% Archive\";s:34:\"social-description-tax-post_format\";s:0:\"\";s:32:\"social-image-url-tax-post_format\";s:0:\"\";s:31:\"social-image-id-tax-post_format\";i:0;s:14:\"person_logo_id\";i:0;s:15:\"company_logo_id\";i:0;s:17:\"company_logo_meta\";b:0;s:16:\"person_logo_meta\";b:0;s:29:\"open_graph_frontpage_image_id\";i:0;}","yes"),
("391","wpseo_social","a:18:{s:13:\"facebook_site\";s:0:\"\";s:13:\"instagram_url\";s:0:\"\";s:12:\"linkedin_url\";s:0:\"\";s:11:\"myspace_url\";s:0:\"\";s:16:\"og_default_image\";s:0:\"\";s:19:\"og_default_image_id\";s:0:\"\";s:18:\"og_frontpage_title\";s:0:\"\";s:17:\"og_frontpage_desc\";s:0:\"\";s:18:\"og_frontpage_image\";s:0:\"\";s:21:\"og_frontpage_image_id\";s:0:\"\";s:9:\"opengraph\";b:1;s:13:\"pinterest_url\";s:0:\"\";s:15:\"pinterestverify\";s:0:\"\";s:7:\"twitter\";b:1;s:12:\"twitter_site\";s:0:\"\";s:17:\"twitter_card_type\";s:19:\"summary_large_image\";s:11:\"youtube_url\";s:0:\"\";s:13:\"wikipedia_url\";s:0:\"\";}","yes"),
("414","wpseo_ryte","a:2:{s:6:\"status\";i:0;s:10:\"last_fetch\";i:1648824830;}","yes"),
("452","duplicate_post_copytitle","1","yes"),
("453","duplicate_post_copydate","0","yes"),
("454","duplicate_post_copystatus","0","yes"),
("455","duplicate_post_copyslug","0","yes"),
("456","duplicate_post_copyexcerpt","1","yes"),
("457","duplicate_post_copycontent","1","yes"),
("458","duplicate_post_copythumbnail","1","yes"),
("459","duplicate_post_copytemplate","1","yes"),
("460","duplicate_post_copyformat","1","yes"),
("461","duplicate_post_copyauthor","0","yes"),
("462","duplicate_post_copypassword","0","yes"),
("463","duplicate_post_copyattachments","0","yes"),
("464","duplicate_post_copychildren","0","yes"),
("465","duplicate_post_copycomments","0","yes"),
("466","duplicate_post_copymenuorder","1","yes"),
("467","duplicate_post_taxonomies_blacklist","a:0:{}","yes"),
("468","duplicate_post_blacklist","","yes"),
("469","duplicate_post_types_enabled","a:2:{i:0;s:4:\"post\";i:1;s:4:\"page\";}","yes"),
("470","duplicate_post_show_original_column","0","yes"),
("471","duplicate_post_show_original_in_post_states","0","yes"),
("472","duplicate_post_show_original_meta_box","0","yes"),
("473","duplicate_post_show_link","a:3:{s:9:\"new_draft\";s:1:\"1\";s:5:\"clone\";s:1:\"1\";s:17:\"rewrite_republish\";s:1:\"1\";}","yes"),
("474","duplicate_post_show_link_in","a:4:{s:3:\"row\";s:1:\"1\";s:8:\"adminbar\";s:1:\"1\";s:9:\"submitbox\";s:1:\"1\";s:11:\"bulkactions\";s:1:\"1\";}","yes"),
("475","duplicate_post_show_notice","0","no"),
("502","updraft_task_manager_dbversion","1.1","yes"),
("524","updraft_lastmessage","The backup succeeded and is now complete (Nov 06 18:30:27)","yes"),
("525","updraftplus_unlocked_fd","1","no"),
("526","updraftplus_last_lock_time_fd","2023-11-06 17:29:17","no"),
("527","updraftplus_semaphore_fd","0","no"),
("528","updraft_last_scheduled_fd","1699291757","yes"),
("530","updraft_backup_history","a:2:{i:1699291757;a:19:{s:7:\"plugins\";a:1:{i:0;s:66:\"backup_2023-11-06-1829_Garten_Hecke_Rasen_f8d9ced298ae-plugins.zip\";}s:12:\"plugins-size\";i:31641188;s:6:\"themes\";a:1:{i:0;s:65:\"backup_2023-11-06-1829_Garten_Hecke_Rasen_f8d9ced298ae-themes.zip\";}s:11:\"themes-size\";i:15144700;s:7:\"uploads\";a:1:{i:0;s:66:\"backup_2023-11-06-1829_Garten_Hecke_Rasen_f8d9ced298ae-uploads.zip\";}s:12:\"uploads-size\";i:29089104;s:6:\"others\";a:1:{i:0;s:65:\"backup_2023-11-06-1829_Garten_Hecke_Rasen_f8d9ced298ae-others.zip\";}s:11:\"others-size\";i:15089592;s:2:\"db\";s:60:\"backup_2023-11-06-1829_Garten_Hecke_Rasen_f8d9ced298ae-db.gz\";s:7:\"db-size\";i:93238;s:9:\"checksums\";a:2:{s:4:\"sha1\";a:5:{s:8:\"plugins0\";s:40:\"47765689a4455412dc0cd9c6955587ee2a249aae\";s:7:\"themes0\";s:40:\"b2a0d4c91c15970b5f52911089b7d45968821b72\";s:8:\"uploads0\";s:40:\"c65249a87dba062323145cd6673bc55458051b47\";s:7:\"others0\";s:40:\"bb8ed7640d4b0a3cad3c8f705fbf74252292a2de\";s:3:\"db0\";s:40:\"854c2b22c2c4050c13855af6cae63855b9fb8352\";}s:6:\"sha256\";a:5:{s:8:\"plugins0\";s:64:\"7059a9843d0319fd9b0e8dd4f6273d0212243b252817c26849e458b8d718a042\";s:7:\"themes0\";s:64:\"ef41cc3f0f64111e8b577ef0fa1a87240a2c081a1768a462166a88aceb58d997\";s:8:\"uploads0\";s:64:\"ea84c4ecd170c48530de075585a24ece7d97b915117e581d2bf8b814dc15a6e2\";s:7:\"others0\";s:64:\"205c07144e246a2cfad170d3d3ec7fe03cc6f2e22821c92506a21d74701c640b\";s:3:\"db0\";s:64:\"70c9853a6d2150e382dbcd3b8555cb4a17f5e03562e9ab41db9e6fd0eca928eb\";}}s:5:\"nonce\";s:12:\"f8d9ced298ae\";s:7:\"service\";a:1:{i:0;s:11:\"googledrive\";}s:20:\"service_instance_ids\";a:1:{s:11:\"googledrive\";a:1:{i:0;s:34:\"s-0fd8d34d253331ed387b212555568929\";}}s:11:\"always_keep\";b:0;s:19:\"files_enumerated_at\";a:4:{s:7:\"plugins\";i:1699291757;s:6:\"themes\";i:1699291773;s:7:\"uploads\";i:1699291780;s:6:\"others\";i:1699291785;}s:18:\"created_by_version\";s:7:\"1.23.10\";s:21:\"last_saved_by_version\";s:7:\"1.23.10\";s:12:\"is_multisite\";b:0;}i:1698176497;a:19:{s:7:\"plugins\";a:1:{i:0;s:66:\"backup_2023-10-24-2141_Garten_Hecke_Rasen_7d5d0656a49a-plugins.zip\";}s:12:\"plugins-size\";i:33022318;s:6:\"themes\";a:1:{i:0;s:65:\"backup_2023-10-24-2141_Garten_Hecke_Rasen_7d5d0656a49a-themes.zip\";}s:11:\"themes-size\";i:14854701;s:7:\"uploads\";a:1:{i:0;s:66:\"backup_2023-10-24-2141_Garten_Hecke_Rasen_7d5d0656a49a-uploads.zip\";}s:12:\"uploads-size\";i:29125202;s:6:\"others\";a:1:{i:0;s:65:\"backup_2023-10-24-2141_Garten_Hecke_Rasen_7d5d0656a49a-others.zip\";}s:11:\"others-size\";i:1494881;s:2:\"db\";s:60:\"backup_2023-10-24-2141_Garten_Hecke_Rasen_7d5d0656a49a-db.gz\";s:7:\"db-size\";i:102257;s:9:\"checksums\";a:2:{s:4:\"sha1\";a:5:{s:8:\"plugins0\";s:40:\"1547513b31ab42655eead284f3c024f12c74ae87\";s:7:\"themes0\";s:40:\"680d66c6a7c944f746ca57f914583a898a63dca8\";s:8:\"uploads0\";s:40:\"a7b9b3ab0a5ec62fb743e9593cc6766c475a2397\";s:7:\"others0\";s:40:\"822ea9a4b32504016040d286fdb9d9bb7c5a7f68\";s:3:\"db0\";s:40:\"9cdea2c1a38d00369592602753129cdfa18fc5ad\";}s:6:\"sha256\";a:5:{s:8:\"plugins0\";s:64:\"31773d6ab4b870ededbcd45f67932d83ec8b3ce250199201479bfc1a04c6dacb\";s:7:\"themes0\";s:64:\"99843b7a1849911c63a50acbb727a09fd55d424d3cb8acfb0c36c52bd4742c60\";s:8:\"uploads0\";s:64:\"39d719cc68d7e11f52b5a08cb268b087e8ca3ad687b116f5d9322ae3e86c175c\";s:7:\"others0\";s:64:\"b79a1d77391c3e37f8e9ca95252e0494f83f144be3a81d57cf3d40ae105faf8b\";s:3:\"db0\";s:64:\"f503d50b48079511a79b871436e64aa6ab57090df6c552c50cd529c1d06eab37\";}}s:5:\"nonce\";s:12:\"7d5d0656a49a\";s:7:\"service\";a:1:{i:0;s:11:\"googledrive\";}s:20:\"service_instance_ids\";a:1:{s:11:\"googledrive\";a:1:{i:0;s:34:\"s-0fd8d34d253331ed387b212555568929\";}}s:11:\"always_keep\";b:0;s:19:\"files_enumerated_at\";a:4:{s:7:\"plugins\";i:1698176497;s:6:\"themes\";i:1698176517;s:7:\"uploads\";i:1698176526;s:6:\"others\";i:1698176532;}s:18:\"created_by_version\";s:7:\"1.23.10\";s:21:\"last_saved_by_version\";s:7:\"1.23.10\";s:12:\"is_multisite\";b:0;}}","no"),
("531","updraft_last_backup","a:6:{s:26:\"nonincremental_backup_time\";i:1699291757;s:11:\"backup_time\";i:1699291757;s:12:\"backup_array\";a:11:{s:7:\"plugins\";a:1:{i:0;s:66:\"backup_2023-11-06-1829_Garten_Hecke_Rasen_f8d9ced298ae-plugins.zip\";}s:12:\"plugins-size\";i:31641188;s:6:\"themes\";a:1:{i:0;s:65:\"backup_2023-11-06-1829_Garten_Hecke_Rasen_f8d9ced298ae-themes.zip\";}s:11:\"themes-size\";i:15144700;s:7:\"uploads\";a:1:{i:0;s:66:\"backup_2023-11-06-1829_Garten_Hecke_Rasen_f8d9ced298ae-uploads.zip\";}s:12:\"uploads-size\";i:29089104;s:6:\"others\";a:1:{i:0;s:65:\"backup_2023-11-06-1829_Garten_Hecke_Rasen_f8d9ced298ae-others.zip\";}s:11:\"others-size\";i:15089592;s:2:\"db\";s:60:\"backup_2023-11-06-1829_Garten_Hecke_Rasen_f8d9ced298ae-db.gz\";s:7:\"db-size\";i:93238;s:9:\"checksums\";a:2:{s:4:\"sha1\";a:5:{s:8:\"plugins0\";s:40:\"47765689a4455412dc0cd9c6955587ee2a249aae\";s:7:\"themes0\";s:40:\"b2a0d4c91c15970b5f52911089b7d45968821b72\";s:8:\"uploads0\";s:40:\"c65249a87dba062323145cd6673bc55458051b47\";s:7:\"others0\";s:40:\"bb8ed7640d4b0a3cad3c8f705fbf74252292a2de\";s:3:\"db0\";s:40:\"854c2b22c2c4050c13855af6cae63855b9fb8352\";}s:6:\"sha256\";a:5:{s:8:\"plugins0\";s:64:\"7059a9843d0319fd9b0e8dd4f6273d0212243b252817c26849e458b8d718a042\";s:7:\"themes0\";s:64:\"ef41cc3f0f64111e8b577ef0fa1a87240a2c081a1768a462166a88aceb58d997\";s:8:\"uploads0\";s:64:\"ea84c4ecd170c48530de075585a24ece7d97b915117e581d2bf8b814dc15a6e2\";s:7:\"others0\";s:64:\"205c07144e246a2cfad170d3d3ec7fe03cc6f2e22821c92506a21d74701c640b\";s:3:\"db0\";s:64:\"70c9853a6d2150e382dbcd3b8555cb4a17f5e03562e9ab41db9e6fd0eca928eb\";}}}s:7:\"success\";i:1;s:6:\"errors\";a:0:{}s:12:\"backup_nonce\";s:12:\"f8d9ced298ae\";}","yes"),
("537","themify_customizer","advanced","no"),
("563","duplicator_pro_license_key","activated","yes"),
("565","duplicator_pro_reset_user_settings_required","0","yes"),
("637","wp_statistics","a:86:{s:9:\"robotlist\";s:1888:\"007ac9\r\n5bot\r\nA6-Indexer\r\nAbachoBOT\r\naccoona\r\nAcoiRobot\r\nAddThis.com\r\nADmantX\r\nAdsBot-Google\r\nadvbot\r\nAhrefsBot\r\naiHitBot\r\nalexa\r\nalphabot\r\nAltaVista\r\nAntivirusPro\r\nanyevent\r\nappie\r\nApplebot\r\narchive.org_bot\r\nAsk Jeeves\r\nASPSeek\r\nBaiduspider\r\nBenjojo\r\nBeetleBot\r\nbingbot\r\nBlekkobot\r\nblexbot\r\nBOT for JCE\r\nbubing\r\nButterfly\r\ncbot\r\nclamantivirus\r\ncliqzbot\r\nclumboot\r\ncoccoc\r\ncrawler\r\nCrocCrawler\r\ncrowsnest.tv\r\ndbot\r\ndl2bot\r\ndotbot\r\ndownloadbot\r\nduckduckgo\r\nDumbot\r\nEasouSpider\r\neStyle\r\nEveryoneSocialBot\r\nExabot\r\nezooms\r\nfacebook.com\r\nfacebookexternalhit\r\nFAST\r\nFeedfetcher-Google\r\nfeedzirra\r\nfindxbot\r\nFirfly\r\nFriendFeedBot\r\nfroogle\r\nGeonaBot\r\nGigabot\r\ngirafabot\r\ngimme60bot\r\nglbot\r\nGooglebot\r\nGroupHigh\r\nia_archiver\r\nIDBot\r\nInfoSeek\r\ninktomi\r\nIstellaBot\r\njetmon\r\nKraken\r\nLeikibot\r\nlinkapediabot\r\nlinkdexbot\r\nLinkpadBot\r\nLoadTimeBot\r\nlooksmart\r\nltx71\r\nLycos\r\nMail.RU_Bot\r\nMe.dium\r\nmeanpathbot\r\nmediabot\r\nmedialbot\r\nMediapartners-Google\r\nMJ12bot\r\nmsnbot\r\nMojeekBot\r\nmonobot\r\nmoreover\r\nMRBOT\r\nNationalDirectory\r\nNerdyBot\r\nNetcraftSurveyAgent\r\nniki-bot\r\nnutch\r\nOpenbot\r\nOrangeBot\r\nowler\r\np4Bot\r\nPaperLiBot\r\npageanalyzer\r\nPagesInventory\r\nPimonster\r\nporkbun\r\npr-cy\r\nproximic\r\npwbot\r\nr4bot\r\nrabaz\r\nRambler\r\nRankivabot\r\nrevip\r\nriddler\r\nrogerbot\r\nScooter\r\nScrubby\r\nscrapy.org\r\nSearchmetricsBot\r\nsees.co\r\nSemanticBot\r\nSemrushBot\r\nSeznamBot\r\nsfFeedReader\r\nshareaholic-bot\r\nsistrix\r\nSiteExplorer\r\nSlurp\r\nSocialradarbot\r\nSocialSearch\r\nSogou web spider\r\nSpade\r\nspbot\r\nSpiderLing\r\nSputnikBot\r\nSuperfeedr\r\nSurveyBot\r\nTechnoratiSnoop\r\nTECNOSEEK\r\nTeoma\r\ntrendictionbot\r\nTweetmemeBot\r\nTwiceler\r\nTwitterbot\r\nTwitturls\r\nu2bot\r\nuMBot-LN\r\nuni5download\r\nunrulymedia\r\nUptimeRobot\r\nURL_Spider_SQL\r\nVagabondo\r\nvBSEO\r\nWASALive-Bot\r\nWebAlta Crawler\r\nWebBug\r\nWebFindBot\r\nWebMasterAid\r\nWeSEE\r\nWotbox\r\nwsowner\r\nwsr-agent\r\nwww.galaxy.com\r\nx100bot\r\nXoviBot\r\nxzybot\r\nyandex\r\nYahoo\r\nYammybot\r\nYoudaoBot\r\nZyBorg\r\nZemlyaCrawl\";s:13:\"anonymize_ips\";s:0:\"\";s:5:\"geoip\";s:0:\"\";s:10:\"useronline\";s:1:\"1\";s:6:\"visits\";s:1:\"1\";s:8:\"visitors\";s:1:\"1\";s:5:\"pages\";s:1:\"1\";s:12:\"check_online\";s:3:\"120\";s:8:\"menu_bar\";s:1:\"0\";s:11:\"coefficient\";s:1:\"1\";s:12:\"stats_report\";s:0:\"\";s:11:\"time_report\";s:5:\"daily\";s:11:\"send_report\";s:4:\"mail\";s:14:\"content_report\";s:0:\"\";s:12:\"update_geoip\";s:0:\"\";s:8:\"store_ua\";s:0:\"\";s:21:\"exclude_administrator\";s:1:\"1\";s:18:\"disable_se_clearch\";s:1:\"1\";s:16:\"disable_se_qwant\";s:1:\"1\";s:16:\"disable_se_baidu\";s:1:\"1\";s:14:\"disable_se_ask\";s:1:\"1\";s:8:\"map_type\";s:6:\"jqvmap\";s:18:\"force_robot_update\";s:1:\"1\";s:9:\"ip_method\";s:11:\"REMOTE_ADDR\";s:17:\"exclude_loginpage\";s:1:\"1\";s:12:\"exclude_404s\";s:1:\"1\";s:13:\"exclude_feeds\";s:1:\"1\";s:15:\"disable_se_bing\";s:0:\"\";s:21:\"disable_se_duckduckgo\";s:0:\"\";s:17:\"disable_se_google\";s:0:\"\";s:16:\"disable_se_yahoo\";s:0:\"\";s:17:\"disable_se_yandex\";s:0:\"\";s:12:\"visitors_log\";s:0:\"\";s:18:\"enable_user_column\";s:0:\"\";s:15:\"track_all_pages\";s:0:\"\";s:16:\"use_cache_plugin\";s:1:\"1\";s:14:\"disable_column\";s:0:\"\";s:16:\"hit_post_metabox\";s:0:\"\";s:9:\"show_hits\";s:0:\"\";s:21:\"display_hits_position\";s:1:\"0\";s:12:\"chart_totals\";s:0:\"\";s:12:\"hide_notices\";s:0:\"\";s:10:\"all_online\";s:0:\"\";s:20:\"strip_uri_parameters\";s:0:\"\";s:14:\"addsearchwords\";s:0:\"\";s:15:\"read_capability\";s:14:\"manage_options\";s:17:\"manage_capability\";s:14:\"manage_options\";s:14:\"exclude_editor\";s:0:\"\";s:14:\"exclude_author\";s:0:\"\";s:19:\"exclude_contributor\";s:0:\"\";s:18:\"exclude_subscriber\";s:0:\"\";s:19:\"exclude_seo_manager\";s:0:\"\";s:18:\"exclude_seo_editor\";s:0:\"\";s:17:\"record_exclusions\";s:0:\"\";s:10:\"exclude_ip\";s:0:\"\";s:18:\"excluded_countries\";s:0:\"\";s:18:\"included_countries\";s:0:\"\";s:14:\"excluded_hosts\";s:0:\"\";s:15:\"robot_threshold\";s:0:\"\";s:12:\"use_honeypot\";s:0:\"\";s:15:\"honeypot_postid\";s:0:\"\";s:13:\"excluded_urls\";s:0:\"\";s:20:\"corrupt_browser_info\";s:0:\"\";s:14:\"schedule_geoip\";s:0:\"\";s:10:\"geoip_city\";s:0:\"\";s:8:\"auto_pop\";s:0:\"\";s:20:\"private_country_code\";s:3:\"000\";s:12:\"referrerspam\";s:0:\"\";s:21:\"schedule_referrerspam\";s:0:\"\";s:6:\"wp_cli\";s:0:\"\";s:14:\"wp_cli_summary\";s:0:\"\";s:18:\"wp_cli_user_online\";s:0:\"\";s:15:\"wp_cli_visitors\";s:0:\"\";s:16:\"schedule_dbmaint\";s:0:\"\";s:21:\"schedule_dbmaint_days\";s:3:\"365\";s:24:\"schedule_dbmaint_visitor\";s:0:\"\";s:29:\"schedule_dbmaint_visitor_hits\";s:2:\"50\";s:10:\"email_list\";s:0:\"\";s:12:\"geoip_report\";s:0:\"\";s:12:\"prune_report\";s:0:\"\";s:14:\"upgrade_report\";s:0:\"\";s:13:\"admin_notices\";s:0:\"\";s:11:\"disable_map\";s:0:\"\";s:17:\"disable_dashboard\";s:0:\"\";s:14:\"disable_editor\";s:0:\"\";s:8:\"hash_ips\";s:0:\"\";}","yes"),
("638","wp_statistics_plugin_version","13.1.6","yes"),
("639","wp_statistics_disable_addons","yes","yes"),
("640","widget_wp_statistics_widget","a:1:{s:12:\"_multiwidget\";i:1;}","yes"),
("641","wp_statistics_check_user_online","1648832019","yes"),
("693","rsssl_mixed_content_scan_dismissed","1","no"),
("694","rsssl_google_analytics_dismissed","1","yes"),
("737","wp_statistics_referrals_detail","a:1:{s:19:\"heshmedia-client.de\";a:3:{s:2:\"ip\";s:14:\"77.111.240.135\";s:7:\"country\";s:3:\"000\";s:5:\"title\";s:42:\"Hosted By One.com | Webhosting made simple\";}}","no"),
("755","wp_statistics_overview_page_ads","a:3:{s:9:\"timestamp\";i:1643084618;s:3:\"ads\";a:6:{s:2:\"ID\";s:5:\"qpage\";s:5:\"title\";s:48:\"Recruiting platform for ‍talent-led businesses\";s:4:\"link\";s:22:\"https://bit.ly/3A9paTo\";s:5:\"image\";s:22:\"https://bit.ly/350U4Ca\";s:7:\"_target\";s:3:\"yes\";s:6:\"status\";s:3:\"yes\";}s:4:\"view\";s:0:\"\";}","no"),
("767","dismissed_general_notices_until","1650338875","yes"),
("807","cerber_admin_info","<h1>Highlights from WP Cerber Security 9.0</h1><ul><li>New: Different <a href=\"https://wpcerber.com/wordpress-notifications-made-easy/\" target=\"_blank\">alerts</a> can be sent through different channels. You can select delivering notifications through Pushbullet and email simultaneously, Pushbullet only, or email only. The settings are configured on a per-alert basis in the alert creation form.</li><li>New: Implemented a new &quot;Message format&quot; feature and setting. You can reduce the number of links in WP Cerber’s messages or disable them completely to prevent sending sensitive data.</li><li>New: Implemented separate rate limiting settings for email and <a href=\"https://wpcerber.com/wordpress-mobile-and-browser-notifications-pushbullet/\" target=\"_blank\">Pushbullet notifications</a>.</li><li>New: Lockout notifications and appropriate threshold can be enabled for Pushbullet and emails separately.</li><li>New: Email reports and alerts can be sent via a separate SMTP server configured in the WP Cerber settings.</li><li>New: Implemented masking IP addresses and usernames (logins) in emails and mobile alerts.</li><li>New: Disabling login language switcher. If enabled, removes language switcher on the standard WordPress login page introduced in WordPress 5.9.</li></ul><p style=\"margin-top: 18px; line-height: 1.3;\"><span class=\"dashicons-before dashicons-info-outline\"></span>  &nbsp; <a href=\"https://wpcerber.com/?plugin_version=9.0\" target=\"_blank\">Read more on wpcerber.com</a></p>  <h2 style=\"margin-top: 28px;\">We need your support to keep moving forward</h2>\r\n                    <table style=\"margin-top: 20px;\"><tr><td></td><td style=\"padding-top: 0;\">By sharing your unique opinion on WP Cerber, you help the engineers behind the plugin make greater progress and help other professionals find the right software. You can leave your review on one of the following websites. Feel free to use your native language. Thanks!\r\n                    </td></tr></table>\r\n                       \r\n                    <p><a href=\"https://www.trustpilot.com/review/wpcerber.com\" target=\"_blank\">Leave review on Trustpilot</a>\r\n                    &nbsp;|&nbsp; \r\n                    <a href=\"https://www.g2.com/products/cerber-security-antispam-malware-scan/reviews/start\" target=\"_blank\">Leave review on G2.COM</a><p style=\"text-align:right; padding-right: 20px;\">\r\n    		    <input type=\"button\" class=\"button button-primary cerber-dismiss\" value=\" &nbsp; Awesome! &nbsp; \"/></p>","no"),
("811","db_upgraded","","yes"),
("818","auto_core_update_notified","a:4:{s:4:\"type\";s:7:\"success\";s:5:\"email\";s:23:\"write@sparkway-media.de\";s:7:\"version\";s:5:\"6.3.2\";s:9:\"timestamp\";i:1698176494;}","no"),
("969","rewrite_rules","a:214:{s:19:\"sitemap_index\\.xml$\";s:19:\"index.php?sitemap=1\";s:31:\"([^/]+?)-sitemap([0-9]+)?\\.xml$\";s:51:\"index.php?sitemap=$matches[1]&sitemap_n=$matches[2]\";s:24:\"([a-z]+)?-?sitemap\\.xsl$\";s:39:\"index.php?yoast-sitemap-xsl=$matches[1]\";s:11:\"^wp-json/?$\";s:22:\"index.php?rest_route=/\";s:14:\"^wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:21:\"^index.php/wp-json/?$\";s:22:\"index.php?rest_route=/\";s:24:\"^index.php/wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:17:\"^wp-sitemap\\.xml$\";s:23:\"index.php?sitemap=index\";s:17:\"^wp-sitemap\\.xsl$\";s:36:\"index.php?sitemap-stylesheet=sitemap\";s:23:\"^wp-sitemap-index\\.xsl$\";s:34:\"index.php?sitemap-stylesheet=index\";s:48:\"^wp-sitemap-([a-z]+?)-([a-z\\d_-]+?)-(\\d+?)\\.xml$\";s:75:\"index.php?sitemap=$matches[1]&sitemap-subtype=$matches[2]&paged=$matches[3]\";s:34:\"^wp-sitemap-([a-z]+?)-(\\d+?)\\.xml$\";s:47:\"index.php?sitemap=$matches[1]&paged=$matches[2]\";s:33:\"tb-cf/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:43:\"tb-cf/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:63:\"tb-cf/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:58:\"tb-cf/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:58:\"tb-cf/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:39:\"tb-cf/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:22:\"tb-cf/([^/]+)/embed/?$\";s:38:\"index.php?tb_cf=$matches[1]&embed=true\";s:26:\"tb-cf/([^/]+)/trackback/?$\";s:32:\"index.php?tb_cf=$matches[1]&tb=1\";s:34:\"tb-cf/([^/]+)/page/?([0-9]{1,})/?$\";s:45:\"index.php?tb_cf=$matches[1]&paged=$matches[2]\";s:41:\"tb-cf/([^/]+)/comment-page-([0-9]{1,})/?$\";s:45:\"index.php?tb_cf=$matches[1]&cpage=$matches[2]\";s:30:\"tb-cf/([^/]+)(?:/([0-9]+))?/?$\";s:44:\"index.php?tb_cf=$matches[1]&page=$matches[2]\";s:22:\"tb-cf/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:32:\"tb-cf/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:52:\"tb-cf/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:47:\"tb-cf/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:47:\"tb-cf/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:28:\"tb-cf/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:23:\"category/(.+?)/embed/?$\";s:46:\"index.php?category_name=$matches[1]&embed=true\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:20:\"tag/([^/]+)/embed/?$\";s:36:\"index.php?tag=$matches[1]&embed=true\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:21:\"type/([^/]+)/embed/?$\";s:44:\"index.php?post_format=$matches[1]&embed=true\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:43:\"tbuilder-layout/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:53:\"tbuilder-layout/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:73:\"tbuilder-layout/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:68:\"tbuilder-layout/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:68:\"tbuilder-layout/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:49:\"tbuilder-layout/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:32:\"tbuilder-layout/([^/]+)/embed/?$\";s:48:\"index.php?tbuilder_layout=$matches[1]&embed=true\";s:36:\"tbuilder-layout/([^/]+)/trackback/?$\";s:42:\"index.php?tbuilder_layout=$matches[1]&tb=1\";s:44:\"tbuilder-layout/([^/]+)/page/?([0-9]{1,})/?$\";s:55:\"index.php?tbuilder_layout=$matches[1]&paged=$matches[2]\";s:51:\"tbuilder-layout/([^/]+)/comment-page-([0-9]{1,})/?$\";s:55:\"index.php?tbuilder_layout=$matches[1]&cpage=$matches[2]\";s:40:\"tbuilder-layout/([^/]+)(?:/([0-9]+))?/?$\";s:54:\"index.php?tbuilder_layout=$matches[1]&page=$matches[2]\";s:32:\"tbuilder-layout/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:42:\"tbuilder-layout/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:62:\"tbuilder-layout/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:57:\"tbuilder-layout/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:57:\"tbuilder-layout/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:38:\"tbuilder-layout/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:48:\"tbuilder-layout-part/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:58:\"tbuilder-layout-part/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:78:\"tbuilder-layout-part/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:73:\"tbuilder-layout-part/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:73:\"tbuilder-layout-part/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:54:\"tbuilder-layout-part/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:37:\"tbuilder-layout-part/([^/]+)/embed/?$\";s:53:\"index.php?tbuilder_layout_part=$matches[1]&embed=true\";s:41:\"tbuilder-layout-part/([^/]+)/trackback/?$\";s:47:\"index.php?tbuilder_layout_part=$matches[1]&tb=1\";s:49:\"tbuilder-layout-part/([^/]+)/page/?([0-9]{1,})/?$\";s:60:\"index.php?tbuilder_layout_part=$matches[1]&paged=$matches[2]\";s:56:\"tbuilder-layout-part/([^/]+)/comment-page-([0-9]{1,})/?$\";s:60:\"index.php?tbuilder_layout_part=$matches[1]&cpage=$matches[2]\";s:45:\"tbuilder-layout-part/([^/]+)(?:/([0-9]+))?/?$\";s:59:\"index.php?tbuilder_layout_part=$matches[1]&page=$matches[2]\";s:37:\"tbuilder-layout-part/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:47:\"tbuilder-layout-part/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:67:\"tbuilder-layout-part/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:62:\"tbuilder-layout-part/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:62:\"tbuilder-layout-part/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:43:\"tbuilder-layout-part/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:41:\"tglobal-style/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:51:\"tglobal-style/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:71:\"tglobal-style/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:66:\"tglobal-style/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:66:\"tglobal-style/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:47:\"tglobal-style/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:30:\"tglobal-style/([^/]+)/embed/?$\";s:46:\"index.php?tglobal_style=$matches[1]&embed=true\";s:34:\"tglobal-style/([^/]+)/trackback/?$\";s:40:\"index.php?tglobal_style=$matches[1]&tb=1\";s:42:\"tglobal-style/([^/]+)/page/?([0-9]{1,})/?$\";s:53:\"index.php?tglobal_style=$matches[1]&paged=$matches[2]\";s:49:\"tglobal-style/([^/]+)/comment-page-([0-9]{1,})/?$\";s:53:\"index.php?tglobal_style=$matches[1]&cpage=$matches[2]\";s:38:\"tglobal-style/([^/]+)(?:/([0-9]+))?/?$\";s:52:\"index.php?tglobal_style=$matches[1]&page=$matches[2]\";s:30:\"tglobal-style/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:40:\"tglobal-style/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:60:\"tglobal-style/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:55:\"tglobal-style/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:55:\"tglobal-style/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:36:\"tglobal-style/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:44:\"contact_messages/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:54:\"contact_messages/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:74:\"contact_messages/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:69:\"contact_messages/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:69:\"contact_messages/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:50:\"contact_messages/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:33:\"contact_messages/([^/]+)/embed/?$\";s:49:\"index.php?contact_messages=$matches[1]&embed=true\";s:37:\"contact_messages/([^/]+)/trackback/?$\";s:43:\"index.php?contact_messages=$matches[1]&tb=1\";s:45:\"contact_messages/([^/]+)/page/?([0-9]{1,})/?$\";s:56:\"index.php?contact_messages=$matches[1]&paged=$matches[2]\";s:52:\"contact_messages/([^/]+)/comment-page-([0-9]{1,})/?$\";s:56:\"index.php?contact_messages=$matches[1]&cpage=$matches[2]\";s:41:\"contact_messages/([^/]+)(?:/([0-9]+))?/?$\";s:55:\"index.php?contact_messages=$matches[1]&page=$matches[2]\";s:33:\"contact_messages/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:43:\"contact_messages/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:63:\"contact_messages/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:58:\"contact_messages/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:58:\"contact_messages/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:39:\"contact_messages/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:37:\"tbp-theme/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:47:\"tbp-theme/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:67:\"tbp-theme/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:62:\"tbp-theme/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:62:\"tbp-theme/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:43:\"tbp-theme/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:26:\"tbp-theme/([^/]+)/embed/?$\";s:42:\"index.php?tbp_theme=$matches[1]&embed=true\";s:30:\"tbp-theme/([^/]+)/trackback/?$\";s:36:\"index.php?tbp_theme=$matches[1]&tb=1\";s:38:\"tbp-theme/([^/]+)/page/?([0-9]{1,})/?$\";s:49:\"index.php?tbp_theme=$matches[1]&paged=$matches[2]\";s:45:\"tbp-theme/([^/]+)/comment-page-([0-9]{1,})/?$\";s:49:\"index.php?tbp_theme=$matches[1]&cpage=$matches[2]\";s:34:\"tbp-theme/([^/]+)(?:/([0-9]+))?/?$\";s:48:\"index.php?tbp_theme=$matches[1]&page=$matches[2]\";s:26:\"tbp-theme/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:36:\"tbp-theme/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:56:\"tbp-theme/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:51:\"tbp-theme/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:51:\"tbp-theme/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:32:\"tbp-theme/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:40:\"tbp-template/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:50:\"tbp-template/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:70:\"tbp-template/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:65:\"tbp-template/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:65:\"tbp-template/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:46:\"tbp-template/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:29:\"tbp-template/([^/]+)/embed/?$\";s:45:\"index.php?tbp_template=$matches[1]&embed=true\";s:33:\"tbp-template/([^/]+)/trackback/?$\";s:39:\"index.php?tbp_template=$matches[1]&tb=1\";s:41:\"tbp-template/([^/]+)/page/?([0-9]{1,})/?$\";s:52:\"index.php?tbp_template=$matches[1]&paged=$matches[2]\";s:48:\"tbp-template/([^/]+)/comment-page-([0-9]{1,})/?$\";s:52:\"index.php?tbp_template=$matches[1]&cpage=$matches[2]\";s:37:\"tbp-template/([^/]+)(?:/([0-9]+))?/?$\";s:51:\"index.php?tbp_template=$matches[1]&page=$matches[2]\";s:29:\"tbp-template/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:39:\"tbp-template/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:59:\"tbp-template/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:54:\"tbp-template/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:54:\"tbp-template/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:35:\"tbp-template/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:8:\"embed/?$\";s:21:\"index.php?&embed=true\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:27:\"comment-page-([0-9]{1,})/?$\";s:38:\"index.php?&page_id=8&cpage=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:17:\"comments/embed/?$\";s:21:\"index.php?&embed=true\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:20:\"search/(.+)/embed/?$\";s:34:\"index.php?s=$matches[1]&embed=true\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:23:\"author/([^/]+)/embed/?$\";s:44:\"index.php?author_name=$matches[1]&embed=true\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:45:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/embed/?$\";s:74:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:32:\"([0-9]{4})/([0-9]{1,2})/embed/?$\";s:58:\"index.php?year=$matches[1]&monthnum=$matches[2]&embed=true\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:19:\"([0-9]{4})/embed/?$\";s:37:\"index.php?year=$matches[1]&embed=true\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\".?.+?/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"(.?.+?)/embed/?$\";s:41:\"index.php?pagename=$matches[1]&embed=true\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:24:\"(.?.+?)(?:/([0-9]+))?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:27:\"[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\"[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\"[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\"[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"([^/]+)/embed/?$\";s:37:\"index.php?name=$matches[1]&embed=true\";s:20:\"([^/]+)/trackback/?$\";s:31:\"index.php?name=$matches[1]&tb=1\";s:40:\"([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:35:\"([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:28:\"([^/]+)/page/?([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&paged=$matches[2]\";s:35:\"([^/]+)/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&cpage=$matches[2]\";s:24:\"([^/]+)(?:/([0-9]+))?/?$\";s:43:\"index.php?name=$matches[1]&page=$matches[2]\";s:16:\"[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:26:\"[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:46:\"[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:22:\"[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";}","yes"),
("1058","updraftplus_dismisseddashnotice","1729799063","yes"),
("1060","themify_updater_licence","{\"key\":\"V2BNSSSA5JEA9T\",\"username\":\"heshmedia\",\"hideKey\":false,\"hideName\":false,\"autoUpdate\":true,\"hideNotice\":false,\"notification\":false,\"noticeEmail\":\"\"}","yes"),
("1071","autoptimize_version","3.1.9","yes"),
("1072","autoptimize_ccss_version","AO_3.1.9","yes"),
("1074","autoptimize_service_availablity","a:2:{s:12:\"extra_imgopt\";a:3:{s:6:\"status\";s:2:\"up\";s:5:\"hosts\";a:1:{i:1;s:28:\"https://sp-ao.shortpixel.ai/\";}s:16:\"launch-threshold\";s:4:\"4096\";}s:7:\"critcss\";a:2:{s:6:\"status\";s:2:\"up\";s:5:\"hosts\";a:1:{i:1;s:24:\"https://criticalcss.com/\";}}}","yes"),
("1080","autoptimize_imgopt_launched","on","yes"),
("1088","autoptimize_html","","yes"),
("1089","autoptimize_html_keepcomments","","yes"),
("1090","autoptimize_enable_site_config","on","yes"),
("1091","autoptimize_js","on","yes"),
("1092","autoptimize_js_aggregate","on","yes"),
("1093","autoptimize_js_defer_not_aggregate","","yes"),
("1094","autoptimize_js_defer_inline","on","yes"),
("1095","autoptimize_js_exclude",", wp-includes/js/dist/, wp-includes/js/tinymce/, js/jquery/jquery.min.js","yes"),
("1096","autoptimize_js_trycatch","","yes"),
("1097","autoptimize_js_justhead","","yes"),
("1098","autoptimize_js_forcehead","","yes"),
("1099","autoptimize_js_include_inline","","yes"),
("1100","autoptimize_css","on","yes"),
("1101","autoptimize_css_aggregate","on","yes"),
("1102","autoptimize_css_exclude",", admin-bar.min.css, dashicons.min.css, wp-content/cache/, wp-content/uploads/","yes"),
("1103","autoptimize_css_justhead","","yes"),
("1104","autoptimize_css_datauris","","yes"),
("1105","autoptimize_css_defer","","yes"),
("1106","autoptimize_css_defer_inline","","yes"),
("1107","autoptimize_css_inline","on","yes"),
("1108","autoptimize_css_include_inline","on","yes"),
("1109","autoptimize_cdn_url","","yes"),
("1110","autoptimize_cache_clean","0","yes"),
("1111","autoptimize_cache_nogzip","on","yes"),
("1112","autoptimize_optimize_logged","on","yes"),
("1113","autoptimize_optimize_checkout","","yes"),
("1114","autoptimize_minify_excluded","on","yes"),
("1115","autoptimize_cache_fallback","on","yes"),
("1116","autoptimize_enable_meta_ao_settings","on","yes"),
("1123","autoptimize_imgopt_settings","a:7:{s:35:\"autoptimize_imgopt_checkbox_field_1\";s:1:\"1\";s:31:\"autoptimize_imgopt_text_field_6\";s:0:\"\";s:33:\"autoptimize_imgopt_select_field_2\";s:1:\"2\";s:35:\"autoptimize_imgopt_checkbox_field_4\";s:1:\"1\";s:35:\"autoptimize_imgopt_checkbox_field_3\";s:1:\"1\";s:31:\"autoptimize_imgopt_text_field_5\";s:0:\"\";s:33:\"autoptimize_imgopt_number_field_7\";s:1:\"2\";}","yes"),
("1126","wp-short-pixel-query-id-stop","25","yes"),
("1127","wp-short-pixel-query-id-start","25","yes"),
("1128","wp-short-pixel-create-webp-markup","0","yes"),
("1129","wp-short-pixel-verifiedKey","1","no"),
("1131","wp-short-pixel-activation-date","1657407922","no"),
("1132","wp-short-pixel-apiKey","2DEuKPqIoyeT68GbkLPQ","no"),
("1133","wp-short-pixel-compression","1","yes"),
("1134","wp-short-process_thumbnails","1","yes"),
("1135","wp-short-pixel_cmyk2rgb","1","yes"),
("1136","wp-short-backup_images","1","yes"),
("1137","wp-short-pixel-resize-images","1","yes"),
("1138","wp-short-pixel-resize-width","924","yes"),
("1139","wp-short-pixel-resize-height","924","yes"),
("1140","wp-short-pixel-front-bootstrap","0","yes"),
("1141","wp-short-pixel-last-back-action","","no"),
("1142","wp-short-pixel-keep-exif","1","yes"),
("1143","wp-short-create-webp","1","yes"),
("1144","wp-short-create-avif","0","yes"),
("1145","wp-short-pixel-optimize-retina","1","yes"),
("1146","wp-short-pixel-optimize-unlisted","0","yes"),
("1147","wp-short-pixel-resize-type","outer","yes"),
("1148","wp-short-pixel-site-auth-user","","no"),
("1149","wp-short-pixel-site-auth-pass","","no"),
("1150","wp-short-pixel-auto-media-library","1","yes"),
("1151","wp-short-pixel-optimize-pdfs","1","yes"),
("1152","wp-short-pixel-exclude-patterns","a:0:{}","no"),
("1153","wp-short-pixel-png2jpg","0","yes"),
("1154","wp-short-pixel-excludeSizes","a:0:{}","no"),
("1155","wp-short-pixel-cloudflareAPIEmail","","no"),
("1156","wp-short-pixel-cloudflareAuthKey","","no"),
("1157","wp-short-pixel-cloudflareAPIZoneID","","no"),
("1158","wp-short-pixel-cloudflareToken","","no"),
("1159","wp-short-pixel-include-next-gen","0","yes"),
("1160","wp-short-pixel-has-custom-folders","","no"),
("1161","wp-short-pixel-custom-bulk-paused","0","yes"),
("1164","wp-short-pixel-fileCount","0","no"),
("1165","wp-short-pixel-thumbnail-count","0","no"),
("1166","wp-short-pixel-files-under-5-percent","0","no"),
("1167","wp-short-pixel-savedSpace","0","no"),
("1168","wp-short-pixel-api-retries","0","no"),
("1169","wp-short-pixel-total-optimized","0","no"),
("1170","wp-short-pixel-total-original","0","no"),
("1171","wp-short-pixel-quota-exceeded","0","yes"),
("1172","wp-short-pixel-protocol","https","no"),
("1173","wp-short-pixel-download-protocol","","no"),
("1174","wp-short-pixel-download-archive","0","yes"),
("1175","wp-short-pixel-media-alert","","no"),
("1176","wp-short-pixel-dismissed-notices","a:0:{}","no"),
("1177","wp-short-pixel-view-mode","1","yes"),
("1178","wp-short-pixel-redirected-settings","1","no"),
("1179","wp-short-pixel-converted-png2jpg","a:0:{}","no"),
("1180","wp-short-pixel-helpscout-optin","0","yes"),
("1183","wp-short-pixel-bulk-count","0","yes"),
("1184","wp-short-pixel-bulk-previous-percent","0","yes"),
("1185","wp-short-pixel-bulk-processed-items","0","yes"),
("1186","wp-short-pixel-bulk-done-count","0","yes"),
("1187","wp-short-pixel-last-bulk-start-time","0","no"),
("1188","wp-short-pixel-last-bulk-success-time","0","no"),
("1189","wp-short-pixel-bulk-running-time","0","no"),
("1190","wp-short-pixel-cancel-pointer","0","no"),
("1191","wp-short-pixel-skip-to-custom","","no"),
("1192","wp-short-pixel-bulk-ever-ran","1","yes"),
("1193","wp-short-pixel-flag-id","12","yes"),
("1194","wp-short-pixel-failed-imgs","","yes"),
("1197","wp-short-pixel-apiKeyTried","","yes"),
("1226","wp-short-pixel-prioritySkip","a:0:{}","yes"),
("1227","wp-short-pixel-bulk-type","","no"),
("1239","WpFc_api_key","9688bf092cc77b9f5058882483263903","yes"),
("1242","WpFastestCachePreLoad","{\"homepage\":-1,\"post\":0,\"category\":0,\"page\":0,\"tag\":0,\"attachment\":0,\"customposttypes\":0,\"customTaxonomies\":0,\"number\":\"4\",\"order\":\"post,category,page,tag,attachment,customposttypes,customTaxonomies\"}","yes"),
("1243","WpFastestCache","{\"wpFastestCacheStatus\":\"on\",\"wpFastestCachePreload\":\"on\",\"wpFastestCachePreload_homepage\":\"on\",\"wpFastestCachePreload_post\":\"on\",\"wpFastestCachePreload_category\":\"on\",\"wpFastestCachePreload_page\":\"on\",\"wpFastestCachePreload_tag\":\"on\",\"wpFastestCachePreload_attachment\":\"on\",\"wpFastestCachePreload_customposttypes\":\"on\",\"wpFastestCachePreload_customTaxonomies\":\"on\",\"wpFastestCachePreload_number\":\"4\",\"wpFastestCachePreload_order\":\"homepage,post,category,page,tag,attachment,customposttypes,customTaxonomies,number,restart,order\",\"wpFastestCacheNewPost\":\"on\",\"wpFastestCacheNewPost_type\":\"all\",\"wpFastestCacheUpdatePost\":\"on\",\"wpFastestCacheUpdatePost_type\":\"post\",\"wpFastestCacheMinifyHtml\":\"on\",\"wpFastestCacheGzip\":\"on\",\"wpFastestCacheLBC\":\"on\",\"wpFastestCacheDisableEmojis\":\"on\",\"wpFastestCacheLanguage\":\"de\"}","yes"),
("1244","wpfc-group","","yes"),
("1252","category_children","a:0:{}","yes"),
("1254","nav_menu_options","a:2:{i:0;b:0;s:8:\"auto_add\";a:0:{}}","yes"),
("1302","bulkProcessingStatus","","no"),
("1332","famne_options","a:10:{s:32:\"wp_new_user_notification_to_user\";s:1:\"1\";s:20:\"wp_notify_postauthor\";s:1:\"1\";s:19:\"wp_notify_moderator\";s:1:\"1\";s:26:\"send_password_change_email\";s:1:\"1\";s:23:\"send_email_change_email\";s:1:\"1\";s:29:\"send_password_forgotten_email\";s:1:\"1\";s:33:\"wp_new_user_notification_to_admin\";s:1:\"1\";s:31:\"wp_password_change_notification\";s:1:\"1\";s:35:\"send_password_admin_forgotten_email\";s:1:\"1\";s:23:\"custom_admin_recipients\";s:0:\"\";}","yes"),
("1333","fa_mne_version","1.8.5","no"),
("1415","autoptimize_imgopt_provider_stat","a:8:{s:10:\"HasAccount\";b:0;s:23:\"TemporaryRedirectOrigin\";b:0;s:11:\"FreeCredits\";i:500;s:15:\"UsedFreeCredits\";i:3;s:8:\"CDNQuota\";i:5368709000;s:7:\"UsedCDN\";i:692;s:6:\"Status\";i:2;i:0;s:2:\"OK\";}","yes"),
("1426","wp-short-pixel-currentVersion","5.0.5","yes"),
("1428","shortqwp_SPIO","a:1:{s:6:\"queues\";a:4:{s:5:\"media\";O:24:\"ShortPixel\\ShortQ\\Status\":15:{s:8:\"\0*\0items\";i:0;s:13:\"\0*\0in_process\";i:0;s:12:\"\0*\0preparing\";b:0;s:10:\"\0*\0running\";b:0;s:11:\"\0*\0finished\";b:0;s:15:\"\0*\0bulk_running\";b:0;s:7:\"\0*\0done\";i:0;s:9:\"\0*\0errors\";i:0;s:15:\"\0*\0fatal_errors\";i:0;s:11:\"\0*\0last_run\";i:0;s:14:\"\0*\0last_update\";i:0;s:12:\"\0*\0times_ran\";i:0;s:14:\"\0*\0average_ask\";i:0;s:15:\"\0*\0last_item_id\";i:0;s:14:\"\0*\0custom_data\";N;}s:11:\"mediaSingle\";O:24:\"ShortPixel\\ShortQ\\Status\":15:{s:8:\"\0*\0items\";i:0;s:13:\"\0*\0in_process\";i:0;s:12:\"\0*\0preparing\";b:0;s:10:\"\0*\0running\";b:0;s:11:\"\0*\0finished\";b:0;s:15:\"\0*\0bulk_running\";b:0;s:7:\"\0*\0done\";i:0;s:9:\"\0*\0errors\";i:0;s:15:\"\0*\0fatal_errors\";i:0;s:11:\"\0*\0last_run\";i:0;s:14:\"\0*\0last_update\";i:0;s:12:\"\0*\0times_ran\";i:0;s:14:\"\0*\0average_ask\";i:0;s:15:\"\0*\0last_item_id\";i:0;s:14:\"\0*\0custom_data\";N;}s:6:\"custom\";O:24:\"ShortPixel\\ShortQ\\Status\":15:{s:8:\"\0*\0items\";i:0;s:13:\"\0*\0in_process\";i:0;s:12:\"\0*\0preparing\";b:0;s:10:\"\0*\0running\";b:0;s:11:\"\0*\0finished\";b:0;s:15:\"\0*\0bulk_running\";b:0;s:7:\"\0*\0done\";i:0;s:9:\"\0*\0errors\";i:0;s:15:\"\0*\0fatal_errors\";i:0;s:11:\"\0*\0last_run\";i:0;s:14:\"\0*\0last_update\";i:0;s:12:\"\0*\0times_ran\";i:0;s:14:\"\0*\0average_ask\";i:0;s:15:\"\0*\0last_item_id\";i:0;s:14:\"\0*\0custom_data\";N;}s:12:\"customSingle\";O:24:\"ShortPixel\\ShortQ\\Status\":15:{s:8:\"\0*\0items\";i:0;s:13:\"\0*\0in_process\";i:0;s:12:\"\0*\0preparing\";b:0;s:10:\"\0*\0running\";b:0;s:11:\"\0*\0finished\";b:0;s:15:\"\0*\0bulk_running\";b:0;s:7:\"\0*\0done\";i:0;s:9:\"\0*\0errors\";i:0;s:15:\"\0*\0fatal_errors\";i:0;s:11:\"\0*\0last_run\";i:0;s:14:\"\0*\0last_update\";i:0;s:12:\"\0*\0times_ran\";i:0;s:14:\"\0*\0average_ask\";i:0;s:15:\"\0*\0last_item_id\";i:0;s:14:\"\0*\0custom_data\";N;}}}","yes"),
("1433","wp-short-pixel-current-total-files","a:5:{s:5:\"media\";a:5:{s:5:\"items\";i:-1;s:6:\"images\";i:-1;s:6:\"thumbs\";i:-1;s:10:\"itemsTotal\";i:-1;s:11:\"thumbsTotal\";i:-1;}s:6:\"custom\";a:3:{s:5:\"items\";i:-1;s:6:\"images\";i:-1;s:10:\"itemsTotal\";i:-1;}s:6:\"period\";a:1:{s:6:\"months\";a:4:{i:1;i:-1;i:2;i:-1;i:3;i:-1;i:4;i:-1;}}s:5:\"total\";a:5:{s:5:\"items\";i:-1;s:6:\"images\";i:-1;s:6:\"thumbs\";i:-1;s:10:\"itemsTotal\";i:-1;s:11:\"thumbsTotal\";i:-1;}s:4:\"time\";i:1657407937;}","yes"),
("1443","duplicate_post_version","4.5","yes"),
("1462","duplicator_pro_exe_safe_mode","0","yes"),
("1463","duplicator_pro_activate_plugins_after_installation","a:0:{}","yes"),
("1537","widget_recent-posts","a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}","yes"),
("1538","widget_recent-comments","a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}","yes"),
("1541","themify_custom_fonts","a:6:{i:0;s:10:\"Montserrat\";i:1;s:10:\"Montserrat\";i:2;s:18:\"Montserrat:400,300\";i:3;s:18:\"Montserrat:400,200\";i:4;s:18:\"Montserrat:400,500\";i:5;s:18:\"Montserrat:400,500\";}","yes"),
("1542","themify_custom_cf_fonts","a:0:{}","yes"),
("1932","user_count","1","no"),
("2382","ucp_meta","a:3:{s:13:\"first_version\";s:4:\"3.93\";s:13:\"first_install\";i:1665572707;s:11:\"options_ver\";s:4:\"3.97\";}","yes"),
("2384","ucp_options","a:33:{s:6:\"status\";s:1:\"1\";s:11:\"license_key\";s:0:\"\";s:14:\"license_active\";b:0;s:15:\"license_expires\";s:10:\"1900-01-01\";s:12:\"license_type\";s:0:\"\";s:8:\"end_date\";s:0:\"\";s:14:\"ga_tracking_id\";s:0:\"\";s:5:\"theme\";s:18:\"under_construction\";s:10:\"custom_css\";s:0:\"\";s:5:\"title\";s:34:\"[site-title] is under construction\";s:11:\"description\";s:14:\"[site-tagline]\";s:8:\"heading1\";s:65:\"Entschuldigung, wir führen einige Arbeiten an der Website durch.\";s:7:\"content\";s:143:\"Danke für deine Geduld. Wir arbeiten gerade an der Website und sind in Kürze wieder zurück.\r\n\r\nBei Fragen bitte an mail@hesh-media.de wenden\";s:15:\"social_facebook\";s:0:\"\";s:14:\"social_twitter\";s:0:\"\";s:15:\"social_linkedin\";s:0:\"\";s:14:\"social_youtube\";s:0:\"\";s:12:\"social_vimeo\";s:0:\"\";s:16:\"social_pinterest\";s:0:\"\";s:15:\"social_dribbble\";s:0:\"\";s:14:\"social_behance\";s:0:\"\";s:16:\"social_instagram\";s:0:\"\";s:13:\"social_tumblr\";s:0:\"\";s:9:\"social_vk\";s:0:\"\";s:12:\"social_email\";s:0:\"\";s:12:\"social_phone\";s:0:\"\";s:12:\"social_skype\";s:0:\"\";s:15:\"social_telegram\";s:0:\"\";s:15:\"social_whatsapp\";s:0:\"\";s:12:\"login_button\";s:1:\"1\";s:8:\"linkback\";i:0;s:17:\"whitelisted_roles\";a:1:{i:0;s:13:\"administrator\";}s:17:\"whitelisted_users\";a:0:{}}","yes"),
("2425","omgf_current_db_version","5.6.0","yes"),
("2434","omgf_cache_timestamp","1665573222","yes"),
("2448","omgf_optimize_has_run","1","yes"),
("2455","ffwp_encryption_cypher","64c6bfbae3cd0704","yes"),
("2456","ffwp_valid_licenses","a:1:{i:4027;a:4:{s:14:\"license_status\";s:5:\"valid\";s:7:\"license\";s:44:\"qQG/eUlzggLfb8M8DGhenm3WRd8yFL1gc94P6/QQONQ=\";s:7:\"expires\";s:19:\"2023-08-25 23:59:59\";s:11:\"plugin_file\";s:124:\"/customers/c/5/1/sparkway-client.de/httpd.www/sparkgarten/wp-content/plugins/host-google-fonts-pro/host-google-fonts-pro.php\";}}","yes"),
("2457","ffwp_db_version","1.10.3","yes"),
("2458","omgf_pro_source_url","","yes"),
("2459","omgf_pro_db_version","3.7.6","yes"),
("2461","omgf_pro_enrollment_shown","1","yes"),
("2466","ffwp_license_key","a:1:{i:4027;a:2:{s:3:\"key\";s:44:\"qQG/eUlzggLfb8M8DGhenm3WRd8yFL1gc94P6/QQONQ=\";s:11:\"plugin_file\";s:124:\"/customers/c/5/1/sparkway-client.de/httpd.www/sparkgarten/wp-content/plugins/host-google-fonts-pro/host-google-fonts-pro.php\";}}","yes"),
("2482","edd_sl_0c2b05a94bd82b1c71d2da33b3bae35c","a:2:{s:7:\"timeout\";i:1698187576;s:5:\"value\";s:5:\"false\";}","no"),
("2504","omgf_pro_auto_config","on","yes"),
("2505","omgf_pro_force_font_display","","yes"),
("2506","omgf_pro_remove_async_fonts","","yes"),
("2507","omgf_pro_replace_font","","yes"),
("2508","omgf_pro_fallback_font_stack","","yes"),
("2509","omgf_optimized_fonts","a:2:{s:37:\"local-stylesheet-font-face-montserrat\";a:1:{s:10:\"montserrat\";O:8:\"stdClass\":4:{s:2:\"id\";s:10:\"montserrat\";s:6:\"family\";s:10:\"Montserrat\";s:8:\"variants\";a:10:{s:20:\"latin-ext-400-italic\";O:8:\"stdClass\":7:{s:2:\"id\";s:9:\"400italic\";s:10:\"fontFamily\";s:10:\"Montserrat\";s:9:\"fontStyle\";s:6:\"italic\";s:10:\"fontWeight\";s:3:\"400\";s:5:\"woff2\";s:133:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-montserrat/montserrat-italic-latin-ext.woff2\";s:6:\"subset\";s:9:\"latin-ext\";s:5:\"range\";s:100:\"U+0100-024F, U+0259, U+1E00-1EFF, U+2020, U+20A0-20AB, U+20AD-20CF, U+2113, U+2C60-2C7F, U+A720-A7FF\";}s:16:\"latin-400-italic\";O:8:\"stdClass\":7:{s:2:\"id\";s:9:\"400italic\";s:10:\"fontFamily\";s:10:\"Montserrat\";s:9:\"fontStyle\";s:6:\"italic\";s:10:\"fontWeight\";s:3:\"400\";s:5:\"woff2\";s:129:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-montserrat/montserrat-italic-latin.woff2\";s:6:\"subset\";s:5:\"latin\";s:5:\"range\";s:154:\"U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD\";}s:13:\"latin-ext-200\";O:8:\"stdClass\":7:{s:2:\"id\";s:3:\"200\";s:10:\"fontFamily\";s:10:\"Montserrat\";s:9:\"fontStyle\";s:6:\"normal\";s:10:\"fontWeight\";s:3:\"200\";s:5:\"woff2\";s:133:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-montserrat/montserrat-normal-latin-ext.woff2\";s:6:\"subset\";s:9:\"latin-ext\";s:5:\"range\";s:100:\"U+0100-024F, U+0259, U+1E00-1EFF, U+2020, U+20A0-20AB, U+20AD-20CF, U+2113, U+2C60-2C7F, U+A720-A7FF\";}s:9:\"latin-200\";O:8:\"stdClass\":7:{s:2:\"id\";s:3:\"200\";s:10:\"fontFamily\";s:10:\"Montserrat\";s:9:\"fontStyle\";s:6:\"normal\";s:10:\"fontWeight\";s:3:\"200\";s:5:\"woff2\";s:129:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-montserrat/montserrat-normal-latin.woff2\";s:6:\"subset\";s:5:\"latin\";s:5:\"range\";s:154:\"U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD\";}s:13:\"latin-ext-300\";O:8:\"stdClass\":7:{s:2:\"id\";s:3:\"300\";s:10:\"fontFamily\";s:10:\"Montserrat\";s:9:\"fontStyle\";s:6:\"normal\";s:10:\"fontWeight\";s:3:\"300\";s:5:\"woff2\";s:133:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-montserrat/montserrat-normal-latin-ext.woff2\";s:6:\"subset\";s:9:\"latin-ext\";s:5:\"range\";s:100:\"U+0100-024F, U+0259, U+1E00-1EFF, U+2020, U+20A0-20AB, U+20AD-20CF, U+2113, U+2C60-2C7F, U+A720-A7FF\";}s:9:\"latin-300\";O:8:\"stdClass\":7:{s:2:\"id\";s:3:\"300\";s:10:\"fontFamily\";s:10:\"Montserrat\";s:9:\"fontStyle\";s:6:\"normal\";s:10:\"fontWeight\";s:3:\"300\";s:5:\"woff2\";s:129:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-montserrat/montserrat-normal-latin.woff2\";s:6:\"subset\";s:5:\"latin\";s:5:\"range\";s:154:\"U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD\";}s:13:\"latin-ext-400\";O:8:\"stdClass\":7:{s:2:\"id\";s:3:\"400\";s:10:\"fontFamily\";s:10:\"Montserrat\";s:9:\"fontStyle\";s:6:\"normal\";s:10:\"fontWeight\";s:3:\"400\";s:5:\"woff2\";s:133:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-montserrat/montserrat-normal-latin-ext.woff2\";s:6:\"subset\";s:9:\"latin-ext\";s:5:\"range\";s:100:\"U+0100-024F, U+0259, U+1E00-1EFF, U+2020, U+20A0-20AB, U+20AD-20CF, U+2113, U+2C60-2C7F, U+A720-A7FF\";}s:9:\"latin-400\";O:8:\"stdClass\":7:{s:2:\"id\";s:3:\"400\";s:10:\"fontFamily\";s:10:\"Montserrat\";s:9:\"fontStyle\";s:6:\"normal\";s:10:\"fontWeight\";s:3:\"400\";s:5:\"woff2\";s:129:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-montserrat/montserrat-normal-latin.woff2\";s:6:\"subset\";s:5:\"latin\";s:5:\"range\";s:154:\"U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD\";}s:13:\"latin-ext-500\";O:8:\"stdClass\":7:{s:2:\"id\";s:3:\"500\";s:10:\"fontFamily\";s:10:\"Montserrat\";s:9:\"fontStyle\";s:6:\"normal\";s:10:\"fontWeight\";s:3:\"500\";s:5:\"woff2\";s:133:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-montserrat/montserrat-normal-latin-ext.woff2\";s:6:\"subset\";s:9:\"latin-ext\";s:5:\"range\";s:100:\"U+0100-024F, U+0259, U+1E00-1EFF, U+2020, U+20A0-20AB, U+20AD-20CF, U+2113, U+2C60-2C7F, U+A720-A7FF\";}s:9:\"latin-500\";O:8:\"stdClass\":7:{s:2:\"id\";s:3:\"500\";s:10:\"fontFamily\";s:10:\"Montserrat\";s:9:\"fontStyle\";s:6:\"normal\";s:10:\"fontWeight\";s:3:\"500\";s:5:\"woff2\";s:129:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-montserrat/montserrat-normal-latin.woff2\";s:6:\"subset\";s:5:\"latin\";s:5:\"range\";s:154:\"U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD\";}}s:7:\"subsets\";a:5:{i:0;s:12:\"cyrillic-ext\";i:1;s:8:\"cyrillic\";i:2;s:10:\"vietnamese\";i:3;s:9:\"latin-ext\";i:4;s:5:\"latin\";}}}s:38:\"local-stylesheet-font-face-public-sans\";a:1:{s:11:\"public-sans\";O:8:\"stdClass\":4:{s:2:\"id\";s:11:\"public-sans\";s:6:\"family\";s:11:\"Public Sans\";s:8:\"variants\";a:12:{s:20:\"latin-ext-400-italic\";O:8:\"stdClass\":7:{s:2:\"id\";s:9:\"400italic\";s:10:\"fontFamily\";s:13:\"Public%20Sans\";s:9:\"fontStyle\";s:6:\"italic\";s:10:\"fontWeight\";s:3:\"400\";s:5:\"woff2\";s:135:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-public-sans/public-sans-italic-latin-ext.woff2\";s:6:\"subset\";s:9:\"latin-ext\";s:5:\"range\";s:100:\"U+0100-024F, U+0259, U+1E00-1EFF, U+2020, U+20A0-20AB, U+20AD-20CF, U+2113, U+2C60-2C7F, U+A720-A7FF\";}s:16:\"latin-400-italic\";O:8:\"stdClass\":7:{s:2:\"id\";s:9:\"400italic\";s:10:\"fontFamily\";s:13:\"Public%20Sans\";s:9:\"fontStyle\";s:6:\"italic\";s:10:\"fontWeight\";s:3:\"400\";s:5:\"woff2\";s:131:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-public-sans/public-sans-italic-latin.woff2\";s:6:\"subset\";s:5:\"latin\";s:5:\"range\";s:154:\"U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD\";}s:20:\"latin-ext-600-italic\";O:8:\"stdClass\":7:{s:2:\"id\";s:9:\"600italic\";s:10:\"fontFamily\";s:13:\"Public%20Sans\";s:9:\"fontStyle\";s:6:\"italic\";s:10:\"fontWeight\";s:3:\"600\";s:5:\"woff2\";s:135:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-public-sans/public-sans-italic-latin-ext.woff2\";s:6:\"subset\";s:9:\"latin-ext\";s:5:\"range\";s:100:\"U+0100-024F, U+0259, U+1E00-1EFF, U+2020, U+20A0-20AB, U+20AD-20CF, U+2113, U+2C60-2C7F, U+A720-A7FF\";}s:16:\"latin-600-italic\";O:8:\"stdClass\":7:{s:2:\"id\";s:9:\"600italic\";s:10:\"fontFamily\";s:13:\"Public%20Sans\";s:9:\"fontStyle\";s:6:\"italic\";s:10:\"fontWeight\";s:3:\"600\";s:5:\"woff2\";s:131:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-public-sans/public-sans-italic-latin.woff2\";s:6:\"subset\";s:5:\"latin\";s:5:\"range\";s:154:\"U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD\";}s:20:\"latin-ext-700-italic\";O:8:\"stdClass\":7:{s:2:\"id\";s:9:\"700italic\";s:10:\"fontFamily\";s:13:\"Public%20Sans\";s:9:\"fontStyle\";s:6:\"italic\";s:10:\"fontWeight\";s:3:\"700\";s:5:\"woff2\";s:135:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-public-sans/public-sans-italic-latin-ext.woff2\";s:6:\"subset\";s:9:\"latin-ext\";s:5:\"range\";s:100:\"U+0100-024F, U+0259, U+1E00-1EFF, U+2020, U+20A0-20AB, U+20AD-20CF, U+2113, U+2C60-2C7F, U+A720-A7FF\";}s:16:\"latin-700-italic\";O:8:\"stdClass\":7:{s:2:\"id\";s:9:\"700italic\";s:10:\"fontFamily\";s:13:\"Public%20Sans\";s:9:\"fontStyle\";s:6:\"italic\";s:10:\"fontWeight\";s:3:\"700\";s:5:\"woff2\";s:131:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-public-sans/public-sans-italic-latin.woff2\";s:6:\"subset\";s:5:\"latin\";s:5:\"range\";s:154:\"U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD\";}s:13:\"latin-ext-400\";O:8:\"stdClass\":7:{s:2:\"id\";s:3:\"400\";s:10:\"fontFamily\";s:13:\"Public%20Sans\";s:9:\"fontStyle\";s:6:\"normal\";s:10:\"fontWeight\";s:3:\"400\";s:5:\"woff2\";s:135:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-public-sans/public-sans-normal-latin-ext.woff2\";s:6:\"subset\";s:9:\"latin-ext\";s:5:\"range\";s:100:\"U+0100-024F, U+0259, U+1E00-1EFF, U+2020, U+20A0-20AB, U+20AD-20CF, U+2113, U+2C60-2C7F, U+A720-A7FF\";}s:9:\"latin-400\";O:8:\"stdClass\":7:{s:2:\"id\";s:3:\"400\";s:10:\"fontFamily\";s:13:\"Public%20Sans\";s:9:\"fontStyle\";s:6:\"normal\";s:10:\"fontWeight\";s:3:\"400\";s:5:\"woff2\";s:131:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-public-sans/public-sans-normal-latin.woff2\";s:6:\"subset\";s:5:\"latin\";s:5:\"range\";s:154:\"U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD\";}s:13:\"latin-ext-600\";O:8:\"stdClass\":7:{s:2:\"id\";s:3:\"600\";s:10:\"fontFamily\";s:13:\"Public%20Sans\";s:9:\"fontStyle\";s:6:\"normal\";s:10:\"fontWeight\";s:3:\"600\";s:5:\"woff2\";s:135:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-public-sans/public-sans-normal-latin-ext.woff2\";s:6:\"subset\";s:9:\"latin-ext\";s:5:\"range\";s:100:\"U+0100-024F, U+0259, U+1E00-1EFF, U+2020, U+20A0-20AB, U+20AD-20CF, U+2113, U+2C60-2C7F, U+A720-A7FF\";}s:9:\"latin-600\";O:8:\"stdClass\":7:{s:2:\"id\";s:3:\"600\";s:10:\"fontFamily\";s:13:\"Public%20Sans\";s:9:\"fontStyle\";s:6:\"normal\";s:10:\"fontWeight\";s:3:\"600\";s:5:\"woff2\";s:131:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-public-sans/public-sans-normal-latin.woff2\";s:6:\"subset\";s:5:\"latin\";s:5:\"range\";s:154:\"U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD\";}s:13:\"latin-ext-700\";O:8:\"stdClass\":7:{s:2:\"id\";s:3:\"700\";s:10:\"fontFamily\";s:13:\"Public%20Sans\";s:9:\"fontStyle\";s:6:\"normal\";s:10:\"fontWeight\";s:3:\"700\";s:5:\"woff2\";s:135:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-public-sans/public-sans-normal-latin-ext.woff2\";s:6:\"subset\";s:9:\"latin-ext\";s:5:\"range\";s:100:\"U+0100-024F, U+0259, U+1E00-1EFF, U+2020, U+20A0-20AB, U+20AD-20CF, U+2113, U+2C60-2C7F, U+A720-A7FF\";}s:9:\"latin-700\";O:8:\"stdClass\":7:{s:2:\"id\";s:3:\"700\";s:10:\"fontFamily\";s:13:\"Public%20Sans\";s:9:\"fontStyle\";s:6:\"normal\";s:10:\"fontWeight\";s:3:\"700\";s:5:\"woff2\";s:131:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/omgf/local-stylesheet-font-face-public-sans/public-sans-normal-latin.woff2\";s:6:\"subset\";s:5:\"latin\";s:5:\"range\";s:154:\"U+0000-00FF, U+0131, U+0152-0153, U+02BB-02BC, U+02C6, U+02DA, U+02DC, U+2000-206F, U+2074, U+20AC, U+2122, U+2191, U+2193, U+2212, U+2215, U+FEFF, U+FFFD\";}}s:7:\"subsets\";a:3:{i:0;s:10:\"vietnamese\";i:1;s:9:\"latin-ext\";i:2;s:5:\"latin\";}}}}","yes");

INSERT IGNORE INTO `come_options` VALUES 
("2510","omgf_preload_fonts","","yes"),
("2511","omgf_unload_fonts","","yes"),
("2527","omgf_pro_process_local_stylesheets","on","yes"),
("2528","omgf_pro_process_inline_styles","on","yes"),
("2529","omgf_pro_process_webfont_loader","on","yes"),
("2530","omgf_pro_process_early_access","on","yes"),
("2620","omgf_pro_processed_local_stylesheets","a:14:{i:0;s:108:\"http://sparkway-client.de/sparkgarten/wp-content/uploads/themify-concate/20795596/themify-2607162203.min.css\";i:1;s:94:\"http://sparkway-client.de/sparkgarten/wp-content/plugins/duplicate-post/css/duplicate-post.css\";i:2;s:89:\"http://sparkway-client.de/sparkgarten/wp-content/plugins/wp-fastest-cache/css/toolbar.css\";i:3;s:97:\"http://sparkway-client.de/sparkgarten/wp-content/plugins/wordpress-seo/css/dist/adminbar-2010.css\";i:4;s:95:\"http://sparkway-client.de/sparkgarten/wp-content/plugins/autoptimize/classes/static/toolbar.css\";i:5;s:135:\"http://sparkway-client.de/sparkgarten/wp-content/themes/themify-ultra/themify/themify-builder/css/editor/themify.builder.loader.min.css\";i:6;s:102:\"http://sparkway-client.de/sparkgarten/wp-content/themes/themify-ultra/styles/modules/admin-bar.min.css\";i:7;s:109:\"https://sparkway-client.de/sparkgarten/wp-content/uploads/themify-concate/20795596/themify-3497899503.min.css\";i:8;s:95:\"https://sparkway-client.de/sparkgarten/wp-content/plugins/duplicate-post/css/duplicate-post.css\";i:9;s:90:\"https://sparkway-client.de/sparkgarten/wp-content/plugins/wp-fastest-cache/css/toolbar.css\";i:10;s:98:\"https://sparkway-client.de/sparkgarten/wp-content/plugins/wordpress-seo/css/dist/adminbar-2010.css\";i:11;s:96:\"https://sparkway-client.de/sparkgarten/wp-content/plugins/autoptimize/classes/static/toolbar.css\";i:12;s:132:\"https://sparkway-client.de/sparkgarten/wp-content/themes/themify-ultra/themify/themify-builder/css/editor/themify.builder.loader.css\";i:13;s:99:\"https://sparkway-client.de/sparkgarten/wp-content/themes/themify-ultra/styles/modules/admin-bar.css\";}","yes"),
("2627","edd_sl_a3082723c63b116f21b97dfd1be654bd","a:2:{s:7:\"timeout\";i:1699335082;s:5:\"value\";s:5:\"false\";}","no"),
("2637","duplicator_pro_migration_data","{\n    \"installType\": -1,\n    \"restoreBackupMode\": false,\n    \"recoveryMode\": false,\n    \"archivePath\": \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/20230218_gartenheckerasen_c28bc460b1874a607181_20230218233934_archive.zip\",\n    \"packageHash\": \"c28bc46-18233934\",\n    \"installerPath\": \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/installer.php\",\n    \"installerBootLog\": \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/dup-installer-bootlog__f950553-18233934.txt\",\n    \"installerLog\": \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/dup-installer\\/dup-installer-log__f950553-18233934.txt\",\n    \"dupInstallerPath\": \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/dup-installer\",\n    \"origFileFolderPath\": \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/dup-installer\\/original_files_c28bc46-18233934\",\n    \"safeMode\": 0,\n    \"cleanInstallerFiles\": true\n}","no"),
("2664","duplicator_pro_ui_view_state","a:1:{s:28:\"dup-settings-diag-opts-panel\";s:1:\"1\";}","yes"),
("2688","cerber_configuration","a:65:{s:5:\"email\";s:0:\"\";s:9:\"emailrate\";s:2:\"12\";s:6:\"notify\";s:0:\"\";s:14:\"notify-new-ver\";s:0:\"\";s:10:\"email_mask\";s:0:\"\";s:12:\"email_format\";s:0:\"\";s:8:\"use_smtp\";s:0:\"\";s:9:\"smtp_host\";s:0:\"\";s:9:\"smtp_port\";s:3:\"587\";s:9:\"smtp_encr\";s:3:\"tls\";s:8:\"smtp_pwd\";s:0:\"\";s:9:\"smtp_user\";s:0:\"\";s:9:\"smtp_from\";s:0:\"\";s:14:\"smtp_from_name\";s:9:\"WP Cerber\";s:7:\"pbtoken\";s:0:\"\";s:8:\"pbdevice\";s:1:\"N\";s:6:\"pbrate\";s:0:\"\";s:8:\"pbnotify\";s:0:\"\";s:7:\"pb_mask\";s:0:\"\";s:9:\"pb_format\";s:0:\"\";s:13:\"enable-report\";s:0:\"\";s:8:\"wreports\";s:0:\"\";s:12:\"email-report\";s:0:\"\";s:5:\"above\";s:1:\"3\";s:12:\"wreports-day\";s:1:\"1\";s:13:\"wreports-time\";s:1:\"9\";s:9:\"boot-mode\";s:1:\"0\";s:8:\"attempts\";s:1:\"5\";s:7:\"lockout\";s:2:\"60\";s:10:\"aggressive\";s:0:\"\";s:10:\"limitwhite\";s:0:\"\";s:9:\"loginnowp\";s:1:\"1\";s:11:\"nologinhint\";s:0:\"\";s:10:\"nopasshint\";s:0:\"\";s:11:\"nologinlang\";s:0:\"\";s:9:\"loginpath\";s:7:\"come-in\";s:13:\"logindeferred\";s:0:\"\";s:10:\"noredirect\";s:1:\"1\";s:8:\"nonusers\";s:1:\"1\";s:7:\"wplogin\";s:1:\"1\";s:6:\"subnet\";s:0:\"\";s:5:\"proxy\";s:0:\"\";s:10:\"cookiepref\";s:0:\"\";s:7:\"page404\";s:1:\"1\";s:10:\"citadel_on\";s:1:\"1\";s:7:\"citadel\";s:0:\"\";s:10:\"ciduration\";s:2:\"60\";s:8:\"cinotify\";s:1:\"1\";s:7:\"keeplog\";s:2:\"30\";s:12:\"keeplog_auth\";s:2:\"30\";s:9:\"cerberlab\";s:0:\"\";s:11:\"cerberproto\";s:1:\"0\";s:7:\"usefile\";s:0:\"\";s:8:\"ip_extra\";s:0:\"\";s:10:\"dateformat\";s:0:\"\";s:10:\"plain_date\";s:0:\"\";s:10:\"admin_lang\";s:0:\"\";s:14:\"top_admin_menu\";s:0:\"\";s:14:\"no_white_my_ip\";s:0:\"\";s:6:\"period\";s:2:\"30\";s:8:\"agperiod\";s:2:\"24\";s:7:\"aglocks\";s:1:\"2\";s:6:\"aglast\";s:1:\"4\";s:7:\"cilimit\";s:3:\"200\";s:8:\"ciperiod\";s:2:\"15\";}","no"),
("2715","omgf_settings","a:9:{s:12:\"auto_subsets\";s:0:\"\";s:14:\"display_option\";s:4:\"swap\";s:9:\"test_mode\";s:0:\"\";s:13:\"compatibility\";s:0:\"\";s:7:\"subsets\";a:2:{i:0;s:5:\"latin\";i:1;s:9:\"latin-ext\";}s:5:\"debug\";s:0:\"\";s:9:\"uninstall\";s:0:\"\";s:10:\"cache_keys\";s:0:\"\";s:18:\"unload_stylesheets\";s:0:\"\";}","yes"),
("2718","_transient_timeout_tf_531773131","1701805268","no"),
("2719","_transient_tf_531773131","{\"s\":{\"https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUFjIg1_i6t8kCHKm459Wx7xQYXK0vOoz6jq6R9WXV0poK5.woff2\":[\"0460-052F\",\"1C80-1C88\",\"20B4\",\"2DE0-2DFF\",\"A640-A69F\",\"FE2E-FE2F\"],\"https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUFjIg1_i6t8kCHKm459Wx7xQYXK0vOoz6jq6R9WXx0poK5.woff2\":[\"0301\",\"0400-045F\",\"0490-0491\",\"04B0-04B1\",\"2116\"],\"https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUFjIg1_i6t8kCHKm459Wx7xQYXK0vOoz6jq6R9WXd0poK5.woff2\":[\"0102-0103\",\"0110-0111\",\"0128-0129\",\"0168-0169\",\"01A0-01A1\",\"01AF-01B0\",\"0300-0301\",\"0303-0304\",\"0308-0309\",\"0323\",\"0329\",\"1EA0-1EF9\",\"20AB\"],\"https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUFjIg1_i6t8kCHKm459Wx7xQYXK0vOoz6jq6R9WXZ0poK5.woff2\":[\"0100-02AF\",\"0304\",\"0308\",\"0329\",\"1E00-1E9F\",\"1EF2-1EFF\",\"2020\",\"20A0-20AB\",\"20AD-20CF\",\"2113\",\"2C60-2C7F\",\"A720-A7FF\"],\"https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUFjIg1_i6t8kCHKm459Wx7xQYXK0vOoz6jq6R9WXh0pg.woff2\":[\"0000-00FF\",\"0131\",\"0152-0153\",\"02BB-02BC\",\"02C6\",\"02DA\",\"02DC\",\"0304\",\"0308\",\"0329\",\"2000-206F\",\"2074\",\"20AC\",\"2122\",\"2191\",\"2193\",\"2212\",\"2215\",\"FEFF\",\"FFFD\"],\"https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459WRhyzbi.woff2\":[\"0460-052F\",\"1C80-1C88\",\"20B4\",\"2DE0-2DFF\",\"A640-A69F\",\"FE2E-FE2F\"],\"https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459W1hyzbi.woff2\":[\"0301\",\"0400-045F\",\"0490-0491\",\"04B0-04B1\",\"2116\"],\"https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459WZhyzbi.woff2\":[\"0102-0103\",\"0110-0111\",\"0128-0129\",\"0168-0169\",\"01A0-01A1\",\"01AF-01B0\",\"0300-0301\",\"0303-0304\",\"0308-0309\",\"0323\",\"0329\",\"1EA0-1EF9\",\"20AB\"],\"https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459Wdhyzbi.woff2\":[\"0100-02AF\",\"0304\",\"0308\",\"0329\",\"1E00-1E9F\",\"1EF2-1EFF\",\"2020\",\"20A0-20AB\",\"20AD-20CF\",\"2113\",\"2C60-2C7F\",\"A720-A7FF\"],\"https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459Wlhyw.woff2\":[\"0000-00FF\",\"0131\",\"0152-0153\",\"02BB-02BC\",\"02C6\",\"02DA\",\"02DC\",\"0304\",\"0308\",\"0329\",\"2000-206F\",\"2074\",\"20AC\",\"2122\",\"2191\",\"2193\",\"2212\",\"2215\",\"FEFF\",\"FFFD\"],\"https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwTs572Xtc6ZYQws9YVwnNDTJPax9k0.woff2\":[\"0102-0103\",\"0110-0111\",\"0128-0129\",\"0168-0169\",\"01A0-01A1\",\"01AF-01B0\",\"0300-0301\",\"0303-0304\",\"0308-0309\",\"0323\",\"0329\",\"1EA0-1EF9\",\"20AB\"],\"https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwTs572Xtc6ZYQws9YVwnNDTJLax9k0.woff2\":[\"0100-02AF\",\"0304\",\"0308\",\"0329\",\"1E00-1E9F\",\"1EF2-1EFF\",\"2020\",\"20A0-20AB\",\"20AD-20CF\",\"2113\",\"2C60-2C7F\",\"A720-A7FF\"],\"https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwTs572Xtc6ZYQws9YVwnNDTJzaxw.woff2\":[\"0000-00FF\",\"0131\",\"0152-0153\",\"02BB-02BC\",\"02C6\",\"02DA\",\"02DC\",\"0304\",\"0308\",\"0329\",\"2000-206F\",\"2074\",\"20AC\",\"2122\",\"2191\",\"2193\",\"2212\",\"2215\",\"FEFF\",\"FFFD\"],\"https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwRs572Xtc6ZYQws9YVwnNJfJ7Cww.woff2\":[\"0102-0103\",\"0110-0111\",\"0128-0129\",\"0168-0169\",\"01A0-01A1\",\"01AF-01B0\",\"0300-0301\",\"0303-0304\",\"0308-0309\",\"0323\",\"0329\",\"1EA0-1EF9\",\"20AB\"],\"https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwRs572Xtc6ZYQws9YVwnNIfJ7Cww.woff2\":[\"0100-02AF\",\"0304\",\"0308\",\"0329\",\"1E00-1E9F\",\"1EF2-1EFF\",\"2020\",\"20A0-20AB\",\"20AD-20CF\",\"2113\",\"2C60-2C7F\",\"A720-A7FF\"],\"https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwRs572Xtc6ZYQws9YVwnNGfJ4.woff2\":[\"0000-00FF\",\"0131\",\"0152-0153\",\"02BB-02BC\",\"02C6\",\"02DA\",\"02DC\",\"0304\",\"0308\",\"0329\",\"2000-206F\",\"2074\",\"20AC\",\"2122\",\"2191\",\"2193\",\"2212\",\"2215\",\"FEFF\",\"FFFD\"]},\"c\":\"\\/* cyrillic-ext *\\/@font-face{  font-family:\'Montserrat\';  font-style:italic;  font-weight:400;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUFjIg1_i6t8kCHKm459Wx7xQYXK0vOoz6jq6R9WXV0poK5.woff2) format(\'woff2\');  unicode-range:U+0460-052F,U+1C80-1C88,U+20B4,U+2DE0-2DFF,U+A640-A69F,U+FE2E-FE2F;}\\/* cyrillic *\\/@font-face{  font-family:\'Montserrat\';  font-style:italic;  font-weight:400;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUFjIg1_i6t8kCHKm459Wx7xQYXK0vOoz6jq6R9WXx0poK5.woff2) format(\'woff2\');  unicode-range:U+0301,U+0400-045F,U+0490-0491,U+04B0-04B1,U+2116;}\\/* vietnamese *\\/@font-face{  font-family:\'Montserrat\';  font-style:italic;  font-weight:400;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUFjIg1_i6t8kCHKm459Wx7xQYXK0vOoz6jq6R9WXd0poK5.woff2) format(\'woff2\');  unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}\\/* latin-ext *\\/@font-face{  font-family:\'Montserrat\';  font-style:italic;  font-weight:400;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUFjIg1_i6t8kCHKm459Wx7xQYXK0vOoz6jq6R9WXZ0poK5.woff2) format(\'woff2\');  unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}\\/* latin *\\/@font-face{  font-family:\'Montserrat\';  font-style:italic;  font-weight:400;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUFjIg1_i6t8kCHKm459Wx7xQYXK0vOoz6jq6R9WXh0pg.woff2) format(\'woff2\');  unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}\\/* cyrillic-ext *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:200;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459WRhyzbi.woff2) format(\'woff2\');  unicode-range:U+0460-052F,U+1C80-1C88,U+20B4,U+2DE0-2DFF,U+A640-A69F,U+FE2E-FE2F;}\\/* cyrillic *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:200;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459W1hyzbi.woff2) format(\'woff2\');  unicode-range:U+0301,U+0400-045F,U+0490-0491,U+04B0-04B1,U+2116;}\\/* vietnamese *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:200;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459WZhyzbi.woff2) format(\'woff2\');  unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}\\/* latin-ext *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:200;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459Wdhyzbi.woff2) format(\'woff2\');  unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}\\/* latin *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:200;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459Wlhyw.woff2) format(\'woff2\');  unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}\\/* cyrillic-ext *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:300;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459WRhyzbi.woff2) format(\'woff2\');  unicode-range:U+0460-052F,U+1C80-1C88,U+20B4,U+2DE0-2DFF,U+A640-A69F,U+FE2E-FE2F;}\\/* cyrillic *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:300;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459W1hyzbi.woff2) format(\'woff2\');  unicode-range:U+0301,U+0400-045F,U+0490-0491,U+04B0-04B1,U+2116;}\\/* vietnamese *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:300;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459WZhyzbi.woff2) format(\'woff2\');  unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}\\/* latin-ext *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:300;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459Wdhyzbi.woff2) format(\'woff2\');  unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}\\/* latin *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:300;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459Wlhyw.woff2) format(\'woff2\');  unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}\\/* cyrillic-ext *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:400;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459WRhyzbi.woff2) format(\'woff2\');  unicode-range:U+0460-052F,U+1C80-1C88,U+20B4,U+2DE0-2DFF,U+A640-A69F,U+FE2E-FE2F;}\\/* cyrillic *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:400;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459W1hyzbi.woff2) format(\'woff2\');  unicode-range:U+0301,U+0400-045F,U+0490-0491,U+04B0-04B1,U+2116;}\\/* vietnamese *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:400;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459WZhyzbi.woff2) format(\'woff2\');  unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}\\/* latin-ext *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:400;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459Wdhyzbi.woff2) format(\'woff2\');  unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}\\/* latin *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:400;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459Wlhyw.woff2) format(\'woff2\');  unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}\\/* cyrillic-ext *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:500;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459WRhyzbi.woff2) format(\'woff2\');  unicode-range:U+0460-052F,U+1C80-1C88,U+20B4,U+2DE0-2DFF,U+A640-A69F,U+FE2E-FE2F;}\\/* cyrillic *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:500;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459W1hyzbi.woff2) format(\'woff2\');  unicode-range:U+0301,U+0400-045F,U+0490-0491,U+04B0-04B1,U+2116;}\\/* vietnamese *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:500;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459WZhyzbi.woff2) format(\'woff2\');  unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}\\/* latin-ext *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:500;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459Wdhyzbi.woff2) format(\'woff2\');  unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}\\/* latin *\\/@font-face{  font-family:\'Montserrat\';  font-style:normal;  font-weight:500;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/montserrat\\/v26\\/JTUSjIg1_i6t8kCHKm459Wlhyw.woff2) format(\'woff2\');  unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}\\/* vietnamese *\\/@font-face{  font-family:\'Public Sans\';  font-style:italic;  font-weight:400;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwTs572Xtc6ZYQws9YVwnNDTJPax9k0.woff2) format(\'woff2\');  unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}\\/* latin-ext *\\/@font-face{  font-family:\'Public Sans\';  font-style:italic;  font-weight:400;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwTs572Xtc6ZYQws9YVwnNDTJLax9k0.woff2) format(\'woff2\');  unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}\\/* latin *\\/@font-face{  font-family:\'Public Sans\';  font-style:italic;  font-weight:400;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwTs572Xtc6ZYQws9YVwnNDTJzaxw.woff2) format(\'woff2\');  unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}\\/* vietnamese *\\/@font-face{  font-family:\'Public Sans\';  font-style:italic;  font-weight:600;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwTs572Xtc6ZYQws9YVwnNDTJPax9k0.woff2) format(\'woff2\');  unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}\\/* latin-ext *\\/@font-face{  font-family:\'Public Sans\';  font-style:italic;  font-weight:600;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwTs572Xtc6ZYQws9YVwnNDTJLax9k0.woff2) format(\'woff2\');  unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}\\/* latin *\\/@font-face{  font-family:\'Public Sans\';  font-style:italic;  font-weight:600;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwTs572Xtc6ZYQws9YVwnNDTJzaxw.woff2) format(\'woff2\');  unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}\\/* vietnamese *\\/@font-face{  font-family:\'Public Sans\';  font-style:italic;  font-weight:700;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwTs572Xtc6ZYQws9YVwnNDTJPax9k0.woff2) format(\'woff2\');  unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}\\/* latin-ext *\\/@font-face{  font-family:\'Public Sans\';  font-style:italic;  font-weight:700;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwTs572Xtc6ZYQws9YVwnNDTJLax9k0.woff2) format(\'woff2\');  unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}\\/* latin *\\/@font-face{  font-family:\'Public Sans\';  font-style:italic;  font-weight:700;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwTs572Xtc6ZYQws9YVwnNDTJzaxw.woff2) format(\'woff2\');  unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}\\/* vietnamese *\\/@font-face{  font-family:\'Public Sans\';  font-style:normal;  font-weight:400;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwRs572Xtc6ZYQws9YVwnNJfJ7Cww.woff2) format(\'woff2\');  unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}\\/* latin-ext *\\/@font-face{  font-family:\'Public Sans\';  font-style:normal;  font-weight:400;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwRs572Xtc6ZYQws9YVwnNIfJ7Cww.woff2) format(\'woff2\');  unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}\\/* latin *\\/@font-face{  font-family:\'Public Sans\';  font-style:normal;  font-weight:400;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwRs572Xtc6ZYQws9YVwnNGfJ4.woff2) format(\'woff2\');  unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}\\/* vietnamese *\\/@font-face{  font-family:\'Public Sans\';  font-style:normal;  font-weight:600;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwRs572Xtc6ZYQws9YVwnNJfJ7Cww.woff2) format(\'woff2\');  unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}\\/* latin-ext *\\/@font-face{  font-family:\'Public Sans\';  font-style:normal;  font-weight:600;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwRs572Xtc6ZYQws9YVwnNIfJ7Cww.woff2) format(\'woff2\');  unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}\\/* latin *\\/@font-face{  font-family:\'Public Sans\';  font-style:normal;  font-weight:600;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwRs572Xtc6ZYQws9YVwnNGfJ4.woff2) format(\'woff2\');  unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}\\/* vietnamese *\\/@font-face{  font-family:\'Public Sans\';  font-style:normal;  font-weight:700;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwRs572Xtc6ZYQws9YVwnNJfJ7Cww.woff2) format(\'woff2\');  unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}\\/* latin-ext *\\/@font-face{  font-family:\'Public Sans\';  font-style:normal;  font-weight:700;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwRs572Xtc6ZYQws9YVwnNIfJ7Cww.woff2) format(\'woff2\');  unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}\\/* latin *\\/@font-face{  font-family:\'Public Sans\';  font-style:normal;  font-weight:700;  font-display:swap;  src:url(https:\\/\\/fonts.gstatic.com\\/s\\/publicsans\\/v15\\/ijwRs572Xtc6ZYQws9YVwnNGfJ4.woff2) format(\'woff2\');  unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}\"}","no"),
("2729","_transient_health-check-site-status-result","{\"good\":17,\"recommended\":5,\"critical\":0}","yes"),
("2747","can_compress_scripts","0","yes"),
("2764","updraft_lock_7d5d0656a49a","0","no"),
("2777","rsssl_options","a:31:{s:12:\"site_has_ssl\";s:1:\"1\";s:11:\"ssl_enabled\";s:0:\"\";s:19:\"mixed_content_fixer\";b:1;s:8:\"redirect\";s:11:\"wp_redirect\";s:20:\"do_not_edit_htaccess\";b:1;s:19:\"dismiss_all_notices\";b:1;s:31:\"switch_mixed_content_fixer_hook\";i:1;s:24:\"send_notifications_email\";i:0;s:25:\"admin_mixed_content_fixer\";i:1;s:24:\"delete_data_on_uninstall\";i:1;s:36:\"vulnerability_notification_dashboard\";s:1:\"l\";s:35:\"vulnerability_notification_sitewide\";s:1:\"h\";s:38:\"vulnerability_notification_email_admin\";s:1:\"c\";s:27:\"limit_login_attempts_amount\";s:1:\"3\";s:29:\"limit_login_attempts_duration\";s:2:\"30\";s:40:\"limit_login_attempts_locked_out_duration\";s:2:\"30\";s:16:\"x_xss_protection\";s:4:\"zero\";s:15:\"x_frame_options\";s:0:\"\";s:15:\"referrer_policy\";s:31:\"strict-origin-when-cross-origin\";s:12:\"hsts_max_age\";s:8:\"63072000\";s:26:\"cross_origin_opener_policy\";s:8:\"disabled\";s:28:\"cross_origin_resource_policy\";s:8:\"disabled\";s:28:\"cross_origin_embedder_policy\";s:8:\"disabled\";s:19:\"csp_frame_ancestors\";s:8:\"disabled\";s:20:\"disable_file_editing\";i:1;s:28:\"block_code_execution_uploads\";i:1;s:22:\"hide_wordpress_version\";i:1;s:22:\"disable_login_feedback\";i:1;s:24:\"disable_user_enumeration\";i:1;s:17:\"rename_admin_user\";i:1;s:14:\"disable_xmlrpc\";i:1;}","yes"),
("2781","rsssl_6_notice_dismissed","1","no"),
("2784","rsssl_show_onboarding","1","no"),
("2785","rsssl_flush_rewrite_rules","1698176938","yes"),
("2787","rsssl_previous_version","5.3.5","no"),
("2793","_site_transient_update_core","O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:65:\"https://downloads.wordpress.org/release/de_DE/wordpress-6.3.2.zip\";s:6:\"locale\";s:5:\"de_DE\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:65:\"https://downloads.wordpress.org/release/de_DE/wordpress-6.3.2.zip\";s:10:\"no_content\";s:0:\"\";s:11:\"new_bundled\";s:0:\"\";s:7:\"partial\";s:0:\"\";s:8:\"rollback\";s:0:\"\";}s:7:\"current\";s:5:\"6.3.2\";s:7:\"version\";s:5:\"6.3.2\";s:11:\"php_version\";s:5:\"7.0.0\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"6.1\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1699291840;s:15:\"version_checked\";s:5:\"6.3.2\";s:12:\"translations\";a:0:{}}","no"),
("2812","rsssl_last_tested_http_method","11","no"),
("2813","rsssl_http_methods_allowed","a:2:{s:11:\"not-allowed\";a:0:{}s:7:\"allowed\";a:12:{i:0;s:3:\"GET\";i:1;s:4:\"POST\";i:2;s:3:\"PUT\";i:3;s:6:\"DELETE\";i:4;s:4:\"HEAD\";i:5;s:7:\"OPTIONS\";i:6;s:7:\"CONNECT\";i:7;s:5:\"TRACE\";i:8;s:5:\"TRACK\";i:9;s:5:\"PATCH\";i:10;s:4:\"COPY\";i:11;s:4:\"LINK\";}}","no"),
("2814","rsssl_onboarding_dismissed","","no"),
("2817","rsssl_wp_version_detected","not-found","no"),
("2821","_transient_timeout_wpseo_total_unindexed_posts_limited","1699292632","no"),
("2822","_transient_wpseo_total_unindexed_posts_limited","0","no"),
("2823","_transient_timeout_wpseo_total_unindexed_terms_limited","1699292632","no"),
("2824","_transient_wpseo_total_unindexed_terms_limited","0","no"),
("2825","_transient_timeout_wpseo_total_unindexed_post_type_archives","1699378132","no"),
("2826","_transient_wpseo_total_unindexed_post_type_archives","0","no"),
("2827","_transient_timeout_wpseo_total_unindexed_general_items","1699378132","no"),
("2828","_transient_wpseo_total_unindexed_general_items","0","no"),
("2829","_transient_timeout_wpseo_unindexed_post_link_count","1699378132","no"),
("2830","_transient_wpseo_unindexed_post_link_count","0","no"),
("2831","_transient_timeout_wpseo_unindexed_term_link_count","1699378132","no"),
("2832","_transient_wpseo_unindexed_term_link_count","0","no"),
("2834","_site_transient_timeout_theme_roots","1699293534","no"),
("2835","_site_transient_theme_roots","a:3:{s:13:\"themify-ultra\";s:7:\"/themes\";s:17:\"twentytwentythree\";s:7:\"/themes\";s:15:\"twentytwentytwo\";s:7:\"/themes\";}","no"),
("2836","themify_updater_cache","a:1:{s:2:\"db\";a:4:{s:16:\"tu_license_error\";a:2:{s:5:\"value\";a:3:{s:4:\"code\";s:2:\"ok\";s:7:\"message\";s:0:\"\";s:6:\"notice\";s:0:\"\";}s:6:\"expire\";i:2145916799;}s:19:\"tu_license_products\";a:2:{s:5:\"value\";a:123:{i:0;s:16:\"announcement-bar\";i:1;s:19:\"themify-builder-pro\";i:2;s:11:\"themify-ptb\";i:3;s:15:\"themify-builder\";i:4;s:24:\"themify-ptb-extra-fields\";i:5;s:20:\"themify-ptb-map-view\";i:6;s:20:\"themify-ptb-relation\";i:7;s:18:\"themify-ptb-search\";i:8;s:23:\"themify-ptb-submissions\";i:9;s:16:\"builder-ab-image\";i:10;s:13:\"builder-audio\";i:11;s:17:\"builder-bar-chart\";i:12;s:23:\"builder-bg-video-slider\";i:13;s:14:\"builder-button\";i:14;s:15:\"builder-contact\";i:15;s:27:\"builder-content-restriction\";i:16;s:17:\"builder-countdown\";i:17;s:15:\"builder-counter\";i:18;s:15:\"builder-fittext\";i:19;s:17:\"builder-image-pro\";i:20;s:27:\"builder-infinite-background\";i:21;s:22:\"builder-infinite-posts\";i:22;s:16:\"builder-maps-pro\";i:23;s:20:\"builder-masked-image\";i:24;s:14:\"builder-mosaic\";i:25;s:16:\"builder-pointers\";i:26;s:21:\"builder-pricing-table\";i:27;s:20:\"builder-progress-bar\";i:28;s:18:\"builder-slider-pro\";i:29;s:17:\"builder-slideshow\";i:30;s:13:\"builder-tiles\";i:31;s:16:\"builder-timeline\";i:32;s:18:\"builder-typewriter\";i:33;s:19:\"builder-woocommerce\";i:34;s:13:\"themify-ultra\";i:35;s:14:\"themify-shoppe\";i:36;s:8:\"parallax\";i:37;s:13:\"themify-music\";i:38;s:8:\"fullpane\";i:39;s:13:\"themify-split\";i:40;s:6:\"agency\";i:41;s:16:\"agency-developer\";i:43;s:15:\"basic-developer\";i:44;s:5:\"bizco\";i:45;s:15:\"bizco-developer\";i:46;s:4:\"bold\";i:47;s:14:\"bold-developer\";i:48;s:17:\"themify-corporate\";i:49;s:27:\"themify-corporate-developer\";i:50;s:15:\"themify-elegant\";i:51;s:25:\"themify-elegant-developer\";i:52;s:6:\"elemin\";i:53;s:16:\"elemin-developer\";i:54;s:5:\"event\";i:55;s:15:\"event-developer\";i:56;s:4:\"flat\";i:57;s:14:\"flat-developer\";i:58;s:8:\"flatshop\";i:59;s:18:\"flatshop-developer\";i:60;s:13:\"themify-float\";i:61;s:23:\"themify-float-developer\";i:62;s:18:\"fullpane-developer\";i:63;s:10:\"fullscreen\";i:64;s:20:\"fullscreen-developer\";i:65;s:5:\"funki\";i:66;s:15:\"funki-developer\";i:67;s:5:\"grido\";i:68;s:15:\"grido-developer\";i:69;s:16:\"themify-infinite\";i:70;s:26:\"themify-infinite-developer\";i:72;s:17:\"itheme2-developer\";i:73;s:15:\"themify-landing\";i:74;s:25:\"themify-landing-developer\";i:75;s:8:\"magazine\";i:76;s:18:\"magazine-developer\";i:77;s:5:\"metro\";i:78;s:15:\"metro-developer\";i:79;s:6:\"minblr\";i:80;s:16:\"minblr-developer\";i:81;s:7:\"minshop\";i:82;s:17:\"minshop-developer\";i:83;s:23:\"themify-music-developer\";i:84;s:5:\"notes\";i:85;s:15:\"notes-developer\";i:86;s:18:\"parallax-developer\";i:87;s:12:\"themify-peak\";i:88;s:22:\"themify-peak-developer\";i:89;s:10:\"phototouch\";i:90;s:20:\"phototouch-developer\";i:91;s:8:\"pinboard\";i:92;s:18:\"pinboard-developer\";i:93;s:7:\"pinshop\";i:94;s:17:\"pinshop-developer\";i:95;s:8:\"postline\";i:96;s:18:\"postline-developer\";i:97;s:7:\"responz\";i:98;s:17:\"responz-developer\";i:99;s:8:\"shopdock\";i:100;s:18:\"shopdock-developer\";i:101;s:24:\"themify-shoppe-developer\";i:107;s:5:\"simfo\";i:108;s:15:\"simfo-developer\";i:110;s:24:\"themify-simple-developer\";i:111;s:23:\"themify-split-developer\";i:112;s:13:\"themify-stack\";i:113;s:23:\"themify-stack-developer\";i:114;s:4:\"suco\";i:115;s:14:\"suco-developer\";i:116;s:8:\"thememin\";i:117;s:18:\"thememin-developer\";i:118;s:4:\"tisa\";i:119;s:14:\"tisa-developer\";i:120;s:23:\"themify-ultra-developer\";i:157;s:6:\"wumblr\";i:158;s:16:\"wumblr-developer\";i:159;s:18:\"themify-event-post\";i:160;s:13:\"themify-popup\";i:161;s:22:\"themify-portfolio-post\";i:162;s:25:\"themify-wc-product-filter\";i:163;s:18:\"themify-shortcodes\";i:164;s:15:\"themify-updater\";i:165;s:13:\"themify-tiles\";i:166;s:20:\"woocommerce-shopdock\";}s:6:\"expire\";i:2145916799;}s:18:\"tu_license_expires\";a:2:{s:5:\"value\";i:2145916799;s:6:\"expire\";i:2145916799;}s:18:\"versions_fetchTime\";a:2:{s:5:\"value\";i:1699291735;s:6:\"expire\";i:1699334935;}}}","yes"),
("2838","_site_transient_update_plugins","O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1699291877;s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:14:{s:37:\"tinymce-advanced/tinymce-advanced.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:30:\"w.org/plugins/tinymce-advanced\";s:4:\"slug\";s:16:\"tinymce-advanced\";s:6:\"plugin\";s:37:\"tinymce-advanced/tinymce-advanced.php\";s:11:\"new_version\";s:5:\"5.9.2\";s:3:\"url\";s:47:\"https://wordpress.org/plugins/tinymce-advanced/\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/plugin/tinymce-advanced.5.9.2.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:68:\"https://ps.w.org/tinymce-advanced/assets/icon-256x256.png?rev=971511\";s:2:\"1x\";s:68:\"https://ps.w.org/tinymce-advanced/assets/icon-128x128.png?rev=971511\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:72:\"https://ps.w.org/tinymce-advanced/assets/banner-1544x500.png?rev=2390186\";s:2:\"1x\";s:71:\"https://ps.w.org/tinymce-advanced/assets/banner-772x250.png?rev=2390186\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"5.9\";}s:29:\"antispam-bee/antispam_bee.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:26:\"w.org/plugins/antispam-bee\";s:4:\"slug\";s:12:\"antispam-bee\";s:6:\"plugin\";s:29:\"antispam-bee/antispam_bee.php\";s:11:\"new_version\";s:6:\"2.11.5\";s:3:\"url\";s:43:\"https://wordpress.org/plugins/antispam-bee/\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/plugin/antispam-bee.2.11.5.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:65:\"https://ps.w.org/antispam-bee/assets/icon-256x256.png?rev=2898402\";s:2:\"1x\";s:65:\"https://ps.w.org/antispam-bee/assets/icon-128x128.png?rev=2898402\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:68:\"https://ps.w.org/antispam-bee/assets/banner-1544x500.png?rev=2898402\";s:2:\"1x\";s:67:\"https://ps.w.org/antispam-bee/assets/banner-772x250.png?rev=2898402\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"4.5\";}s:27:\"autoptimize/autoptimize.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:25:\"w.org/plugins/autoptimize\";s:4:\"slug\";s:11:\"autoptimize\";s:6:\"plugin\";s:27:\"autoptimize/autoptimize.php\";s:11:\"new_version\";s:5:\"3.1.9\";s:3:\"url\";s:42:\"https://wordpress.org/plugins/autoptimize/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/plugin/autoptimize.3.1.9.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:64:\"https://ps.w.org/autoptimize/assets/icon-256X256.png?rev=2211608\";s:2:\"1x\";s:64:\"https://ps.w.org/autoptimize/assets/icon-128x128.png?rev=1864142\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:66:\"https://ps.w.org/autoptimize/assets/banner-772x250.jpg?rev=1315920\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"5.3\";}s:32:\"blackhole-bad-bots/blackhole.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:32:\"w.org/plugins/blackhole-bad-bots\";s:4:\"slug\";s:18:\"blackhole-bad-bots\";s:6:\"plugin\";s:32:\"blackhole-bad-bots/blackhole.php\";s:11:\"new_version\";s:5:\"3.6.1\";s:3:\"url\";s:49:\"https://wordpress.org/plugins/blackhole-bad-bots/\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/plugin/blackhole-bad-bots.3.6.1.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:71:\"https://ps.w.org/blackhole-bad-bots/assets/icon-256x256.png?rev=1471215\";s:2:\"1x\";s:71:\"https://ps.w.org/blackhole-bad-bots/assets/icon-128x128.png?rev=1471215\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:74:\"https://ps.w.org/blackhole-bad-bots/assets/banner-1544x500.jpg?rev=1353077\";s:2:\"1x\";s:73:\"https://ps.w.org/blackhole-bad-bots/assets/banner-772x250.jpg?rev=1353077\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"4.6\";}s:39:\"disable-gutenberg/disable-gutenberg.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:31:\"w.org/plugins/disable-gutenberg\";s:4:\"slug\";s:17:\"disable-gutenberg\";s:6:\"plugin\";s:39:\"disable-gutenberg/disable-gutenberg.php\";s:11:\"new_version\";s:3:\"3.1\";s:3:\"url\";s:48:\"https://wordpress.org/plugins/disable-gutenberg/\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/plugin/disable-gutenberg.3.1.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:70:\"https://ps.w.org/disable-gutenberg/assets/icon-256x256.png?rev=1925990\";s:2:\"1x\";s:70:\"https://ps.w.org/disable-gutenberg/assets/icon-128x128.png?rev=1925990\";}s:7:\"banners\";a:0:{}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"4.9\";}s:57:\"manage-notification-emails/manage-notification-emails.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:40:\"w.org/plugins/manage-notification-emails\";s:4:\"slug\";s:26:\"manage-notification-emails\";s:6:\"plugin\";s:57:\"manage-notification-emails/manage-notification-emails.php\";s:11:\"new_version\";s:5:\"1.8.5\";s:3:\"url\";s:57:\"https://wordpress.org/plugins/manage-notification-emails/\";s:7:\"package\";s:75:\"https://downloads.wordpress.org/plugin/manage-notification-emails.1.8.5.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:79:\"https://ps.w.org/manage-notification-emails/assets/icon-256x256.png?rev=1242800\";s:2:\"1x\";s:79:\"https://ps.w.org/manage-notification-emails/assets/icon-128x128.png?rev=1252518\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:82:\"https://ps.w.org/manage-notification-emails/assets/banner-1544x500.png?rev=1242800\";s:2:\"1x\";s:81:\"https://ps.w.org/manage-notification-emails/assets/banner-772x250.png?rev=1252518\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:5:\"4.0.0\";}s:47:\"really-simple-ssl/rlrsssl-really-simple-ssl.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:31:\"w.org/plugins/really-simple-ssl\";s:4:\"slug\";s:17:\"really-simple-ssl\";s:6:\"plugin\";s:47:\"really-simple-ssl/rlrsssl-really-simple-ssl.php\";s:11:\"new_version\";s:5:\"7.1.3\";s:3:\"url\";s:48:\"https://wordpress.org/plugins/really-simple-ssl/\";s:7:\"package\";s:66:\"https://downloads.wordpress.org/plugin/really-simple-ssl.7.1.3.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:70:\"https://ps.w.org/really-simple-ssl/assets/icon-256x256.png?rev=2839720\";s:2:\"1x\";s:70:\"https://ps.w.org/really-simple-ssl/assets/icon-128x128.png?rev=2839720\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:73:\"https://ps.w.org/really-simple-ssl/assets/banner-1544x500.png?rev=2810049\";s:2:\"1x\";s:72:\"https://ps.w.org/really-simple-ssl/assets/banner-772x250.png?rev=2810049\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"5.8\";}s:44:\"shortpixel-image-optimiser/wp-shortpixel.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:40:\"w.org/plugins/shortpixel-image-optimiser\";s:4:\"slug\";s:26:\"shortpixel-image-optimiser\";s:6:\"plugin\";s:44:\"shortpixel-image-optimiser/wp-shortpixel.php\";s:11:\"new_version\";s:5:\"5.4.3\";s:3:\"url\";s:57:\"https://wordpress.org/plugins/shortpixel-image-optimiser/\";s:7:\"package\";s:75:\"https://downloads.wordpress.org/plugin/shortpixel-image-optimiser.5.4.3.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:79:\"https://ps.w.org/shortpixel-image-optimiser/assets/icon-256x256.png?rev=1038819\";s:2:\"1x\";s:79:\"https://ps.w.org/shortpixel-image-optimiser/assets/icon-128x128.png?rev=1038819\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:81:\"https://ps.w.org/shortpixel-image-optimiser/assets/banner-772x250.png?rev=1730573\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:5:\"4.8.0\";}s:46:\"under-construction-page/under-construction.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:37:\"w.org/plugins/under-construction-page\";s:4:\"slug\";s:23:\"under-construction-page\";s:6:\"plugin\";s:46:\"under-construction-page/under-construction.php\";s:11:\"new_version\";s:4:\"3.97\";s:3:\"url\";s:54:\"https://wordpress.org/plugins/under-construction-page/\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/plugin/under-construction-page.3.97.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:76:\"https://ps.w.org/under-construction-page/assets/icon-256x256.gif?rev=2284849\";s:2:\"1x\";s:76:\"https://ps.w.org/under-construction-page/assets/icon-128x128.gif?rev=2284852\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:79:\"https://ps.w.org/under-construction-page/assets/banner-1544x500.png?rev=1628376\";s:2:\"1x\";s:78:\"https://ps.w.org/under-construction-page/assets/banner-772x250.png?rev=1575797\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"4.0\";}s:27:\"updraftplus/updraftplus.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:25:\"w.org/plugins/updraftplus\";s:4:\"slug\";s:11:\"updraftplus\";s:6:\"plugin\";s:27:\"updraftplus/updraftplus.php\";s:11:\"new_version\";s:7:\"1.23.11\";s:3:\"url\";s:42:\"https://wordpress.org/plugins/updraftplus/\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/plugin/updraftplus.1.23.11.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:64:\"https://ps.w.org/updraftplus/assets/icon-256x256.jpg?rev=1686200\";s:2:\"1x\";s:64:\"https://ps.w.org/updraftplus/assets/icon-128x128.jpg?rev=1686200\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/updraftplus/assets/banner-1544x500.png?rev=1686200\";s:2:\"1x\";s:66:\"https://ps.w.org/updraftplus/assets/banner-772x250.png?rev=1686200\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"3.2\";}s:49:\"wordpress-ping-optimizer/cbnet-ping-optimizer.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:38:\"w.org/plugins/wordpress-ping-optimizer\";s:4:\"slug\";s:24:\"wordpress-ping-optimizer\";s:6:\"plugin\";s:49:\"wordpress-ping-optimizer/cbnet-ping-optimizer.php\";s:11:\"new_version\";s:10:\"2.35.1.3.0\";s:3:\"url\";s:55:\"https://wordpress.org/plugins/wordpress-ping-optimizer/\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/plugin/wordpress-ping-optimizer.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:77:\"https://ps.w.org/wordpress-ping-optimizer/assets/icon-256x256.png?rev=1342442\";s:2:\"1x\";s:77:\"https://ps.w.org/wordpress-ping-optimizer/assets/icon-128x128.png?rev=1342442\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:79:\"https://ps.w.org/wordpress-ping-optimizer/assets/banner-772x250.png?rev=1342442\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:5:\"3.0.1\";}s:35:\"wp-fastest-cache/wpFastestCache.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:30:\"w.org/plugins/wp-fastest-cache\";s:4:\"slug\";s:16:\"wp-fastest-cache\";s:6:\"plugin\";s:35:\"wp-fastest-cache/wpFastestCache.php\";s:11:\"new_version\";s:5:\"1.2.1\";s:3:\"url\";s:47:\"https://wordpress.org/plugins/wp-fastest-cache/\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/plugin/wp-fastest-cache.1.2.1.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:69:\"https://ps.w.org/wp-fastest-cache/assets/icon-256x256.png?rev=2064586\";s:2:\"1x\";s:69:\"https://ps.w.org/wp-fastest-cache/assets/icon-128x128.png?rev=1068904\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:71:\"https://ps.w.org/wp-fastest-cache/assets/banner-772x250.jpg?rev=1064099\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"3.3\";}s:33:\"duplicate-post/duplicate-post.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:28:\"w.org/plugins/duplicate-post\";s:4:\"slug\";s:14:\"duplicate-post\";s:6:\"plugin\";s:33:\"duplicate-post/duplicate-post.php\";s:11:\"new_version\";s:3:\"4.5\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/duplicate-post/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/plugin/duplicate-post.4.5.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/duplicate-post/assets/icon-256x256.png?rev=2336666\";s:2:\"1x\";s:67:\"https://ps.w.org/duplicate-post/assets/icon-128x128.png?rev=2336666\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:70:\"https://ps.w.org/duplicate-post/assets/banner-1544x500.png?rev=2336666\";s:2:\"1x\";s:69:\"https://ps.w.org/duplicate-post/assets/banner-772x250.png?rev=2336666\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"6.2\";}s:24:\"wordpress-seo/wp-seo.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:27:\"w.org/plugins/wordpress-seo\";s:4:\"slug\";s:13:\"wordpress-seo\";s:6:\"plugin\";s:24:\"wordpress-seo/wp-seo.php\";s:11:\"new_version\";s:4:\"21.5\";s:3:\"url\";s:44:\"https://wordpress.org/plugins/wordpress-seo/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/plugin/wordpress-seo.21.5.zip\";s:5:\"icons\";a:2:{s:2:\"1x\";s:58:\"https://ps.w.org/wordpress-seo/assets/icon.svg?rev=2363699\";s:3:\"svg\";s:58:\"https://ps.w.org/wordpress-seo/assets/icon.svg?rev=2363699\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:69:\"https://ps.w.org/wordpress-seo/assets/banner-1544x500.png?rev=2643727\";s:2:\"1x\";s:68:\"https://ps.w.org/wordpress-seo/assets/banner-772x250.png?rev=2643727\";}s:11:\"banners_rtl\";a:2:{s:2:\"2x\";s:73:\"https://ps.w.org/wordpress-seo/assets/banner-1544x500-rtl.png?rev=2643727\";s:2:\"1x\";s:72:\"https://ps.w.org/wordpress-seo/assets/banner-772x250-rtl.png?rev=2643727\";}s:8:\"requires\";s:3:\"6.2\";}}s:7:\"checked\";a:18:{s:37:\"tinymce-advanced/tinymce-advanced.php\";s:5:\"5.9.2\";s:29:\"antispam-bee/antispam_bee.php\";s:6:\"2.11.5\";s:27:\"autoptimize/autoptimize.php\";s:5:\"3.1.9\";s:32:\"blackhole-bad-bots/blackhole.php\";s:5:\"3.6.1\";s:24:\"builder-contact/init.php\";s:5:\"3.0.5\";s:39:\"disable-gutenberg/disable-gutenberg.php\";s:3:\"3.1\";s:33:\"duplicator-pro/duplicator-pro.php\";s:7:\"4.5.8.3\";s:57:\"manage-notification-emails/manage-notification-emails.php\";s:5:\"1.8.5\";s:47:\"really-simple-ssl/rlrsssl-really-simple-ssl.php\";s:5:\"7.1.3\";s:44:\"shortpixel-image-optimiser/wp-shortpixel.php\";s:5:\"5.4.3\";s:43:\"themify-builder-pro/themify-builder-pro.php\";s:5:\"3.1.2\";s:35:\"themify-updater/themify-updater.php\";s:5:\"1.4.7\";s:46:\"under-construction-page/under-construction.php\";s:4:\"3.97\";s:27:\"updraftplus/updraftplus.php\";s:7:\"1.23.11\";s:49:\"wordpress-ping-optimizer/cbnet-ping-optimizer.php\";s:10:\"2.35.1.3.0\";s:35:\"wp-fastest-cache/wpFastestCache.php\";s:5:\"1.2.1\";s:33:\"duplicate-post/duplicate-post.php\";s:3:\"4.5\";s:24:\"wordpress-seo/wp-seo.php\";s:4:\"21.5\";}}","no"),
("2839","_site_transient_timeout_php_check_4e65496a675acbae70f7731b62fe9fd1","1699896553","no"),
("2840","_site_transient_php_check_4e65496a675acbae70f7731b62fe9fd1","a:5:{s:19:\"recommended_version\";s:3:\"7.4\";s:15:\"minimum_version\";s:3:\"7.0\";s:12:\"is_supported\";b:1;s:9:\"is_secure\";b:1;s:13:\"is_acceptable\";b:1;}","no"),
("2843","_site_transient_timeout_available_translations","1699302601","no"),
("2844","_site_transient_available_translations","a:131:{s:2:\"af\";a:8:{s:8:\"language\";s:2:\"af\";s:7:\"version\";s:8:\"5.8-beta\";s:7:\"updated\";s:19:\"2021-05-13 15:59:22\";s:12:\"english_name\";s:9:\"Afrikaans\";s:11:\"native_name\";s:9:\"Afrikaans\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/5.8-beta/af.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"af\";i:2;s:3:\"afr\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"Gaan voort\";}}s:2:\"am\";a:8:{s:8:\"language\";s:2:\"am\";s:7:\"version\";s:5:\"6.0.6\";s:7:\"updated\";s:19:\"2022-09-29 20:43:49\";s:12:\"english_name\";s:7:\"Amharic\";s:11:\"native_name\";s:12:\"አማርኛ\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.0.6/am.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"am\";i:2;s:3:\"amh\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"ቀጥል\";}}s:3:\"arg\";a:8:{s:8:\"language\";s:3:\"arg\";s:7:\"version\";s:8:\"6.2-beta\";s:7:\"updated\";s:19:\"2022-09-22 16:46:56\";s:12:\"english_name\";s:9:\"Aragonese\";s:11:\"native_name\";s:9:\"Aragonés\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/6.2-beta/arg.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"an\";i:2;s:3:\"arg\";i:3;s:3:\"arg\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continar\";}}s:2:\"ar\";a:8:{s:8:\"language\";s:2:\"ar\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-20 14:52:12\";s:12:\"english_name\";s:6:\"Arabic\";s:11:\"native_name\";s:14:\"العربية\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.3.2/ar.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ar\";i:2;s:3:\"ara\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"متابعة\";}}s:3:\"ary\";a:8:{s:8:\"language\";s:3:\"ary\";s:7:\"version\";s:6:\"4.8.23\";s:7:\"updated\";s:19:\"2017-01-26 15:42:35\";s:12:\"english_name\";s:15:\"Moroccan Arabic\";s:11:\"native_name\";s:31:\"العربية المغربية\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/translation/core/4.8.23/ary.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ar\";i:3;s:3:\"ary\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"المتابعة\";}}s:2:\"as\";a:8:{s:8:\"language\";s:2:\"as\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-17 09:27:56\";s:12:\"english_name\";s:8:\"Assamese\";s:11:\"native_name\";s:21:\"অসমীয়া\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.3.2/as.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"as\";i:2;s:3:\"asm\";i:3;s:3:\"asm\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:3:\"azb\";a:8:{s:8:\"language\";s:3:\"azb\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-09-12 20:34:31\";s:12:\"english_name\";s:17:\"South Azerbaijani\";s:11:\"native_name\";s:29:\"گؤنئی آذربایجان\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/azb.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"az\";i:3;s:3:\"azb\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:2:\"az\";a:8:{s:8:\"language\";s:2:\"az\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-11-06 00:09:27\";s:12:\"english_name\";s:11:\"Azerbaijani\";s:11:\"native_name\";s:16:\"Azərbaycan dili\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/az.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"az\";i:2;s:3:\"aze\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Davam\";}}s:3:\"bel\";a:8:{s:8:\"language\";s:3:\"bel\";s:7:\"version\";s:6:\"4.9.24\";s:7:\"updated\";s:19:\"2019-10-29 07:54:22\";s:12:\"english_name\";s:10:\"Belarusian\";s:11:\"native_name\";s:29:\"Беларуская мова\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/translation/core/4.9.24/bel.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"be\";i:2;s:3:\"bel\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Працягнуць\";}}s:5:\"bg_BG\";a:8:{s:8:\"language\";s:5:\"bg_BG\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-30 17:34:42\";s:12:\"english_name\";s:9:\"Bulgarian\";s:11:\"native_name\";s:18:\"Български\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/bg_BG.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"bg\";i:2;s:3:\"bul\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Напред\";}}s:5:\"bn_BD\";a:8:{s:8:\"language\";s:5:\"bn_BD\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-16 10:44:14\";s:12:\"english_name\";s:20:\"Bengali (Bangladesh)\";s:11:\"native_name\";s:15:\"বাংলা\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/bn_BD.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"bn\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:28:\"চালিয়ে যান\";}}s:2:\"bo\";a:8:{s:8:\"language\";s:2:\"bo\";s:7:\"version\";s:8:\"5.8-beta\";s:7:\"updated\";s:19:\"2020-10-30 03:24:38\";s:12:\"english_name\";s:7:\"Tibetan\";s:11:\"native_name\";s:21:\"བོད་ཡིག\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/5.8-beta/bo.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"bo\";i:2;s:3:\"tib\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:33:\"མུ་མཐུད་དུ།\";}}s:5:\"bs_BA\";a:8:{s:8:\"language\";s:5:\"bs_BA\";s:7:\"version\";s:5:\"6.2.3\";s:7:\"updated\";s:19:\"2023-02-22 20:45:53\";s:12:\"english_name\";s:7:\"Bosnian\";s:11:\"native_name\";s:8:\"Bosanski\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.2.3/bs_BA.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"bs\";i:2;s:3:\"bos\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Nastavi\";}}s:2:\"ca\";a:8:{s:8:\"language\";s:2:\"ca\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-18 13:58:36\";s:12:\"english_name\";s:7:\"Catalan\";s:11:\"native_name\";s:7:\"Català\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.3.2/ca.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ca\";i:2;s:3:\"cat\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continua\";}}s:3:\"ceb\";a:8:{s:8:\"language\";s:3:\"ceb\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-03-02 17:25:51\";s:12:\"english_name\";s:7:\"Cebuano\";s:11:\"native_name\";s:7:\"Cebuano\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/ceb.zip\";s:3:\"iso\";a:2:{i:2;s:3:\"ceb\";i:3;s:3:\"ceb\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Padayun\";}}s:5:\"cs_CZ\";a:8:{s:8:\"language\";s:5:\"cs_CZ\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-13 05:44:31\";s:12:\"english_name\";s:5:\"Czech\";s:11:\"native_name\";s:9:\"Čeština\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/cs_CZ.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"cs\";i:2;s:3:\"ces\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:11:\"Pokračovat\";}}s:2:\"cy\";a:8:{s:8:\"language\";s:2:\"cy\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-18 09:36:50\";s:12:\"english_name\";s:5:\"Welsh\";s:11:\"native_name\";s:7:\"Cymraeg\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.3.2/cy.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"cy\";i:2;s:3:\"cym\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Parhau\";}}s:5:\"da_DK\";a:8:{s:8:\"language\";s:5:\"da_DK\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-12 12:32:40\";s:12:\"english_name\";s:6:\"Danish\";s:11:\"native_name\";s:5:\"Dansk\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/da_DK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"da\";i:2;s:3:\"dan\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Fortsæt\";}}s:5:\"de_AT\";a:8:{s:8:\"language\";s:5:\"de_AT\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-08-18 08:19:14\";s:12:\"english_name\";s:16:\"German (Austria)\";s:11:\"native_name\";s:21:\"Deutsch (Österreich)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/de_AT.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Weiter\";}}s:5:\"de_CH\";a:8:{s:8:\"language\";s:5:\"de_CH\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-08-08 09:49:50\";s:12:\"english_name\";s:20:\"German (Switzerland)\";s:11:\"native_name\";s:17:\"Deutsch (Schweiz)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/de_CH.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Weiter\";}}s:14:\"de_CH_informal\";a:8:{s:8:\"language\";s:14:\"de_CH_informal\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-08-08 09:52:35\";s:12:\"english_name\";s:30:\"German (Switzerland, Informal)\";s:11:\"native_name\";s:21:\"Deutsch (Schweiz, Du)\";s:7:\"package\";s:73:\"https://downloads.wordpress.org/translation/core/6.3.2/de_CH_informal.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Weiter\";}}s:12:\"de_DE_formal\";a:8:{s:8:\"language\";s:12:\"de_DE_formal\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-12 18:16:41\";s:12:\"english_name\";s:15:\"German (Formal)\";s:11:\"native_name\";s:13:\"Deutsch (Sie)\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/translation/core/6.3.2/de_DE_formal.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Weiter\";}}s:5:\"de_DE\";a:8:{s:8:\"language\";s:5:\"de_DE\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-12 18:16:33\";s:12:\"english_name\";s:6:\"German\";s:11:\"native_name\";s:7:\"Deutsch\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/de_DE.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Weiter\";}}s:3:\"dsb\";a:8:{s:8:\"language\";s:3:\"dsb\";s:7:\"version\";s:5:\"6.2.3\";s:7:\"updated\";s:19:\"2022-07-16 12:13:09\";s:12:\"english_name\";s:13:\"Lower Sorbian\";s:11:\"native_name\";s:16:\"Dolnoserbšćina\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/6.2.3/dsb.zip\";s:3:\"iso\";a:2:{i:2;s:3:\"dsb\";i:3;s:3:\"dsb\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Dalej\";}}s:3:\"dzo\";a:8:{s:8:\"language\";s:3:\"dzo\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-06-29 08:59:03\";s:12:\"english_name\";s:8:\"Dzongkha\";s:11:\"native_name\";s:18:\"རྫོང་ཁ\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/dzo.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"dz\";i:2;s:3:\"dzo\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:2:\"el\";a:8:{s:8:\"language\";s:2:\"el\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-31 11:51:34\";s:12:\"english_name\";s:5:\"Greek\";s:11:\"native_name\";s:16:\"Ελληνικά\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.3.2/el.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"el\";i:2;s:3:\"ell\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"Συνέχεια\";}}s:5:\"en_AU\";a:8:{s:8:\"language\";s:5:\"en_AU\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-22 00:24:59\";s:12:\"english_name\";s:19:\"English (Australia)\";s:11:\"native_name\";s:19:\"English (Australia)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/en_AU.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_ZA\";a:8:{s:8:\"language\";s:5:\"en_ZA\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-08-28 15:58:51\";s:12:\"english_name\";s:22:\"English (South Africa)\";s:11:\"native_name\";s:22:\"English (South Africa)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/en_ZA.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_GB\";a:8:{s:8:\"language\";s:5:\"en_GB\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-07 10:32:51\";s:12:\"english_name\";s:12:\"English (UK)\";s:11:\"native_name\";s:12:\"English (UK)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/en_GB.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_NZ\";a:8:{s:8:\"language\";s:5:\"en_NZ\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-08-28 15:57:23\";s:12:\"english_name\";s:21:\"English (New Zealand)\";s:11:\"native_name\";s:21:\"English (New Zealand)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/en_NZ.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_CA\";a:8:{s:8:\"language\";s:5:\"en_CA\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-08-03 07:25:21\";s:12:\"english_name\";s:16:\"English (Canada)\";s:11:\"native_name\";s:16:\"English (Canada)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/en_CA.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:2:\"eo\";a:8:{s:8:\"language\";s:2:\"eo\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-09-20 08:57:43\";s:12:\"english_name\";s:9:\"Esperanto\";s:11:\"native_name\";s:9:\"Esperanto\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.3.2/eo.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"eo\";i:2;s:3:\"epo\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Daŭrigi\";}}s:5:\"es_MX\";a:8:{s:8:\"language\";s:5:\"es_MX\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-09-22 13:44:03\";s:12:\"english_name\";s:16:\"Spanish (Mexico)\";s:11:\"native_name\";s:19:\"Español de México\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/es_MX.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_CR\";a:8:{s:8:\"language\";s:5:\"es_CR\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-08-26 01:50:26\";s:12:\"english_name\";s:20:\"Spanish (Costa Rica)\";s:11:\"native_name\";s:22:\"Español de Costa Rica\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/es_CR.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_AR\";a:8:{s:8:\"language\";s:5:\"es_AR\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-08-31 02:13:04\";s:12:\"english_name\";s:19:\"Spanish (Argentina)\";s:11:\"native_name\";s:21:\"Español de Argentina\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/es_AR.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_VE\";a:8:{s:8:\"language\";s:5:\"es_VE\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-16 16:00:04\";s:12:\"english_name\";s:19:\"Spanish (Venezuela)\";s:11:\"native_name\";s:21:\"Español de Venezuela\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/es_VE.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_CO\";a:8:{s:8:\"language\";s:5:\"es_CO\";s:7:\"version\";s:5:\"6.2.3\";s:7:\"updated\";s:19:\"2023-03-14 22:16:37\";s:12:\"english_name\";s:18:\"Spanish (Colombia)\";s:11:\"native_name\";s:20:\"Español de Colombia\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.2.3/es_CO.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_EC\";a:8:{s:8:\"language\";s:5:\"es_EC\";s:7:\"version\";s:5:\"6.2.3\";s:7:\"updated\";s:19:\"2023-04-21 13:32:10\";s:12:\"english_name\";s:17:\"Spanish (Ecuador)\";s:11:\"native_name\";s:19:\"Español de Ecuador\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.2.3/es_EC.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_DO\";a:8:{s:8:\"language\";s:5:\"es_DO\";s:7:\"version\";s:5:\"5.8.8\";s:7:\"updated\";s:19:\"2021-10-08 14:32:50\";s:12:\"english_name\";s:28:\"Spanish (Dominican Republic)\";s:11:\"native_name\";s:33:\"Español de República Dominicana\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/5.8.8/es_DO.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_PE\";a:8:{s:8:\"language\";s:5:\"es_PE\";s:7:\"version\";s:5:\"5.8.8\";s:7:\"updated\";s:19:\"2021-10-04 20:53:18\";s:12:\"english_name\";s:14:\"Spanish (Peru)\";s:11:\"native_name\";s:17:\"Español de Perú\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/5.8.8/es_PE.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_UY\";a:8:{s:8:\"language\";s:5:\"es_UY\";s:7:\"version\";s:8:\"5.8-beta\";s:7:\"updated\";s:19:\"2021-03-31 18:33:26\";s:12:\"english_name\";s:17:\"Spanish (Uruguay)\";s:11:\"native_name\";s:19:\"Español de Uruguay\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/translation/core/5.8-beta/es_UY.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_CL\";a:8:{s:8:\"language\";s:5:\"es_CL\";s:7:\"version\";s:8:\"5.8-beta\";s:7:\"updated\";s:19:\"2021-06-14 16:02:22\";s:12:\"english_name\";s:15:\"Spanish (Chile)\";s:11:\"native_name\";s:17:\"Español de Chile\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/translation/core/5.8-beta/es_CL.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_PR\";a:8:{s:8:\"language\";s:5:\"es_PR\";s:7:\"version\";s:6:\"5.4.14\";s:7:\"updated\";s:19:\"2020-04-29 15:36:59\";s:12:\"english_name\";s:21:\"Spanish (Puerto Rico)\";s:11:\"native_name\";s:23:\"Español de Puerto Rico\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/5.4.14/es_PR.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_ES\";a:8:{s:8:\"language\";s:5:\"es_ES\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-17 16:18:36\";s:12:\"english_name\";s:15:\"Spanish (Spain)\";s:11:\"native_name\";s:8:\"Español\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/es_ES.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_GT\";a:8:{s:8:\"language\";s:5:\"es_GT\";s:7:\"version\";s:6:\"5.2.19\";s:7:\"updated\";s:19:\"2019-03-02 06:35:01\";s:12:\"english_name\";s:19:\"Spanish (Guatemala)\";s:11:\"native_name\";s:21:\"Español de Guatemala\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/5.2.19/es_GT.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:2:\"et\";a:8:{s:8:\"language\";s:2:\"et\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-05 10:16:58\";s:12:\"english_name\";s:8:\"Estonian\";s:11:\"native_name\";s:5:\"Eesti\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.3.2/et.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"et\";i:2;s:3:\"est\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Jätka\";}}s:2:\"eu\";a:8:{s:8:\"language\";s:2:\"eu\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-15 17:16:26\";s:12:\"english_name\";s:6:\"Basque\";s:11:\"native_name\";s:7:\"Euskara\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.3.2/eu.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"eu\";i:2;s:3:\"eus\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Jarraitu\";}}s:5:\"fa_AF\";a:8:{s:8:\"language\";s:5:\"fa_AF\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-12 23:13:21\";s:12:\"english_name\";s:21:\"Persian (Afghanistan)\";s:11:\"native_name\";s:31:\"(فارسی (افغانستان\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/fa_AF.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fa\";i:2;s:3:\"fas\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"ادامه\";}}s:5:\"fa_IR\";a:8:{s:8:\"language\";s:5:\"fa_IR\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-18 14:24:18\";s:12:\"english_name\";s:7:\"Persian\";s:11:\"native_name\";s:10:\"فارسی\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/fa_IR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fa\";i:2;s:3:\"fas\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"ادامه\";}}s:2:\"fi\";a:8:{s:8:\"language\";s:2:\"fi\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-30 17:30:18\";s:12:\"english_name\";s:7:\"Finnish\";s:11:\"native_name\";s:5:\"Suomi\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.3.2/fi.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fi\";i:2;s:3:\"fin\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Jatka\";}}s:5:\"fr_CA\";a:8:{s:8:\"language\";s:5:\"fr_CA\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-15 23:14:34\";s:12:\"english_name\";s:15:\"French (Canada)\";s:11:\"native_name\";s:19:\"Français du Canada\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/fr_CA.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fr\";i:2;s:3:\"fra\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuer\";}}s:5:\"fr_FR\";a:8:{s:8:\"language\";s:5:\"fr_FR\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-11-03 13:04:16\";s:12:\"english_name\";s:15:\"French (France)\";s:11:\"native_name\";s:9:\"Français\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/fr_FR.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"fr\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuer\";}}s:5:\"fr_BE\";a:8:{s:8:\"language\";s:5:\"fr_BE\";s:7:\"version\";s:8:\"5.8-beta\";s:7:\"updated\";s:19:\"2021-02-22 13:54:46\";s:12:\"english_name\";s:16:\"French (Belgium)\";s:11:\"native_name\";s:21:\"Français de Belgique\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/translation/core/5.8-beta/fr_BE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fr\";i:2;s:3:\"fra\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuer\";}}s:3:\"fur\";a:8:{s:8:\"language\";s:3:\"fur\";s:7:\"version\";s:6:\"4.8.23\";s:7:\"updated\";s:19:\"2023-04-30 13:56:46\";s:12:\"english_name\";s:8:\"Friulian\";s:11:\"native_name\";s:8:\"Friulian\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/translation/core/4.8.23/fur.zip\";s:3:\"iso\";a:2:{i:2;s:3:\"fur\";i:3;s:3:\"fur\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:2:\"fy\";a:8:{s:8:\"language\";s:2:\"fy\";s:7:\"version\";s:5:\"6.2.3\";s:7:\"updated\";s:19:\"2022-12-25 12:53:23\";s:12:\"english_name\";s:7:\"Frisian\";s:11:\"native_name\";s:5:\"Frysk\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.2.3/fy.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fy\";i:2;s:3:\"fry\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Trochgean\";}}s:2:\"gd\";a:8:{s:8:\"language\";s:2:\"gd\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-08-23 17:41:37\";s:12:\"english_name\";s:15:\"Scottish Gaelic\";s:11:\"native_name\";s:9:\"Gàidhlig\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/gd.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"gd\";i:2;s:3:\"gla\";i:3;s:3:\"gla\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:15:\"Lean air adhart\";}}s:5:\"gl_ES\";a:8:{s:8:\"language\";s:5:\"gl_ES\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-12 23:41:33\";s:12:\"english_name\";s:8:\"Galician\";s:11:\"native_name\";s:6:\"Galego\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/gl_ES.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"gl\";i:2;s:3:\"glg\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:2:\"gu\";a:8:{s:8:\"language\";s:2:\"gu\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-08-09 07:20:47\";s:12:\"english_name\";s:8:\"Gujarati\";s:11:\"native_name\";s:21:\"ગુજરાતી\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.3.2/gu.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"gu\";i:2;s:3:\"guj\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:25:\"ચાલુ રાખો\";}}s:3:\"haz\";a:8:{s:8:\"language\";s:3:\"haz\";s:7:\"version\";s:6:\"4.4.31\";s:7:\"updated\";s:19:\"2015-12-05 00:59:09\";s:12:\"english_name\";s:8:\"Hazaragi\";s:11:\"native_name\";s:15:\"هزاره گی\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/translation/core/4.4.31/haz.zip\";s:3:\"iso\";a:1:{i:3;s:3:\"haz\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"ادامه\";}}s:5:\"he_IL\";a:8:{s:8:\"language\";s:5:\"he_IL\";s:7:\"version\";s:5:\"6.2.3\";s:7:\"updated\";s:19:\"2023-05-28 22:06:16\";s:12:\"english_name\";s:6:\"Hebrew\";s:11:\"native_name\";s:16:\"עִבְרִית\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.2.3/he_IL.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"he\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"המשך\";}}s:5:\"hi_IN\";a:8:{s:8:\"language\";s:5:\"hi_IN\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-31 09:18:27\";s:12:\"english_name\";s:5:\"Hindi\";s:11:\"native_name\";s:18:\"हिन्दी\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/hi_IN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hi\";i:2;s:3:\"hin\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:25:\"जारी रखें\";}}s:2:\"hr\";a:8:{s:8:\"language\";s:2:\"hr\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-09-05 16:40:26\";s:12:\"english_name\";s:8:\"Croatian\";s:11:\"native_name\";s:8:\"Hrvatski\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.3.2/hr.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hr\";i:2;s:3:\"hrv\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Nastavi\";}}s:3:\"hsb\";a:8:{s:8:\"language\";s:3:\"hsb\";s:7:\"version\";s:5:\"6.2.3\";s:7:\"updated\";s:19:\"2023-02-22 17:37:32\";s:12:\"english_name\";s:13:\"Upper Sorbian\";s:11:\"native_name\";s:17:\"Hornjoserbšćina\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/6.2.3/hsb.zip\";s:3:\"iso\";a:2:{i:2;s:3:\"hsb\";i:3;s:3:\"hsb\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:4:\"Dale\";}}s:5:\"hu_HU\";a:8:{s:8:\"language\";s:5:\"hu_HU\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-09-06 09:35:55\";s:12:\"english_name\";s:9:\"Hungarian\";s:11:\"native_name\";s:6:\"Magyar\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/hu_HU.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hu\";i:2;s:3:\"hun\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"Folytatás\";}}s:2:\"hy\";a:8:{s:8:\"language\";s:2:\"hy\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-12-03 16:21:10\";s:12:\"english_name\";s:8:\"Armenian\";s:11:\"native_name\";s:14:\"Հայերեն\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/hy.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hy\";i:2;s:3:\"hye\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Շարունակել\";}}s:5:\"id_ID\";a:8:{s:8:\"language\";s:5:\"id_ID\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-11-03 15:28:58\";s:12:\"english_name\";s:10:\"Indonesian\";s:11:\"native_name\";s:16:\"Bahasa Indonesia\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/id_ID.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"id\";i:2;s:3:\"ind\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Lanjutkan\";}}s:5:\"is_IS\";a:8:{s:8:\"language\";s:5:\"is_IS\";s:7:\"version\";s:6:\"4.9.24\";s:7:\"updated\";s:19:\"2018-12-11 10:40:02\";s:12:\"english_name\";s:9:\"Icelandic\";s:11:\"native_name\";s:9:\"Íslenska\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/4.9.24/is_IS.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"is\";i:2;s:3:\"isl\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Áfram\";}}s:5:\"it_IT\";a:8:{s:8:\"language\";s:5:\"it_IT\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-25 18:45:51\";s:12:\"english_name\";s:7:\"Italian\";s:11:\"native_name\";s:8:\"Italiano\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/it_IT.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"it\";i:2;s:3:\"ita\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continua\";}}s:2:\"ja\";a:8:{s:8:\"language\";s:2:\"ja\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-13 01:54:01\";s:12:\"english_name\";s:8:\"Japanese\";s:11:\"native_name\";s:9:\"日本語\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.3.2/ja.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"ja\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"次へ\";}}s:5:\"jv_ID\";a:8:{s:8:\"language\";s:5:\"jv_ID\";s:7:\"version\";s:6:\"4.9.24\";s:7:\"updated\";s:19:\"2019-02-16 23:58:56\";s:12:\"english_name\";s:8:\"Javanese\";s:11:\"native_name\";s:9:\"Basa Jawa\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/4.9.24/jv_ID.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"jv\";i:2;s:3:\"jav\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Nerusaké\";}}s:5:\"ka_GE\";a:8:{s:8:\"language\";s:5:\"ka_GE\";s:7:\"version\";s:5:\"6.0.6\";s:7:\"updated\";s:19:\"2023-10-31 08:47:02\";s:12:\"english_name\";s:8:\"Georgian\";s:11:\"native_name\";s:21:\"ქართული\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.0.6/ka_GE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ka\";i:2;s:3:\"kat\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:30:\"გაგრძელება\";}}s:3:\"kab\";a:8:{s:8:\"language\";s:3:\"kab\";s:7:\"version\";s:5:\"6.2.3\";s:7:\"updated\";s:19:\"2023-07-05 11:40:39\";s:12:\"english_name\";s:6:\"Kabyle\";s:11:\"native_name\";s:9:\"Taqbaylit\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/6.2.3/kab.zip\";s:3:\"iso\";a:2:{i:2;s:3:\"kab\";i:3;s:3:\"kab\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Kemmel\";}}s:2:\"kk\";a:8:{s:8:\"language\";s:2:\"kk\";s:7:\"version\";s:6:\"4.9.24\";s:7:\"updated\";s:19:\"2018-07-10 11:35:44\";s:12:\"english_name\";s:6:\"Kazakh\";s:11:\"native_name\";s:19:\"Қазақ тілі\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.9.24/kk.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"kk\";i:2;s:3:\"kaz\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Жалғастыру\";}}s:2:\"km\";a:8:{s:8:\"language\";s:2:\"km\";s:7:\"version\";s:6:\"5.2.19\";s:7:\"updated\";s:19:\"2019-06-10 16:18:28\";s:12:\"english_name\";s:5:\"Khmer\";s:11:\"native_name\";s:27:\"ភាសាខ្មែរ\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/5.2.19/km.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"km\";i:2;s:3:\"khm\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"បន្ត\";}}s:2:\"kn\";a:8:{s:8:\"language\";s:2:\"kn\";s:7:\"version\";s:5:\"6.1.4\";s:7:\"updated\";s:19:\"2022-10-20 17:15:28\";s:12:\"english_name\";s:7:\"Kannada\";s:11:\"native_name\";s:15:\"ಕನ್ನಡ\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.4/kn.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"kn\";i:2;s:3:\"kan\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:30:\"ಮುಂದುವರಿಸು\";}}s:5:\"ko_KR\";a:8:{s:8:\"language\";s:5:\"ko_KR\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-09-13 00:53:29\";s:12:\"english_name\";s:6:\"Korean\";s:11:\"native_name\";s:9:\"한국어\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/ko_KR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ko\";i:2;s:3:\"kor\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"계속\";}}s:3:\"ckb\";a:8:{s:8:\"language\";s:3:\"ckb\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-14 15:26:14\";s:12:\"english_name\";s:16:\"Kurdish (Sorani)\";s:11:\"native_name\";s:13:\"كوردی‎\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/6.3.2/ckb.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ku\";i:3;s:3:\"ckb\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:30:\"به‌رده‌وام به‌\";}}s:3:\"kir\";a:8:{s:8:\"language\";s:3:\"kir\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-29 06:43:10\";s:12:\"english_name\";s:6:\"Kyrgyz\";s:11:\"native_name\";s:16:\"Кыргызча\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/6.3.2/kir.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"ky\";i:2;s:3:\"kir\";i:3;s:3:\"kir\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:14:\"Улантуу\";}}s:2:\"lo\";a:8:{s:8:\"language\";s:2:\"lo\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-11-12 09:59:23\";s:12:\"english_name\";s:3:\"Lao\";s:11:\"native_name\";s:21:\"ພາສາລາວ\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/lo.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"lo\";i:2;s:3:\"lao\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:18:\"ຕໍ່​ໄປ\";}}s:5:\"lt_LT\";a:8:{s:8:\"language\";s:5:\"lt_LT\";s:7:\"version\";s:5:\"6.1.4\";s:7:\"updated\";s:19:\"2022-11-24 03:51:58\";s:12:\"english_name\";s:10:\"Lithuanian\";s:11:\"native_name\";s:15:\"Lietuvių kalba\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.4/lt_LT.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"lt\";i:2;s:3:\"lit\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Tęsti\";}}s:2:\"lv\";a:8:{s:8:\"language\";s:2:\"lv\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-09-01 07:05:22\";s:12:\"english_name\";s:7:\"Latvian\";s:11:\"native_name\";s:16:\"Latviešu valoda\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.3.2/lv.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"lv\";i:2;s:3:\"lav\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Turpināt\";}}s:5:\"mk_MK\";a:8:{s:8:\"language\";s:5:\"mk_MK\";s:7:\"version\";s:5:\"6.0.6\";s:7:\"updated\";s:19:\"2022-10-01 09:23:52\";s:12:\"english_name\";s:10:\"Macedonian\";s:11:\"native_name\";s:31:\"Македонски јазик\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.0.6/mk_MK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"mk\";i:2;s:3:\"mkd\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"Продолжи\";}}s:5:\"ml_IN\";a:8:{s:8:\"language\";s:5:\"ml_IN\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-13 08:36:49\";s:12:\"english_name\";s:9:\"Malayalam\";s:11:\"native_name\";s:18:\"മലയാളം\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/ml_IN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ml\";i:2;s:3:\"mal\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:18:\"തുടരുക\";}}s:2:\"mn\";a:8:{s:8:\"language\";s:2:\"mn\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-05 01:27:19\";s:12:\"english_name\";s:9:\"Mongolian\";s:11:\"native_name\";s:12:\"Монгол\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.3.2/mn.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"mn\";i:2;s:3:\"mon\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:2:\"mr\";a:8:{s:8:\"language\";s:2:\"mr\";s:7:\"version\";s:6:\"4.9.24\";s:7:\"updated\";s:19:\"2019-11-22 15:32:08\";s:12:\"english_name\";s:7:\"Marathi\";s:11:\"native_name\";s:15:\"मराठी\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.9.24/mr.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"mr\";i:2;s:3:\"mar\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:25:\"सुरु ठेवा\";}}s:5:\"ms_MY\";a:8:{s:8:\"language\";s:5:\"ms_MY\";s:7:\"version\";s:6:\"5.5.13\";s:7:\"updated\";s:19:\"2022-03-11 13:52:22\";s:12:\"english_name\";s:5:\"Malay\";s:11:\"native_name\";s:13:\"Bahasa Melayu\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/5.5.13/ms_MY.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ms\";i:2;s:3:\"msa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Teruskan\";}}s:5:\"my_MM\";a:8:{s:8:\"language\";s:5:\"my_MM\";s:7:\"version\";s:6:\"4.2.36\";s:7:\"updated\";s:19:\"2017-12-26 11:57:10\";s:12:\"english_name\";s:17:\"Myanmar (Burmese)\";s:11:\"native_name\";s:15:\"ဗမာစာ\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/4.2.36/my_MM.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"my\";i:2;s:3:\"mya\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:54:\"ဆက်လက်လုပ်ဆောင်ပါ။\";}}s:5:\"nb_NO\";a:8:{s:8:\"language\";s:5:\"nb_NO\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-12 23:32:44\";s:12:\"english_name\";s:19:\"Norwegian (Bokmål)\";s:11:\"native_name\";s:13:\"Norsk bokmål\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/nb_NO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nb\";i:2;s:3:\"nob\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Fortsett\";}}s:5:\"ne_NP\";a:8:{s:8:\"language\";s:5:\"ne_NP\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-18 12:10:13\";s:12:\"english_name\";s:6:\"Nepali\";s:11:\"native_name\";s:18:\"नेपाली\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/ne_NP.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ne\";i:2;s:3:\"nep\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:43:\"जारी राख्नुहोस्\";}}s:12:\"nl_NL_formal\";a:8:{s:8:\"language\";s:12:\"nl_NL_formal\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-08-29 11:56:04\";s:12:\"english_name\";s:14:\"Dutch (Formal)\";s:11:\"native_name\";s:20:\"Nederlands (Formeel)\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/translation/core/6.3.2/nl_NL_formal.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nl\";i:2;s:3:\"nld\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Doorgaan\";}}s:5:\"nl_BE\";a:8:{s:8:\"language\";s:5:\"nl_BE\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-11-02 16:15:05\";s:12:\"english_name\";s:15:\"Dutch (Belgium)\";s:11:\"native_name\";s:20:\"Nederlands (België)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/nl_BE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nl\";i:2;s:3:\"nld\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Doorgaan\";}}s:5:\"nl_NL\";a:8:{s:8:\"language\";s:5:\"nl_NL\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-09-10 16:26:11\";s:12:\"english_name\";s:5:\"Dutch\";s:11:\"native_name\";s:10:\"Nederlands\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/nl_NL.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nl\";i:2;s:3:\"nld\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Doorgaan\";}}s:5:\"nn_NO\";a:8:{s:8:\"language\";s:5:\"nn_NO\";s:7:\"version\";s:8:\"5.8-beta\";s:7:\"updated\";s:19:\"2021-03-18 10:59:16\";s:12:\"english_name\";s:19:\"Norwegian (Nynorsk)\";s:11:\"native_name\";s:13:\"Norsk nynorsk\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/translation/core/5.8-beta/nn_NO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nn\";i:2;s:3:\"nno\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Hald fram\";}}s:3:\"oci\";a:8:{s:8:\"language\";s:3:\"oci\";s:7:\"version\";s:6:\"4.8.23\";s:7:\"updated\";s:19:\"2017-08-25 10:03:08\";s:12:\"english_name\";s:7:\"Occitan\";s:11:\"native_name\";s:7:\"Occitan\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/translation/core/4.8.23/oci.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"oc\";i:2;s:3:\"oci\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Contunhar\";}}s:5:\"pa_IN\";a:8:{s:8:\"language\";s:5:\"pa_IN\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-16 05:19:43\";s:12:\"english_name\";s:15:\"Panjabi (India)\";s:11:\"native_name\";s:18:\"ਪੰਜਾਬੀ\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/pa_IN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"pa\";i:2;s:3:\"pan\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:25:\"ਜਾਰੀ ਰੱਖੋ\";}}s:5:\"pl_PL\";a:8:{s:8:\"language\";s:5:\"pl_PL\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-20 04:59:22\";s:12:\"english_name\";s:6:\"Polish\";s:11:\"native_name\";s:6:\"Polski\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/pl_PL.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"pl\";i:2;s:3:\"pol\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Kontynuuj\";}}s:2:\"ps\";a:8:{s:8:\"language\";s:2:\"ps\";s:7:\"version\";s:6:\"4.3.32\";s:7:\"updated\";s:19:\"2015-12-02 21:41:29\";s:12:\"english_name\";s:6:\"Pashto\";s:11:\"native_name\";s:8:\"پښتو\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.3.32/ps.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ps\";i:2;s:3:\"pus\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:19:\"دوام ورکړه\";}}s:5:\"pt_PT\";a:8:{s:8:\"language\";s:5:\"pt_PT\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-27 11:36:32\";s:12:\"english_name\";s:21:\"Portuguese (Portugal)\";s:11:\"native_name\";s:10:\"Português\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/pt_PT.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"pt\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:10:\"pt_PT_ao90\";a:8:{s:8:\"language\";s:10:\"pt_PT_ao90\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-09-28 12:14:59\";s:12:\"english_name\";s:27:\"Portuguese (Portugal, AO90)\";s:11:\"native_name\";s:17:\"Português (AO90)\";s:7:\"package\";s:69:\"https://downloads.wordpress.org/translation/core/6.3.2/pt_PT_ao90.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"pt\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"pt_AO\";a:8:{s:8:\"language\";s:5:\"pt_AO\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-08-21 12:17:05\";s:12:\"english_name\";s:19:\"Portuguese (Angola)\";s:11:\"native_name\";s:20:\"Português de Angola\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/pt_AO.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"pt\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"pt_BR\";a:8:{s:8:\"language\";s:5:\"pt_BR\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-18 18:23:14\";s:12:\"english_name\";s:19:\"Portuguese (Brazil)\";s:11:\"native_name\";s:20:\"Português do Brasil\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/pt_BR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"pt\";i:2;s:3:\"por\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:3:\"rhg\";a:8:{s:8:\"language\";s:3:\"rhg\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-03-16 13:03:18\";s:12:\"english_name\";s:8:\"Rohingya\";s:11:\"native_name\";s:8:\"Ruáinga\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/rhg.zip\";s:3:\"iso\";a:1:{i:3;s:3:\"rhg\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"ro_RO\";a:8:{s:8:\"language\";s:5:\"ro_RO\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-31 21:49:13\";s:12:\"english_name\";s:8:\"Romanian\";s:11:\"native_name\";s:8:\"Română\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/ro_RO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ro\";i:2;s:3:\"ron\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuă\";}}s:5:\"ru_RU\";a:8:{s:8:\"language\";s:5:\"ru_RU\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-20 06:29:06\";s:12:\"english_name\";s:7:\"Russian\";s:11:\"native_name\";s:14:\"Русский\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/ru_RU.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ru\";i:2;s:3:\"rus\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Продолжить\";}}s:3:\"sah\";a:8:{s:8:\"language\";s:3:\"sah\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-21 02:06:41\";s:12:\"english_name\";s:5:\"Sakha\";s:11:\"native_name\";s:14:\"Сахалыы\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/sah.zip\";s:3:\"iso\";a:2:{i:2;s:3:\"sah\";i:3;s:3:\"sah\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Салҕаа\";}}s:3:\"snd\";a:8:{s:8:\"language\";s:3:\"snd\";s:7:\"version\";s:6:\"5.4.14\";s:7:\"updated\";s:19:\"2020-07-07 01:53:37\";s:12:\"english_name\";s:6:\"Sindhi\";s:11:\"native_name\";s:8:\"سنڌي\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/translation/core/5.4.14/snd.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"sd\";i:2;s:3:\"snd\";i:3;s:3:\"snd\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:15:\"اڳتي هلو\";}}s:5:\"si_LK\";a:8:{s:8:\"language\";s:5:\"si_LK\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-11-12 06:00:52\";s:12:\"english_name\";s:7:\"Sinhala\";s:11:\"native_name\";s:15:\"සිංහල\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/si_LK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"si\";i:2;s:3:\"sin\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:44:\"දිගටම කරගෙන යන්න\";}}s:5:\"sk_SK\";a:8:{s:8:\"language\";s:5:\"sk_SK\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-23 12:34:38\";s:12:\"english_name\";s:6:\"Slovak\";s:11:\"native_name\";s:11:\"Slovenčina\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/sk_SK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sk\";i:2;s:3:\"slk\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Pokračovať\";}}s:3:\"skr\";a:8:{s:8:\"language\";s:3:\"skr\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-11 16:19:53\";s:12:\"english_name\";s:7:\"Saraiki\";s:11:\"native_name\";s:14:\"سرائیکی\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/6.3.2/skr.zip\";s:3:\"iso\";a:1:{i:3;s:3:\"skr\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:17:\"جاری رکھو\";}}s:5:\"sl_SI\";a:8:{s:8:\"language\";s:5:\"sl_SI\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-27 05:53:56\";s:12:\"english_name\";s:9:\"Slovenian\";s:11:\"native_name\";s:13:\"Slovenščina\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/sl_SI.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sl\";i:2;s:3:\"slv\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Nadaljuj\";}}s:2:\"sq\";a:8:{s:8:\"language\";s:2:\"sq\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-21 10:39:13\";s:12:\"english_name\";s:8:\"Albanian\";s:11:\"native_name\";s:5:\"Shqip\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.3.2/sq.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sq\";i:2;s:3:\"sqi\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Vazhdo\";}}s:5:\"sr_RS\";a:8:{s:8:\"language\";s:5:\"sr_RS\";s:7:\"version\";s:5:\"5.8.8\";s:7:\"updated\";s:19:\"2021-08-01 21:21:06\";s:12:\"english_name\";s:7:\"Serbian\";s:11:\"native_name\";s:23:\"Српски језик\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/5.8.8/sr_RS.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sr\";i:2;s:3:\"srp\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:14:\"Настави\";}}s:5:\"sv_SE\";a:8:{s:8:\"language\";s:5:\"sv_SE\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-13 08:42:34\";s:12:\"english_name\";s:7:\"Swedish\";s:11:\"native_name\";s:7:\"Svenska\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/sv_SE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sv\";i:2;s:3:\"swe\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Fortsätt\";}}s:2:\"sw\";a:8:{s:8:\"language\";s:2:\"sw\";s:7:\"version\";s:6:\"5.3.16\";s:7:\"updated\";s:19:\"2019-10-13 15:35:35\";s:12:\"english_name\";s:7:\"Swahili\";s:11:\"native_name\";s:9:\"Kiswahili\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/5.3.16/sw.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sw\";i:2;s:3:\"swa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Endelea\";}}s:3:\"szl\";a:8:{s:8:\"language\";s:3:\"szl\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-09-24 19:58:14\";s:12:\"english_name\";s:8:\"Silesian\";s:11:\"native_name\";s:17:\"Ślōnskŏ gŏdka\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/szl.zip\";s:3:\"iso\";a:1:{i:3;s:3:\"szl\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:13:\"Kōntynuować\";}}s:5:\"ta_IN\";a:8:{s:8:\"language\";s:5:\"ta_IN\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-27 03:22:47\";s:12:\"english_name\";s:5:\"Tamil\";s:11:\"native_name\";s:15:\"தமிழ்\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/ta_IN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ta\";i:2;s:3:\"tam\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:24:\"தொடரவும்\";}}s:5:\"ta_LK\";a:8:{s:8:\"language\";s:5:\"ta_LK\";s:7:\"version\";s:6:\"4.2.36\";s:7:\"updated\";s:19:\"2015-12-03 01:07:44\";s:12:\"english_name\";s:17:\"Tamil (Sri Lanka)\";s:11:\"native_name\";s:15:\"தமிழ்\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/4.2.36/ta_LK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ta\";i:2;s:3:\"tam\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:18:\"தொடர்க\";}}s:2:\"te\";a:8:{s:8:\"language\";s:2:\"te\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-26 15:47:39\";s:12:\"english_name\";s:6:\"Telugu\";s:11:\"native_name\";s:18:\"తెలుగు\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/te.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"te\";i:2;s:3:\"tel\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:30:\"కొనసాగించు\";}}s:2:\"th\";a:8:{s:8:\"language\";s:2:\"th\";s:7:\"version\";s:5:\"5.8.8\";s:7:\"updated\";s:19:\"2022-06-08 04:30:30\";s:12:\"english_name\";s:4:\"Thai\";s:11:\"native_name\";s:9:\"ไทย\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/5.8.8/th.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"th\";i:2;s:3:\"tha\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:15:\"ต่อไป\";}}s:2:\"tl\";a:8:{s:8:\"language\";s:2:\"tl\";s:7:\"version\";s:6:\"4.8.23\";s:7:\"updated\";s:19:\"2017-09-30 09:04:29\";s:12:\"english_name\";s:7:\"Tagalog\";s:11:\"native_name\";s:7:\"Tagalog\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8.23/tl.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"tl\";i:2;s:3:\"tgl\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"Magpatuloy\";}}s:5:\"tr_TR\";a:8:{s:8:\"language\";s:5:\"tr_TR\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-14 17:48:14\";s:12:\"english_name\";s:7:\"Turkish\";s:11:\"native_name\";s:8:\"Türkçe\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/tr_TR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"tr\";i:2;s:3:\"tur\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Devam\";}}s:5:\"tt_RU\";a:8:{s:8:\"language\";s:5:\"tt_RU\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-11-20 20:20:50\";s:12:\"english_name\";s:5:\"Tatar\";s:11:\"native_name\";s:19:\"Татар теле\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/tt_RU.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"tt\";i:2;s:3:\"tat\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:17:\"дәвам итү\";}}s:3:\"tah\";a:8:{s:8:\"language\";s:3:\"tah\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-03-06 18:39:39\";s:12:\"english_name\";s:8:\"Tahitian\";s:11:\"native_name\";s:10:\"Reo Tahiti\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/tah.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"ty\";i:2;s:3:\"tah\";i:3;s:3:\"tah\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"ug_CN\";a:8:{s:8:\"language\";s:5:\"ug_CN\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-11-04 14:18:50\";s:12:\"english_name\";s:6:\"Uighur\";s:11:\"native_name\";s:16:\"ئۇيغۇرچە\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/ug_CN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ug\";i:2;s:3:\"uig\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:26:\"داۋاملاشتۇرۇش\";}}s:2:\"uk\";a:8:{s:8:\"language\";s:2:\"uk\";s:7:\"version\";s:5:\"6.1.4\";s:7:\"updated\";s:19:\"2023-03-04 10:46:30\";s:12:\"english_name\";s:9:\"Ukrainian\";s:11:\"native_name\";s:20:\"Українська\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.4/uk.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"uk\";i:2;s:3:\"ukr\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Продовжити\";}}s:2:\"ur\";a:8:{s:8:\"language\";s:2:\"ur\";s:7:\"version\";s:6:\"5.4.14\";s:7:\"updated\";s:19:\"2020-04-09 11:17:33\";s:12:\"english_name\";s:4:\"Urdu\";s:11:\"native_name\";s:8:\"اردو\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/5.4.14/ur.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ur\";i:2;s:3:\"urd\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:19:\"جاری رکھیں\";}}s:5:\"uz_UZ\";a:8:{s:8:\"language\";s:5:\"uz_UZ\";s:7:\"version\";s:8:\"5.8-beta\";s:7:\"updated\";s:19:\"2021-02-28 12:02:22\";s:12:\"english_name\";s:5:\"Uzbek\";s:11:\"native_name\";s:11:\"O‘zbekcha\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/translation/core/5.8-beta/uz_UZ.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"uz\";i:2;s:3:\"uzb\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:11:\"Davom etish\";}}s:2:\"vi\";a:8:{s:8:\"language\";s:2:\"vi\";s:7:\"version\";s:5:\"6.2.3\";s:7:\"updated\";s:19:\"2023-07-15 15:30:50\";s:12:\"english_name\";s:10:\"Vietnamese\";s:11:\"native_name\";s:14:\"Tiếng Việt\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.2.3/vi.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"vi\";i:2;s:3:\"vie\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Tiếp tục\";}}s:5:\"zh_TW\";a:8:{s:8:\"language\";s:5:\"zh_TW\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-10-12 21:22:49\";s:12:\"english_name\";s:16:\"Chinese (Taiwan)\";s:11:\"native_name\";s:12:\"繁體中文\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/zh_TW.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"zh\";i:2;s:3:\"zho\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"繼續\";}}s:5:\"zh_HK\";a:8:{s:8:\"language\";s:5:\"zh_HK\";s:7:\"version\";s:5:\"6.2.3\";s:7:\"updated\";s:19:\"2022-07-15 15:25:03\";s:12:\"english_name\";s:19:\"Chinese (Hong Kong)\";s:11:\"native_name\";s:12:\"香港中文\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.2.3/zh_HK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"zh\";i:2;s:3:\"zho\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"繼續\";}}s:5:\"zh_CN\";a:8:{s:8:\"language\";s:5:\"zh_CN\";s:7:\"version\";s:5:\"6.3.2\";s:7:\"updated\";s:19:\"2023-11-02 06:09:18\";s:12:\"english_name\";s:15:\"Chinese (China)\";s:11:\"native_name\";s:12:\"简体中文\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.3.2/zh_CN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"zh\";i:2;s:3:\"zho\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"继续\";}}}","no"),
("2846","updraft_combine_jobs_around","1699331267","yes"),
("2847","_transient_timeout_rsssl_testpage","1699378228","no"),
("2848","_transient_rsssl_testpage","<html>\n<head>\n    <meta charset=\"UTF-8\">\n    <META NAME=\"ROBOTS\" CONTENT=\"NOINDEX, NOFOLLOW\">\n</head>\n<body>\n<h1>#SSL TEST PAGE#</h1>\n<p>This page is used purely to test for SSL availability.</p>\n#SERVER-HTTPS-ON# (on)<br>#ENVHTTPS#<br>#LOADBALANCER#<br><br>#SUCCESSFULLY DETECTED SSL#\n</body>\n</html>\n","no"),
("2849","_transient_timeout_rsssl_admin_users","1699295428","no"),
("2850","_transient_rsssl_admin_users","a:1:{i:0;O:7:\"WP_User\":8:{s:4:\"data\";O:8:\"stdClass\":10:{s:2:\"ID\";s:1:\"1\";s:10:\"user_login\";s:13:\"land-log-1357\";s:9:\"user_pass\";s:34:\"$P$BTbqwSz97TAULjX4.swwTwzBW9agaN/\";s:13:\"user_nicename\";s:12:\"Spark Garten\";s:10:\"user_email\";s:23:\"write@sparkway-media.de\";s:8:\"user_url\";s:37:\"http://sparkway-client.de/sparkgarten\";s:15:\"user_registered\";s:19:\"2022-01-08 22:03:30\";s:19:\"user_activation_key\";s:0:\"\";s:11:\"user_status\";s:1:\"0\";s:12:\"display_name\";s:12:\"Spark Garten\";}s:2:\"ID\";i:1;s:4:\"caps\";a:1:{s:13:\"administrator\";b:1;}s:7:\"cap_key\";s:17:\"come_capabilities\";s:5:\"roles\";a:1:{i:0;s:13:\"administrator\";}s:7:\"allcaps\";a:89:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:20:\"wpseo_manage_options\";b:1;s:10:\"copy_posts\";b:1;s:15:\"manage_security\";b:1;s:17:\"read_tbp_template\";b:1;s:25:\"read_private_tbp_template\";b:1;s:17:\"edit_tbp_template\";b:1;s:18:\"edit_tbp_templates\";b:1;s:28:\"edit_published_tbp_templates\";b:1;s:21:\"publish_tbp_templates\";b:1;s:19:\"delete_tbp_template\";b:1;s:20:\"delete_tbp_templates\";b:1;s:28:\"delete_private_tbp_templates\";b:1;s:30:\"delete_published_tbp_templates\";b:1;s:25:\"edit_others_tbp_templates\";b:1;s:27:\"delete_others_tbp_templates\";b:1;s:14:\"read_tbp_theme\";b:1;s:22:\"read_private_tbp_theme\";b:1;s:14:\"edit_tbp_theme\";b:1;s:15:\"edit_tbp_themes\";b:1;s:25:\"edit_published_tbp_themes\";b:1;s:18:\"publish_tbp_themes\";b:1;s:16:\"delete_tbp_theme\";b:1;s:17:\"delete_tbp_themes\";b:1;s:25:\"delete_private_tbp_themes\";b:1;s:27:\"delete_published_tbp_themes\";b:1;s:22:\"edit_others_tbp_themes\";b:1;s:24:\"delete_others_tbp_themes\";b:1;s:13:\"administrator\";b:1;}s:6:\"filter\";N;s:16:\"\0WP_User\0site_id\";i:1;}}","no"),
("2851","_transient_timeout_rsssl_certinfo","1699378228","no"),
("2852","_transient_rsssl_certinfo","a:16:{s:4:\"name\";s:24:\"/CN=*.sparkway-client.de\";s:7:\"subject\";a:1:{s:2:\"CN\";s:20:\"*.sparkway-client.de\";}s:4:\"hash\";s:8:\"c95fa811\";s:6:\"issuer\";a:3:{s:1:\"C\";s:2:\"US\";s:1:\"O\";s:13:\"Let\'s Encrypt\";s:2:\"CN\";s:2:\"R3\";}s:7:\"version\";i:2;s:12:\"serialNumber\";s:38:\"0x04F019C1B9C8CD3D310D0FE18DD0ED58292A\";s:15:\"serialNumberHex\";s:36:\"04F019C1B9C8CD3D310D0FE18DD0ED58292A\";s:9:\"validFrom\";s:13:\"230823111439Z\";s:7:\"validTo\";s:13:\"231121111438Z\";s:16:\"validFrom_time_t\";i:1692789279;s:14:\"validTo_time_t\";i:1700565278;s:15:\"signatureTypeSN\";s:10:\"RSA-SHA256\";s:15:\"signatureTypeLN\";s:23:\"sha256WithRSAEncryption\";s:16:\"signatureTypeNID\";i:668;s:8:\"purposes\";a:9:{i:1;a:3:{i:0;b:1;i:1;b:0;i:2;s:9:\"sslclient\";}i:2;a:3:{i:0;b:1;i:1;b:0;i:2;s:9:\"sslserver\";}i:3;a:3:{i:0;b:0;i:1;b:0;i:2;s:11:\"nssslserver\";}i:4;a:3:{i:0;b:0;i:1;b:0;i:2;s:9:\"smimesign\";}i:5;a:3:{i:0;b:0;i:1;b:0;i:2;s:12:\"smimeencrypt\";}i:6;a:3:{i:0;b:0;i:1;b:0;i:2;s:7:\"crlsign\";}i:7;a:3:{i:0;b:1;i:1;b:1;i:2;s:3:\"any\";}i:8;a:3:{i:0;b:1;i:1;b:0;i:2;s:10:\"ocsphelper\";}i:9;a:3:{i:0;b:0;i:1;b:0;i:2;s:13:\"timestampsign\";}}s:10:\"extensions\";a:9:{s:8:\"keyUsage\";s:17:\"Digital Signature\";s:16:\"extendedKeyUsage\";s:60:\"TLS Web Server Authentication, TLS Web Client Authentication\";s:16:\"basicConstraints\";s:8:\"CA:FALSE\";s:20:\"subjectKeyIdentifier\";s:59:\"AB:43:62:4E:1D:C6:B9:8B:7D:56:69:AD:BF:2A:74:D0:5E:52:61:C4\";s:22:\"authorityKeyIdentifier\";s:66:\"keyid:14:2E:B3:17:B7:58:56:CB:AE:50:09:40:E6:1F:AF:9D:8B:14:C2:C6\n\";s:19:\"authorityInfoAccess\";s:73:\"OCSP - URI:http://r3.o.lencr.org\nCA Issuers - URI:http://r3.i.lencr.org/\n\";s:14:\"subjectAltName\";s:48:\"DNS:*.sparkway-client.de, DNS:sparkway-client.de\";s:19:\"certificatePolicies\";s:23:\"Policy: 2.23.140.1.2.1\n\";s:15:\"ct_precert_scts\";s:1164:\"Signed Certificate Timestamp:\n    Version   : v1 (0x0)\n    Log ID    : B7:3E:FB:24:DF:9C:4D:BA:75:F2:39:C5:BA:58:F4:6C:\n                5D:FC:42:CF:7A:9F:35:C4:9E:1D:09:81:25:ED:B4:99\n    Timestamp : Aug 23 12:14:39.293 2023 GMT\n    Extensions: none\n    Signature : ecdsa-with-SHA256\n                30:45:02:20:7E:FC:5A:B4:4A:A1:32:AB:64:61:B3:31:\n                C6:03:33:78:B6:E4:64:79:DD:D3:38:58:F5:7F:AA:E0:\n                E7:28:32:65:02:21:00:96:7E:8C:9A:2F:60:E9:D2:16:\n                08:06:6D:28:54:5C:CE:EB:2A:D9:FF:C9:B0:95:1A:0E:\n                E0:7F:10:CC:C9:A7:72\nSigned Certificate Timestamp:\n    Version   : v1 (0x0)\n    Log ID    : E8:3E:D0:DA:3E:F5:06:35:32:E7:57:28:BC:89:6B:C9:\n                03:D3:CB:D1:11:6B:EC:EB:69:E1:77:7D:6D:06:BD:6E\n    Timestamp : Aug 23 12:14:39.301 2023 GMT\n    Extensions: none\n    Signature : ecdsa-with-SHA256\n                30:46:02:21:00:93:48:A5:B6:A5:7F:B2:4E:80:EF:4A:\n                2C:6C:C2:89:67:ED:81:74:4B:26:C4:02:E0:50:3F:75:\n                BC:48:B3:4E:FD:02:21:00:BF:9D:A1:77:55:7F:A0:9E:\n                25:18:63:E4:11:98:E5:34:04:28:F6:1B:67:8A:67:59:\n                C4:C4:0C:3E:95:40:4B:62\";}}","no"),
("2853","_transient_timeout_rsssl_mixed_content_fixer_detected","1699292428","no"),
("2854","_transient_rsssl_mixed_content_fixer_detected","not-found","no"),
("2855","_transient_timeout_rsssl_can_use_curl_headers_check","1699292198","no"),
("2856","_transient_rsssl_can_use_curl_headers_check","a:7:{i:0;s:25:\"Upgrade Insecure Requests\";i:1;s:16:\"X-XSS protection\";i:2;s:22:\"X-Content Type Options\";i:3;s:15:\"Referrer-Policy\";i:4;s:15:\"X-Frame-Options\";i:5;s:18:\"Permissions-Policy\";i:6;s:30:\"HTTP Strict Transport Security\";}","no"),
("2857","_transient_timeout_rsssl_code_execution_allowed_status","1699378228","no"),
("2858","_transient_rsssl_code_execution_allowed_status","allowed","no"),
("2860","_site_transient_timeout_browser_cd1da34f8e79f73eb8f5bd74198e6c51","1699896628","no"),
("2861","_site_transient_browser_cd1da34f8e79f73eb8f5bd74198e6c51","a:10:{s:4:\"name\";s:6:\"Safari\";s:7:\"version\";s:4:\"17.1\";s:8:\"platform\";s:9:\"Macintosh\";s:10:\"update_url\";s:29:\"https://www.apple.com/safari/\";s:7:\"img_src\";s:43:\"http://s.w.org/images/browsers/safari.png?1\";s:11:\"img_src_ssl\";s:44:\"https://s.w.org/images/browsers/safari.png?1\";s:15:\"current_version\";s:2:\"11\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;s:6:\"mobile\";b:0;}","no"),
("2863","_transient_timeout_feed_11b3ddfc9600e79bbb81f3371fcce15e","1699335030","no"),
("2864","_transient_feed_11b3ddfc9600e79bbb81f3371fcce15e","a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:49:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"https://themify.me\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"Drag & Drop WordPress Themes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 25 Oct 2023 00:01:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"https://wordpress.org/?v=6.2.3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:62:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n\n					\n		\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"Spooktacular Savings Await: Halloween Sale 2023 Is Here!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"https://themify.me/blog/halloween-sale-2023\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://themify.me/blog/halloween-sale-2023#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 25 Oct 2023 00:01:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:4:\"Blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:10:\"Promotions\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"https://themify.me/?p=972531\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:323:\"Halloween is a time for fun, tricks, and treats, and we\'ve got the treats part covered. But remember, this spooky sale will vanish into thin air on October 31st at midnight, so don\'t let it haunt your dreams. Grab your favorite themes, plugins, and tools now and give your online presence the Halloween glow-up it [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Nick @ Themify\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"https://themify.me/blog/halloween-sale-2023/feed\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:62:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n\n					\n		\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"Create Membership Websites in WordPress: 8 Easy Steps with SureMembers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://themify.me/blog/create-membership-with-suremembers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"https://themify.me/blog/create-membership-with-suremembers#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 17 Oct 2023 00:02:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:4:\"Blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:9:\"Tutorials\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"https://themify.me/?p=971718\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:366:\"Building a membership website is an exciting way to generate recurring revenue while providing premium value to your users. But it takes the right tools and strategy to create one successfully. In this comprehensive guide, we\'ll explore how the WordPress plugin SureMembers can empower you to easily build a fully functional membership site. Whether you\'re [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Nick @ Themify\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"https://themify.me/blog/create-membership-with-suremembers/feed\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:62:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n\n					\n		\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"uKONTENTowani: From Custom CMS to WordPress + Themify\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://themify.me/blog/ukontentowani-from-custom-cms-to-themify\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"https://themify.me/blog/ukontentowani-from-custom-cms-to-themify#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 28 Sep 2023 02:05:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:4:\"Blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:16:\"Customer Stories\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"https://themify.me/?p=969581\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:336:\"We are uKONTENTowani - a small agency based in Zielona Góra, Poland. Our company\'s name can be translated as \"contented\" - because that\'s what we do. We deliver content (texts) as well as contentment to our clients. In our work, websites are viewed as another tool through which we implement SEO strategies. But our company\'s [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Nick @ Themify\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://themify.me/blog/ukontentowani-from-custom-cms-to-themify/feed\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:62:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n\n					\n		\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:37:\"New eCommerce Skin for Jewelry Stores\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"https://themify.me/blog/ecommerce-skin-for-jewelry-stores\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"https://themify.me/blog/ecommerce-skin-for-jewelry-stores#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 30 Aug 2023 00:19:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:4:\"Blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:16:\"Product Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"https://themify.me/?p=966221\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:342:\"We are delighted to announce the release of our latest masterpiece, the Jewelry skin! Crafted with precision and elegance, this skin is set to dazzle and captivate your audience, just like the gems it showcases. The Jewelry skin is designed to put your jewelry collection in the spotlight. With its clean and minimalist layout, your [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Nick @ Themify\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"https://themify.me/blog/ecommerce-skin-for-jewelry-stores/feed\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"6\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:62:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n\n					\n		\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Celebrating 13 Years of Growth!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"https://themify.me/blog/13-years-of-growth\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://themify.me/blog/13-years-of-growth#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Aug 2023 01:56:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:4:\"Blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:10:\"Promotions\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"https://themify.me/?p=964677\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:351:\"Today, we\'re overjoyed to mark our 13th anniversary! From our beginnings to this moment, your support has fueled our growth and innovation. It feels like just yesterday that we embarked on this incredible adventure, and yet here we are, stronger and more committed than ever to empowering your creative endeavors. Our mission has always been [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Nick @ Themify\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"https://themify.me/blog/13-years-of-growth/feed\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:62:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n\n					\n		\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"Introducing Mega Menu in the Builder\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"https://themify.me/blog/introducing-mega-menu\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://themify.me/blog/introducing-mega-menu#respond\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 14 Aug 2023 01:12:02 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:4:\"Blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"https://themify.me/?p=964216\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:350:\"Hello, mega menu lovers. We are thrilled to bring you some exciting news. The beloved mega menu, previously limited to selective themes like Ultra and Shoppe, has now been seamlessly integrated with our Builder. The new mega menu feature has been designed for effortless usability and functionality. It uses the core WordPress menu admin to [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Nick @ Themify\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"https://themify.me/blog/introducing-mega-menu/feed\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:62:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n\n					\n		\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"New Lottie Animation Feature\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"https://themify.me/blog/new-lottie-animation-feature\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"https://themify.me/blog/new-lottie-animation-feature#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 27 Jul 2023 18:30:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:4:\"Blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"https://themify.me/?p=961801\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:368:\"Introducing the highly anticipated Lottie feature! The wait may have been a little longer than expected, but we assure you, it\'s well worth it. We\'ve made adding fancy Lottie animations with the Builder super easy. For those unfamiliar with Lottie, it\'s a lightweight, interactive, and scalable motion graphic format that delivers seamless performance on any [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Nick @ Themify\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"https://themify.me/blog/new-lottie-animation-feature/feed\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"12\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:62:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n\n					\n		\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"Pagespeed Showcase Series: Round 6\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"https://themify.me/blog/pagespeed-showcase-series-round-6\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"https://themify.me/blog/pagespeed-showcase-series-round-6#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Jul 2023 00:58:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:4:\"Blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:17:\"Customer Showcase\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"https://themify.me/?p=959174\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:350:\"We\'re back with another exhilarating edition of our Pagespeed Showcase Series: Round 6! Get ready to be amazed by the incredible speed and performance of the websites crafted by our brilliant users. Even without the luxury of costly CDN services or premium cache plugins, their websites have aced the Google Pagespeed Insight audit. In this [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Nick @ Themify\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"https://themify.me/blog/pagespeed-showcase-series-round-6/feed\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:62:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n\n					\n		\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"New Author Skin &amp; 30% Sale\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"https://themify.me/blog/new-author-skin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"https://themify.me/blog/new-author-skin#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 28 Jun 2023 15:07:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:4:\"Blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:16:\"Product Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"https://themify.me/?p=958168\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:344:\"Today we are releasing another fantastic skin for Ultra, Shoppe, or Builder Pro. The new Author skin is for writers and authors who want to sell books and works online. The design style and typography is very clean and minimal which is suitable for creative writers, artists and freelancers. Again, we are offering a 30% discount or [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Nick @ Themify\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"https://themify.me/blog/new-author-skin/feed\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:62:\"\n		\n		\n					\n		\n		\n		\n				\n		\n		\n\n					\n		\n					\n			\n		\n		\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"More &amp; Better PTB Features\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"https://themify.me/blog/more-better-ptb-features\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"https://themify.me/blog/more-better-ptb-features#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 14 Jun 2023 14:50:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:4:\"Blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"https://themify.me/?p=956434\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:339:\"We recently released a major PTB update, today we are dropping more new features for PTB. The new version of PTB provides better integrations between Builder Pro and third-party post types. PTB is no longer limited to just adding custom fields for third-party post types. You can create archive templates for any custom post type [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Nick @ Themify\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://themify.me/blog/more-better-ptb-features/feed\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:28:\"https://themify.me/blog/feed\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"\n	hourly	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"\n	1	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";O:48:\"WpOrg\\Requests\\Utility\\CaseInsensitiveDictionary\":1:{s:7:\"\0*\0data\";a:19:{s:4:\"date\";s:29:\"Mon, 06 Nov 2023 17:30:30 GMT\";s:12:\"content-type\";s:34:\"application/rss+xml; charset=UTF-8\";s:4:\"link\";s:146:\"<https://themify.me/wp-json/>; rel=\"https://api.w.org/\", <https://themify.me/wp-json/wp/v2/categories/1>; rel=\"alternate\"; type=\"application/json\"\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:13:\"last-modified\";s:29:\"Mon, 06 Nov 2023 17:30:10 GMT\";s:4:\"etag\";s:41:\"W/\"4684e46dc47ff0020e6ef998a922e28d-gzip\"\";s:13:\"cache-control\";s:14:\"max-age=172800\";s:7:\"expires\";s:29:\"Wed, 08 Nov 2023 17:30:30 GMT\";s:4:\"vary\";s:26:\"Accept-Encoding,User-Agent\";s:15:\"cf-cache-status\";s:7:\"DYNAMIC\";s:9:\"report-to\";s:239:\"{\"endpoints\":[{\"url\":\"https:\\/\\/a.nel.cloudflare.com\\/report\\/v3?s=IOEh9weaU1PNzdfVStNSJ%2FFWDzFc95s7Nt53dAHyiiLGpOdXulYmRyZWBZu%2BJzvDvWWM%2FLZDwfHjred8RvJ9I9i4HuvSMg8Ro1ofFbNwwdhXz%2FuGEaNiz9QB8Mw%3D\"}],\"group\":\"cf-nel\",\"max_age\":604800}\";s:3:\"nel\";s:60:\"{\"success_fraction\":0,\"report_to\":\"cf-nel\",\"max_age\":604800}\";s:25:\"strict-transport-security\";s:44:\"max-age=31536000; includeSubDomains; preload\";s:22:\"x-content-type-options\";s:7:\"nosniff\";s:15:\"referrer-policy\";s:31:\"strict-origin-when-cross-origin\";s:6:\"server\";s:10:\"cloudflare\";s:6:\"cf-ray\";s:20:\"821f10904c79abc6-CPH\";s:16:\"content-encoding\";s:2:\"br\";s:7:\"alt-svc\";s:19:\"h3=\":443\"; ma=86400\";}}s:5:\"build\";s:14:\"20220303202232\";}","no");

INSERT IGNORE INTO `come_options` VALUES 
("2865","_transient_timeout_feed_mod_11b3ddfc9600e79bbb81f3371fcce15e","1699335030","no"),
("2866","_transient_feed_mod_11b3ddfc9600e79bbb81f3371fcce15e","1699291830","no"),
("2867","_transient_timeout_autoptimize_cache_warmer_protector","1699292449","no"),
("2868","_transient_autoptimize_cache_warmer_protector","I shall not warm cache for another 10 minutes.","no"),
("2869","_site_transient_update_themes","O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1699291850;s:7:\"checked\";a:3:{s:13:\"themify-ultra\";s:5:\"7.3.6\";s:17:\"twentytwentythree\";s:3:\"1.2\";s:15:\"twentytwentytwo\";s:3:\"1.5\";}s:8:\"response\";a:0:{}s:9:\"no_update\";a:2:{s:17:\"twentytwentythree\";a:6:{s:5:\"theme\";s:17:\"twentytwentythree\";s:11:\"new_version\";s:3:\"1.2\";s:3:\"url\";s:47:\"https://wordpress.org/themes/twentytwentythree/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/theme/twentytwentythree.1.2.zip\";s:8:\"requires\";s:3:\"6.1\";s:12:\"requires_php\";s:3:\"5.6\";}s:15:\"twentytwentytwo\";a:6:{s:5:\"theme\";s:15:\"twentytwentytwo\";s:11:\"new_version\";s:3:\"1.5\";s:3:\"url\";s:45:\"https://wordpress.org/themes/twentytwentytwo/\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/theme/twentytwentytwo.1.5.zip\";s:8:\"requires\";s:3:\"5.9\";s:12:\"requires_php\";s:3:\"5.6\";}}s:12:\"translations\";a:0:{}}","no"),
("2871","duplicator_pro_plugin_version","4.5.8.3","yes"),
("2872","duplicator_expire_tmp_cleanup_check","{\"expire\":1699378282,\"value\":true}","yes"),
("2873","duplicator_expire_rename_delay","{\"expire\":1699335082,\"value\":true}","yes"),
("2875","duplicator_expire_duplicator_pro_frotend_delay","{\"expire\":1699292043,\"value\":true}","yes"),
("2876","duplicator_expire_license_check","{\"expire\":1699292044,\"value\":true}","yes"),
("2877","duplicator_pro_package_active","{\n    \"ID\": null,\n    \"Created\": \"2023-11-06 17:34:03\",\n    \"Version\": \"4.5.8.3\",\n    \"VersionWP\": \"6.3.2\",\n    \"VersionDB\": \"10.5.21\",\n    \"VersionPHP\": \"8.1.25\",\n    \"VersionOS\": \"Linux\",\n    \"Name\": \"20231106_gartenheckerasen_spark\",\n    \"Hash\": \"7dee4bdf8967fca84395_20231106173403\",\n    \"NameHash\": \"20231106_gartenheckerasen_spark_7dee4bdf8967fca84395_20231106173403\",\n    \"Type\": 0,\n    \"notes\": \"\",\n    \"StorePath\": \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/backups-dup-pro\\/tmp\",\n    \"StoreURL\": \"https:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/backups-dup-pro\\/\",\n    \"ScanFile\": \"20231106_gartenheckerasen_spark_7dee4bdf8967fca84395_20231106173403_scan.json\",\n    \"timer_start\": -1,\n    \"Runtime\": 0,\n    \"ExeSize\": \"0\",\n    \"ZipSize\": \"0\",\n    \"Brand\": \"Default\",\n    \"Brand_ID\": -1,\n    \"ziparchive_mode\": 0,\n    \"Archive\": {\n        \"ExportOnlyDB\": 0,\n        \"FilterDirs\": \"\",\n        \"FilterExts\": \"\",\n        \"FilterFiles\": \"\",\n        \"FilterDirsAll\": [\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/.opcache\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/.tmb\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/ai1wm-backups\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/backups-dup-lite\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/backups-dup-pro\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/backups-dup-pro\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/backupwordpress\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/bps-backup\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/cache\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/content\\/cache\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/contents\\/cache\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/infinitewp\\/backups\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/managewp\\/backups\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/old-cache\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/plugins\\/all-in-one-wp-migration\\/storage\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/plugins\\/really-simple-captcha\\/tmp\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/plugins\\/wordfence\\/tmp\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/updraft\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/aiowps_backups\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/backup-guard\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/backupbuddy_backups\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/backupbuddy_temp\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/ithemes-security\\/backups\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/mainwp\\/backup\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/pb_backupbuddy\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/snapshots\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/sucuri\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/wp-clone\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/wp_all_backup\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/uploads\\/wpbackitup_backups\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/wfcache\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/wishlist-backup\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-content\\/wpvividbackups\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-snapshots\"\n        ],\n        \"FilterExtsAll\": [],\n        \"FilterFilesAll\": [\n            \".DS_Store\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/.htaccess\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/.user.ini\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/php.ini\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/web.config\",\n            \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\\/wp-config.php\",\n            \"dbcache\",\n            \"debug_log\",\n            \"error_log\",\n            \"objectcache\",\n            \"pgcache\",\n            \"ws_ftp.log\"\n        ],\n        \"FilterOn\": 0,\n        \"FilterNames\": false,\n        \"File\": null,\n        \"Format\": \"ZIP\",\n        \"PackDir\": \"\\/customers\\/c\\/5\\/1\\/sparkway-client.de\\/httpd.www\\/sparkgarten\",\n        \"Size\": 197305986,\n        \"Dirs\": null,\n        \"DirCount\": 1659,\n        \"RecursiveLinks\": [],\n        \"Files\": null,\n        \"FileCount\": 12493,\n        \"file_count\": -1,\n        \"FilterInfo\": {\n            \"Dirs\": {\n                \"Warning\": [],\n                \"AddonSites\": [],\n                \"Size\": [],\n                \"Core\": [],\n                \"Global\": [],\n                \"Instance\": [],\n                \"Unreadable\": []\n            },\n            \"Files\": {\n                \"Warning\": [],\n                \"Size\": [],\n                \"Core\": [],\n                \"Global\": [],\n                \"Instance\": [],\n                \"Unreadable\": []\n            },\n            \"Exts\": {\n                \"Core\": [],\n                \"Global\": [],\n                \"Instance\": [],\n                \"Unreadable\": []\n            },\n            \"TreeSize\": null,\n            \"TreeWarning\": null\n        },\n        \"ListDelimiter\": \"\\n\",\n        \"throttleDelayInUs\": 0\n    },\n    \"Multisite\": {\n        \"FilterSites\": \"\"\n    },\n    \"Installer\": {\n        \"File\": \"\",\n        \"Size\": 0,\n        \"OptsSecureOn\": 0,\n        \"passowrd\": \"eoZ1lfwdmtu+h2yGeg3Mg6Xuu6SDqm2oFCUinO45UM\\/VydIAZcXtuxC8L6JCzuNhmHz0c1tIPoQ5Hgj9o1CJcw==\",\n        \"OptsSecurePass\": \"\",\n        \"OptsSkipScan\": 0,\n        \"OptsDBHost\": \"\",\n        \"OptsDBName\": \"\",\n        \"OptsDBUser\": \"\",\n        \"OptsCPNLHost\": \"\",\n        \"OptsCPNLUser\": \"\",\n        \"OptsCPNLPass\": \"\",\n        \"OptsCPNLEnable\": 0,\n        \"OptsCPNLConnect\": false,\n        \"OptsCPNLDBAction\": \"create\",\n        \"OptsCPNLDBHost\": \"\",\n        \"OptsCPNLDBName\": \"\",\n        \"OptsCPNLDBUser\": \"\",\n        \"numFilesAdded\": 0,\n        \"numDirsAdded\": 0\n    },\n    \"Database\": {\n        \"info\": {\n            \"buildMode\": \"PHPCHUNKING\",\n            \"charSetList\": [\n                \"utf8\",\n                \"utf8mb4\"\n            ],\n            \"collationList\": [\n                \"ascii_general_ci\",\n                \"latin1_general_ci\",\n                \"utf8_general_ci\",\n                \"utf8mb4_general_ci\",\n                \"utf8mb4_unicode_520_ci\",\n                \"utf8mb4_unicode_ci\"\n            ],\n            \"engineList\": [\n                \"InnoDB\"\n            ],\n            \"isTablesUpperCase\": 0,\n            \"isNameUpperCase\": 0,\n            \"name\": \"sparkway_client_degarten\",\n            \"tablesBaseCount\": 47,\n            \"tablesFinalCount\": 47,\n            \"muFilteredTableCount\": 0,\n            \"tablesRowCount\": 1715,\n            \"tablesSizeOnDisk\": 5390336,\n            \"tablesList\": {\n                \"cerber_acl\": {\n                    \"inaccurateRows\": 2,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"cerber_blocks\": {\n                    \"inaccurateRows\": 1,\n                    \"insertedRows\": false,\n                    \"size\": 16384\n                },\n                \"cerber_countries\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 16384\n                },\n                \"cerber_lab\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 16384\n                },\n                \"cerber_lab_ip\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 16384\n                },\n                \"cerber_lab_net\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"cerber_log\": {\n                    \"inaccurateRows\": 2,\n                    \"insertedRows\": false,\n                    \"size\": 65536\n                },\n                \"cerber_qmem\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"cerber_traffic\": {\n                    \"inaccurateRows\": 1,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_cbnetpo_ping_optimizer\": {\n                    \"inaccurateRows\": 29,\n                    \"insertedRows\": false,\n                    \"size\": 16384\n                },\n                \"come_cerber_files\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 16384\n                },\n                \"come_cerber_sets\": {\n                    \"inaccurateRows\": 15,\n                    \"insertedRows\": false,\n                    \"size\": 16384\n                },\n                \"come_cerber_uss\": {\n                    \"inaccurateRows\": 1,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_commentmeta\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_comments\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 98304\n                },\n                \"come_duplicator_pro_entities\": {\n                    \"inaccurateRows\": 5,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_duplicator_pro_packages\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_links\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_options\": {\n                    \"inaccurateRows\": 1218,\n                    \"insertedRows\": false,\n                    \"size\": 458752\n                },\n                \"come_postmeta\": {\n                    \"inaccurateRows\": 241,\n                    \"insertedRows\": false,\n                    \"size\": 2211840\n                },\n                \"come_posts\": {\n                    \"inaccurateRows\": 69,\n                    \"insertedRows\": false,\n                    \"size\": 589824\n                },\n                \"come_shortpixel_folders\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_shortpixel_meta\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_shortpixel_postmeta\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 98304\n                },\n                \"come_shortpixel_queue\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 114688\n                },\n                \"come_statistics_exclusions\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_statistics_historical\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 65536\n                },\n                \"come_statistics_pages\": {\n                    \"inaccurateRows\": 1,\n                    \"insertedRows\": false,\n                    \"size\": 98304\n                },\n                \"come_statistics_search\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 65536\n                },\n                \"come_statistics_useronline\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 16384\n                },\n                \"come_statistics_visit\": {\n                    \"inaccurateRows\": 6,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_statistics_visitor\": {\n                    \"inaccurateRows\": 1,\n                    \"insertedRows\": false,\n                    \"size\": 98304\n                },\n                \"come_statistics_visitor_relationships\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_termmeta\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_terms\": {\n                    \"inaccurateRows\": 3,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_term_relationships\": {\n                    \"inaccurateRows\": 8,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_term_taxonomy\": {\n                    \"inaccurateRows\": 3,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_tf_storage\": {\n                    \"inaccurateRows\": 13,\n                    \"insertedRows\": false,\n                    \"size\": 65536\n                },\n                \"come_tm_taskmeta\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_tm_tasks\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_usermeta\": {\n                    \"inaccurateRows\": 52,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_users\": {\n                    \"inaccurateRows\": 1,\n                    \"insertedRows\": false,\n                    \"size\": 65536\n                },\n                \"come_yoast_indexable\": {\n                    \"inaccurateRows\": 12,\n                    \"insertedRows\": false,\n                    \"size\": 114688\n                },\n                \"come_yoast_indexable_hierarchy\": {\n                    \"inaccurateRows\": 7,\n                    \"insertedRows\": false,\n                    \"size\": 65536\n                },\n                \"come_yoast_migrations\": {\n                    \"inaccurateRows\": 24,\n                    \"insertedRows\": false,\n                    \"size\": 32768\n                },\n                \"come_yoast_primary_term\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                },\n                \"come_yoast_seo_links\": {\n                    \"inaccurateRows\": 0,\n                    \"insertedRows\": false,\n                    \"size\": 49152\n                }\n            },\n            \"varLowerCaseTables\": \"0\",\n            \"dbEngine\": \"MariaDB\",\n            \"version\": \"10.5.21\",\n            \"versionComment\": \"mariadb.org binary distribution\",\n            \"viewCount\": 0,\n            \"procCount\": 0,\n            \"funcCount\": 0,\n            \"triggerList\": []\n        },\n        \"Type\": \"MySQL\",\n        \"Size\": 0,\n        \"File\": \"\",\n        \"FilterTables\": \"\",\n        \"FilterOn\": 0,\n        \"prefixFilter\": false,\n        \"prefixSubFilter\": false,\n        \"DBMode\": \"PHP\",\n        \"Compatible\": \"\",\n        \"Comments\": \"mariadb.org binary distribution\",\n        \"dbStorePathPublic\": \"\"\n    },\n    \"Status\": 5,\n    \"schedule_id\": -1,\n    \"build_progress\": {\n        \"thread_start_time\": 0,\n        \"initialized\": false,\n        \"installer_built\": false,\n        \"archive_started\": false,\n        \"archive_start_time\": 0,\n        \"archive_has_database\": false,\n        \"archive_built\": false,\n        \"database_script_built\": false,\n        \"failed\": false,\n        \"next_archive_file_index\": 0,\n        \"next_archive_dir_index\": 0,\n        \"retries\": 0,\n        \"current_build_mode\": -1,\n        \"current_build_compression\": true,\n        \"dupCreate\": null,\n        \"dupExpand\": null,\n        \"warnings\": []\n    },\n    \"db_build_progress\": {\n        \"tablesToProcess\": [],\n        \"validationStage1\": false,\n        \"doneInit\": false,\n        \"doneFiltering\": false,\n        \"doneCreates\": false,\n        \"completed\": false,\n        \"startTime\": 0,\n        \"wasInterrupted\": false,\n        \"errorOut\": false,\n        \"failureCount\": 0,\n        \"countCheckData\": {\n            \"impreciseTotalRows\": 0,\n            \"countTotal\": 0,\n            \"tables\": []\n        }\n    },\n    \"upload_infos\": [\n        {\n            \"storage_id\": \"-2\",\n            \"archive_offset\": 0,\n            \"copied_installer\": false,\n            \"copied_archive\": false,\n            \"progress\": 0,\n            \"num_failures\": 0,\n            \"failed\": false,\n            \"cancelled\": false,\n            \"upload_id\": null,\n            \"failure_count\": 0,\n            \"data\": \"\",\n            \"data2\": \"\",\n            \"has_started\": false,\n            \"status_message_details\": \"\",\n            \"started_timestamp\": null,\n            \"stopped_timestamp\": null,\n            \"chunkPosition\": []\n        }\n    ],\n    \"active_storage_id\": -1,\n    \"template_id\": 5\n}","yes");

INSERT IGNORE INTO `come_postmeta` VALUES 
("13","8","_edit_lock","1657724459:1"),
("14","10","_edit_lock","1641679764:1"),
("15","12","_edit_lock","1641679777:1"),
("24","22","_menu_item_type","post_type"),
("25","22","_menu_item_menu_item_parent","0"),
("26","22","_menu_item_object_id","8"),
("27","22","_menu_item_object","page"),
("28","22","_menu_item_target",""),
("29","22","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("30","22","_menu_item_xfn",""),
("31","22","_menu_item_url",""),
("33","23","_menu_item_type","post_type"),
("34","23","_menu_item_menu_item_parent","0"),
("35","23","_menu_item_object_id","8"),
("36","23","_menu_item_object","page"),
("37","23","_menu_item_target",""),
("38","23","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("39","23","_menu_item_xfn",""),
("40","23","_menu_item_url",""),
("42","24","_menu_item_type","post_type"),
("43","24","_menu_item_menu_item_parent","0"),
("44","24","_menu_item_object_id","12"),
("45","24","_menu_item_object","page"),
("46","24","_menu_item_target",""),
("47","24","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("48","24","_menu_item_xfn",""),
("49","24","_menu_item_url",""),
("51","25","_menu_item_type","post_type"),
("52","25","_menu_item_menu_item_parent","0"),
("53","25","_menu_item_object_id","10"),
("54","25","_menu_item_object","page"),
("55","25","_menu_item_target",""),
("56","25","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("57","25","_menu_item_xfn",""),
("58","25","_menu_item_url",""),
("69","8","_edit_last","1"),
("70","8","ao_post_optimize","a:6:{s:16:\"ao_post_optimize\";s:2:\"on\";s:19:\"ao_post_js_optimize\";s:2:\"on\";s:20:\"ao_post_css_optimize\";s:2:\"on\";s:12:\"ao_post_ccss\";s:2:\"on\";s:16:\"ao_post_lazyload\";s:2:\"on\";s:15:\"ao_post_preload\";s:0:\"\";}"),
("79","8","content_width","full_width"),
("80","8","_yoast_wpseo_estimated-reading-time-minutes",""),
("81","8","_yoast_wpseo_wordproof_timestamp",""),
("86","37","_wp_attached_file","2022/07/pexels-creative-vix-7283.jpg"),
("87","37","_wp_attachment_metadata","a:6:{s:5:\"width\";i:1280;s:6:\"height\";i:853;s:4:\"file\";s:36:\"2022/07/pexels-creative-vix-7283.jpg\";s:8:\"filesize\";i:266676;s:5:\"sizes\";a:4:{s:6:\"medium\";a:5:{s:4:\"file\";s:36:\"pexels-creative-vix-7283-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:16487;}s:5:\"large\";a:5:{s:4:\"file\";s:37:\"pexels-creative-vix-7283-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:139756;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:36:\"pexels-creative-vix-7283-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:6921;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:36:\"pexels-creative-vix-7283-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:87032;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("88","38","_wp_attached_file","2022/07/pexels-creative-vix-7283-Kopie.jpg"),
("89","38","_wp_attachment_metadata","a:6:{s:5:\"width\";i:1280;s:6:\"height\";i:853;s:4:\"file\";s:42:\"2022/07/pexels-creative-vix-7283-Kopie.jpg\";s:8:\"filesize\";i:293760;s:5:\"sizes\";a:4:{s:6:\"medium\";a:5:{s:4:\"file\";s:42:\"pexels-creative-vix-7283-Kopie-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:19346;}s:5:\"large\";a:5:{s:4:\"file\";s:43:\"pexels-creative-vix-7283-Kopie-1024x682.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:682;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:160463;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:42:\"pexels-creative-vix-7283-Kopie-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:8006;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:42:\"pexels-creative-vix-7283-Kopie-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:100999;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}"),
("93","41","_wp_attached_file","2022/07/Brandl-Landschaftspflege.png"),
("94","41","_wp_attachment_metadata","a:6:{s:5:\"width\";i:958;s:6:\"height\";i:88;s:4:\"file\";s:36:\"2022/07/Brandl-Landschaftspflege.png\";s:8:\"filesize\";i:18342;s:5:\"sizes\";a:3:{s:6:\"medium\";a:5:{s:4:\"file\";s:35:\"Brandl-Landschaftspflege-300x28.png\";s:5:\"width\";i:300;s:6:\"height\";i:28;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:5438;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:35:\"Brandl-Landschaftspflege-150x88.png\";s:5:\"width\";i:150;s:6:\"height\";i:88;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:4214;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:35:\"Brandl-Landschaftspflege-768x71.png\";s:5:\"width\";i:768;s:6:\"height\";i:71;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:16619;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("97","43","_edit_last","1"),
("98","43","_edit_lock","1657410213:1"),
("99","43","_themify_builder_settings_json","[{\"element_id\":\"98m8524\",\"cols\":[{\"element_id\":\"ayok525\",\"grid_class\":\"col-full\"}]}]"),
("100","44","_themify_builder_settings_json","[{\"element_id\":\"98m8524\",\"cols\":[{\"element_id\":\"ayok525\",\"grid_class\":\"col-full\"}]}]"),
("101","43","section_scrolling_mobile","on"),
("102","43","ao_post_optimize","a:6:{s:16:\"ao_post_optimize\";s:2:\"on\";s:19:\"ao_post_js_optimize\";s:2:\"on\";s:20:\"ao_post_css_optimize\";s:2:\"on\";s:12:\"ao_post_ccss\";s:2:\"on\";s:16:\"ao_post_lazyload\";s:2:\"on\";s:15:\"ao_post_preload\";s:0:\"\";}"),
("103","43","_yoast_wpseo_estimated-reading-time-minutes",""),
("104","43","_yoast_wpseo_wordproof_timestamp",""),
("106","45","_edit_last","1"),
("107","45","section_scrolling_mobile","on"),
("108","45","ao_post_optimize","a:6:{s:16:\"ao_post_optimize\";s:2:\"on\";s:19:\"ao_post_js_optimize\";s:2:\"on\";s:20:\"ao_post_css_optimize\";s:2:\"on\";s:12:\"ao_post_ccss\";s:2:\"on\";s:16:\"ao_post_lazyload\";s:2:\"on\";s:15:\"ao_post_preload\";s:0:\"\";}"),
("109","45","_yoast_wpseo_estimated-reading-time-minutes",""),
("110","45","_yoast_wpseo_wordproof_timestamp",""),
("111","45","_edit_lock","1657410359:1"),
("112","47","_themify_builder_settings_json","[{\"element_id\":\"2jmi242\",\"cols\":[{\"element_id\":\"2suk242\",\"grid_class\":\"col-full\"}]}]"),
("113","47","_edit_last","1"),
("114","47","section_scrolling_mobile","on"),
("115","47","ao_post_optimize","a:6:{s:16:\"ao_post_optimize\";s:2:\"on\";s:19:\"ao_post_js_optimize\";s:2:\"on\";s:20:\"ao_post_css_optimize\";s:2:\"on\";s:12:\"ao_post_ccss\";s:2:\"on\";s:16:\"ao_post_lazyload\";s:2:\"on\";s:15:\"ao_post_preload\";s:0:\"\";}"),
("116","47","_yoast_wpseo_estimated-reading-time-minutes",""),
("117","47","_yoast_wpseo_wordproof_timestamp",""),
("118","47","_edit_lock","1657410325:1"),
("119","23","_wp_old_date","2022-05-24"),
("120","25","_wp_old_date","2022-05-24"),
("121","24","_wp_old_date","2022-05-24"),
("131","22","_wp_old_date","2022-05-24"),
("150","45","_themify_builder_settings_json","[{\"element_id\":\"wenf252\",\"cols\":[{\"element_id\":\"zv9r252\",\"grid_class\":\"col-full\"}]}]"),
("151","52","_themify_builder_settings_json","[{\"element_id\":\"wenf252\",\"cols\":[{\"element_id\":\"zv9r252\",\"grid_class\":\"col-full\"}]}]"),
("165","59","_wp_attached_file","2022/07/Brandl-Landschaftspflege-white.png"),
("166","59","_wp_attachment_metadata","a:6:{s:5:\"width\";i:958;s:6:\"height\";i:87;s:4:\"file\";s:42:\"2022/07/Brandl-Landschaftspflege-white.png\";s:8:\"filesize\";i:15704;s:5:\"sizes\";a:3:{s:6:\"medium\";a:5:{s:4:\"file\";s:41:\"Brandl-Landschaftspflege-white-300x27.png\";s:5:\"width\";i:300;s:6:\"height\";i:27;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:5157;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:41:\"Brandl-Landschaftspflege-white-150x87.png\";s:5:\"width\";i:150;s:6:\"height\";i:87;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:3946;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:41:\"Brandl-Landschaftspflege-white-768x70.png\";s:5:\"width\";i:768;s:6:\"height\";i:70;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:16226;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("190","8","_yoast_wpseo_content_score","90"),
("205","79","_wp_attached_file","2022/07/pankaj-shah-1ff_i7jO-4g-unsplash.jpg"),
("206","79","_wp_attachment_metadata","a:6:{s:5:\"width\";i:1920;s:6:\"height\";i:1440;s:4:\"file\";s:44:\"2022/07/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\";s:8:\"filesize\";i:1473666;s:5:\"sizes\";a:8:{s:6:\"medium\";a:5:{s:4:\"file\";s:44:\"pankaj-shah-1ff_i7jO-4g-unsplash-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:30389;}s:5:\"large\";a:5:{s:4:\"file\";s:45:\"pankaj-shah-1ff_i7jO-4g-unsplash-1024x768.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:388748;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:44:\"pankaj-shah-1ff_i7jO-4g-unsplash-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:9875;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:44:\"pankaj-shah-1ff_i7jO-4g-unsplash-768x576.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:218736;}s:9:\"1536x1536\";a:5:{s:4:\"file\";s:46:\"pankaj-shah-1ff_i7jO-4g-unsplash-1536x1152.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:838990;}s:15:\"resized-360x200\";a:5:{s:4:\"file\";s:53:\"pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-360x200.jpg\";s:5:\"width\";i:360;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:31116;}s:15:\"resized-500x200\";a:5:{s:4:\"file\";s:53:\"pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x200.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:44165;}s:15:\"resized-500x500\";a:5:{s:4:\"file\";s:53:\"pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:500;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:110539;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("211","82","_wp_attached_file","2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg"),
("212","82","_wp_attachment_metadata","a:6:{s:5:\"width\";i:1000;s:6:\"height\";i:667;s:4:\"file\";s:46:\"2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\";s:8:\"filesize\";i:289048;s:5:\"sizes\";a:4:{s:6:\"medium\";a:5:{s:4:\"file\";s:46:\"matthew-HBjsSlRHXnY-unsplash-Kopie-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:22110;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:46:\"matthew-HBjsSlRHXnY-unsplash-Kopie-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:9078;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:46:\"matthew-HBjsSlRHXnY-unsplash-Kopie-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:130215;}s:15:\"resized-400x300\";a:5:{s:4:\"file\";s:46:\"matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:42999;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}"),
("213","83","_wp_attached_file","2022/07/benjamin-rascoe-v9jEOnzAkK0-unsplash-Kopie.jpg"),
("214","83","_wp_attachment_metadata","a:6:{s:5:\"width\";i:1000;s:6:\"height\";i:667;s:4:\"file\";s:54:\"2022/07/benjamin-rascoe-v9jEOnzAkK0-unsplash-Kopie.jpg\";s:8:\"filesize\";i:314373;s:5:\"sizes\";a:3:{s:6:\"medium\";a:5:{s:4:\"file\";s:54:\"benjamin-rascoe-v9jEOnzAkK0-unsplash-Kopie-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:23807;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:54:\"benjamin-rascoe-v9jEOnzAkK0-unsplash-Kopie-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:9690;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:54:\"benjamin-rascoe-v9jEOnzAkK0-unsplash-Kopie-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:136345;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}"),
("215","84","_wp_attached_file","2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg"),
("216","84","_wp_attachment_metadata","a:6:{s:5:\"width\";i:1000;s:6:\"height\";i:670;s:4:\"file\";s:51:\"2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\";s:8:\"filesize\";i:301595;s:5:\"sizes\";a:6:{s:6:\"medium\";a:5:{s:4:\"file\";s:51:\"annie-spratt-scIRUSc7Q38-unsplash-Kopie-300x201.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:201;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:23481;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:51:\"annie-spratt-scIRUSc7Q38-unsplash-Kopie-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:9326;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:51:\"annie-spratt-scIRUSc7Q38-unsplash-Kopie-768x515.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:515;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:138219;}s:15:\"resized-360x200\";a:5:{s:4:\"file\";s:51:\"annie-spratt-scIRUSc7Q38-unsplash-Kopie-360x200.jpg\";s:5:\"width\";i:360;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:27818;}s:15:\"resized-500x200\";a:5:{s:4:\"file\";s:51:\"annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x200.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:41888;}s:15:\"resized-500x500\";a:5:{s:4:\"file\";s:51:\"annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:500;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:86803;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}"),
("219","86","_wp_attached_file","2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg"),
("220","86","_wp_attachment_metadata","a:7:{s:5:\"width\";i:2560;s:6:\"height\";i:1742;s:4:\"file\";s:55:\"2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\";s:8:\"filesize\";i:1073564;s:5:\"sizes\";a:9:{s:6:\"medium\";a:5:{s:4:\"file\";s:48:\"tania-melnyczuk-dSOQHP-ALqw-unsplash-300x204.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:204;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:20455;}s:5:\"large\";a:5:{s:4:\"file\";s:49:\"tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:697;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:220153;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:48:\"tania-melnyczuk-dSOQHP-ALqw-unsplash-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:7856;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:48:\"tania-melnyczuk-dSOQHP-ALqw-unsplash-768x523.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:523;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:126353;}s:9:\"1536x1536\";a:5:{s:4:\"file\";s:50:\"tania-melnyczuk-dSOQHP-ALqw-unsplash-1536x1045.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:1045;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:461506;}s:9:\"2048x2048\";a:5:{s:4:\"file\";s:50:\"tania-melnyczuk-dSOQHP-ALqw-unsplash-2048x1394.jpg\";s:5:\"width\";i:2048;s:6:\"height\";i:1394;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:752563;}s:15:\"resized-360x200\";a:5:{s:4:\"file\";s:57:\"tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-360x200.jpg\";s:5:\"width\";i:360;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:24322;}s:15:\"resized-500x200\";a:5:{s:4:\"file\";s:57:\"tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x200.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:36866;}s:15:\"resized-500x500\";a:5:{s:4:\"file\";s:57:\"tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:500;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:69031;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}s:14:\"original_image\";s:40:\"tania-melnyczuk-dSOQHP-ALqw-unsplash.jpg\";}"),
("225","89","_wp_attached_file","2022/07/WhatsApp-Image-2022-06-23-at-14.57.00-Kopie.jpeg"),
("226","89","_wp_attachment_metadata","a:6:{s:5:\"width\";i:1408;s:6:\"height\";i:1408;s:4:\"file\";s:56:\"2022/07/WhatsApp-Image-2022-06-23-at-14.57.00-Kopie.jpeg\";s:8:\"filesize\";i:180819;s:5:\"sizes\";a:4:{s:6:\"medium\";a:5:{s:4:\"file\";s:56:\"WhatsApp-Image-2022-06-23-at-14.57.00-Kopie-300x300.jpeg\";s:5:\"width\";i:300;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:18576;}s:5:\"large\";a:5:{s:4:\"file\";s:58:\"WhatsApp-Image-2022-06-23-at-14.57.00-Kopie-1024x1024.jpeg\";s:5:\"width\";i:1024;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:125984;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:56:\"WhatsApp-Image-2022-06-23-at-14.57.00-Kopie-150x150.jpeg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:6129;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:56:\"WhatsApp-Image-2022-06-23-at-14.57.00-Kopie-768x768.jpeg\";s:5:\"width\";i:768;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:82303;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}"),
("233","93","_wp_attached_file","2022/07/marta-bibi-N-lK5xhXIug-unsplash.jpg"),
("234","93","_wp_attachment_metadata","a:6:{s:5:\"width\";i:1920;s:6:\"height\";i:1440;s:4:\"file\";s:43:\"2022/07/marta-bibi-N-lK5xhXIug-unsplash.jpg\";s:8:\"filesize\";i:1004276;s:5:\"sizes\";a:5:{s:6:\"medium\";a:5:{s:4:\"file\";s:43:\"marta-bibi-N-lK5xhXIug-unsplash-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:25351;}s:5:\"large\";a:5:{s:4:\"file\";s:44:\"marta-bibi-N-lK5xhXIug-unsplash-1024x768.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:268384;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:43:\"marta-bibi-N-lK5xhXIug-unsplash-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:9223;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:43:\"marta-bibi-N-lK5xhXIug-unsplash-768x576.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:157271;}s:9:\"1536x1536\";a:5:{s:4:\"file\";s:45:\"marta-bibi-N-lK5xhXIug-unsplash-1536x1152.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:552648;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("245","99","_menu_item_type","custom"),
("246","99","_menu_item_menu_item_parent","0"),
("247","99","_menu_item_object_id","99"),
("248","99","_menu_item_object","custom"),
("249","99","_menu_item_target",""),
("250","99","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("251","99","_menu_item_xfn",""),
("252","99","_menu_item_url","#leistungen"),
("254","100","_menu_item_type","custom"),
("255","100","_menu_item_menu_item_parent","0"),
("256","100","_menu_item_object_id","100"),
("257","100","_menu_item_object","custom"),
("258","100","_menu_item_target",""),
("259","100","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("260","100","_menu_item_xfn",""),
("261","100","_menu_item_url","#service"),
("263","101","_menu_item_type","custom"),
("264","101","_menu_item_menu_item_parent","0"),
("265","101","_menu_item_object_id","101"),
("266","101","_menu_item_object","custom"),
("267","101","_menu_item_target",""),
("268","101","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("269","101","_menu_item_xfn",""),
("270","101","_menu_item_url","#ueberuns"),
("272","102","_menu_item_type","custom"),
("273","102","_menu_item_menu_item_parent","0"),
("274","102","_menu_item_object_id","102"),
("275","102","_menu_item_object","custom"),
("276","102","_menu_item_target",""),
("277","102","_menu_item_classes","a:1:{i:0;s:0:\"\";}"),
("278","102","_menu_item_xfn",""),
("279","102","_menu_item_url","#kontakt"),
("305","8","header_wrap","transparent"),
("306","116","_wp_attached_file","2022/07/michael-lZTlmTOx_dA-unsplash.jpg"),
("307","116","_wp_attachment_metadata","a:6:{s:5:\"width\";i:640;s:6:\"height\";i:561;s:4:\"file\";s:40:\"2022/07/michael-lZTlmTOx_dA-unsplash.jpg\";s:8:\"filesize\";i:132591;s:5:\"sizes\";a:2:{s:6:\"medium\";a:5:{s:4:\"file\";s:40:\"michael-lZTlmTOx_dA-unsplash-300x263.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:263;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:26048;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:40:\"michael-lZTlmTOx_dA-unsplash-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:8826;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}"),
("308","117","_wp_attached_file","2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg"),
("309","117","_wp_attachment_metadata","a:6:{s:5:\"width\";i:491;s:6:\"height\";i:356;s:4:\"file\";s:60:\"2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\";s:8:\"filesize\";i:72552;s:5:\"sizes\";a:3:{s:6:\"medium\";a:5:{s:4:\"file\";s:60:\"stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-300x218.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:218;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:21573;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:60:\"stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:8995;}s:15:\"resized-400x300\";a:5:{s:4:\"file\";s:60:\"stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:36046;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("310","118","_wp_attached_file","2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg"),
("311","118","_wp_attachment_metadata","a:6:{s:5:\"width\";i:640;s:6:\"height\";i:480;s:4:\"file\";s:46:\"2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\";s:8:\"filesize\";i:88144;s:5:\"sizes\";a:3:{s:6:\"medium\";a:5:{s:4:\"file\";s:46:\"henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:18216;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:46:\"henrique-paim-8s7AjrOxa0Y-unsplash-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:7199;}s:15:\"resized-400x300\";a:5:{s:4:\"file\";s:46:\"henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:30219;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("312","117","_wp_attachment_backup_sizes","a:4:{s:9:\"full-orig\";a:3:{s:5:\"width\";i:640;s:6:\"height\";i:360;s:4:\"file\";s:37:\"stefan-cosma-aqBQPZUeWfw-unsplash.jpg\";}s:14:\"thumbnail-orig\";a:5:{s:4:\"file\";s:45:\"stefan-cosma-aqBQPZUeWfw-unsplash-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:8098;}s:11:\"medium-orig\";a:5:{s:4:\"file\";s:45:\"stefan-cosma-aqBQPZUeWfw-unsplash-300x169.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:169;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:15525;}s:15:\"resized-400x300\";a:5:{s:4:\"file\";s:60:\"stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:36046;}}"),
("313","119","_wp_attached_file","2022/07/Brandl-Square-Landschaftspflege.png"),
("314","119","_wp_attachment_metadata","a:6:{s:5:\"width\";i:402;s:6:\"height\";i:162;s:4:\"file\";s:43:\"2022/07/Brandl-Square-Landschaftspflege.png\";s:8:\"filesize\";i:15440;s:5:\"sizes\";a:2:{s:6:\"medium\";a:5:{s:4:\"file\";s:43:\"Brandl-Square-Landschaftspflege-300x121.png\";s:5:\"width\";i:300;s:6:\"height\";i:121;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:12189;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:43:\"Brandl-Square-Landschaftspflege-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:7714;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("315","82","_wp_attachment_backup_sizes","a:1:{s:15:\"resized-400x300\";a:5:{s:4:\"file\";s:46:\"matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:42999;}}"),
("322","22","_wp_old_date","2022-07-10"),
("323","100","_wp_old_date","2022-07-10"),
("324","99","_wp_old_date","2022-07-10"),
("325","101","_wp_old_date","2022-07-10"),
("326","102","_wp_old_date","2022-07-10"),
("327","118","_wp_attachment_backup_sizes","a:1:{s:15:\"resized-400x300\";a:5:{s:4:\"file\";s:46:\"henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\";s:5:\"width\";i:400;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:30219;}}"),
("342","132","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"uebermich\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/Brandl-Square-Landschaftspflege.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"}}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":65}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("343","133","_wp_attached_file","2022/07/P2181257-1024x768-1.jpg"),
("344","133","_wp_attachment_metadata","a:6:{s:5:\"width\";i:1024;s:6:\"height\";i:768;s:4:\"file\";s:31:\"2022/07/P2181257-1024x768-1.jpg\";s:8:\"filesize\";i:195441;s:5:\"sizes\";a:6:{s:6:\"medium\";a:5:{s:4:\"file\";s:31:\"P2181257-1024x768-1-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:20365;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:31:\"P2181257-1024x768-1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:8090;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:31:\"P2181257-1024x768-1-768x576.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:96395;}s:15:\"resized-450x200\";a:5:{s:4:\"file\";s:31:\"P2181257-1024x768-1-450x200.jpg\";s:5:\"width\";i:450;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:27866;}s:15:\"resized-500x200\";a:5:{s:4:\"file\";s:31:\"P2181257-1024x768-1-500x200.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:31010;}s:15:\"resized-500x400\";a:5:{s:4:\"file\";s:31:\"P2181257-1024x768-1-500x400.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:49534;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("345","134","_wp_attached_file","2022/07/logol-1024x210-1.jpg"),
("346","134","_wp_attachment_metadata","a:6:{s:5:\"width\";i:1024;s:6:\"height\";i:210;s:4:\"file\";s:28:\"2022/07/logol-1024x210-1.jpg\";s:8:\"filesize\";i:32735;s:5:\"sizes\";a:3:{s:6:\"medium\";a:5:{s:4:\"file\";s:27:\"logol-1024x210-1-300x62.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:62;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:7212;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:28:\"logol-1024x210-1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:5145;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:28:\"logol-1024x210-1-768x158.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:158;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:22065;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("348","135","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"uebermich\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/Brandl-Square-Landschaftspflege.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"}}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":65}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol-1024x210-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"sw8b98\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("350","136","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"uebermich\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/Brandl-Square-Landschaftspflege.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"}}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":65}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol-1024x210-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"sw8b98\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\"}}]}],\"styling\":{\"padding_bottom\":60,\"background_color\":\"#b9ed76\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"}}]"),
("352","137","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"uebermich\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/Brandl-Square-Landschaftspflege.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"}}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":65}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol-1024x210-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"sw8b98\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\"}}]}],\"styling\":{\"padding_bottom\":60,\"background_color\":\"#b9ed76\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":35}}]"),
("354","138","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"uebermich\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/Brandl-Square-Landschaftspflege.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"}}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":65}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol-1024x210-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"sw8b98\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\"}}]}],\"styling\":{\"padding_bottom\":60,\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":35}}]");

INSERT IGNORE INTO `come_postmeta` VALUES 
("356","139","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"uebermich\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/Brandl-Square-Landschaftspflege.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"}}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol-1024x210-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"sw8b98\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\"}}]}],\"styling\":{\"padding_bottom\":60,\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":35}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":65}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("366","22","_wp_old_date","2022-07-12"),
("367","100","_wp_old_date","2022-07-12"),
("368","99","_wp_old_date","2022-07-12"),
("369","101","_wp_old_date","2022-07-12"),
("370","102","_wp_old_date","2022-07-12"),
("372","142","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"uebermich\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/Brandl-Square-Landschaftspflege.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"}}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol-1024x210-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"sw8b98\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\"}}]}],\"styling\":{\"padding_bottom\":60,\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":35}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":65}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("376","145","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/Brandl-Square-Landschaftspflege.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"}}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol-1024x210-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"sw8b98\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\"}}]}],\"styling\":{\"padding_bottom\":60,\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":35}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":65}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("378","146","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/Brandl-Square-Landschaftspflege.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"}}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol-1024x210-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"sw8b98\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\"}}]}],\"styling\":{\"padding_bottom\":60,\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":35,\"row_anchor\":\"blumen\",\"_link_o\":\"no\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":65}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("380","147","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/Brandl-Square-Landschaftspflege.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"}}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol-1024x210-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"sw8b98\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\"}}]}],\"styling\":{\"padding_bottom\":60,\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":35,\"_link_o\":\"no\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":65}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("381","148","_wp_attached_file","2022/07/PA171077-scaled.jpg"),
("382","148","_wp_attachment_metadata","a:7:{s:5:\"width\";i:2560;s:6:\"height\";i:1920;s:4:\"file\";s:27:\"2022/07/PA171077-scaled.jpg\";s:8:\"filesize\";i:989403;s:5:\"sizes\";a:9:{s:6:\"medium\";a:5:{s:4:\"file\";s:20:\"PA171077-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:21421;}s:5:\"large\";a:5:{s:4:\"file\";s:21:\"PA171077-1024x768.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:206466;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:20:\"PA171077-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:8377;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:20:\"PA171077-768x576.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:121762;}s:9:\"1536x1536\";a:5:{s:4:\"file\";s:22:\"PA171077-1536x1152.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:431340;}s:9:\"2048x2048\";a:5:{s:4:\"file\";s:22:\"PA171077-2048x1536.jpg\";s:5:\"width\";i:2048;s:6:\"height\";i:1536;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:688869;}s:15:\"resized-450x200\";a:5:{s:4:\"file\";s:29:\"PA171077-1024x768-450x200.jpg\";s:5:\"width\";i:450;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:29299;}s:15:\"resized-500x200\";a:5:{s:4:\"file\";s:29:\"PA171077-1024x768-500x200.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:32228;}s:15:\"resized-500x400\";a:5:{s:4:\"file\";s:29:\"PA171077-1024x768-500x400.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:55690;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}s:14:\"original_image\";s:12:\"PA171077.jpg\";}"),
("383","149","_wp_attached_file","2022/07/logol.png"),
("384","149","_wp_attachment_metadata","a:6:{s:5:\"width\";i:3700;s:6:\"height\";i:760;s:4:\"file\";s:17:\"2022/07/logol.png\";s:8:\"filesize\";i:211785;s:5:\"sizes\";a:6:{s:6:\"medium\";a:5:{s:4:\"file\";s:16:\"logol-300x62.png\";s:5:\"width\";i:300;s:6:\"height\";i:62;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:9526;}s:5:\"large\";a:5:{s:4:\"file\";s:18:\"logol-1024x210.png\";s:5:\"width\";i:1024;s:6:\"height\";i:210;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:40206;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:17:\"logol-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:5916;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:17:\"logol-768x158.png\";s:5:\"width\";i:768;s:6:\"height\";i:158;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:27555;}s:9:\"1536x1536\";a:5:{s:4:\"file\";s:18:\"logol-1536x316.png\";s:5:\"width\";i:1536;s:6:\"height\";i:316;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:68101;}s:9:\"2048x2048\";a:5:{s:4:\"file\";s:18:\"logol-2048x421.png\";s:5:\"width\";i:2048;s:6:\"height\";i:421;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:103597;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("386","150","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/Brandl-Square-Landschaftspflege.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"}}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\"}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"sw8b98\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\"}}]}],\"styling\":{\"padding_bottom\":60,\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":35,\"_link_o\":\"no\",\"cover_color\":\"#ffffff_0.83\",\"cover_color-type\":\"color\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"}}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":65}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]");

INSERT IGNORE INTO `come_postmeta` VALUES 
("387","151","_wp_attached_file","2022/07/PA110936-e1558441423834-scaled.jpg"),
("388","151","_wp_attachment_metadata","a:7:{s:5:\"width\";i:2560;s:6:\"height\";i:1920;s:4:\"file\";s:42:\"2022/07/PA110936-e1558441423834-scaled.jpg\";s:8:\"filesize\";i:549206;s:5:\"sizes\";a:9:{s:6:\"medium\";a:5:{s:4:\"file\";s:35:\"PA110936-e1558441423834-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:23237;}s:5:\"large\";a:5:{s:4:\"file\";s:36:\"PA110936-e1558441423834-1024x768.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:147694;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:35:\"PA110936-e1558441423834-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:9851;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:35:\"PA110936-e1558441423834-768x576.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:96749;}s:9:\"1536x1536\";a:5:{s:4:\"file\";s:37:\"PA110936-e1558441423834-1536x1152.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:265617;}s:9:\"2048x2048\";a:5:{s:4:\"file\";s:37:\"PA110936-e1558441423834-2048x1536.jpg\";s:5:\"width\";i:2048;s:6:\"height\";i:1536;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:399639;}s:15:\"resized-450x200\";a:5:{s:4:\"file\";s:44:\"PA110936-e1558441423834-1024x768-450x200.jpg\";s:5:\"width\";i:450;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:27916;}s:15:\"resized-500x200\";a:5:{s:4:\"file\";s:44:\"PA110936-e1558441423834-1024x768-500x200.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:29525;}s:15:\"resized-500x400\";a:5:{s:4:\"file\";s:44:\"PA110936-e1558441423834-1024x768-500x400.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:51624;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}s:14:\"original_image\";s:27:\"PA110936-e1558441423834.jpg\";}"),
("390","152","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/Brandl-Square-Landschaftspflege.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"}}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\"}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"450\",\"img_h_slider\":\"200\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"styling\":{\"padding_bottom\":60,\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":35,\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":65}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("392","153","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/Brandl-Square-Landschaftspflege.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"}}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\"}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"450\",\"img_h_slider\":\"200\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"styling\":{\"padding_bottom\":60,\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":35,\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":65}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("393","133","_wp_attachment_backup_sizes","a:3:{s:15:\"resized-450x200\";a:5:{s:4:\"file\";s:31:\"P2181257-1024x768-1-450x200.jpg\";s:5:\"width\";i:450;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:27866;}s:15:\"resized-500x200\";a:5:{s:4:\"file\";s:31:\"P2181257-1024x768-1-500x200.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:31010;}s:15:\"resized-500x400\";a:5:{s:4:\"file\";s:31:\"P2181257-1024x768-1-500x400.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:49534;}}"),
("394","148","_wp_attachment_backup_sizes","a:3:{s:15:\"resized-450x200\";a:5:{s:4:\"file\";s:29:\"PA171077-1024x768-450x200.jpg\";s:5:\"width\";i:450;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:29299;}s:15:\"resized-500x200\";a:5:{s:4:\"file\";s:29:\"PA171077-1024x768-500x200.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:32228;}s:15:\"resized-500x400\";a:5:{s:4:\"file\";s:29:\"PA171077-1024x768-500x400.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:55690;}}"),
("395","151","_wp_attachment_backup_sizes","a:3:{s:15:\"resized-450x200\";a:5:{s:4:\"file\";s:44:\"PA110936-e1558441423834-1024x768-450x200.jpg\";s:5:\"width\";i:450;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:27916;}s:15:\"resized-500x200\";a:5:{s:4:\"file\";s:44:\"PA110936-e1558441423834-1024x768-500x200.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:29525;}s:15:\"resized-500x400\";a:5:{s:4:\"file\";s:44:\"PA110936-e1558441423834-1024x768-500x400.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:400;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:51624;}}"),
("397","154","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/Brandl-Square-Landschaftspflege.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"}}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"450\",\"img_h_slider\":\"200\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"styling\":{\"padding_bottom\":60,\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":35,\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":65}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("399","155","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/Brandl-Square-Landschaftspflege.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"}}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":60,\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":35,\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":65}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("401","156","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/Brandl-Square-Landschaftspflege.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"}}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("402","158","_wp_attached_file","2022/08/Ghr-Logo-V1.png"),
("403","158","_wp_attachment_metadata","a:6:{s:5:\"width\";i:720;s:6:\"height\";i:101;s:4:\"file\";s:23:\"2022/08/Ghr-Logo-V1.png\";s:8:\"filesize\";i:28739;s:5:\"sizes\";a:2:{s:6:\"medium\";a:5:{s:4:\"file\";s:22:\"Ghr-Logo-V1-300x42.png\";s:5:\"width\";i:300;s:6:\"height\";i:42;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:10884;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:23:\"Ghr-Logo-V1-150x101.png\";s:5:\"width\";i:150;s:6:\"height\";i:101;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:6934;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("410","161","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"20\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]");

INSERT IGNORE INTO `come_postmeta` VALUES 
("412","162","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":50}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"20\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("414","163","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":50}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"20\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("416","164","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":50}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"20\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("417","22","_wp_old_date","2022-07-13"),
("418","100","_wp_old_date","2022-07-13"),
("419","99","_wp_old_date","2022-07-13"),
("420","101","_wp_old_date","2022-07-13"),
("421","102","_wp_old_date","2022-07-13"),
("423","165","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":50}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"20\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("425","166","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":50}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\"}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("427","167","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col3-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":50}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"360\",\"img_h_slider\":\"200\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]");

INSERT IGNORE INTO `come_postmeta` VALUES 
("428","84","_wp_attachment_backup_sizes","a:3:{s:15:\"resized-360x200\";a:5:{s:4:\"file\";s:51:\"annie-spratt-scIRUSc7Q38-unsplash-Kopie-360x200.jpg\";s:5:\"width\";i:360;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:27818;}s:15:\"resized-500x200\";a:5:{s:4:\"file\";s:51:\"annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x200.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:41888;}s:15:\"resized-500x500\";a:5:{s:4:\"file\";s:51:\"annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:500;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:86803;}}"),
("429","86","_wp_attachment_backup_sizes","a:3:{s:15:\"resized-360x200\";a:5:{s:4:\"file\";s:57:\"tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-360x200.jpg\";s:5:\"width\";i:360;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:24322;}s:15:\"resized-500x200\";a:5:{s:4:\"file\";s:57:\"tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x200.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:36866;}s:15:\"resized-500x500\";a:5:{s:4:\"file\";s:57:\"tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:500;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:69031;}}"),
("430","79","_wp_attachment_backup_sizes","a:3:{s:15:\"resized-360x200\";a:5:{s:4:\"file\";s:53:\"pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-360x200.jpg\";s:5:\"width\";i:360;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:31116;}s:15:\"resized-500x200\";a:5:{s:4:\"file\";s:53:\"pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x200.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:44165;}s:15:\"resized-500x500\";a:5:{s:4:\"file\";s:53:\"pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\";s:5:\"width\";i:500;s:6:\"height\";i:500;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:110539;}}"),
("432","168","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":50}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"500\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("434","169","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":50}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"500\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\",\"padding_top\":40}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("436","170","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":25}},{\"mod_name\":\"buttons\",\"element_id\":\"li14507\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"left\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"500\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\",\"padding_top\":40}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("442","173","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"49vj404\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"ldmj189\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"gcq384\",\"cols\":[{\"element_id\":\"fzai85\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"dpeq85\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"5cof85\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":25}},{\"mod_name\":\"buttons\",\"element_id\":\"li14507\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"left\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"500\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\",\"padding_top\":40}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("443","174","_wp_attached_file","2022/08/Ghr-Logo-V2.png"),
("444","174","_wp_attachment_metadata","a:6:{s:5:\"width\";i:800;s:6:\"height\";i:110;s:4:\"file\";s:23:\"2022/08/Ghr-Logo-V2.png\";s:8:\"filesize\";i:32430;s:5:\"sizes\";a:3:{s:6:\"medium\";a:5:{s:4:\"file\";s:22:\"Ghr-Logo-V2-300x41.png\";s:5:\"width\";i:300;s:6:\"height\";i:41;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:10680;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:23:\"Ghr-Logo-V2-150x110.png\";s:5:\"width\";i:150;s:6:\"height\";i:110;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:6411;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:23:\"Ghr-Logo-V2-768x106.png\";s:5:\"width\";i:768;s:6:\"height\";i:106;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:36521;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("445","175","_wp_attached_file","2022/08/Ghr-Logo-V2-1000px.png"),
("446","175","_wp_attachment_metadata","a:6:{s:5:\"width\";i:1182;s:6:\"height\";i:164;s:4:\"file\";s:30:\"2022/08/Ghr-Logo-V2-1000px.png\";s:8:\"filesize\";i:53476;s:5:\"sizes\";a:5:{s:6:\"medium\";a:5:{s:4:\"file\";s:29:\"Ghr-Logo-V2-1000px-300x42.png\";s:5:\"width\";i:300;s:6:\"height\";i:42;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:10455;}s:5:\"large\";a:5:{s:4:\"file\";s:31:\"Ghr-Logo-V2-1000px-1024x142.png\";s:5:\"width\";i:1024;s:6:\"height\";i:142;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:50329;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:30:\"Ghr-Logo-V2-1000px-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:8341;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:30:\"Ghr-Logo-V2-1000px-768x107.png\";s:5:\"width\";i:768;s:6:\"height\";i:107;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:33831;}s:14:\"resized-600x83\";a:5:{s:4:\"file\";s:38:\"Ghr-Logo-V2-1000px-1024x142-600x83.png\";s:5:\"width\";i:600;s:6:\"height\";i:83;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:26788;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}"),
("448","176","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"d3af145\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"height_image\":\"83\",\"auto_fullwidth\":false,\"width_image\":\"600\",\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V2-1000px.png\",\"caption_on_overlay\":false,\"style_image\":\"image-center\"}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"gcq384\",\"cols\":[{\"element_id\":\"fzai85\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"dpeq85\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"5cof85\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":25}},{\"mod_name\":\"buttons\",\"element_id\":\"li14507\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"left\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"500\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\",\"padding_top\":40}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]");

INSERT IGNORE INTO `come_postmeta` VALUES 
("449","175","_wp_attachment_backup_sizes","a:1:{s:14:\"resized-600x83\";a:5:{s:4:\"file\";s:38:\"Ghr-Logo-V2-1000px-1024x142-600x83.png\";s:5:\"width\";i:600;s:6:\"height\";i:83;s:9:\"mime-type\";s:9:\"image/png\";s:8:\"filesize\";i:26788;}}"),
("451","177","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"d3af145\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"height_image\":\"83\",\"auto_fullwidth\":false,\"width_image\":\"600\",\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V2-1000px.png\",\"caption_on_overlay\":false,\"style_image\":\"image-center\"}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"gcq384\",\"cols\":[{\"element_id\":\"fzai85\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"dpeq85\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"5cof85\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":25}},{\"mod_name\":\"buttons\",\"element_id\":\"li14507\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"left\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"500\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\",\"padding_top\":40}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("453","178","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"d3af145\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"height_image\":\"83\",\"auto_fullwidth\":false,\"width_image\":\"600\",\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V2-1000px.png\",\"caption_on_overlay\":false,\"style_image\":\"image-center\",\"motion_effects\":{\"v\":{\"val\":{\"v_vp\":\"47,100\",\"v_speed\":\"6\",\"v_dir\":\"down\"}},\"t\":{\"val\":{\"t_dir\":\"fadeout\"}}},\"hover_animation_effect\":\"pulse\",\"animation_effect_delay\":\"0.3\",\"animation_effect\":\"zoomInUp\"}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"gcq384\",\"cols\":[{\"element_id\":\"fzai85\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"dpeq85\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"5cof85\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":25}},{\"mod_name\":\"buttons\",\"element_id\":\"li14507\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"left\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"500\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\",\"padding_top\":40}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("455","179","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"d3af145\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"height_image\":\"83\",\"auto_fullwidth\":false,\"width_image\":\"600\",\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V2-1000px.png\",\"caption_on_overlay\":false,\"style_image\":\"image-center\",\"motion_effects\":{\"v\":{\"val\":{\"v_vp\":\"0,100\",\"v_speed\":\"6\",\"v_dir\":\"down\"}},\"t\":{\"val\":{\"t_dir\":\"fadeout\"}}},\"hover_animation_effect\":\"pulse\",\"animation_effect_delay\":\"0.3\",\"animation_effect\":\"zoomInUp\"}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"gcq384\",\"cols\":[{\"element_id\":\"fzai85\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"dpeq85\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"5cof85\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":25}},{\"mod_name\":\"buttons\",\"element_id\":\"li14507\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"left\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"500\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\",\"padding_top\":40}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("457","180","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"d3af145\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"height_image\":\"83\",\"auto_fullwidth\":false,\"width_image\":\"600\",\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V2-1000px.png\",\"caption_on_overlay\":false,\"style_image\":\"image-center\",\"motion_effects\":{\"v\":{\"val\":{\"v_vp\":\"0,100\",\"v_speed\":\"1\",\"v_dir\":\"down\"}},\"t\":{\"val\":{\"t_dir\":\"fadeout\"}}},\"hover_animation_effect\":\"pulse\",\"animation_effect_delay\":\"0.3\",\"animation_effect\":\"zoomInUp\"}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"gcq384\",\"cols\":[{\"element_id\":\"fzai85\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"dpeq85\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"5cof85\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":25}},{\"mod_name\":\"buttons\",\"element_id\":\"li14507\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"left\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"500\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\",\"padding_top\":40}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("459","181","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"d3af145\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"height_image\":\"83\",\"auto_fullwidth\":false,\"width_image\":\"600\",\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V2-1000px.png\",\"caption_on_overlay\":false,\"style_image\":\"image-center\",\"motion_effects\":{\"v\":{\"val\":{\"v_vp\":\"0,100\",\"v_speed\":\"1\",\"v_dir\":\"down\"}},\"t\":{\"val\":{\"t_dir\":\"fadeout\"}}},\"animation_effect_delay\":\"0.3\",\"animation_effect\":\"zoomInUp\"}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"gcq384\",\"cols\":[{\"element_id\":\"fzai85\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"dpeq85\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"5cof85\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":25}},{\"mod_name\":\"buttons\",\"element_id\":\"li14507\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"left\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"500\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\",\"padding_top\":40}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]");

INSERT IGNORE INTO `come_postmeta` VALUES 
("461","182","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"d3af145\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"height_image\":\"83\",\"auto_fullwidth\":false,\"width_image\":\"600\",\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V2-1000px.png\",\"caption_on_overlay\":false,\"style_image\":\"image-center\",\"motion_effects\":{\"v\":{\"val\":{\"v_vp\":\"0,100\",\"v_speed\":\"1\",\"v_dir\":\"down\"}},\"t\":{\"val\":{\"t_dir\":\"fadeout\"}}},\"animation_effect\":\"zoomInUp\"}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"gcq384\",\"cols\":[{\"element_id\":\"fzai85\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"dpeq85\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"5cof85\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":25}},{\"mod_name\":\"buttons\",\"element_id\":\"li14507\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"left\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"500\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\",\"padding_top\":40}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("463","183","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"d3af145\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"height_image\":\"83\",\"auto_fullwidth\":false,\"width_image\":\"600\",\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V2-1000px.png\",\"caption_on_overlay\":false,\"style_image\":\"image-center\",\"motion_effects\":{\"v\":{\"val\":{\"v_vp\":\"0,100\",\"v_speed\":\"1\",\"v_dir\":\"down\"}},\"t\":{\"val\":{\"t_dir\":\"fadeout\"}}},\"animation_effect\":\"zoomIn\"}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"gcq384\",\"cols\":[{\"element_id\":\"fzai85\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"dpeq85\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"5cof85\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":25}},{\"mod_name\":\"buttons\",\"element_id\":\"li14507\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"left\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"500\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\",\"padding_top\":40}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("465","184","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"d3af145\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"height_image\":\"83\",\"auto_fullwidth\":false,\"width_image\":\"600\",\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V2-1000px.png\",\"caption_on_overlay\":false,\"style_image\":\"image-center\",\"motion_effects\":{\"v\":{\"val\":{\"v_vp\":\"0,100\",\"v_speed\":\"1\",\"v_dir\":\"down\"}},\"t\":{\"val\":{\"t_dir\":\"fadeout\"}}},\"animation_effect\":\"zoomIn\",\"animation_effect_delay\":\"1\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-type\":\"image\"}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"gcq384\",\"cols\":[{\"element_id\":\"fzai85\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"dpeq85\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"5cof85\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":25}},{\"mod_name\":\"buttons\",\"element_id\":\"li14507\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"left\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"500\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\",\"padding_top\":40}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("467","185","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"d3af145\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"height_image\":\"83\",\"auto_fullwidth\":false,\"width_image\":\"600\",\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V2-1000px.png\",\"caption_on_overlay\":false,\"style_image\":\"image-center\",\"motion_effects\":{\"v\":{\"val\":{\"v_vp\":\"0,100\",\"v_speed\":\"1\",\"v_dir\":\"down\"}},\"t\":{\"val\":{\"t_dir\":\"fadeout\"}}},\"animation_effect\":\"zoomIn\",\"animation_effect_delay\":\"0.3\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-type\":\"image\"}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"gcq384\",\"cols\":[{\"element_id\":\"fzai85\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"dpeq85\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"5cof85\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":25}},{\"mod_name\":\"buttons\",\"element_id\":\"li14507\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"left\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"500\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\",\"padding_top\":40}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("468","8","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"d3af145\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"height_image\":\"83\",\"auto_fullwidth\":false,\"width_image\":\"600\",\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V2-1000px.png\",\"caption_on_overlay\":false,\"style_image\":\"image-center\",\"motion_effects\":{\"v\":{\"val\":{\"v_vp\":\"0,100\",\"v_speed\":\"1\",\"v_dir\":\"down\"}},\"t\":{\"val\":{\"t_dir\":\"fadeout\"}}},\"animation_effect\":\"zoomIn\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-type\":\"image\"}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"gcq384\",\"cols\":[{\"element_id\":\"fzai85\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"dpeq85\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"5cof85\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":25}},{\"mod_name\":\"buttons\",\"element_id\":\"li14507\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"left\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"500\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\",\"padding_top\":40}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]");

INSERT IGNORE INTO `come_postmeta` VALUES 
("469","186","_themify_builder_settings_json","[{\"element_id\":\"lau9657\",\"cols\":[{\"element_id\":\"55je657\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"d3af145\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"height_image\":\"83\",\"auto_fullwidth\":false,\"width_image\":\"600\",\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V2-1000px.png\",\"caption_on_overlay\":false,\"style_image\":\"image-center\",\"motion_effects\":{\"v\":{\"val\":{\"v_vp\":\"0,100\",\"v_speed\":\"1\",\"v_dir\":\"down\"}},\"t\":{\"val\":{\"t_dir\":\"fadeout\"}}},\"animation_effect\":\"zoomIn\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-type\":\"image\"}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\"}},{\"element_id\":\"gcq384\",\"cols\":[{\"element_id\":\"fzai85\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"dpeq85\",\"mod_settings\":{\"content_text\":\"<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE<\\/p>\",\"text_align\":\"center\",\"line_height\":\"36\",\"font_size\":\"26\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_transform\":\"uppercase\",\"breakpoint_mobile\":{\"padding_left\":\"15\",\"padding_left_unit\":\"px\",\"checkbox_padding_apply_all\":false,\"padding_right_unit\":\"px\",\"padding_right\":\"15\",\"padding_opp_left\":false,\"padding_opp_bottom\":false,\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"36\",\"font_size_unit\":\"px\",\"font_size\":\"22\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}},{\"mod_name\":\"text\",\"element_id\":\"5cof85\",\"mod_settings\":{\"content_text\":\"<p>GARTEN  HECKE  RASEN<\\/p>\",\"line_height\":\"60\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"font_weight\":\"bold\",\"breakpoint_mobile\":{\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height_unit\":\"px\",\"line_height\":\"70\",\"font_size_unit\":\"px\",\"font_size\":\"50\",\"font_color\":\"#ffffff\",\"font_gradient_color-circle-radial\":false,\"font_gradient_color-gradient-angle\":\"180\",\"font_gradient_color-gradient-type\":\"linear\",\"font_color_type\":\"font_color_solid\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"row_height\":\"fullheight\",\"background_position\":\"50,50\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pexels-creative-vix-7283-Kopie.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#284208_0.45\",\"cover_color-type\":\"cover_gradient\",\"cover_gradient-gradient\":\"0% rgba(58, 94, 19, 0.63)|12% rgba(58, 94, 19, 0.63)|100% rgba(60, 94, 19, 0.27)\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"6omz750\",\"cols\":[{\"element_id\":\"pdme751\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"m5dq266\",\"mod_settings\":{\"content_text\":\"<p>SERVICE<\\/p>\",\"padding_top\":50,\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"service\"}},{\"element_id\":\"n32m421\",\"cols\":[{\"element_id\":\"0u8y422\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"s328975\",\"mod_settings\":{\"content_text\":\"<p>Garten<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"etq1976\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"padding_bottom\":50,\"padding_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"scek571\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"8ywd573\",\"mod_settings\":{\"content_text\":\"<p>hecke<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"9v3z285\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_bottom\":51,\"margin_bottom_unit\":\"px\"},\"height_image\":\"300\",\"width_image\":\"400\"}}]},{\"element_id\":\"ya8j958\",\"grid_class\":\"col3-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"l56f960\",\"mod_settings\":{\"content_text\":\"<p>Rasen<\\/p>\",\"text_transform\":\"uppercase\",\"text_align\":\"center\",\"font_size\":\"30\",\"font_color\":\"#3d5e13\",\"font_color_type\":\"font_color_solid\"}},{\"mod_name\":\"image\",\"element_id\":\"tfgy6\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":\"rounded\",\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/henrique-paim-8s7AjrOxa0Y-unsplash.jpg\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"height_image\":\"300\",\"width_image\":\"400\"}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"mcui232\",\"cols\":[{\"element_id\":\"4xag232\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"2dzs421\",\"mod_settings\":{\"content_text\":\"<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​<\\/p>\\n<p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.<\\/strong><\\/p>\",\"font_size\":\"20\",\"font_color_type\":\"font_color_solid\",\"text_align\":\"center\",\"line_height\":\"30\",\"padding_bottom\":30}},{\"mod_name\":\"buttons\",\"element_id\":\"ibum933\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]}],\"styling\":{\"padding_top\":40,\"_link_o\":\"no\"}},{\"element_id\":\"o5xq770\",\"cols\":[{\"element_id\":\"tyck771\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"lc4o201\",\"mod_settings\":{\"content_text\":\"<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":197,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":32,\"padding_right_unit\":\"px\",\"padding_left\":26,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"48,33.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"kvwo595\",\"cols\":[{\"element_id\":\"m8yp596\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zy72246\",\"mod_settings\":{\"content_text\":\"<p>LEISTUNGEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"leistungen\"}},{\"element_id\":\"wn52104\",\"cols\":[{\"element_id\":\"89kl105\",\"grid_class\":\"col4-1\"},{\"element_id\":\"9pl6106\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"d8jw925\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanzenschutz<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Wässern<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Mäharbeiten \\/ Rasenpflege<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Vertikutieren<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Rollrasen Verlegung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Fachgerechter Gehölzschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Betreuung von Wohnungsgesellschaften<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bdje494\",\"grid_class\":\"col4-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"zej3610\",\"mod_settings\":{\"content_text\":\"<ul class=\\\"font_8 color_14\\\">\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Pflanz- &amp; Schnittarbeiten<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenschnitt<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Heckenpflanzung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Abfuhr &amp; Laubentsorgung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Individuelle Beratung<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Arbeiten mit Steiger<\\/span><\\/p>\\n<\\/li>\\n<li>\\n<p class=\\\"font_8\\\"><span class=\\\"color_14\\\">Professionelle Langzeitpflege<\\/span><\\/p>\\n<\\/li>\\n<\\/ul>\",\"line_height\":\"26\",\"font_size\":\"16\",\"font_color_type\":\"font_color_solid\"}}]},{\"element_id\":\"bs35564\",\"grid_class\":\"col4-1\"}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"tmvv116\",\"cols\":[{\"element_id\":\"h4ub117\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"yzkx117\",\"mod_settings\":{\"content_text\":\"<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":193,\"padding_top\":191,\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_left\":19,\"padding_left_unit\":\"px\",\"padding_right\":28,\"padding_right_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,53.75\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\",\"margin-top\":31}},{\"element_id\":\"xv91523\",\"cols\":[{\"element_id\":\"digy524\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"55fd553\",\"mod_settings\":{\"content_text\":\"<p>ÜBER UNS<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"ueberuns\"}},{\"element_id\":\"1pe5549\",\"cols\":[{\"element_id\":\"33e6551\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"bhr7179\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/08\\/Ghr-Logo-V1.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"breakpoint_mobile\":{\"margin_top\":40,\"margin_top_unit\":\"px\"},\"checkbox_padding_apply_all\":\"1\",\"padding_top\":\"30\",\"background_position\":\"50,50\",\"background_repeat\":\"repeat\",\"background_image-gradient\":\"0% rgb(37, 61, 0)|100% rgb(21, 140, 5)\",\"background_image-gradient-angle\":\"35\",\"background_image-type\":\"gradient\",\"checkbox_margin_apply_all\":\"1\",\"margin_top\":\"40\"}},{\"mod_name\":\"text\",\"element_id\":\"ip8s21\",\"mod_settings\":{\"content_text\":\"<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>info@brandl-garten.de<\\/strong><\\/p>\",\"visibility_all\":\"hide_all\"}},{\"mod_name\":\"text\",\"element_id\":\"y2xf613\",\"mod_settings\":{\"content_text\":\"<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.<\\/p>\\n<p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.<\\/p>\\n<p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.<\\/p>\\n<p><span style=\\\"font-size: 14pt; color: #003300;\\\"><strong>0176-123456<\\/strong><\\/span><br><strong>post@ghr-muenchen.de<\\/strong><\\/p>\",\"padding_bottom\":25}},{\"mod_name\":\"buttons\",\"element_id\":\"li14507\",\"mod_settings\":{\"content_button\":[{\"label\":\"ANFRAGE SENDEN\",\"link\":\"#kontakt\",\"link_options\":\"regular\",\"button_color_bg\":\"green\",\"icon_alignment\":\"left\"}],\"padding_bottom\":50,\"alignment\":\"left\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"qk72552\",\"grid_class\":\"col4-2\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"udpp294\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"500\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"resume\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"yes\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"off\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\",\"padding_top\":40}}]}],\"styling\":{\"_link_o\":\"no\"}},{\"element_id\":\"ayrw398\",\"cols\":[{\"element_id\":\"2w4c398\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"pcxx398\",\"mod_settings\":{\"content_text\":\"<p>BLUMEN<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"blumen\",\"background_color\":\"#d3e3bf\",\"background_position\":\"50,50\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"b1b8581\",\"cols\":[{\"element_id\":\"m9zm582\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"image\",\"element_id\":\"kexv682\",\"mod_settings\":{\"image_zoom_icon\":false,\"title_tag\":\"h3\",\"auto_fullwidth\":false,\"appearance_image\":false,\"url_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/logol.png\",\"caption_on_overlay\":false,\"style_image\":\"image-top\",\"padding_bottom\":25}},{\"mod_name\":\"divider\",\"element_id\":\"qtu9498\",\"mod_settings\":{\"stroke_w_divider\":\"1\",\"color_divider\":\"#000\",\"divider_width\":\"150\",\"divider_type\":\"fullwidth\"}},{\"mod_name\":\"text\",\"element_id\":\"5wl558\",\"mod_settings\":{\"content_text\":\"<p><span style=\\\"font-size: 14pt;\\\"><strong>FLORALE POESIE<\\/strong><\\/span><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#2d470b\",\"margin_top\":25}},{\"mod_name\":\"text\",\"element_id\":\"r0x598\",\"mod_settings\":{\"content_text\":\"<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe<\\/p>\",\"text_align\":\"center\",\"line_height\":\"28\",\"font_size\":\"18\",\"font_color_type\":\"font_color_solid\",\"font_color\":\"#324f0d\"}},{\"mod_name\":\"buttons\",\"element_id\":\"xp4c556\",\"mod_settings\":{\"content_button\":[{\"label\":\"ZUR WEBSEITE\",\"link\":\"https:\\/\\/www.brandl-blumen.de\",\"link_options\":\"newtab\",\"button_color_bg\":\"green\",\"icon\":\"ti-arrow-top-right\",\"icon_alignment\":\"left\"}],\"alignment\":\"center\",\"display\":\"buttons-horizontal\",\"buttons_shape\":\"circle\",\"buttons_size\":\"large\",\"b_p_h\":\"50,50\",\"b_r_h\":\"repeat\",\"button_hover_background_color\":\"#56871b\",\"b_i_h-circle-radial\":false,\"b_i_h-type\":\"image\",\"b_p\":\"50,50\",\"b_r\":\"repeat\",\"button_background_color\":\"#3d5e13\",\"b_i-circle-radial\":false,\"b_i-type\":\"image\"}}]},{\"element_id\":\"2dtu583\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"slider\",\"element_id\":\"bj6d810\",\"mod_settings\":{\"posts_per_page_slider\":\"4\",\"display_slider\":\"none\",\"img_w_slider\":\"500\",\"img_h_slider\":\"400\",\"horizontal\":\"no\",\"visible_opt_slider\":\"1\",\"pause_on_hover_slider\":\"false\",\"play_pause_control\":\"no\",\"show_arrow_slider\":\"no\",\"show_nav_slider\":\"no\",\"wrap_slider\":\"yes\",\"auto_scroll_opt_slider\":\"2\",\"post_type\":\"post\",\"hide_post_date\":\"yes\",\"hook_content\":[{\"h\":\"themify_before_post_image_module\"}],\"height_slider\":\"variable\",\"show_arrow_buttons_vertical\":\"vertical\",\"speed_opt_slider\":\"normal\",\"scroll_opt_slider\":\"1\",\"mob_visible_opt_slider\":\"1\",\"tab_visible_opt_slider\":\"1\",\"effect_slider\":\"scroll\",\"img_fullwidth_slider\":false,\"layout_slider\":\"slider-default\",\"video_content_slider\":[{\"video_title_tag\":\"h3\"}],\"img_content_slider\":[{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/P2181257-1024x768-1.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA171077-scaled.jpg\",\"img_title_tag\":\"h3\"},{\"img_url_slider\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/PA110936-e1558441423834-scaled.jpg\",\"img_title_tag\":\"h3\"}],\"open_link_new_tab_slider\":\"no\",\"unlink_feat_img_slider\":\"no\",\"hide_feat_img_slider\":\"no\",\"unlink_post_title_slider\":\"no\",\"hide_post_title_slider\":\"no\",\"orderby_slider\":\"date\",\"order_slider\":\"desc\",\"blog_category_slider\":\"0|single\",\"taxonomy\":\"category\",\"tbpdq_sameauthor_match_post_type\":\"y\",\"tbpdq\":\"off\",\"layout_display_slider\":\"image\"}}]}],\"column_alignment\":\"col_align_middle\",\"styling\":{\"padding_bottom\":\"60\",\"background_color\":\"#d3e3bf\",\"background_position\":\"64,35\",\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat-none\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"padding_top\":\"35\",\"_link_o\":\"no\",\"cover_color-type\":\"cover_gradient\",\"breakpoint_tablet_landscape\":{\"background_color\":\"#b3cc95\",\"background_position\":\"50,51.25\",\"background_zoom\":false,\"background_attachment\":\"scroll\",\"background_repeat\":\"repeat\",\"resp_no_bg\":false,\"background_gradient-circle-radial\":false,\"background_gradient-gradient-angle\":\"180\",\"background_gradient-gradient-type\":\"linear\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\"},\"cover_gradient-gradient\":\"0% rgb(211, 227, 191)|100% rgb(168, 207, 120)\",\"border-type\":\"top\",\"visibility_all\":\"hide_all\"}},{\"element_id\":\"mitq18\",\"cols\":[{\"element_id\":\"rrxb19\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"wcuf19\",\"mod_settings\":{\"content_text\":\"<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten<\\/p>\",\"padding_right\":\"100\",\"padding_left\":\"100\",\"padding_bottom\":\"193\",\"padding_top\":\"191\",\"text-shadow_color\":\"#000000_0.55\",\"text-shadow_blur\":\"3\",\"text-shadow_vShadow\":\"3\",\"text-shadow_hShadow\":\"3\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"line_height\":\"40\",\"font_size\":\"30\",\"font_color\":\"#ffffff\",\"font_color_type\":\"font_color_solid\",\"breakpoint_mobile\":{\"padding_right\":25,\"padding_right_unit\":\"px\",\"padding_left\":17,\"padding_left_unit\":\"px\"}}}]}],\"styling\":{\"row_width\":\"fullwidth-content\",\"background_position\":\"50,100\",\"background_attachment\":\"fixed\",\"background_repeat\":\"fullcover\",\"background_image\":\"http:\\/\\/sparkway-client.de\\/sparkgarten\\/wp-content\\/uploads\\/2022\\/07\\/marta-bibi-N-lK5xhXIug-unsplash.jpg\",\"background_video_options\":\"mute\",\"background_slider_speed\":\"2000\",\"background_slider_mode\":\"fullcover\",\"background_slider_size\":\"large\",\"background_type\":\"image\",\"cover_color\":\"#365212_0.54\",\"cover_color-type\":\"color\"}},{\"element_id\":\"s88k253\",\"cols\":[{\"element_id\":\"xmzz254\",\"grid_class\":\"col-full\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"e43m423\",\"mod_settings\":{\"content_text\":\"<p>KONTAKT<\\/p>\",\"padding_top\":\"50\",\"font_weight\":\"bold\",\"text_align\":\"center\",\"font_size\":\"40\",\"font_color\":\"#314a10\",\"font_color_type\":\"font_color_solid\"}}]}],\"styling\":{\"_link_o\":\"no\",\"row_anchor\":\"kontakt\"}},{\"element_id\":\"zpbd860\",\"cols\":[{\"element_id\":\"5gv2861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"text\",\"element_id\":\"9652902\",\"mod_settings\":{\"content_text\":\"<h3 class=\\\"av-special-heading-tag\\\">Schreiben Sie uns!<\\/h3>\\n<section class=\\\"av_textblock_section av-j3oqt-f6fe01e797b0eb1826bf7d115e607dd2\\\">\\n<div class=\\\"avia_textblock\\\">\\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.<\\/p>\\n<p>Sie können mich telefonisch unter <strong>+49 176 66038200<\\/strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.<\\/p>\\n<\\/div>\\n<\\/section>\"}}]},{\"element_id\":\"5hjq861\",\"grid_class\":\"col2-1\",\"modules\":[{\"mod_name\":\"contact\",\"element_id\":\"2r44633\",\"mod_settings\":{\"layout_contact\":\"style1\",\"field_subject_label\":\"Subject\",\"field_sendcopy_label\":\"Send a copy to myself\",\"field_sendcopy_subject\":\"COPY:\",\"field_send_label\":\"Send\",\"gdpr_label\":\"I consent to my submitted data being collected and stored\",\"field_name_require\":false,\"field_email_require\":\"yes\",\"field_name_active\":\"yes\",\"field_email_active\":\"yes\",\"field_subject_active\":false,\"field_subject_require\":\"yes\",\"field_message_active\":\"yes\",\"field_send_align\":\"left\",\"field_extra\":\"{\\\"fields\\\":[]}\",\"field_order\":\"{}\",\"field_optin_label\":\"Subscribe to my newsletter.\",\"template\":\"From: %name% @ %email%<br>\\n<b>Subject:<\\/b> %subject%\\n\\n%message%\\n<br>Sent from: %referer%<br>\",\"field_optin_active\":false,\"provider\":\"mailchimp\",\"field_sendcopy_active\":false,\"field_captcha_active\":false,\"field_message_placeholder\":\"Nachricht\",\"field_email_placeholder\":\"Email\",\"field_name_placeholder\":\"Name\",\"include_name_mail\":false,\"contact_sent_from\":\"enable\",\"post_author\":false,\"user_role\":\"admin\",\"send_to_admins\":false,\"mail_contact\":\"mail@hesh-media.de\",\"background_color_send_h\":\"#67a31f\",\"background_color_send\":\"#3d5e13\"}}]}],\"styling\":{\"padding_bottom\":60}}]"),
("474","192","_wp_attached_file","2023/11/JTUQjIg1_i6t8kCHKm459WxRxC7mw9c.woff2"),
("475","192","_wp_attachment_metadata","a:1:{s:8:\"filesize\";i:23716;}"),
("476","193","_wp_attached_file","2023/11/JTUQjIg1_i6t8kCHKm459WxRzS7mw9c.woff2"),
("477","193","_wp_attachment_metadata","a:1:{s:8:\"filesize\";i:21932;}"),
("478","194","_wp_attached_file","2023/11/JTUQjIg1_i6t8kCHKm459WxRxi7mw9c.woff2"),
("479","194","_wp_attachment_metadata","a:1:{s:8:\"filesize\";i:9728;}"),
("480","195","_wp_attached_file","2023/11/JTUQjIg1_i6t8kCHKm459WxRxy7mw9c.woff2"),
("481","195","_wp_attachment_metadata","a:1:{s:8:\"filesize\";i:28892;}"),
("482","196","_wp_attached_file","2023/11/JTUQjIg1_i6t8kCHKm459WxRyS7m.woff2"),
("483","196","_wp_attachment_metadata","a:1:{s:8:\"filesize\";i:34288;}"),
("484","197","_wp_attached_file","2023/11/JTUSjIg1_i6t8kCHKm459WRhyzbi.woff2"),
("485","197","_wp_attachment_metadata","a:1:{s:8:\"filesize\";i:23516;}"),
("486","198","_wp_attached_file","2023/11/JTUSjIg1_i6t8kCHKm459W1hyzbi.woff2"),
("487","198","_wp_attachment_metadata","a:1:{s:8:\"filesize\";i:21288;}"),
("488","199","_wp_attached_file","2023/11/JTUSjIg1_i6t8kCHKm459WZhyzbi.woff2"),
("489","199","_wp_attachment_metadata","a:1:{s:8:\"filesize\";i:9512;}"),
("490","200","_wp_attached_file","2023/11/JTUSjIg1_i6t8kCHKm459Wdhyzbi.woff2"),
("491","200","_wp_attachment_metadata","a:1:{s:8:\"filesize\";i:27812;}"),
("492","201","_wp_attached_file","2023/11/JTUSjIg1_i6t8kCHKm459Wlhyw.woff2"),
("493","201","_wp_attachment_metadata","a:1:{s:8:\"filesize\";i:33092;}"),
("494","202","_wp_attached_file","2023/11/ijwTs572Xtc6ZYQws9YVwnNDTJPax9k0.woff2"),
("495","202","_wp_attachment_metadata","a:1:{s:8:\"filesize\";i:8188;}"),
("496","203","_wp_attached_file","2023/11/ijwTs572Xtc6ZYQws9YVwnNDTJLax9k0.woff2"),
("497","203","_wp_attachment_metadata","a:1:{s:8:\"filesize\";i:18592;}"),
("498","204","_wp_attached_file","2023/11/ijwTs572Xtc6ZYQws9YVwnNDTJzaxw.woff2"),
("499","204","_wp_attachment_metadata","a:1:{s:8:\"filesize\";i:27984;}"),
("500","205","_wp_attached_file","2023/11/ijwRs572Xtc6ZYQws9YVwnNJfJ7Cww.woff2"),
("501","205","_wp_attachment_metadata","a:1:{s:8:\"filesize\";i:7304;}"),
("502","206","_wp_attached_file","2023/11/ijwRs572Xtc6ZYQws9YVwnNIfJ7Cww.woff2"),
("503","206","_wp_attachment_metadata","a:1:{s:8:\"filesize\";i:17792;}"),
("504","207","_wp_attached_file","2023/11/ijwRs572Xtc6ZYQws9YVwnNGfJ4.woff2"),
("505","207","_wp_attachment_metadata","a:1:{s:8:\"filesize\";i:26244;}");

INSERT IGNORE INTO `come_posts` VALUES 
("8","1","2022-01-08 23:11:32","2022-01-08 22:11:32","<!--themify_builder_static--><img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png\" width=\"600\" height=\"83\" title=\"Ghr Logo V2 1000px\" alt=\"Ghr Logo V2 1000px\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png 600w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-300x42.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-768x107.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px.png 1182w\" sizes=\"(max-width: 600px) 100vw, 600px\" />\n<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\" width=\"500\" height=\"500\" title=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" alt=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\" width=\"500\" height=\"500\" title=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" alt=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\" width=\"500\" height=\"500\" title=\"pankaj-shah-1ff_i7jO-4g-unsplash\" alt=\"pankaj-shah-1ff_i7jO-4g-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","publish","closed","closed","","home","","","2022-08-29 02:10:44","2022-08-29 00:10:44","","0","http://sparkway-client.de/sparkgarten/?page_id=8","0","page","","0"),
("10","1","2022-01-08 23:11:46","2022-01-08 22:11:46","","Impressum","","publish","closed","closed","","impressum","","","2022-01-08 23:11:46","2022-01-08 22:11:46","","0","http://sparkway-client.de/sparkgarten/?page_id=10","0","page","","0"),
("11","1","2022-01-08 23:11:46","2022-01-08 22:11:46","","Impressum","","inherit","closed","closed","","10-revision-v1","","","2022-01-08 23:11:46","2022-01-08 22:11:46","","10","http://sparkway-client.de/sparkgarten/?p=11","0","revision","","0"),
("12","1","2022-01-08 23:11:59","2022-01-08 22:11:59","","Datenschutz","","publish","closed","closed","","datenschutz","","","2022-01-08 23:11:59","2022-01-08 22:11:59","","0","http://sparkway-client.de/sparkgarten/?page_id=12","0","page","","0"),
("13","1","2022-01-08 23:11:59","2022-01-08 22:11:59","","Datenschutz","","inherit","closed","closed","","12-revision-v1","","","2022-01-08 23:11:59","2022-01-08 22:11:59","","12","http://sparkway-client.de/sparkgarten/?p=13","0","revision","","0"),
("22","1","2022-08-26 17:33:51","2022-05-24 17:20:59"," ","","","publish","closed","closed","","22","","","2022-08-26 17:33:51","2022-08-26 15:33:51","","0","http://sparkway-client.de/sparkgarten/?p=22","1","nav_menu_item","","0"),
("23","1","2022-07-10 01:44:59","2022-05-24 17:21:25"," ","","","publish","closed","closed","","23","","","2022-07-10 01:44:59","2022-07-09 23:44:59","","0","http://sparkway-client.de/sparkgarten/?p=23","1","nav_menu_item","","0"),
("24","1","2022-07-10 01:44:59","2022-05-24 17:21:25"," ","","","publish","closed","closed","","24","","","2022-07-10 01:44:59","2022-07-09 23:44:59","","0","http://sparkway-client.de/sparkgarten/?p=24","3","nav_menu_item","","0"),
("25","1","2022-07-10 01:44:59","2022-05-24 17:21:25"," ","","","publish","closed","closed","","25","","","2022-07-10 01:44:59","2022-07-09 23:44:59","","0","http://sparkway-client.de/sparkgarten/?p=25","2","nav_menu_item","","0"),
("37","1","2022-07-10 01:34:44","2022-07-09 23:34:44","","pexels-creative-vix-7283","","inherit","","closed","","pexels-creative-vix-7283","","","2022-07-10 01:34:44","2022-07-09 23:34:44","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pexels-creative-vix-7283.jpg","0","attachment","image/jpeg","0"),
("38","1","2022-07-10 01:36:06","2022-07-09 23:36:06","","pexels-creative-vix-7283 Kopie","","inherit","","closed","","pexels-creative-vix-7283-kopie","","","2022-07-10 01:36:06","2022-07-09 23:36:06","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pexels-creative-vix-7283-Kopie.jpg","0","attachment","image/jpeg","0"),
("41","1","2022-07-10 01:40:22","2022-07-09 23:40:22","","Brandl Landschaftspflege","","inherit","","closed","","brandl-landschaftspflege","","","2022-07-10 01:40:22","2022-07-09 23:40:22","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Landschaftspflege.png","0","attachment","image/png","0"),
("43","1","2022-07-10 01:43:33","2022-07-09 23:43:33","","Service","","publish","closed","closed","","service","","","2022-07-10 01:43:33","2022-07-09 23:43:33","","0","http://sparkway-client.de/sparkgarten/?page_id=43","0","page","","0"),
("44","1","2022-07-10 01:43:32","2022-07-09 23:43:32","","Service","","inherit","closed","closed","","43-revision-v1","","","2022-07-10 01:43:32","2022-07-09 23:43:32","","43","http://sparkway-client.de/sparkgarten/?p=44","0","revision","","0"),
("45","1","2022-07-10 01:43:45","2022-07-09 23:43:45","","Über mich","","publish","closed","closed","","uber-mich","","","2022-07-10 01:45:59","2022-07-09 23:45:59","","0","http://sparkway-client.de/sparkgarten/?page_id=45","0","page","","0"),
("46","1","2022-07-10 01:43:45","2022-07-09 23:43:45","","Uber mich","","inherit","closed","closed","","45-revision-v1","","","2022-07-10 01:43:45","2022-07-09 23:43:45","","45","http://sparkway-client.de/sparkgarten/?p=46","0","revision","","0"),
("47","1","2022-07-10 01:43:53","2022-07-09 23:43:53","","Kontakt","","publish","closed","closed","","kontakt","","","2022-07-10 01:45:25","2022-07-09 23:45:25","","0","http://sparkway-client.de/sparkgarten/?page_id=47","0","page","","0"),
("48","1","2022-07-10 01:43:53","2022-07-09 23:43:53","","Kontakt","","inherit","closed","closed","","47-revision-v1","","","2022-07-10 01:43:53","2022-07-09 23:43:53","","47","http://sparkway-client.de/sparkgarten/?p=48","0","revision","","0"),
("52","1","2022-07-10 01:45:59","2022-07-09 23:45:59","","Uber mich","","inherit","closed","closed","","45-revision-v1","","","2022-07-10 01:45:59","2022-07-09 23:45:59","","45","http://sparkway-client.de/sparkgarten/?p=52","0","revision","","0"),
("53","1","2022-07-10 01:45:59","2022-07-09 23:45:59","","Über mich","","inherit","closed","closed","","45-revision-v1","","","2022-07-10 01:45:59","2022-07-09 23:45:59","","45","http://sparkway-client.de/sparkgarten/?p=53","0","revision","","0"),
("59","1","2022-07-10 01:55:25","2022-07-09 23:55:25","","Brandl Landschaftspflege white","","inherit","","closed","","brandl-landschaftspflege-white","","","2022-07-10 01:55:25","2022-07-09 23:55:25","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Landschaftspflege-white.png","0","attachment","image/png","0"),
("79","1","2022-07-10 02:31:27","2022-07-10 00:31:27","","pankaj-shah-1ff_i7jO-4g-unsplash","","inherit","","closed","","pankaj-shah-1ff_i7jo-4g-unsplash","","","2022-07-10 02:31:27","2022-07-10 00:31:27","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash.jpg","0","attachment","image/jpeg","0"),
("82","1","2022-07-10 02:40:57","2022-07-10 00:40:57","","matthew-HBjsSlRHXnY-unsplash Kopie","","inherit","","closed","","matthew-hbjsslrhxny-unsplash-kopie","","","2022-07-10 02:40:57","2022-07-10 00:40:57","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie.jpg","0","attachment","image/jpeg","0"),
("83","1","2022-07-10 02:42:09","2022-07-10 00:42:09","","benjamin-rascoe-v9jEOnzAkK0-unsplash Kopie","","inherit","","closed","","benjamin-rascoe-v9jeonzakk0-unsplash-kopie","","","2022-07-10 02:42:09","2022-07-10 00:42:09","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/benjamin-rascoe-v9jEOnzAkK0-unsplash-Kopie.jpg","0","attachment","image/jpeg","0"),
("84","1","2022-07-10 02:42:54","2022-07-10 00:42:54","","annie-spratt-scIRUSc7Q38-unsplash Kopie","","inherit","","closed","","annie-spratt-scirusc7q38-unsplash-kopie","","","2022-07-10 02:42:54","2022-07-10 00:42:54","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg","0","attachment","image/jpeg","0"),
("86","1","2022-07-10 02:44:48","2022-07-10 00:44:48","","tania-melnyczuk-dSOQHP-ALqw-unsplash","","inherit","","closed","","tania-melnyczuk-dsoqhp-alqw-unsplash","","","2022-07-10 02:44:48","2022-07-10 00:44:48","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash.jpg","0","attachment","image/jpeg","0"),
("89","1","2022-07-10 02:59:06","2022-07-10 00:59:06","","WhatsApp Image 2022-06-23 at 14.57.00 Kopie","","inherit","","closed","","whatsapp-image-2022-06-23-at-14-57-00-kopie","","","2022-07-10 02:59:06","2022-07-10 00:59:06","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/WhatsApp-Image-2022-06-23-at-14.57.00-Kopie.jpeg","0","attachment","image/jpeg","0"),
("93","1","2022-07-10 03:11:07","2022-07-10 01:11:07","","marta-bibi-N-lK5xhXIug-unsplash","","inherit","","closed","","marta-bibi-n-lk5xhxiug-unsplash","","","2022-07-10 03:11:07","2022-07-10 01:11:07","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/marta-bibi-N-lK5xhXIug-unsplash.jpg","0","attachment","image/jpeg","0"),
("99","1","2022-08-26 17:33:51","2022-07-10 01:20:18","","Leistungen","","publish","closed","closed","","leistungen","","","2022-08-26 17:33:51","2022-08-26 15:33:51","","0","http://sparkway-client.de/sparkgarten/?p=99","3","nav_menu_item","","0"),
("100","1","2022-08-26 17:33:51","2022-07-10 01:21:26","","Service","","publish","closed","closed","","service","","","2022-08-26 17:33:51","2022-08-26 15:33:51","","0","http://sparkway-client.de/sparkgarten/?p=100","2","nav_menu_item","","0"),
("101","1","2022-08-26 17:33:51","2022-07-10 01:21:26","","Über uns","","publish","closed","closed","","ueber-mich","","","2022-08-26 17:33:51","2022-08-26 15:33:51","","0","http://sparkway-client.de/sparkgarten/?p=101","4","nav_menu_item","","0"),
("102","1","2022-08-26 17:33:51","2022-07-10 01:21:26","","Kontakt","","publish","closed","closed","","kontakt","","","2022-08-26 17:33:51","2022-08-26 15:33:51","","0","http://sparkway-client.de/sparkgarten/?p=102","5","nav_menu_item","","0"),
("116","1","2022-07-12 12:58:56","2022-07-12 10:58:56","","michael-lZTlmTOx_dA-unsplash","","inherit","","closed","","michael-lztlmtox_da-unsplash","","","2022-07-12 12:58:56","2022-07-12 10:58:56","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/michael-lZTlmTOx_dA-unsplash.jpg","0","attachment","image/jpeg","0"),
("117","1","2022-07-12 13:01:18","2022-07-12 11:01:18","","stefan-cosma-aqBQPZUeWfw-unsplash","","inherit","","closed","","stefan-cosma-aqbqpzuewfw-unsplash","","","2022-07-12 13:01:18","2022-07-12 11:01:18","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash.jpg","0","attachment","image/jpeg","0"),
("118","1","2022-07-12 13:02:51","2022-07-12 11:02:51","","henrique-paim-8s7AjrOxa0Y-unsplash","","inherit","","closed","","henrique-paim-8s7ajroxa0y-unsplash","","","2022-07-12 13:02:51","2022-07-12 11:02:51","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg","0","attachment","image/jpeg","0"),
("119","1","2022-07-12 13:05:52","2022-07-12 11:05:52","","Brandl Square Landschaftspflege","","inherit","","closed","","brandl-square-landschaftspflege","","","2022-07-12 13:05:52","2022-07-12 11:05:52","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png","0","attachment","image/png","0"),
("131","1","2022-07-13 15:05:30","2022-07-13 13:05:30","<!--themify_builder_static-->\r\n\r\nEXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE\r\n\r\nGARTEN  HECKE  RASEN\r\n\r\nSERVICE\r\n\r\nGarten\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\r\n\r\nhecke\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\r\n\r\nRasen\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\r\n\r\nWenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​\r\n\r\n<strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong>\r\n\r\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\r\n\r\nWir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.\r\n\r\nLEISTUNGEN\r\n<ul>\r\n 	<li>Pflanzenschutz</li>\r\n 	<li>Wässern</li>\r\n 	<li>Mäharbeiten / Rasenpflege</li>\r\n 	<li>Vertikutieren</li>\r\n 	<li>Rollrasen Verlegung</li>\r\n 	<li>Fachgerechter Gehölzschnitt</li>\r\n 	<li>Betreuung von Wohnungsgesellschaften</li>\r\n</ul>\r\n<ul>\r\n 	<li>Pflanz- &amp; Schnittarbeiten</li>\r\n 	<li>Heckenschnitt</li>\r\n 	<li>Heckenpflanzung</li>\r\n 	<li>Abfuhr &amp; Laubentsorgung</li>\r\n 	<li>Individuelle Beratung</li>\r\n 	<li>Arbeiten mit Steiger</li>\r\n 	<li>Professionelle Langzeitpflege</li>\r\n</ul>\r\nWir hegen und pflegen alles, was wächst, blüht und gedeiht\r\n\r\nÜBER UNS\r\n\r\nSeit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.\r\nWir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.\r\n\r\nAus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.\r\n\r\nSchreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.\r\n\r\n<strong>0176-123456</strong>\r\n<strong>info@brandl-garten.de</strong>\r\n\r\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\r\n\r\nWenn meine Seele Urlaub braucht, geh Ich in den Garten\r\n\r\nKONTAKT\r\n<h3>Schreiben Sie uns!</h3>\r\n<section>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.\r\n\r\nSie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.\r\n\r\n</section>\r\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 15:05:30","2022-07-13 13:05:30","","8","http://sparkway-client.de/sparkgarten/?p=131","0","revision","","0"),
("132","1","2022-07-13 15:06:05","2022-07-13 13:06:05","<!--themify_builder_static-->\r\n\r\nEXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE\r\n\r\nGARTEN  HECKE  RASEN\r\n\r\nSERVICE\r\n\r\nGarten\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\r\n\r\nhecke\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\r\n\r\nRasen\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\r\n\r\nWenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​\r\n\r\n<strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong>\r\n\r\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\r\n\r\nWir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.\r\n\r\nLEISTUNGEN\r\n<ul>\r\n 	<li>Pflanzenschutz</li>\r\n 	<li>Wässern</li>\r\n 	<li>Mäharbeiten / Rasenpflege</li>\r\n 	<li>Vertikutieren</li>\r\n 	<li>Rollrasen Verlegung</li>\r\n 	<li>Fachgerechter Gehölzschnitt</li>\r\n 	<li>Betreuung von Wohnungsgesellschaften</li>\r\n</ul>\r\n<ul>\r\n 	<li>Pflanz- &amp; Schnittarbeiten</li>\r\n 	<li>Heckenschnitt</li>\r\n 	<li>Heckenpflanzung</li>\r\n 	<li>Abfuhr &amp; Laubentsorgung</li>\r\n 	<li>Individuelle Beratung</li>\r\n 	<li>Arbeiten mit Steiger</li>\r\n 	<li>Professionelle Langzeitpflege</li>\r\n</ul>\r\nWir hegen und pflegen alles, was wächst, blüht und gedeiht\r\n\r\nÜBER UNS\r\n\r\nSeit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.\r\nWir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.\r\n\r\nAus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.\r\n\r\nSchreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.\r\n\r\n<strong>0176-123456</strong>\r\n<strong>info@brandl-garten.de</strong>\r\n\r\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\r\n\r\nWenn meine Seele Urlaub braucht, geh Ich in den Garten\r\n\r\nKONTAKT\r\n<h3>Schreiben Sie uns!</h3>\r\n<section>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.\r\n\r\nSie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.\r\n\r\n</section>\r\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 15:06:05","2022-07-13 13:06:05","","8","http://sparkway-client.de/sparkgarten/?p=132","0","revision","","0"),
("133","1","2022-07-13 15:08:00","2022-07-13 13:08:00","","P2181257-1024x768","","inherit","","closed","","p2181257-1024x768","","","2022-07-13 15:08:00","2022-07-13 13:08:00","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg","0","attachment","image/jpeg","0"),
("134","1","2022-07-13 15:08:25","2022-07-13 13:08:25","","logol-1024x210","","inherit","","closed","","logol-1024x210","","","2022-07-13 15:08:25","2022-07-13 13:08:25","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg","0","attachment","image/jpeg","0"),
("135","1","2022-07-13 15:11:35","2022-07-13 13:11:35","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.</p> <p><strong>0176-123456</strong><br><strong>info@brandl-garten.de</strong></p>\n\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 15:11:35","2022-07-13 13:11:35","","8","http://sparkway-client.de/sparkgarten/?p=135","0","revision","","0"),
("136","1","2022-07-13 15:14:42","2022-07-13 13:14:42","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.</p> <p><strong>0176-123456</strong><br><strong>info@brandl-garten.de</strong></p>\n\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg\" width=\"1024\" height=\"210\">\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg\" width=\"1024\" height=\"768\"><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 15:14:42","2022-07-13 13:14:42","","8","http://sparkway-client.de/sparkgarten/?p=136","0","revision","","0"),
("137","1","2022-07-13 15:14:56","2022-07-13 13:14:56","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.</p> <p><strong>0176-123456</strong><br><strong>info@brandl-garten.de</strong></p>\n\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg\" width=\"1024\" height=\"210\">\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg\" width=\"1024\" height=\"768\"><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 15:14:56","2022-07-13 13:14:56","","8","http://sparkway-client.de/sparkgarten/?p=137","0","revision","","0"),
("138","1","2022-07-13 15:16:13","2022-07-13 13:16:13","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.</p> <p><strong>0176-123456</strong><br><strong>info@brandl-garten.de</strong></p>\n\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg\" width=\"1024\" height=\"210\">\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg\" width=\"1024\" height=\"768\"><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 15:16:13","2022-07-13 13:16:13","","8","http://sparkway-client.de/sparkgarten/?p=138","0","revision","","0"),
("139","1","2022-07-13 15:17:03","2022-07-13 13:17:03","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.</p> <p><strong>0176-123456</strong><br><strong>info@brandl-garten.de</strong></p>\n\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg\" width=\"1024\" height=\"210\">\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg\" width=\"1024\" height=\"768\"><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 15:17:03","2022-07-13 13:17:03","","8","http://sparkway-client.de/sparkgarten/?p=139","0","revision","","0"),
("141","1","2022-07-13 15:18:06","2022-07-13 13:18:06","<!--themify_builder_static-->\r\n\r\nEXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE\r\n\r\nGARTEN  HECKE  RASEN\r\n\r\nSERVICE\r\n\r\nGarten\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\r\n\r\nhecke\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\r\n\r\nRasen\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\r\n\r\nWenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​\r\n\r\n<strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong>\r\n\r\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\r\n\r\nWir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.\r\n\r\nLEISTUNGEN\r\n<ul>\r\n 	<li>Pflanzenschutz</li>\r\n 	<li>Wässern</li>\r\n 	<li>Mäharbeiten / Rasenpflege</li>\r\n 	<li>Vertikutieren</li>\r\n 	<li>Rollrasen Verlegung</li>\r\n 	<li>Fachgerechter Gehölzschnitt</li>\r\n 	<li>Betreuung von Wohnungsgesellschaften</li>\r\n</ul>\r\n<ul>\r\n 	<li>Pflanz- &amp; Schnittarbeiten</li>\r\n 	<li>Heckenschnitt</li>\r\n 	<li>Heckenpflanzung</li>\r\n 	<li>Abfuhr &amp; Laubentsorgung</li>\r\n 	<li>Individuelle Beratung</li>\r\n 	<li>Arbeiten mit Steiger</li>\r\n 	<li>Professionelle Langzeitpflege</li>\r\n</ul>\r\nWir hegen und pflegen alles, was wächst, blüht und gedeiht\r\n\r\nÜBER UNS\r\n\r\nSeit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.\r\nWir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.\r\n\r\nAus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.\r\n\r\nSchreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.\r\n\r\n<strong>0176-123456</strong>\r\n<strong>info@brandl-garten.de</strong>\r\n\r\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\r\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg\" width=\"1024\" height=\"210\">\r\n\r\n<strong>FLORALE POESIE</strong>\r\nFür uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!\r\n\r\nLassen Sie sich verzaubern\r\nAußergewöhnliche Blumen für besondere Anlässe\r\n\r\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\r\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg\" width=\"1024\" height=\"768\">\r\n\r\nWenn meine Seele Urlaub braucht, geh Ich in den Garten\r\n\r\nKONTAKT\r\n<h3>Schreiben Sie uns!</h3>\r\n<section>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.\r\n\r\nSie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.\r\n\r\n</section>\r\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 15:18:06","2022-07-13 13:18:06","","8","http://sparkway-client.de/sparkgarten/?p=141","0","revision","","0"),
("142","1","2022-07-13 15:18:37","2022-07-13 13:18:37","<!--themify_builder_static-->\r\n\r\nEXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE\r\n\r\nGARTEN  HECKE  RASEN\r\n\r\nSERVICE\r\n\r\nGarten\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\r\n\r\nhecke\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\r\n\r\nRasen\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\r\n\r\nWenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​\r\n\r\n<strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong>\r\n\r\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\r\n\r\nWir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.\r\n\r\nLEISTUNGEN\r\n<ul>\r\n 	<li>Pflanzenschutz</li>\r\n 	<li>Wässern</li>\r\n 	<li>Mäharbeiten / Rasenpflege</li>\r\n 	<li>Vertikutieren</li>\r\n 	<li>Rollrasen Verlegung</li>\r\n 	<li>Fachgerechter Gehölzschnitt</li>\r\n 	<li>Betreuung von Wohnungsgesellschaften</li>\r\n</ul>\r\n<ul>\r\n 	<li>Pflanz- &amp; Schnittarbeiten</li>\r\n 	<li>Heckenschnitt</li>\r\n 	<li>Heckenpflanzung</li>\r\n 	<li>Abfuhr &amp; Laubentsorgung</li>\r\n 	<li>Individuelle Beratung</li>\r\n 	<li>Arbeiten mit Steiger</li>\r\n 	<li>Professionelle Langzeitpflege</li>\r\n</ul>\r\nWir hegen und pflegen alles, was wächst, blüht und gedeiht\r\n\r\nÜBER UNS\r\n\r\nSeit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.\r\nWir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.\r\n\r\nAus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.\r\n\r\nSchreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.\r\n\r\n<strong>0176-123456</strong>\r\n<strong>info@brandl-garten.de</strong>\r\n\r\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\r\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg\" width=\"1024\" height=\"210\">\r\n\r\n<strong>FLORALE POESIE</strong>\r\nFür uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!\r\n\r\nLassen Sie sich verzaubern\r\nAußergewöhnliche Blumen für besondere Anlässe\r\n\r\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\r\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg\" width=\"1024\" height=\"768\">\r\n\r\nWenn meine Seele Urlaub braucht, geh Ich in den Garten\r\n\r\nKONTAKT\r\n<h3>Schreiben Sie uns!</h3>\r\n<section>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.\r\n\r\nSie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.\r\n\r\n</section>\r\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 15:18:37","2022-07-13 13:18:37","","8","http://sparkway-client.de/sparkgarten/?p=142","0","revision","","0"),
("144","1","2022-07-13 15:26:01","2022-07-13 13:26:01","<!--themify_builder_static-->\r\n\r\nEXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE\r\n\r\nGARTEN  HECKE  RASEN\r\n\r\nSERVICE\r\n\r\nGarten\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\r\n\r\nhecke\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\r\n\r\nRasen\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\r\n\r\nWenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​\r\n\r\n<strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong>\r\n\r\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\r\n\r\nWir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.\r\n\r\nLEISTUNGEN\r\n<ul>\r\n 	<li>Pflanzenschutz</li>\r\n 	<li>Wässern</li>\r\n 	<li>Mäharbeiten / Rasenpflege</li>\r\n 	<li>Vertikutieren</li>\r\n 	<li>Rollrasen Verlegung</li>\r\n 	<li>Fachgerechter Gehölzschnitt</li>\r\n 	<li>Betreuung von Wohnungsgesellschaften</li>\r\n</ul>\r\n<ul>\r\n 	<li>Pflanz- &amp; Schnittarbeiten</li>\r\n 	<li>Heckenschnitt</li>\r\n 	<li>Heckenpflanzung</li>\r\n 	<li>Abfuhr &amp; Laubentsorgung</li>\r\n 	<li>Individuelle Beratung</li>\r\n 	<li>Arbeiten mit Steiger</li>\r\n 	<li>Professionelle Langzeitpflege</li>\r\n</ul>\r\nWir hegen und pflegen alles, was wächst, blüht und gedeiht\r\n\r\nÜBER UNS\r\n\r\nSeit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.\r\nWir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.\r\n\r\nAus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.\r\n\r\nSchreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.\r\n\r\n<strong>0176-123456</strong>\r\n<strong>info@brandl-garten.de</strong>\r\n\r\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\r\n<img loading=\"lazy\" width=\"1024\" height=\"210\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg\" title=\"logol-1024x210\" alt=\"logol-1024x210\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1-300x62.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1-768x158.jpg 768w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" />\r\n\r\n<strong>FLORALE POESIE</strong>\r\nFür uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!\r\n\r\nLassen Sie sich verzaubern\r\nAußergewöhnliche Blumen für besondere Anlässe\r\n\r\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\r\n<img loading=\"lazy\" width=\"1024\" height=\"768\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-768x576.jpg 768w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" />\r\n\r\nWenn meine Seele Urlaub braucht, geh Ich in den Garten\r\n\r\nKONTAKT\r\n<h3>Schreiben Sie uns!</h3>\r\n<section>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.\r\n\r\nSie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.\r\n\r\n</section>\r\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 15:26:01","2022-07-13 13:26:01","","8","http://sparkway-client.de/sparkgarten/?p=144","0","revision","","0"),
("145","1","2022-07-13 17:01:16","2022-07-13 15:01:16","<!--themify_builder_static-->\r\n\r\nEXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE\r\n\r\nGARTEN  HECKE  RASEN\r\n\r\nSERVICE\r\n\r\nGarten\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\r\n\r\nhecke\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\r\n\r\nRasen\r\n\r\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\r\n\r\nWenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​\r\n\r\n<strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong>\r\n\r\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\r\n\r\nWir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.\r\n\r\nLEISTUNGEN\r\n<ul>\r\n 	<li>Pflanzenschutz</li>\r\n 	<li>Wässern</li>\r\n 	<li>Mäharbeiten / Rasenpflege</li>\r\n 	<li>Vertikutieren</li>\r\n 	<li>Rollrasen Verlegung</li>\r\n 	<li>Fachgerechter Gehölzschnitt</li>\r\n 	<li>Betreuung von Wohnungsgesellschaften</li>\r\n</ul>\r\n<ul>\r\n 	<li>Pflanz- &amp; Schnittarbeiten</li>\r\n 	<li>Heckenschnitt</li>\r\n 	<li>Heckenpflanzung</li>\r\n 	<li>Abfuhr &amp; Laubentsorgung</li>\r\n 	<li>Individuelle Beratung</li>\r\n 	<li>Arbeiten mit Steiger</li>\r\n 	<li>Professionelle Langzeitpflege</li>\r\n</ul>\r\nWir hegen und pflegen alles, was wächst, blüht und gedeiht\r\n\r\nÜBER UNS\r\n\r\nSeit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.\r\nWir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.\r\n\r\nAus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.\r\n\r\nSchreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.\r\n\r\n<strong>0176-123456</strong>\r\n<strong>info@brandl-garten.de</strong>\r\n\r\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\r\n<img loading=\"lazy\" width=\"1024\" height=\"210\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg\" title=\"logol-1024x210\" alt=\"logol-1024x210\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1-300x62.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1-768x158.jpg 768w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" />\r\n\r\n<strong>FLORALE POESIE</strong>\r\nFür uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!\r\n\r\nLassen Sie sich verzaubern\r\nAußergewöhnliche Blumen für besondere Anlässe\r\n\r\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\r\n<img loading=\"lazy\" width=\"1024\" height=\"768\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-768x576.jpg 768w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" />\r\n\r\nWenn meine Seele Urlaub braucht, geh Ich in den Garten\r\n\r\nKONTAKT\r\n<h3>Schreiben Sie uns!</h3>\r\n<section>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.\r\n\r\nSie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.\r\n\r\n</section>\r\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 17:01:16","2022-07-13 15:01:16","","8","http://sparkway-client.de/sparkgarten/?p=145","0","revision","","0"),
("146","1","2022-07-13 17:01:42","2022-07-13 15:01:42","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.</p> <p><strong>0176-123456</strong><br><strong>info@brandl-garten.de</strong></p>\n\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\n<img loading=\"lazy\" width=\"1024\" height=\"210\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg\" title=\"logol-1024x210\" alt=\"logol-1024x210\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1-300x62.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1-768x158.jpg 768w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" />\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" width=\"1024\" height=\"768\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-768x576.jpg 768w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" />\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 17:01:42","2022-07-13 15:01:42","","8","http://sparkway-client.de/sparkgarten/?p=146","0","revision","","0"),
("147","1","2022-07-13 17:02:59","2022-07-13 15:02:59","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.</p> <p><strong>0176-123456</strong><br><strong>info@brandl-garten.de</strong></p>\n\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\n<img loading=\"lazy\" width=\"1024\" height=\"210\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg\" title=\"logol-1024x210\" alt=\"logol-1024x210\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1-300x62.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1-768x158.jpg 768w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" />\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" width=\"1024\" height=\"768\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-768x576.jpg 768w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" />\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 17:02:59","2022-07-13 15:02:59","","8","http://sparkway-client.de/sparkgarten/?p=147","0","revision","","0"),
("148","1","2022-07-13 17:05:01","2022-07-13 15:05:01","","PA171077","","inherit","","closed","","pa171077","","","2022-07-13 17:05:01","2022-07-13 15:05:01","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077.jpg","0","attachment","image/jpeg","0"),
("149","1","2022-07-13 17:08:19","2022-07-13 15:08:19","","logol","","inherit","","closed","","logol","","","2022-07-13 17:08:19","2022-07-13 15:08:19","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png","0","attachment","image/png","0"),
("150","1","2022-07-13 17:08:52","2022-07-13 15:08:52","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.</p> <p><strong>0176-123456</strong><br><strong>info@brandl-garten.de</strong></p>\n\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"1024\" height=\"210\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg\" title=\"logol-1024x210\" alt=\"logol-1024x210\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1.jpg 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1-300x62.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210-1-768x158.jpg 768w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" />\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" width=\"1024\" height=\"768\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-768x576.jpg 768w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" />\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 17:08:52","2022-07-13 15:08:52","","8","http://sparkway-client.de/sparkgarten/?p=150","0","revision","","0"),
("151","1","2022-07-13 17:11:33","2022-07-13 15:11:33","","PA110936-e1558441423834","","inherit","","closed","","pa110936-e1558441423834","","","2022-07-13 17:11:33","2022-07-13 15:11:33","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834.jpg","0","attachment","image/jpeg","0"),
("152","1","2022-07-13 17:12:38","2022-07-13 15:12:38","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.</p> <p><strong>0176-123456</strong><br><strong>info@brandl-garten.de</strong></p>\n\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\n<p>BLUMEN</p>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" width=\"3700\" height=\"760\">\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" width=\"1024\" height=\"768\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-768x576.jpg 768w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" />\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 17:12:38","2022-07-13 15:12:38","","8","http://sparkway-client.de/sparkgarten/?p=152","0","revision","","0"),
("153","1","2022-07-13 17:12:48","2022-07-13 15:12:48","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.</p> <p><strong>0176-123456</strong><br><strong>info@brandl-garten.de</strong></p>\n\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\n<p>BLUMEN</p>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" width=\"3700\" height=\"760\">\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg\" width=\"450\" height=\"200\"> <img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-scaled.jpg\" width=\"450\" height=\"200\"> <img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-scaled.jpg\" width=\"450\" height=\"200\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 17:12:48","2022-07-13 15:12:48","","8","http://sparkway-client.de/sparkgarten/?p=153","0","revision","","0"),
("154","1","2022-07-13 17:13:35","2022-07-13 15:13:35","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.</p> <p><strong>0176-123456</strong><br><strong>info@brandl-garten.de</strong></p>\n\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\n<p>BLUMEN</p>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" width=\"3700\" height=\"760\">\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1.jpg\" width=\"450\" height=\"200\"> <img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-scaled.jpg\" width=\"450\" height=\"200\"> <img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-scaled.jpg\" width=\"450\" height=\"200\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 17:13:35","2022-07-13 15:13:35","","8","http://sparkway-client.de/sparkgarten/?p=154","0","revision","","0");

INSERT IGNORE INTO `come_posts` VALUES 
("155","1","2022-07-13 17:14:00","2022-07-13 15:14:00","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.</p> <p><strong>0176-123456</strong><br><strong>info@brandl-garten.de</strong></p>\n\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-450x200.jpg\" width=\"450\" height=\"200\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-450x200.jpg\" width=\"450\" height=\"200\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-450x200.jpg\" width=\"450\" height=\"200\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 17:14:00","2022-07-13 15:14:00","","8","http://sparkway-client.de/sparkgarten/?p=155","0","revision","","0"),
("156","1","2022-07-13 17:16:40","2022-07-13 15:16:40","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.</p> <p><strong>0176-123456</strong><br><strong>info@brandl-garten.de</strong></p>\n\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-07-13 17:16:40","2022-07-13 15:16:40","","8","http://sparkway-client.de/sparkgarten/?p=156","0","revision","","0"),
("158","1","2022-08-26 17:23:06","2022-08-26 15:23:06","","Ghr Logo V1","","inherit","","closed","","ghr-logo-v1","","","2022-08-26 17:23:06","2022-08-26 15:23:06","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png","0","attachment","image/png","0"),
("161","1","2022-08-26 17:29:30","2022-08-26 15:29:30","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<p>Seit über 100 Jahren sind Blumen und Pflanzen unser Leben und Leidenschaft. Daher bieten wir auch Garten- und Landschaftspflege für Sie an, damit Sie und Ihre Pflanzen sich wohlfühlen.<br>Wir können uns nichts schöneres vorstellen, was uns tagtäglich mehr Zufriedenheit bereiten würde. Als gefragter Gärtner bin Ich zwei Grundsätzen verpflichtet: Den bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie uns gerne eine Mail oder rufen mich an, wir stehen Ihnen stets zu Diensten.</p> <p><strong>0176-123456</strong><br><strong>info@brandl-garten.de</strong></p>\n\n<img loading=\"lazy\" width=\"402\" height=\"162\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png\" title=\"Brandl Square Landschaftspflege\" alt=\"Brandl Square Landschaftspflege\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege.png 402w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/Brandl-Square-Landschaftspflege-300x121.png 300w\" sizes=\"(max-width: 402px) 100vw, 402px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-26 17:29:30","2022-08-26 15:29:30","","8","http://sparkway-client.de/sparkgarten/?p=161","0","revision","","0"),
("162","1","2022-08-26 17:29:43","2022-08-26 15:29:43","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" width=\"720\" height=\"101\">\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-26 17:29:43","2022-08-26 15:29:43","","8","http://sparkway-client.de/sparkgarten/?p=162","0","revision","","0"),
("163","1","2022-08-26 17:29:52","2022-08-26 15:29:52","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" width=\"720\" height=\"101\">\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-26 17:29:52","2022-08-26 15:29:52","","8","http://sparkway-client.de/sparkgarten/?p=163","0","revision","","0"),
("164","1","2022-08-26 17:30:03","2022-08-26 15:30:03","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" width=\"720\" height=\"101\">\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-26 17:30:03","2022-08-26 15:30:03","","8","http://sparkway-client.de/sparkgarten/?p=164","0","revision","","0"),
("165","1","2022-08-26 17:38:05","2022-08-26 15:38:05","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" width=\"720\" height=\"101\">\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-26 17:38:05","2022-08-26 15:38:05","","8","http://sparkway-client.de/sparkgarten/?p=165","0","revision","","0"),
("166","1","2022-08-26 17:39:02","2022-08-26 15:39:02","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-26 17:39:02","2022-08-26 15:39:02","","8","http://sparkway-client.de/sparkgarten/?p=166","0","revision","","0"),
("167","1","2022-08-26 17:40:36","2022-08-26 15:40:36","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-26 17:40:36","2022-08-26 15:40:36","","8","http://sparkway-client.de/sparkgarten/?p=167","0","revision","","0"),
("168","1","2022-08-26 17:41:48","2022-08-26 15:41:48","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie.jpg\" width=\"360\" height=\"200\"> <img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-scaled.jpg\" width=\"360\" height=\"200\"> <img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash.jpg\" width=\"360\" height=\"200\">\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-26 17:41:48","2022-08-26 15:41:48","","8","http://sparkway-client.de/sparkgarten/?p=168","0","revision","","0"),
("169","1","2022-08-26 17:43:05","2022-08-26 15:43:05","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\" width=\"500\" height=\"500\" title=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" alt=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\" width=\"500\" height=\"500\" title=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" alt=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\" width=\"500\" height=\"500\" title=\"pankaj-shah-1ff_i7jO-4g-unsplash\" alt=\"pankaj-shah-1ff_i7jO-4g-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-26 17:43:05","2022-08-26 15:43:05","","8","http://sparkway-client.de/sparkgarten/?p=169","0","revision","","0"),
("170","1","2022-08-26 17:44:00","2022-08-26 15:44:00","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\" width=\"500\" height=\"500\" title=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" alt=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\" width=\"500\" height=\"500\" title=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" alt=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\" width=\"500\" height=\"500\" title=\"pankaj-shah-1ff_i7jO-4g-unsplash\" alt=\"pankaj-shah-1ff_i7jO-4g-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-26 17:44:00","2022-08-26 15:44:00","","8","http://sparkway-client.de/sparkgarten/?p=170","0","revision","","0"),
("173","1","2022-08-29 01:59:15","2022-08-28 23:59:15","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\" width=\"500\" height=\"500\" title=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" alt=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\" width=\"500\" height=\"500\" title=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" alt=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\" width=\"500\" height=\"500\" title=\"pankaj-shah-1ff_i7jO-4g-unsplash\" alt=\"pankaj-shah-1ff_i7jO-4g-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-29 01:59:15","2022-08-28 23:59:15","","8","http://sparkway-client.de/sparkgarten/?p=173","0","revision","","0"),
("174","1","2022-08-29 02:00:39","2022-08-29 00:00:39","","Ghr Logo V2","","inherit","","closed","","ghr-logo-v2","","","2022-08-29 02:00:39","2022-08-29 00:00:39","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2.png","0","attachment","image/png","0"),
("175","1","2022-08-29 02:01:51","2022-08-29 00:01:51","","Ghr Logo V2 1000px","","inherit","","closed","","ghr-logo-v2-1000px","","","2022-08-29 02:01:51","2022-08-29 00:01:51","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px.png","0","attachment","image/png","0"),
("176","1","2022-08-29 02:02:18","2022-08-29 00:02:18","<!--themify_builder_static--><p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\" width=\"500\" height=\"500\" title=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" alt=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\" width=\"500\" height=\"500\" title=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" alt=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\" width=\"500\" height=\"500\" title=\"pankaj-shah-1ff_i7jO-4g-unsplash\" alt=\"pankaj-shah-1ff_i7jO-4g-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-29 02:02:18","2022-08-29 00:02:18","","8","http://sparkway-client.de/sparkgarten/?p=176","0","revision","","0"),
("177","1","2022-08-29 02:02:46","2022-08-29 00:02:46","<!--themify_builder_static--><img src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px.png\" width=\"600\" height=\"83\">\n<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\" width=\"500\" height=\"500\" title=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" alt=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\" width=\"500\" height=\"500\" title=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" alt=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\" width=\"500\" height=\"500\" title=\"pankaj-shah-1ff_i7jO-4g-unsplash\" alt=\"pankaj-shah-1ff_i7jO-4g-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-29 02:02:46","2022-08-29 00:02:46","","8","http://sparkway-client.de/sparkgarten/?p=177","0","revision","","0"),
("178","1","2022-08-29 02:07:23","2022-08-29 00:07:23","<!--themify_builder_static--><img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png\" width=\"600\" height=\"83\" title=\"Ghr Logo V2 1000px\" alt=\"Ghr Logo V2 1000px\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png 600w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-300x42.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-768x107.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px.png 1182w\" sizes=\"(max-width: 600px) 100vw, 600px\" />\n<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\" width=\"500\" height=\"500\" title=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" alt=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\" width=\"500\" height=\"500\" title=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" alt=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\" width=\"500\" height=\"500\" title=\"pankaj-shah-1ff_i7jO-4g-unsplash\" alt=\"pankaj-shah-1ff_i7jO-4g-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-29 02:07:23","2022-08-29 00:07:23","","8","http://sparkway-client.de/sparkgarten/?p=178","0","revision","","0"),
("179","1","2022-08-29 02:08:08","2022-08-29 00:08:08","<!--themify_builder_static--><img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png\" width=\"600\" height=\"83\" title=\"Ghr Logo V2 1000px\" alt=\"Ghr Logo V2 1000px\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png 600w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-300x42.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-768x107.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px.png 1182w\" sizes=\"(max-width: 600px) 100vw, 600px\" />\n<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\" width=\"500\" height=\"500\" title=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" alt=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\" width=\"500\" height=\"500\" title=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" alt=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\" width=\"500\" height=\"500\" title=\"pankaj-shah-1ff_i7jO-4g-unsplash\" alt=\"pankaj-shah-1ff_i7jO-4g-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-29 02:08:08","2022-08-29 00:08:08","","8","http://sparkway-client.de/sparkgarten/?p=179","0","revision","","0");

INSERT IGNORE INTO `come_posts` VALUES 
("180","1","2022-08-29 02:08:32","2022-08-29 00:08:32","<!--themify_builder_static--><img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png\" width=\"600\" height=\"83\" title=\"Ghr Logo V2 1000px\" alt=\"Ghr Logo V2 1000px\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png 600w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-300x42.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-768x107.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px.png 1182w\" sizes=\"(max-width: 600px) 100vw, 600px\" />\n<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\" width=\"500\" height=\"500\" title=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" alt=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\" width=\"500\" height=\"500\" title=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" alt=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\" width=\"500\" height=\"500\" title=\"pankaj-shah-1ff_i7jO-4g-unsplash\" alt=\"pankaj-shah-1ff_i7jO-4g-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-29 02:08:32","2022-08-29 00:08:32","","8","http://sparkway-client.de/sparkgarten/?p=180","0","revision","","0"),
("181","1","2022-08-29 02:09:00","2022-08-29 00:09:00","<!--themify_builder_static--><img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png\" width=\"600\" height=\"83\" title=\"Ghr Logo V2 1000px\" alt=\"Ghr Logo V2 1000px\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png 600w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-300x42.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-768x107.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px.png 1182w\" sizes=\"(max-width: 600px) 100vw, 600px\" />\n<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\" width=\"500\" height=\"500\" title=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" alt=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\" width=\"500\" height=\"500\" title=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" alt=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\" width=\"500\" height=\"500\" title=\"pankaj-shah-1ff_i7jO-4g-unsplash\" alt=\"pankaj-shah-1ff_i7jO-4g-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-29 02:09:00","2022-08-29 00:09:00","","8","http://sparkway-client.de/sparkgarten/?p=181","0","revision","","0"),
("182","1","2022-08-29 02:09:27","2022-08-29 00:09:27","<!--themify_builder_static--><img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png\" width=\"600\" height=\"83\" title=\"Ghr Logo V2 1000px\" alt=\"Ghr Logo V2 1000px\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png 600w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-300x42.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-768x107.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px.png 1182w\" sizes=\"(max-width: 600px) 100vw, 600px\" />\n<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\" width=\"500\" height=\"500\" title=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" alt=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\" width=\"500\" height=\"500\" title=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" alt=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\" width=\"500\" height=\"500\" title=\"pankaj-shah-1ff_i7jO-4g-unsplash\" alt=\"pankaj-shah-1ff_i7jO-4g-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-29 02:09:27","2022-08-29 00:09:27","","8","http://sparkway-client.de/sparkgarten/?p=182","0","revision","","0"),
("183","1","2022-08-29 02:09:45","2022-08-29 00:09:45","<!--themify_builder_static--><img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png\" width=\"600\" height=\"83\" title=\"Ghr Logo V2 1000px\" alt=\"Ghr Logo V2 1000px\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png 600w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-300x42.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-768x107.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px.png 1182w\" sizes=\"(max-width: 600px) 100vw, 600px\" />\n<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\" width=\"500\" height=\"500\" title=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" alt=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\" width=\"500\" height=\"500\" title=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" alt=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\" width=\"500\" height=\"500\" title=\"pankaj-shah-1ff_i7jO-4g-unsplash\" alt=\"pankaj-shah-1ff_i7jO-4g-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-29 02:09:45","2022-08-29 00:09:45","","8","http://sparkway-client.de/sparkgarten/?p=183","0","revision","","0"),
("184","1","2022-08-29 02:09:59","2022-08-29 00:09:59","<!--themify_builder_static--><img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png\" width=\"600\" height=\"83\" title=\"Ghr Logo V2 1000px\" alt=\"Ghr Logo V2 1000px\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png 600w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-300x42.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-768x107.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px.png 1182w\" sizes=\"(max-width: 600px) 100vw, 600px\" />\n<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\" width=\"500\" height=\"500\" title=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" alt=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\" width=\"500\" height=\"500\" title=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" alt=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\" width=\"500\" height=\"500\" title=\"pankaj-shah-1ff_i7jO-4g-unsplash\" alt=\"pankaj-shah-1ff_i7jO-4g-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-29 02:09:59","2022-08-29 00:09:59","","8","http://sparkway-client.de/sparkgarten/?p=184","0","revision","","0"),
("185","1","2022-08-29 02:10:24","2022-08-29 00:10:24","<!--themify_builder_static--><img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png\" width=\"600\" height=\"83\" title=\"Ghr Logo V2 1000px\" alt=\"Ghr Logo V2 1000px\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png 600w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-300x42.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-768x107.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px.png 1182w\" sizes=\"(max-width: 600px) 100vw, 600px\" />\n<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\" width=\"500\" height=\"500\" title=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" alt=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\" width=\"500\" height=\"500\" title=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" alt=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\" width=\"500\" height=\"500\" title=\"pankaj-shah-1ff_i7jO-4g-unsplash\" alt=\"pankaj-shah-1ff_i7jO-4g-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-29 02:10:24","2022-08-29 00:10:24","","8","http://sparkway-client.de/sparkgarten/?p=185","0","revision","","0"),
("186","1","2022-08-29 02:10:44","2022-08-29 00:10:44","<!--themify_builder_static--><img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png\" width=\"600\" height=\"83\" title=\"Ghr Logo V2 1000px\" alt=\"Ghr Logo V2 1000px\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png 600w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-300x42.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-768x107.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px.png 1182w\" sizes=\"(max-width: 600px) 100vw, 600px\" />\n<p>EXCLUSIVE Garten- &amp; LANDSCHAFTSPFLEGE</p>\n<p>GARTEN  HECKE  RASEN</p>\n<p>SERVICE</p>\n<p>Garten</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/matthew-HBjsSlRHXnY-unsplash-Kopie-400x300.jpg\" width=\"400\" height=\"300\" title=\"matthew-HBjsSlRHXnY-unsplash Kopie\" alt=\"matthew-HBjsSlRHXnY-unsplash Kopie\">\n<p>hecke</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/stefan-cosma-aqBQPZUeWfw-unsplash-e1657623840438-400x300.jpg\" width=\"400\" height=\"300\" title=\"stefan-cosma-aqBQPZUeWfw-unsplash\" alt=\"stefan-cosma-aqBQPZUeWfw-unsplash\">\n<p>Rasen</p>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg\" width=\"400\" height=\"300\" title=\"henrique-paim-8s7AjrOxa0Y-unsplash\" alt=\"henrique-paim-8s7AjrOxa0Y-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-400x300.jpg 400w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash-300x225.jpg 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/henrique-paim-8s7AjrOxa0Y-unsplash.jpg 640w\" sizes=\"(max-width: 400px) 100vw, 400px\" />\n<p>Wenn es um die fachgerechte Gartenpflege geht, die Hecke geschnitten, der Rasen gemäht, vertikutiert oder gedüngt werden muss, Sie Ihren Garten von Grund auf neu gestalten wollen oder eine persönliche fachliche Beratung benötigen, sind wir für Sie da!​</p> <p><strong>Auf Reisen?  Gerne übernehmen wir während ihres Urlaubs die Betreuung Ihrer Oase daheim.</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<p>Wir sehen die Natur nicht nur mit unseren Augen, sondern auch mit den Herzen und dem Verstand.</p>\n<p>LEISTUNGEN</p>\n<ul> <li> <p>Pflanzenschutz</p> </li> <li> <p>Wässern</p> </li> <li> <p>Mäharbeiten / Rasenpflege</p> </li> <li> <p>Vertikutieren</p> </li> <li> <p>Rollrasen Verlegung</p> </li> <li> <p>Fachgerechter Gehölzschnitt</p> </li> <li> <p>Betreuung von Wohnungsgesellschaften</p> </li> </ul>\n<ul> <li> <p>Pflanz- &amp; Schnittarbeiten</p> </li> <li> <p>Heckenschnitt</p> </li> <li> <p>Heckenpflanzung</p> </li> <li> <p>Abfuhr &amp; Laubentsorgung</p> </li> <li> <p>Individuelle Beratung</p> </li> <li> <p>Arbeiten mit Steiger</p> </li> <li> <p>Professionelle Langzeitpflege</p> </li> </ul>\n<p>Wir hegen und pflegen alles, was wächst, blüht und gedeiht</p>\n<p>ÜBER UNS</p>\n<img loading=\"lazy\" width=\"720\" height=\"101\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png\" title=\"Ghr Logo V1\" alt=\"Ghr Logo V1\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1.png 720w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V1-300x42.png 300w\" sizes=\"(max-width: 720px) 100vw, 720px\" />\n\n<p>Seit 2003 arbeite Ich leidenschaftlich als Garten- und Landschaftgärtner.<br>Ich kann mir nichts schöneres vorstellen, was mir tagtäglich mehr<br>Zufriedenheit bereiten würde. Als gefragter Gärtner bin ich zwei<br>Grundsätzen verpflichtet: Den<br>bestmöglichen Service zu bieten und sicherzustellen, das Sie von meiner langjährigen Arbeit profitieren.</p> <p>Aus dieser erworbenen Erfahrung ist „Brandl Garten- und Landscshaftpflege“ entstanden und bietet Ihnen ein Spektrum von Leistungen im gärtnerischen Gestaltungs- und Pflegebereich für Garten und Grundstück.</p> <p>Schreiben Sie mir gerne eine Mail oder rufen mich an, Ich stehe Ihnen stets zu diensten.</p> <p><strong>0176-123456</strong><br><strong>post@ghr-muenchen.de</strong></p>\n<a href=\"#kontakt\" > ANFRAGE SENDEN </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg\" width=\"500\" height=\"500\" title=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" alt=\"annie-spratt-scIRUSc7Q38-unsplash Kopie\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/annie-spratt-scIRUSc7Q38-unsplash-Kopie-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg\" width=\"500\" height=\"500\" title=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" alt=\"tania-melnyczuk-dSOQHP-ALqw-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-1024x697-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/tania-melnyczuk-dSOQHP-ALqw-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" /> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg\" width=\"500\" height=\"500\" title=\"pankaj-shah-1ff_i7jO-4g-unsplash\" alt=\"pankaj-shah-1ff_i7jO-4g-unsplash\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-1024x768-500x500.jpg 500w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/pankaj-shah-1ff_i7jO-4g-unsplash-150x150.jpg 150w\" sizes=\"(max-width: 500px) 100vw, 500px\" />\n<p>BLUMEN</p>\n<img loading=\"lazy\" width=\"3700\" height=\"760\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png\" title=\"logol\" alt=\"logol\" srcset=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol.png 3700w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-300x62.png 300w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1024x210.png 1024w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-768x158.png 768w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-1536x316.png 1536w, http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/logol-2048x421.png 2048w\" sizes=\"(max-width: 3700px) 100vw, 3700px\" />\n\n<p><strong>FLORALE POESIE</strong><br>Für uns steht die Blume im Fokus- Sie spielt die Hauptrolle, wir setzen das Spotlight!</p>\n<p>Lassen Sie sich verzaubern<br>Außergewöhnliche Blumen für besondere Anlässe</p>\n<a href=\"https://www.brandl-blumen.de\" target=\"_blank\" rel=\"noopener\"> <em><svg aria-hidden=\"true\"><use href=\"#tf-ti-arrow-top-right\"></use></svg></em> ZUR WEBSEITE </a>\n<img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/P2181257-1024x768-1-500x400.jpg\" width=\"500\" height=\"400\" title=\"P2181257-1024x768\" alt=\"P2181257-1024x768\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA171077-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA171077\" alt=\"PA171077\"> <img loading=\"lazy\" src=\"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/07/PA110936-e1558441423834-1024x768-500x400.jpg\" width=\"500\" height=\"400\" title=\"PA110936-e1558441423834\" alt=\"PA110936-e1558441423834\">\n<p>Wenn meine Seele Urlaub braucht, geh Ich in den Garten</p>\n<p>KONTAKT</p>\n<h3>Schreiben Sie uns!</h3> <section>\n<p>Auf der Suche nach einem kompetenten Partner für die Pflege ihres Gartens, dann sind Sie bei mir an der richtigen Adresse. Ich stehe Ihnen jederzeit zur Verfügung, wenn es um Terminvereinbarungen, weitere Informationen oder Wünsche rund um den Garten geht.</p> <p>Sie können mich telefonisch unter <strong>+49 176 66038200</strong> erreichen. Verwenden Sie auch gerne das Kontaktformular, um sich mit uns per Е-Mail in Verbindung zu setzen. Wir freuen uns auf Ihre Nachricht.</p>\n</section>\n<form action=\"http://sparkway-client.de/sparkgarten/wp-admin/admin-ajax.php\" class=\"builder-contact\" id=\"tb_2r44633-form\" method=\"post\" data-post-id=\"0\" data-element-id=\"2r44633\" data-orig-id=\"\" > <label for=\"tb_2r44633-contact-name\"></label> <input type=\"text\" name=\"contact-name\" placeholder=\"Name\" id=\"tb_2r44633-contact-name\" value=\"\" > <label for=\"tb_2r44633-contact-email\"></label> <input type=\"text\" name=\"contact-email\" placeholder=\"Email\" id=\"tb_2r44633-contact-email\" value=\"\" required> <label for=\"tb_2r44633-contact-message\"></label> <textarea name=\"contact-message\" placeholder=\"Nachricht\" id=\"tb_2r44633-contact-message\" required></textarea> <button type=\"submit\">Send</button> </form><!--/themify_builder_static-->","Home","","inherit","closed","closed","","8-revision-v1","","","2022-08-29 02:10:44","2022-08-29 00:10:44","","8","http://sparkway-client.de/sparkgarten/?p=186","0","revision","","0"),
("191","1","2023-11-06 18:30:28","0000-00-00 00:00:00","","Automatisch gespeicherter Entwurf","","auto-draft","","open","","","","","2023-11-06 18:30:28","0000-00-00 00:00:00","","0","https://sparkway-client.de/sparkgarten/?p=191","0","post","","0"),
("192","0","2023-11-06 18:33:03","2023-11-06 17:33:03","Google Font: Montserrat-cyrillic-italic-200","JTUQjIg1_i6t8kCHKm459WxRxC7mw9c.woff2","","inherit","","closed","","d7ebb5b20473e569","","","2023-11-06 18:33:03","2023-11-06 17:33:03","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRxC7mw9c.woff2","0","attachment","font/woff2","0"),
("193","0","2023-11-06 18:33:03","2023-11-06 17:33:03","Google Font: Montserrat-vietnamese-italic-200","JTUQjIg1_i6t8kCHKm459WxRzS7mw9c.woff2","","inherit","","closed","","07a20265f3237a1e","","","2023-11-06 18:33:03","2023-11-06 17:33:03","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRzS7mw9c.woff2","0","attachment","font/woff2","0"),
("194","0","2023-11-06 18:33:03","2023-11-06 17:33:03","Google Font: Montserrat-latin-ext-italic-200","JTUQjIg1_i6t8kCHKm459WxRxi7mw9c.woff2","","inherit","","closed","","669fe17802836977","","","2023-11-06 18:33:03","2023-11-06 17:33:03","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRxi7mw9c.woff2","0","attachment","font/woff2","0"),
("195","0","2023-11-06 18:33:03","2023-11-06 17:33:03","Google Font: Montserrat-latin-italic-200","JTUQjIg1_i6t8kCHKm459WxRxy7mw9c.woff2","","inherit","","closed","","79dfa613a5694070","","","2023-11-06 18:33:03","2023-11-06 17:33:03","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRxy7mw9c.woff2","0","attachment","font/woff2","0"),
("196","0","2023-11-06 18:33:04","2023-11-06 17:33:04","Google Font: Montserrat-cyrillic-ext-italic-200","JTUQjIg1_i6t8kCHKm459WxRyS7m.woff2","","inherit","","closed","","eaf6e72c90c4a66c","","","2023-11-06 18:33:04","2023-11-06 17:33:04","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRyS7m.woff2","0","attachment","font/woff2","0"),
("197","0","2023-11-06 18:33:04","2023-11-06 17:33:04","Google Font: Montserrat-cyrillic-normal-200","JTUSjIg1_i6t8kCHKm459WRhyzbi.woff2","","inherit","","closed","","9c0cb6b48fa5f368","","","2023-11-06 18:33:04","2023-11-06 17:33:04","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459WRhyzbi.woff2","0","attachment","font/woff2","0"),
("198","0","2023-11-06 18:33:04","2023-11-06 17:33:04","Google Font: Montserrat-vietnamese-normal-200","JTUSjIg1_i6t8kCHKm459W1hyzbi.woff2","","inherit","","closed","","3db0d99194054902","","","2023-11-06 18:33:04","2023-11-06 17:33:04","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459W1hyzbi.woff2","0","attachment","font/woff2","0"),
("199","0","2023-11-06 18:33:04","2023-11-06 17:33:04","Google Font: Montserrat-latin-ext-normal-200","JTUSjIg1_i6t8kCHKm459WZhyzbi.woff2","","inherit","","closed","","0f546eb075b80d8b","","","2023-11-06 18:33:04","2023-11-06 17:33:04","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459WZhyzbi.woff2","0","attachment","font/woff2","0"),
("200","0","2023-11-06 18:33:04","2023-11-06 17:33:04","Google Font: Montserrat-latin-normal-200","JTUSjIg1_i6t8kCHKm459Wdhyzbi.woff2","","inherit","","closed","","5087d31448c2eb8b","","","2023-11-06 18:33:04","2023-11-06 17:33:04","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459Wdhyzbi.woff2","0","attachment","font/woff2","0"),
("201","0","2023-11-06 18:33:04","2023-11-06 17:33:04","Google Font: Montserrat-cyrillic-ext-normal-200","JTUSjIg1_i6t8kCHKm459Wlhyw.woff2","","inherit","","closed","","1436c070b323eb71","","","2023-11-06 18:33:04","2023-11-06 17:33:04","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459Wlhyw.woff2","0","attachment","font/woff2","0"),
("202","0","2023-11-06 18:33:04","2023-11-06 17:33:04","Google Font: Public Sans-latin-ext-italic-400","ijwTs572Xtc6ZYQws9YVwnNDTJPax9k0.woff2","","inherit","","closed","","9e64925130e69e40","","","2023-11-06 18:33:04","2023-11-06 17:33:04","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwTs572Xtc6ZYQws9YVwnNDTJPax9k0.woff2","0","attachment","font/woff2","0"),
("203","0","2023-11-06 18:33:04","2023-11-06 17:33:04","Google Font: Public Sans-latin-italic-400","ijwTs572Xtc6ZYQws9YVwnNDTJLax9k0.woff2","","inherit","","closed","","9833f83bbd4c5f42","","","2023-11-06 18:33:04","2023-11-06 17:33:04","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwTs572Xtc6ZYQws9YVwnNDTJLax9k0.woff2","0","attachment","font/woff2","0"),
("204","0","2023-11-06 18:33:04","2023-11-06 17:33:04","Google Font: Public Sans-vietnamese-italic-400","ijwTs572Xtc6ZYQws9YVwnNDTJzaxw.woff2","","inherit","","closed","","2824dbf3c4833992","","","2023-11-06 18:33:04","2023-11-06 17:33:04","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwTs572Xtc6ZYQws9YVwnNDTJzaxw.woff2","0","attachment","font/woff2","0"),
("205","0","2023-11-06 18:33:04","2023-11-06 17:33:04","Google Font: Public Sans-latin-ext-normal-400","ijwRs572Xtc6ZYQws9YVwnNJfJ7Cww.woff2","","inherit","","closed","","5ec99f766de639eb","","","2023-11-06 18:33:04","2023-11-06 17:33:04","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwRs572Xtc6ZYQws9YVwnNJfJ7Cww.woff2","0","attachment","font/woff2","0"),
("206","0","2023-11-06 18:33:05","2023-11-06 17:33:05","Google Font: Public Sans-latin-normal-400","ijwRs572Xtc6ZYQws9YVwnNIfJ7Cww.woff2","","inherit","","closed","","7e5451ddf75cb506","","","2023-11-06 18:33:05","2023-11-06 17:33:05","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwRs572Xtc6ZYQws9YVwnNIfJ7Cww.woff2","0","attachment","font/woff2","0"),
("207","0","2023-11-06 18:33:05","2023-11-06 17:33:05","Google Font: Public Sans-vietnamese-normal-400","ijwRs572Xtc6ZYQws9YVwnNGfJ4.woff2","","inherit","","closed","","1ba62a1af8d5124f","","","2023-11-06 18:33:05","2023-11-06 17:33:05","","0","http://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwRs572Xtc6ZYQws9YVwnNGfJ4.woff2","0","attachment","font/woff2","0");

INSERT IGNORE INTO `come_statistics_pages` VALUES 
("1","/","home","2022-01-25","2","8");

INSERT IGNORE INTO `come_statistics_visit` VALUES 
("1","2022-01-11 16:48:20","2022-01-11","0"),
("2","2022-01-13 10:22:47","2022-01-13","0"),
("3","2022-01-25 04:20:42","2022-01-25","2"),
("4","2022-01-26 04:21:54","2022-01-26","0"),
("5","2022-03-04 21:22:48","2022-03-04","0"),
("6","2022-04-02 16:53:47","2022-04-02","0");

INSERT IGNORE INTO `come_statistics_visitor` VALUES 
("1","2022-01-25","http://sparkway-client.de/sparkgarten","Safari","OS X","10.15.7","","91.64.101.148","000","0","2","0");

INSERT IGNORE INTO `come_terms` VALUES 
("1","Allgemein","allgemein","0"),
("2","Main Menu","main-menu","0"),
("3","Footer Menu","footer-menu","0");

INSERT IGNORE INTO `come_term_relationships` VALUES 
("22","2","0"),
("23","3","0"),
("24","3","0"),
("25","3","0"),
("99","2","0"),
("100","2","0"),
("101","2","0"),
("102","2","0");

INSERT IGNORE INTO `come_term_taxonomy` VALUES 
("1","1","category","","0","0"),
("2","2","nav_menu","","0","5"),
("3","3","nav_menu","","0","3");

INSERT IGNORE INTO `come_tf_storage` VALUES 
("10cd88d6c48f3b51","1182-164",NULL),
("227ae67fd278694c","1000-667",NULL),
("3e44304b7e657641","86",NULL),
("50d4dd671261f893","82",NULL),
("56fa0532bc86288d","491-356",NULL),
("5768d10add3da1b4","79",NULL),
("5a022e80ab59077d","2560-1742",NULL),
("62d88d614c2d83e5","720-101",NULL),
("7eaa0058d5b5a141","118",NULL),
("89132fc5b8d90ed8","720-101",NULL),
("8e442feee3caa1db","1920-1440",NULL),
("91af34122c86616c","175",NULL),
("98976d17a4861518","158",NULL),
("c6b588b712fb4dbf","<ul><li><a class=\'rsswidget\' href=\'https://themify.me/blog/halloween-sale-2023\'>Spooktacular Savings Await: Halloween Sale 2023 Is Here!</a> <span class=\"rss-date\">25. Oktober 2023</span><div class=\"rssSummary\">Halloween is a time for fun, tricks, and treats, and we&#039;ve got the treats part covered. But remember, this spooky sale will vanish into thin air on October 31st at midnight, so don&#039;t let it haunt your dreams. Grab your favorite themes, plugins, and tools now and give your online presence the Halloween glow-up it [&hellip;]</div></li><li><a class=\'rsswidget\' href=\'https://themify.me/blog/create-membership-with-suremembers\'>Create Membership Websites in WordPress: 8 Easy Steps with SureMembers</a> <span class=\"rss-date\">17. Oktober 2023</span><div class=\"rssSummary\">Building a membership website is an exciting way to generate recurring revenue while providing premium value to your users. But it takes the right tools and strategy to create one successfully. In this comprehensive guide, we&#039;ll explore how the WordPress plugin SureMembers can empower you to easily build a fully functional membership site. Whether you&#039;re [&hellip;]</div></li><li><a class=\'rsswidget\' href=\'https://themify.me/blog/ukontentowani-from-custom-cms-to-themify\'>uKONTENTowani: From Custom CMS to WordPress + Themify</a> <span class=\"rss-date\">28. September 2023</span><div class=\"rssSummary\">We are uKONTENTowani - a small agency based in Zielona Góra, Poland. Our company&#039;s name can be translated as &quot;contented&quot; - because that&#039;s what we do. We deliver content (texts) as well as contentment to our clients. In our work, websites are viewed as another tool through which we implement SEO strategies. But our company&#039;s [&hellip;]</div></li><li><a class=\'rsswidget\' href=\'https://themify.me/blog/ecommerce-skin-for-jewelry-stores\'>New eCommerce Skin for Jewelry Stores</a> <span class=\"rss-date\">30. August 2023</span><div class=\"rssSummary\">We are delighted to announce the release of our latest masterpiece, the Jewelry skin! Crafted with precision and elegance, this skin is set to dazzle and captivate your audience, just like the gems it showcases. The Jewelry skin is designed to put your jewelry collection in the spotlight. With its clean and minimalist layout, your [&hellip;]</div></li></ul>","1699335030"),
("cdb886ea0c6e2afb","117",NULL),
("df75f963fd56d58e","640-480",NULL),
("e584f372680b1ff7","1000-670",NULL),
("eed81ee698bad331","84",NULL),
("tf_fg_css_1f14aa","@font-face{font-family:\'Montserrat\';font-style:italic;font-weight:200;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRxC7mw9c.woff2) format(\"woff2\");unicode-range:U+0460-052F,U+1C80-1C88,U+20B4,U+2DE0-2DFF,U+A640-A69F,U+FE2E-FE2F;}@font-face{font-family:\'Montserrat\';font-style:italic;font-weight:200;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRzS7mw9c.woff2) format(\"woff2\");unicode-range:U+0301,U+0400-045F,U+0490-0491,U+04B0-04B1,U+2116;}@font-face{font-family:\'Montserrat\';font-style:italic;font-weight:200;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRxi7mw9c.woff2) format(\"woff2\");unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}@font-face{font-family:\'Montserrat\';font-style:italic;font-weight:200;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRxy7mw9c.woff2) format(\"woff2\");unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}@font-face{font-family:\'Montserrat\';font-style:italic;font-weight:200;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRyS7m.woff2) format(\"woff2\");unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}@font-face{font-family:\'Montserrat\';font-style:italic;font-weight:300;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRxC7mw9c.woff2) format(\"woff2\");unicode-range:U+0460-052F,U+1C80-1C88,U+20B4,U+2DE0-2DFF,U+A640-A69F,U+FE2E-FE2F;}@font-face{font-family:\'Montserrat\';font-style:italic;font-weight:300;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRzS7mw9c.woff2) format(\"woff2\");unicode-range:U+0301,U+0400-045F,U+0490-0491,U+04B0-04B1,U+2116;}@font-face{font-family:\'Montserrat\';font-style:italic;font-weight:300;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRxi7mw9c.woff2) format(\"woff2\");unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}@font-face{font-family:\'Montserrat\';font-style:italic;font-weight:300;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRxy7mw9c.woff2) format(\"woff2\");unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}@font-face{font-family:\'Montserrat\';font-style:italic;font-weight:300;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRyS7m.woff2) format(\"woff2\");unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}@font-face{font-family:\'Montserrat\';font-style:italic;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRxC7mw9c.woff2) format(\"woff2\");unicode-range:U+0460-052F,U+1C80-1C88,U+20B4,U+2DE0-2DFF,U+A640-A69F,U+FE2E-FE2F;}@font-face{font-family:\'Montserrat\';font-style:italic;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRzS7mw9c.woff2) format(\"woff2\");unicode-range:U+0301,U+0400-045F,U+0490-0491,U+04B0-04B1,U+2116;}@font-face{font-family:\'Montserrat\';font-style:italic;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRxi7mw9c.woff2) format(\"woff2\");unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}@font-face{font-family:\'Montserrat\';font-style:italic;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRxy7mw9c.woff2) format(\"woff2\");unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}@font-face{font-family:\'Montserrat\';font-style:italic;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRyS7m.woff2) format(\"woff2\");unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}@font-face{font-family:\'Montserrat\';font-style:italic;font-weight:500;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRxC7mw9c.woff2) format(\"woff2\");unicode-range:U+0460-052F,U+1C80-1C88,U+20B4,U+2DE0-2DFF,U+A640-A69F,U+FE2E-FE2F;}@font-face{font-family:\'Montserrat\';font-style:italic;font-weight:500;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRzS7mw9c.woff2) format(\"woff2\");unicode-range:U+0301,U+0400-045F,U+0490-0491,U+04B0-04B1,U+2116;}@font-face{font-family:\'Montserrat\';font-style:italic;font-weight:500;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRxi7mw9c.woff2) format(\"woff2\");unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}@font-face{font-family:\'Montserrat\';font-style:italic;font-weight:500;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRxy7mw9c.woff2) format(\"woff2\");unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}@font-face{font-family:\'Montserrat\';font-style:italic;font-weight:500;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUQjIg1_i6t8kCHKm459WxRyS7m.woff2) format(\"woff2\");unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}@font-face{font-family:\'Montserrat\';font-weight:200;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459WRhyzbi.woff2) format(\"woff2\");unicode-range:U+0460-052F,U+1C80-1C88,U+20B4,U+2DE0-2DFF,U+A640-A69F,U+FE2E-FE2F;}@font-face{font-family:\'Montserrat\';font-weight:200;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459W1hyzbi.woff2) format(\"woff2\");unicode-range:U+0301,U+0400-045F,U+0490-0491,U+04B0-04B1,U+2116;}@font-face{font-family:\'Montserrat\';font-weight:200;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459WZhyzbi.woff2) format(\"woff2\");unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}@font-face{font-family:\'Montserrat\';font-weight:200;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459Wdhyzbi.woff2) format(\"woff2\");unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}@font-face{font-family:\'Montserrat\';font-weight:200;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459Wlhyw.woff2) format(\"woff2\");unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}@font-face{font-family:\'Montserrat\';font-weight:300;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459WRhyzbi.woff2) format(\"woff2\");unicode-range:U+0460-052F,U+1C80-1C88,U+20B4,U+2DE0-2DFF,U+A640-A69F,U+FE2E-FE2F;}@font-face{font-family:\'Montserrat\';font-weight:300;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459W1hyzbi.woff2) format(\"woff2\");unicode-range:U+0301,U+0400-045F,U+0490-0491,U+04B0-04B1,U+2116;}@font-face{font-family:\'Montserrat\';font-weight:300;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459WZhyzbi.woff2) format(\"woff2\");unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}@font-face{font-family:\'Montserrat\';font-weight:300;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459Wdhyzbi.woff2) format(\"woff2\");unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}@font-face{font-family:\'Montserrat\';font-weight:300;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459Wlhyw.woff2) format(\"woff2\");unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}@font-face{font-family:\'Montserrat\';font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459WRhyzbi.woff2) format(\"woff2\");unicode-range:U+0460-052F,U+1C80-1C88,U+20B4,U+2DE0-2DFF,U+A640-A69F,U+FE2E-FE2F;}@font-face{font-family:\'Montserrat\';font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459W1hyzbi.woff2) format(\"woff2\");unicode-range:U+0301,U+0400-045F,U+0490-0491,U+04B0-04B1,U+2116;}@font-face{font-family:\'Montserrat\';font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459WZhyzbi.woff2) format(\"woff2\");unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}@font-face{font-family:\'Montserrat\';font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459Wdhyzbi.woff2) format(\"woff2\");unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}@font-face{font-family:\'Montserrat\';font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459Wlhyw.woff2) format(\"woff2\");unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}@font-face{font-family:\'Montserrat\';font-weight:500;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459WRhyzbi.woff2) format(\"woff2\");unicode-range:U+0460-052F,U+1C80-1C88,U+20B4,U+2DE0-2DFF,U+A640-A69F,U+FE2E-FE2F;}@font-face{font-family:\'Montserrat\';font-weight:500;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459W1hyzbi.woff2) format(\"woff2\");unicode-range:U+0301,U+0400-045F,U+0490-0491,U+04B0-04B1,U+2116;}@font-face{font-family:\'Montserrat\';font-weight:500;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459WZhyzbi.woff2) format(\"woff2\");unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}@font-face{font-family:\'Montserrat\';font-weight:500;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459Wdhyzbi.woff2) format(\"woff2\");unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}@font-face{font-family:\'Montserrat\';font-weight:500;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/JTUSjIg1_i6t8kCHKm459Wlhyw.woff2) format(\"woff2\");unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}@font-face{font-family:\'Public Sans\';font-style:italic;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwTs572Xtc6ZYQws9YVwnNDTJPax9k0.woff2) format(\"woff2\");unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}@font-face{font-family:\'Public Sans\';font-style:italic;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwTs572Xtc6ZYQws9YVwnNDTJLax9k0.woff2) format(\"woff2\");unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}@font-face{font-family:\'Public Sans\';font-style:italic;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwTs572Xtc6ZYQws9YVwnNDTJzaxw.woff2) format(\"woff2\");unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}@font-face{font-family:\'Public Sans\';font-style:italic;font-weight:600;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwTs572Xtc6ZYQws9YVwnNDTJPax9k0.woff2) format(\"woff2\");unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}@font-face{font-family:\'Public Sans\';font-style:italic;font-weight:600;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwTs572Xtc6ZYQws9YVwnNDTJLax9k0.woff2) format(\"woff2\");unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}@font-face{font-family:\'Public Sans\';font-style:italic;font-weight:600;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwTs572Xtc6ZYQws9YVwnNDTJzaxw.woff2) format(\"woff2\");unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}@font-face{font-family:\'Public Sans\';font-style:italic;font-weight:700;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwTs572Xtc6ZYQws9YVwnNDTJPax9k0.woff2) format(\"woff2\");unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}@font-face{font-family:\'Public Sans\';font-style:italic;font-weight:700;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwTs572Xtc6ZYQws9YVwnNDTJLax9k0.woff2) format(\"woff2\");unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}@font-face{font-family:\'Public Sans\';font-style:italic;font-weight:700;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwTs572Xtc6ZYQws9YVwnNDTJzaxw.woff2) format(\"woff2\");unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}@font-face{font-family:\'Public Sans\';font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwRs572Xtc6ZYQws9YVwnNJfJ7Cww.woff2) format(\"woff2\");unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}@font-face{font-family:\'Public Sans\';font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwRs572Xtc6ZYQws9YVwnNIfJ7Cww.woff2) format(\"woff2\");unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}@font-face{font-family:\'Public Sans\';font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwRs572Xtc6ZYQws9YVwnNGfJ4.woff2) format(\"woff2\");unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}@font-face{font-family:\'Public Sans\';font-weight:600;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwRs572Xtc6ZYQws9YVwnNJfJ7Cww.woff2) format(\"woff2\");unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}@font-face{font-family:\'Public Sans\';font-weight:600;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwRs572Xtc6ZYQws9YVwnNIfJ7Cww.woff2) format(\"woff2\");unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}@font-face{font-family:\'Public Sans\';font-weight:600;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwRs572Xtc6ZYQws9YVwnNGfJ4.woff2) format(\"woff2\");unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}@font-face{font-family:\'Public Sans\';font-weight:700;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwRs572Xtc6ZYQws9YVwnNJfJ7Cww.woff2) format(\"woff2\");unicode-range:U+0102-0103,U+0110-0111,U+0128-0129,U+0168-0169,U+01A0-01A1,U+01AF-01B0,U+0300-0301,U+0303-0304,U+0308-0309,U+0323,U+0329,U+1EA0-1EF9,U+20AB;}@font-face{font-family:\'Public Sans\';font-weight:700;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwRs572Xtc6ZYQws9YVwnNIfJ7Cww.woff2) format(\"woff2\");unicode-range:U+0100-02AF,U+0304,U+0308,U+0329,U+1E00-1E9F,U+1EF2-1EFF,U+2020,U+20A0-20AB,U+20AD-20CF,U+2113,U+2C60-2C7F,U+A720-A7FF;}@font-face{font-family:\'Public Sans\';font-weight:700;font-display:swap;src:url(https://sparkway-client.de/sparkgarten/wp-content/uploads/2023/11/ijwRs572Xtc6ZYQws9YVwnNGfJ4.woff2) format(\"woff2\");unicode-range:U+0000-00FF,U+0131,U+0152-0153,U+02BB-02BC,U+02C6,U+02DA,U+02DC,U+0304,U+0308,U+0329,U+2000-206F,U+2074,U+20AC,U+2122,U+2191,U+2193,U+2212,U+2215,U+FEFF,U+FFFD;}","1714843985");

INSERT IGNORE INTO `come_yoast_indexable` VALUES 
("2","https://sparkway-client.de/sparkgarten/","39:2990987d68a4230d9acbb485549a8294","8","post","page","1","0",NULL,NULL,"Home","publish",NULL,"0",NULL,NULL,NULL,NULL,NULL,"90","0",NULL,"0",NULL,NULL,NULL,NULL,"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png",NULL,NULL,"first-content-image",NULL,NULL,"http://sparkway-client.de/sparkgarten/wp-content/uploads/2022/08/Ghr-Logo-V2-1000px-1024x142-600x83.png",NULL,"first-content-image",NULL,"0",NULL,NULL,"2022-01-08 23:16:51","2023-10-24 19:42:26","1",NULL,NULL,NULL,NULL,"0",NULL,"2","2022-08-29 00:10:44","2022-01-08 22:11:32",NULL),
("3","https://sparkway-client.de/sparkgarten/","39:2990987d68a4230d9acbb485549a8294",NULL,"home-page",NULL,NULL,NULL,"%%sitename%% %%page%% %%sep%% %%sitedesc%%","EXCLUSIVE GARTEN- &amp; LANDSCHAFTSPFLEGE","Startseite",NULL,NULL,"0",NULL,NULL,NULL,NULL,NULL,NULL,"0","1","0","0","0","0",NULL,NULL,NULL,NULL,NULL,"%%sitename%%","","","0",NULL,NULL,NULL,NULL,NULL,"2022-01-08 23:16:51","2023-10-24 19:42:25","1",NULL,NULL,NULL,NULL,"0",NULL,"2",NULL,NULL,NULL),
("4","https://sparkway-client.de/sparkgarten/impressum/","49:b10c1f45b1f8a2ac0fcfca7563a872b8","10","post","page","1","0",NULL,NULL,"Impressum","publish",NULL,"0",NULL,NULL,NULL,NULL,NULL,"0","0",NULL,"0",NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,"0",NULL,NULL,"2022-01-08 23:16:51","2023-10-24 19:49:14","1",NULL,NULL,NULL,NULL,"0",NULL,"2","2022-01-08 22:11:46","2022-01-08 22:11:46","0"),
("5","https://sparkway-client.de/sparkgarten/datenschutz/","51:aab3eaf354fa1b1488689d533b3d4f39","12","post","page","1","0",NULL,NULL,"Datenschutz","publish",NULL,"0",NULL,NULL,NULL,NULL,NULL,"0","0",NULL,"0",NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,"0",NULL,NULL,"2022-01-08 23:16:51","2023-10-24 19:49:14","1",NULL,NULL,NULL,NULL,"0",NULL,"2","2022-01-08 22:11:59","2022-01-08 22:11:59","0"),
("6","https://sparkway-client.de/sparkgarten/category/allgemein/","58:cc08abee3a07f13ccaf7cc7f7ad61ba1","1","term","category",NULL,NULL,NULL,NULL,"Allgemein",NULL,NULL,"0",NULL,NULL,NULL,NULL,NULL,NULL,"0",NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,"0",NULL,NULL,"2022-01-08 23:16:51","2023-10-24 19:42:26","1",NULL,NULL,NULL,NULL,"0",NULL,"2",NULL,NULL,NULL),
("7",NULL,NULL,NULL,"system-page","404",NULL,NULL,"Seite wurde nicht gefunden. %%sep%% %%sitename%%",NULL,"Fehler 404: Seite wurde nicht gefunden",NULL,NULL,"0",NULL,NULL,NULL,NULL,NULL,NULL,"0","1","0","0","0","0",NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,"2022-01-08 23:16:51","2023-10-24 19:42:25","1",NULL,NULL,NULL,NULL,"0",NULL,"1",NULL,NULL,NULL),
("8",NULL,NULL,NULL,"system-page","search-result",NULL,NULL,"Du hast nach %%searchphrase%% gesucht %%page%% %%sep%% %%sitename%%",NULL,NULL,NULL,NULL,"0",NULL,NULL,NULL,NULL,NULL,NULL,"0","1","0","0","0","0",NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,"2022-01-08 23:16:51","2023-10-24 19:49:00","1",NULL,NULL,NULL,NULL,"0",NULL,"1",NULL,NULL,NULL),
("9",NULL,NULL,NULL,"date-archive",NULL,NULL,NULL,"%%date%% %%page%% %%sep%% %%sitename%%","",NULL,NULL,"0","0",NULL,NULL,NULL,NULL,NULL,NULL,"0","1","0","0","0","0",NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,"2022-01-08 23:16:51","2023-10-24 19:49:00","1",NULL,NULL,NULL,NULL,"0",NULL,"1",NULL,NULL,NULL),
("22","https://sparkway-client.de/sparkgarten/service/","47:e6612cadcf70c6efe9a3e392b767c3a8","43","post","page","1","0",NULL,NULL,"Service","publish",NULL,"0",NULL,NULL,NULL,NULL,NULL,"0","0",NULL,"0",NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,"0",NULL,NULL,"2022-07-09 23:43:31","2023-10-24 19:49:14","1",NULL,NULL,NULL,NULL,"0",NULL,"2","2022-07-09 23:43:33","2022-07-09 23:43:33","0"),
("23","https://sparkway-client.de/sparkgarten/uber-mich/","49:f58819b5dad88e600dadbe0769fdfb8e","45","post","page","1","0",NULL,NULL,"Über mich","publish",NULL,"0",NULL,NULL,NULL,NULL,NULL,"0","0",NULL,"0",NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,"0",NULL,NULL,"2022-07-09 23:43:45","2023-10-24 19:49:14","1",NULL,NULL,NULL,NULL,"0",NULL,"2","2022-07-09 23:45:59","2022-07-09 23:43:45","0"),
("24","https://sparkway-client.de/sparkgarten/kontakt/","47:45d751ef4fc67b6ca2a8f5fcb8936bdc","47","post","page","1","0",NULL,NULL,"Kontakt","publish",NULL,"0",NULL,NULL,NULL,NULL,NULL,"0","0",NULL,"0",NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,"0",NULL,NULL,"2022-07-09 23:43:53","2023-10-24 19:49:14","1",NULL,NULL,NULL,NULL,"0",NULL,"2","2022-07-09 23:45:25","2022-07-09 23:43:53","0");

INSERT IGNORE INTO `come_yoast_indexable_hierarchy` VALUES 
("2","0","0","1"),
("4","0","0","1"),
("5","0","0","1"),
("6","0","0","1"),
("22","0","0","1"),
("23","0","0","1"),
("24","0","0","1");

INSERT IGNORE INTO `come_yoast_migrations` VALUES 
("1","20171228151840"),
("2","20171228151841"),
("3","20190529075038"),
("4","20191011111109"),
("5","20200408101900"),
("6","20200420073606"),
("7","20200428123747"),
("8","20200428194858"),
("9","20200429105310"),
("10","20200430075614"),
("11","20200430150130"),
("12","20200507054848"),
("13","20200513133401"),
("14","20200609154515"),
("15","20200616130143"),
("16","20200617122511"),
("17","20200702141921"),
("18","20200728095334"),
("19","20201202144329"),
("20","20201216124002"),
("21","20201216141134"),
("22","20210817092415"),
("23","20211020091404"),
("24","20230417083836");


/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;

/* Duplicator WordPress Timestamp: 2023-11-06 17:34:35*/
/* DUPLICATOR_PRO_MYSQLDUMP_EOF */
